/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import java.util.*;
import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.fracol.PortType;
import org.reuseware.coconut.fragment.APMatchGroup;
import java.util.ArrayList;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.ReferencePoint;
import org.reuseware.coconut.fragment.VariationPoint;
import org.reuseware.coconut.fragment.Prototype;
import org.reuseware.coconut.fracol.Contribution;
import org.reuseware.coconut.fragment.HeterogeneousPort;


/**
 * @generated
 **/
public class CompositionLinkImpl
{


   public CompositionAssociation compositionAssociation (){
      boolean fujaba__Success = false;
      PortType2PortBinding tBinding = null;
      Iterator<?> fujaba__IterTargetToTPort = null;
      Object _TmpObject = null;
      Port tPort = null;
      PortInstance target = null;
      PortType tType = null;
      Iterator<CompositionAssociation> fujaba__IterSTypeToAssoc = null;
      CompositionAssociation assoc = null;
      PortType sType = null;
      PortType2PortBinding sBinding = null;
      Iterator<?> fujaba__IterSourceToSPort = null;
      Port sPort = null;
      PortInstance source = null;
      Iterator<CompositionAssociation> fujaba__IterTypeToAssoc = null;
      PortType type = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // bind object
         source = this.getSource ();

         // check object source is really bound
         if (!( source != null )) {throw new Exception("SDMException");};

         // iterate to-many link $link.InstanceOf.Name from source to sPort
         fujaba__Success = false;
         _TmpObject = source.port();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterSourceToSPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterSourceToSPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterSourceToSPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( !(fujaba__Success) && fujaba__IterSourceToSPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterSourceToSPort.next ();

               // ensure correct type and really bound of object sPort
               if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
               sPort = (Port) _TmpObject;

               // bind object
               sBinding = sPort.getPortTypeBinding ();

               // check object sBinding is really bound
               if (!( sBinding != null )) {throw new Exception("SDMException");};

               // bind object
               sType = sBinding.getPortType ();

               // check object sType is really bound
               if (!( sType != null )) {throw new Exception("SDMException");};

               // iterate to-many link end1 from sType to assoc
               fujaba__Success = false;
               fujaba__IterSTypeToAssoc = sType.getCompositionAssociations().iterator ();

               while ( !(fujaba__Success) && fujaba__IterSTypeToAssoc.hasNext () )
               {
                  try
                  {
                     assoc = (CompositionAssociation) fujaba__IterSTypeToAssoc.next ();

                     // check object assoc is really bound
                     if (!( assoc != null )) {throw new Exception("SDMException");};
                     // bind object
                     tType = assoc.getEnd2 ();

                     // check object tType is really bound
                     if (!( tType != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects tType and sType
                     if (!( !tType.equals (sType) )) {throw new Exception("SDMException");};

                     // bind object
                     target = this.getTarget ();

                     // check object target is really bound
                     if (!( target != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects target and source
                     if (!( !target.equals (source) )) {throw new Exception("SDMException");};

                     // iterate to-many link $link.InstanceOf.Name from target to tPort
                     fujaba__Success = false;
                     _TmpObject = target.port();
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterTargetToTPort = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterTargetToTPort = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterTargetToTPort = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( !(fujaba__Success) && fujaba__IterTargetToTPort.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterTargetToTPort.next ();

                           // ensure correct type and really bound of object tPort
                           if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
                           tPort = (Port) _TmpObject;


                           // check isomorphic binding between objects tPort and sPort
                           if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                           // bind object
                           tBinding = tPort.getPortTypeBinding ();

                           // check object tBinding is really bound
                           if (!( tBinding != null )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects tBinding and sBinding
                           if (!( !tBinding.equals (sBinding) )) {throw new Exception("SDMException");};

                           // check link portType from tBinding to tType
                           if (!(tType.equals (tBinding.getPortType ()))) {throw new Exception("SDMException");};



                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};



               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern Successor of storypatternwiththis
         try 
         {
            fujaba__Success = false; 

            // bind object
            source = this.getSource ();

            // check object source is really bound
            if (!( source != null )) {throw new Exception("SDMException");};

            // iterate to-many link $link.InstanceOf.Name from source to sPort
            fujaba__Success = false;
            _TmpObject = source.port();
            if (_TmpObject instanceof Iterator<?>) {
                fujaba__IterSourceToSPort = (Iterator<?>)_TmpObject;    
            }
            else if (_TmpObject instanceof Iterable<?>) {
                fujaba__IterSourceToSPort = ((Iterable<?>)_TmpObject).iterator();
            }
            else {
                fujaba__IterSourceToSPort = Collections.singletonList(_TmpObject).iterator();
            }
            while ( !(fujaba__Success) && fujaba__IterSourceToSPort.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterSourceToSPort.next ();

                  // ensure correct type and really bound of object sPort
                  if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
                  sPort = (Port) _TmpObject;

                  // bind object
                  sBinding = sPort.getPortTypeBinding ();

                  // check object sBinding is really bound
                  if (!( sBinding != null )) {throw new Exception("SDMException");};

                  // bind object
                  sType = sBinding.getPortType ();

                  // check object sType is really bound
                  if (!( sType != null )) {throw new Exception("SDMException");};

                  // iterate to-many link end2 from sType to assoc
                  fujaba__Success = false;
                  fujaba__IterSTypeToAssoc = sType.getCompositionAssociations2().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterSTypeToAssoc.hasNext () )
                  {
                     try
                     {
                        assoc = (CompositionAssociation) fujaba__IterSTypeToAssoc.next ();

                        // check object assoc is really bound
                        if (!( assoc != null )) {throw new Exception("SDMException");};
                        // bind object
                        tType = assoc.getEnd1 ();

                        // check object tType is really bound
                        if (!( tType != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects tType and sType
                        if (!( !tType.equals (sType) )) {throw new Exception("SDMException");};

                        // bind object
                        target = this.getTarget ();

                        // check object target is really bound
                        if (!( target != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects target and source
                        if (!( !target.equals (source) )) {throw new Exception("SDMException");};

                        // iterate to-many link $link.InstanceOf.Name from target to tPort
                        fujaba__Success = false;
                        _TmpObject = target.port();
                        if (_TmpObject instanceof Iterator<?>) {
                            fujaba__IterTargetToTPort = (Iterator<?>)_TmpObject;    
                        }
                        else if (_TmpObject instanceof Iterable<?>) {
                            fujaba__IterTargetToTPort = ((Iterable<?>)_TmpObject).iterator();
                        }
                        else {
                            fujaba__IterTargetToTPort = Collections.singletonList(_TmpObject).iterator();
                        }
                        while ( !(fujaba__Success) && fujaba__IterTargetToTPort.hasNext () )
                        {
                           try
                           {
                              _TmpObject =  fujaba__IterTargetToTPort.next ();

                              // ensure correct type and really bound of object tPort
                              if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
                              tPort = (Port) _TmpObject;


                              // check isomorphic binding between objects tPort and sPort
                              if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                              // bind object
                              tBinding = tPort.getPortTypeBinding ();

                              // check object tBinding is really bound
                              if (!( tBinding != null )) {throw new Exception("SDMException");};


                              // check isomorphic binding between objects tBinding and sBinding
                              if (!( !tBinding.equals (sBinding) )) {throw new Exception("SDMException");};

                              // check link portType from tBinding to tType
                              if (!(tType.equals (tBinding.getPortType ()))) {throw new Exception("SDMException");};



                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};



                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};



                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern Successor of Successor of storypatternwiththis
            try 
            {
               fujaba__Success = false; 

               // bind object
               source = this.getSource ();

               // check object source is really bound
               if (!( source != null )) {throw new Exception("SDMException");};

               // iterate to-many link $link.InstanceOf.Name from source to sPort
               fujaba__Success = false;
               _TmpObject = source.port();
               if (_TmpObject instanceof Iterator<?>) {
                   fujaba__IterSourceToSPort = (Iterator<?>)_TmpObject;    
               }
               else if (_TmpObject instanceof Iterable<?>) {
                   fujaba__IterSourceToSPort = ((Iterable<?>)_TmpObject).iterator();
               }
               else {
                   fujaba__IterSourceToSPort = Collections.singletonList(_TmpObject).iterator();
               }
               while ( !(fujaba__Success) && fujaba__IterSourceToSPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterSourceToSPort.next ();

                     // ensure correct type and really bound of object sPort
                     if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
                     sPort = (Port) _TmpObject;

                     // bind object
                     sBinding = sPort.getPortTypeBinding ();

                     // check object sBinding is really bound
                     if (!( sBinding != null )) {throw new Exception("SDMException");};

                     // bind object
                     target = this.getTarget ();

                     // check object target is really bound
                     if (!( target != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects target and source
                     if (!( !target.equals (source) )) {throw new Exception("SDMException");};

                     // iterate to-many link $link.InstanceOf.Name from target to tPort
                     fujaba__Success = false;
                     _TmpObject = target.port();
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterTargetToTPort = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterTargetToTPort = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterTargetToTPort = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( !(fujaba__Success) && fujaba__IterTargetToTPort.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterTargetToTPort.next ();

                           // ensure correct type and really bound of object tPort
                           if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
                           tPort = (Port) _TmpObject;


                           // check isomorphic binding between objects tPort and sPort
                           if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                           // bind object
                           tBinding = tPort.getPortTypeBinding ();

                           // check object tBinding is really bound
                           if (!( tBinding != null )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects tBinding and sBinding
                           if (!( !tBinding.equals (sBinding) )) {throw new Exception("SDMException");};

                           // bind object
                           type = tBinding.getPortType ();

                           // check object type is really bound
                           if (!( type != null )) {throw new Exception("SDMException");};

                           // check link portType from sBinding to type
                           if (!(type.equals (sBinding.getPortType ()))) {throw new Exception("SDMException");};

                           // iterate to-many link end1 from type to assoc
                           fujaba__Success = false;
                           fujaba__IterTypeToAssoc = type.getCompositionAssociations().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterTypeToAssoc.hasNext () )
                           {
                              try
                              {
                                 assoc = (CompositionAssociation) fujaba__IterTypeToAssoc.next ();

                                 // check object assoc is really bound
                                 if (!( assoc != null )) {throw new Exception("SDMException");};
                                 // check link end2 from assoc to type
                                 if (!(type.equals (assoc.getEnd2 ()))) {throw new Exception("SDMException");};


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};



                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (!fujaba__Success)
            {
               return null;

            }

         }

      }
      return assoc;

   }


   public void match (){
      boolean fujaba__Success = false;
      Iterator<APMatchGroup> fujaba__IterThisToMatchGroup = null;
      APMatchGroup matchGroup = null;
      APMatchGroup thisMatchGroup = null;
      Iterator<?> fujaba__IterSAPToMatch = null;
      Object _TmpObject = null;
      APMatch match = null;
      Iterator<AddressablePoint> fujaba__IterTPortToTAP = null;
      AddressablePoint tAP = null;
      Iterator<AddressablePoint> fujaba__IterSPortToSAP = null;
      AddressablePoint sAP = null;
      ReferencePoint rp2 = null;
      Iterator<APMatch> fujaba__IterThisMatchGroupToMatch2 = null;
      APMatch match2 = null;
      VariationPoint vp = null;
      ReferencePoint rp1 = null;
      Iterator<APMatch> fujaba__IterThisMatchGroupToMatch1 = null;
      APMatch match1 = null;
      Prototype prototype = null;
      Iterator<APMatch> fujaba__IterThisMatchGroupToMatch = null;
      Iterator<AddressablePoint> fujaba__IterSPortToRp = null;
      ReferencePoint rp = null;
      Iterator<AddressablePoint> fujaba__IterTPortToRp = null;
      Iterator<?> fujaba__IterThisToAssoc = null;
      Contribution assoc = null;
      Iterator<?> fujaba__IterTPortInstanceToTPort = null;
      HeterogeneousPort tPort = null;
      PortInstance tPortInstance = null;
      Iterator<?> fujaba__IterSPortInstanceToSPort = null;
      HeterogeneousPort sPort = null;
      PortInstance sPortInstance = null;


      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // assign statement
         this.setValid (true);
         // assign statement
         this.setContributes (false);
         // assign statement
         this.setEmpty (false);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }


      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link matches from this to matchGroup
         fujaba__Success = false;
         fujaba__IterThisToMatchGroup = new ArrayList<APMatchGroup>(this.getMatches()).iterator ();

         while ( fujaba__IterThisToMatchGroup.hasNext () )
         {
            try
            {
               matchGroup = (APMatchGroup) fujaba__IterThisToMatchGroup.next ();

               // check object matchGroup is really bound
               if (!( matchGroup != null )) {throw new Exception("SDMException");};
               // destroy link
               this.getMatches().remove (matchGroup);

               // delete object
               matchGroup.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // bind object
         sPortInstance = this.getSource ();

         // check object sPortInstance is really bound
         if (!( sPortInstance != null )) {throw new Exception("SDMException");};

         // attribute condition
         if (!( this.isValid () == true )) {throw new Exception("SDMException");};

         // iterate to-many link $link.InstanceOf.Name from sPortInstance to sPort
         fujaba__Success = false;
         _TmpObject = sPortInstance.allPorts();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterSPortInstanceToSPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterSPortInstanceToSPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterSPortInstanceToSPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( fujaba__IterSPortInstanceToSPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterSPortInstanceToSPort.next ();

               // ensure correct type and really bound of object sPort
               if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
               sPort = (HeterogeneousPort) _TmpObject;

               // story pattern 3.1
               try 
               {
                  fujaba__Success = false; 

                  // bind object
                  tPortInstance = this.getTarget ();

                  // check object tPortInstance is really bound
                  if (!( tPortInstance != null )) {throw new Exception("SDMException");};

                  // attribute condition
                  if (!( this.isValid () == true )) {throw new Exception("SDMException");};

                  // iterate to-many link $link.InstanceOf.Name from tPortInstance to tPort
                  fujaba__Success = false;
                  _TmpObject = tPortInstance.allPorts();
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterTPortInstanceToTPort = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterTPortInstanceToTPort = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterTPortInstanceToTPort = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( fujaba__IterTPortInstanceToTPort.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterTPortInstanceToTPort.next ();

                        // ensure correct type and really bound of object tPort
                        if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                        tPort = (HeterogeneousPort) _TmpObject;

                        // story pattern 3.1.1
                        try 
                        {
                           fujaba__Success = false; 

                           // create object
                           thisMatchGroup = FragmentFactory.eINSTANCE.createAPMatchGroup();
                           // create link
                           this.getMatches().add(thisMatchGroup);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.1.2
                        try 
                        {
                           fujaba__Success = false; 

                           // check object sPort is really bound
                           if (!( sPort != null )) {throw new Exception("SDMException");};
                           // check object tPort is really bound
                           if (!( tPort != null )) {throw new Exception("SDMException");};
                           // check object thisMatchGroup is really bound
                           if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};

                           // check isomorphic binding between objects tPort and sPort
                           if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                           // iterate to-many link addressablePoints from sPort to sAP
                           fujaba__Success = false;
                           fujaba__IterSPortToSAP = new ArrayList<AddressablePoint>(sPort.getAddressablePoints()).iterator ();

                           while ( fujaba__IterSPortToSAP.hasNext () )
                           {
                              try
                              {
                                 sAP = (AddressablePoint) fujaba__IterSPortToSAP.next ();

                                 // check object sAP is really bound
                                 if (!( sAP != null )) {throw new Exception("SDMException");};
                                 // iterate to-many link addressablePoints from tPort to tAP
                                 fujaba__Success = false;
                                 fujaba__IterTPortToTAP = new ArrayList<AddressablePoint>(tPort.getAddressablePoints()).iterator ();

                                 while ( fujaba__IterTPortToTAP.hasNext () )
                                 {
                                    try
                                    {
                                       tAP = (AddressablePoint) fujaba__IterTPortToTAP.next ();

                                       // check object tAP is really bound
                                       if (!( tAP != null )) {throw new Exception("SDMException");};

                                       // check isomorphic binding between objects tAP and sAP
                                       if (!( !tAP.equals (sAP) )) {throw new Exception("SDMException");};

                                       // iterate to-many link $link.InstanceOf.Name from sAP to match
                                       fujaba__Success = false;
                                       _TmpObject = sAP.match(tAP);
                                       if (_TmpObject instanceof Iterator<?>) {
                                           fujaba__IterSAPToMatch = (Iterator<?>)_TmpObject;    
                                       }
                                       else if (_TmpObject instanceof Iterable<?>) {
                                           fujaba__IterSAPToMatch = ((Iterable<?>)_TmpObject).iterator();
                                       }
                                       else {
                                           fujaba__IterSAPToMatch = Collections.singletonList(_TmpObject).iterator();
                                       }
                                       while ( fujaba__IterSAPToMatch.hasNext () )
                                       {
                                          try
                                          {
                                             _TmpObject =  fujaba__IterSAPToMatch.next ();

                                             // ensure correct type and really bound of object match
                                             if (!( _TmpObject instanceof APMatch )) {throw new Exception("SDMException");};
                                             match = (APMatch) _TmpObject;

                                             // create link
                                             match.setMatchGroup(thisMatchGroup);


                                             fujaba__Success = true;
                                          }
                                          catch ( Exception fujaba__InternalException )
                                          {
                                             fujaba__Success = false;
                                          }
                                       }
                                       if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.1.3
                        try 
                        {
                           fujaba__Success = false; 

                           // check object thisMatchGroup is really bound
                           if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};
                           // negative check for link singleMatches from thisMatchGroup
                           if (!( thisMatchGroup.getSingleMatches().size() == 0)) {throw new Exception("SDMException");};
                           // assign statement
                           this.setValid (false);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.1.4
                        try 
                        {
                           fujaba__Success = false; 

                           // check object thisMatchGroup is really bound
                           if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};
                           // iterate to-many link singleMatches from thisMatchGroup to match1
                           fujaba__Success = false;
                           fujaba__IterThisMatchGroupToMatch1 = thisMatchGroup.getSingleMatches().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch1.hasNext () )
                           {
                              try
                              {
                                 match1 = (APMatch) fujaba__IterThisMatchGroupToMatch1.next ();

                                 // check object match1 is really bound
                                 if (!( match1 != null )) {throw new Exception("SDMException");};
                                 // bind object
                                 rp1 = match1.getSource ();

                                 // check object rp1 is really bound
                                 if (!( rp1 != null )) {throw new Exception("SDMException");};

                                 // bind object
                                 vp = match1.getTarget ();

                                 // check object vp is really bound
                                 if (!( vp != null )) {throw new Exception("SDMException");};

                                 // iterate to-many link singleMatches from thisMatchGroup to match2
                                 fujaba__Success = false;
                                 fujaba__IterThisMatchGroupToMatch2 = thisMatchGroup.getSingleMatches().iterator ();

                                 while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch2.hasNext () )
                                 {
                                    try
                                    {
                                       match2 = (APMatch) fujaba__IterThisMatchGroupToMatch2.next ();

                                       // check object match2 is really bound
                                       if (!( match2 != null )) {throw new Exception("SDMException");};

                                       // check isomorphic binding between objects match2 and match1
                                       if (!( !match2.equals (match1) )) {throw new Exception("SDMException");};

                                       // check link target from match2 to vp
                                       if (!(vp.equals (match2.getTarget ()))) {throw new Exception("SDMException");};

                                       // bind object
                                       rp2 = match2.getSource ();

                                       // check object rp2 is really bound
                                       if (!( rp2 != null )) {throw new Exception("SDMException");};


                                       // check isomorphic binding between objects rp2 and rp1
                                       if (!( !rp2.equals (rp1) )) {throw new Exception("SDMException");};



                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                 // attribute condition
                                 if (!( !rp2.getName().equals(rp1.getName ()) )) {throw new Exception("SDMException");};



                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // assign statement
                           this.setValid (false);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.1.5
                        try 
                        {
                           fujaba__Success = false; 

                           // check object thisMatchGroup is really bound
                           if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};
                           // iterate to-many link singleMatches from thisMatchGroup to match1
                           fujaba__Success = false;
                           fujaba__IterThisMatchGroupToMatch1 = thisMatchGroup.getSingleMatches().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch1.hasNext () )
                           {
                              try
                              {
                                 match1 = (APMatch) fujaba__IterThisMatchGroupToMatch1.next ();

                                 // check object match1 is really bound
                                 if (!( match1 != null )) {throw new Exception("SDMException");};
                                 // bind object
                                 _TmpObject = match1.getSource ();

                                 // ensure correct type and really bound of object prototype
                                 if (!( _TmpObject instanceof Prototype )) {throw new Exception("SDMException");};
                                 prototype = (Prototype) _TmpObject;


                                 // iterate to-many link singleMatches from thisMatchGroup to match2
                                 fujaba__Success = false;
                                 fujaba__IterThisMatchGroupToMatch2 = thisMatchGroup.getSingleMatches().iterator ();

                                 while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch2.hasNext () )
                                 {
                                    try
                                    {
                                       match2 = (APMatch) fujaba__IterThisMatchGroupToMatch2.next ();

                                       // check object match2 is really bound
                                       if (!( match2 != null )) {throw new Exception("SDMException");};

                                       // check isomorphic binding between objects match2 and match1
                                       if (!( !match2.equals (match1) )) {throw new Exception("SDMException");};

                                       // check link source from match2 to prototype
                                       if (!(prototype.equals (match2.getSource ()))) {throw new Exception("SDMException");};


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // assign statement
                           this.setValid (false);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.1.6
                        try 
                        {
                           fujaba__Success = false; 

                           // check object sPort is really bound
                           if (!( sPort != null )) {throw new Exception("SDMException");};
                           // check object thisMatchGroup is really bound
                           if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};
                           // iterate to-many link addressablePoints from sPort to rp
                           fujaba__Success = false;
                           fujaba__IterSPortToRp = sPort.getAddressablePoints().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterSPortToRp.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterSPortToRp.next ();

                                 // ensure correct type and really bound of object rp
                                 if (!( _TmpObject instanceof ReferencePoint )) {throw new Exception("SDMException");};
                                 rp = (ReferencePoint) _TmpObject;

                                 // iterate to-many link singleMatches from thisMatchGroup to match
                                 fujaba__Success = false;
                                 fujaba__IterThisMatchGroupToMatch = thisMatchGroup.getSingleMatches().iterator ();

                                 while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch.hasNext () )
                                 {
                                    try
                                    {
                                       match = (APMatch) fujaba__IterThisMatchGroupToMatch.next ();

                                       // check object match is really bound
                                       if (!( match != null )) {throw new Exception("SDMException");};
                                       // check link source from match to rp
                                       if (!(rp.equals (match.getSource ()))) {throw new Exception("SDMException");};


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        if (fujaba__Success)
                        {

                        }
                        else
                        {
                           // story pattern 3.1.7
                           try 
                           {
                              fujaba__Success = false; 

                              // check object tPort is really bound
                              if (!( tPort != null )) {throw new Exception("SDMException");};
                              // check object thisMatchGroup is really bound
                              if (!( thisMatchGroup != null )) {throw new Exception("SDMException");};
                              // iterate to-many link addressablePoints from tPort to rp
                              fujaba__Success = false;
                              fujaba__IterTPortToRp = tPort.getAddressablePoints().iterator ();

                              while ( !(fujaba__Success) && fujaba__IterTPortToRp.hasNext () )
                              {
                                 try
                                 {
                                    _TmpObject =  fujaba__IterTPortToRp.next ();

                                    // ensure correct type and really bound of object rp
                                    if (!( _TmpObject instanceof ReferencePoint )) {throw new Exception("SDMException");};
                                    rp = (ReferencePoint) _TmpObject;

                                    // iterate to-many link singleMatches from thisMatchGroup to match
                                    fujaba__Success = false;
                                    fujaba__IterThisMatchGroupToMatch = thisMatchGroup.getSingleMatches().iterator ();

                                    while ( !(fujaba__Success) && fujaba__IterThisMatchGroupToMatch.hasNext () )
                                    {
                                       try
                                       {
                                          match = (APMatch) fujaba__IterThisMatchGroupToMatch.next ();

                                          // check object match is really bound
                                          if (!( match != null )) {throw new Exception("SDMException");};
                                          // check link source from match to rp
                                          if (!(rp.equals (match.getSource ()))) {throw new Exception("SDMException");};


                                          fujaba__Success = true;
                                       }
                                       catch ( Exception fujaba__InternalException )
                                       {
                                          fujaba__Success = false;
                                       }
                                    }
                                    if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           if (fujaba__Success)
                           {

                           }
                           else
                           {
                              // story pattern 3.1.8
                              try 
                              {
                                 fujaba__Success = false; 

                                 // assign statement
                                 this.setValid (false);
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                           }

                        }
                        // story pattern 3.1.9
                        try 
                        {
                           fujaba__Success = false; 

                           // attribute condition
                           if (!( this.isValid () == true )) {throw new Exception("SDMException");};

                           // iterate to-many link $link.InstanceOf.Name from this to assoc
                           fujaba__Success = false;
                           _TmpObject = this.compositionAssociation();
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterThisToAssoc = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterThisToAssoc = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterThisToAssoc = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterThisToAssoc.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterThisToAssoc.next ();

                                 // ensure correct type and really bound of object assoc
                                 if (!( _TmpObject instanceof Contribution )) {throw new Exception("SDMException");};
                                 assoc = (Contribution) _TmpObject;

                                 // constraint (sPortInstance.canContribute() && tPortInstance.canReceive()) || (tPortInstance.canContribute() && sPortInstance.canReceive())
                                 if (!( (sPortInstance.canContribute() && tPortInstance.canReceive()) || (tPortInstance.canContribute() && sPortInstance.canReceive()) )) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // assign statement
                           this.setContributes (true);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 4
      try 
      {
         fujaba__Success = false; 

         // negative check for link matches from this
         if (!( this.getMatches().size() == 0)) {throw new Exception("SDMException");};
         // assign statement
         this.setEmpty (true);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 5
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link matches from this to matchGroup
         fujaba__Success = false;
         fujaba__IterThisToMatchGroup = new ArrayList<APMatchGroup>(this.getMatches()).iterator ();

         while ( fujaba__IterThisToMatchGroup.hasNext () )
         {
            try
            {
               matchGroup = (APMatchGroup) fujaba__IterThisToMatchGroup.next ();

               // check object matchGroup is really bound
               if (!( matchGroup != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( this.isValid () == false )) {throw new Exception("SDMException");};

               // destroy link
               this.getMatches().remove (matchGroup);

               // delete object
               matchGroup.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.setCompositionProgram (null);
      this.getDerivedFrom().clear();
      this.getMatches().clear();
      this.setSource (null);
      this.setTarget (null);
   }
}


