/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import java.util.*;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.HomogeneousPort;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fragment.Anchor;
import org.reuseware.coconut.fragment.Prototype;
import org.reuseware.coconut.fragment.Hook;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.reuseextension.FragmentRoleBinding;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.compositionprogram.Setting;
import java.util.ArrayList;
import org.reuseware.coconut.compositionprogram.CompositionprogramFactory;
import org.reuseware.coconut.compositionprogram.CompositionLink;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.compositionprogram.CompositionProgram;


/**
 * @generated
 **/
public class PortInstanceImpl
{


   public EList<HeterogeneousPort> allPorts (){
      boolean fujaba__Success = false;
      EList<HeterogeneousPort> resultList = null;
      Iterator<?> fujaba__IterThisToHeteroPort = null;
      Object _TmpObject = null;
      HeterogeneousPort heteroPort = null;
      Iterator<?> fujaba__IterThisToHomoPort = null;
      HomogeneousPort homoPort = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         resultList = new org.eclipse.emf.common.util.BasicEList<HeterogeneousPort>();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link $link.InstanceOf.Name from this to heteroPort
         fujaba__Success = false;
         _TmpObject = this.port();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterThisToHeteroPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterThisToHeteroPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterThisToHeteroPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( !(fujaba__Success) && fujaba__IterThisToHeteroPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterThisToHeteroPort.next ();

               // ensure correct type and really bound of object heteroPort
               if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
               heteroPort = (HeterogeneousPort) _TmpObject;


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 3
         try 
         {
            fujaba__Success = false; 

            // collabStat call
            resultList.add(heteroPort);
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern 4
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link $link.InstanceOf.Name from this to homoPort
            fujaba__Success = false;
            _TmpObject = this.port();
            if (_TmpObject instanceof Iterator<?>) {
                fujaba__IterThisToHomoPort = (Iterator<?>)_TmpObject;    
            }
            else if (_TmpObject instanceof Iterable<?>) {
                fujaba__IterThisToHomoPort = ((Iterable<?>)_TmpObject).iterator();
            }
            else {
                fujaba__IterThisToHomoPort = Collections.singletonList(_TmpObject).iterator();
            }
            while ( !(fujaba__Success) && fujaba__IterThisToHomoPort.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterThisToHomoPort.next ();

                  // ensure correct type and really bound of object homoPort
                  if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                  homoPort = (HomogeneousPort) _TmpObject;


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            // story pattern 5
            try 
            {
               fujaba__Success = false; 

               // collabStat call
               resultList.addAll(homoPort.getHeterogeneousPorts());
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         else
         {

         }

      }
      return resultList;

   }


   public boolean canBeReferenced (){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      HeterogeneousPort port = null;
      Iterator<AddressablePoint> fujaba__IterPortToAnchor = null;
      Anchor anchor = null;
      HomogeneousPort homoPort = null;
      Iterator<AddressablePoint> fujaba__IterHeteroPortToAnchor = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToHeteroPort = null;
      HeterogeneousPort heteroPort = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         _TmpObject = port();

         // ensure correct type and really bound of object port
         if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
         port = (HeterogeneousPort) _TmpObject;

         // iterate to-many link addressablePoints from port to anchor
         fujaba__Success = false;
         fujaba__IterPortToAnchor = port.getAddressablePoints().iterator ();

         while ( !(fujaba__Success) && fujaba__IterPortToAnchor.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterPortToAnchor.next ();

               // ensure correct type and really bound of object anchor
               if (!( _TmpObject instanceof Anchor )) {throw new Exception("SDMException");};
               anchor = (Anchor) _TmpObject;


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            _TmpObject = port();

            // ensure correct type and really bound of object homoPort
            if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
            homoPort = (HomogeneousPort) _TmpObject;

            // iterate to-many link heterogeneousPorts from homoPort to heteroPort
            fujaba__Success = false;
            fujaba__IterHomoPortToHeteroPort = homoPort.getHeterogeneousPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterHomoPortToHeteroPort.hasNext () )
            {
               try
               {
                  heteroPort = (HeterogeneousPort) fujaba__IterHomoPortToHeteroPort.next ();

                  // check object heteroPort is really bound
                  if (!( heteroPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link addressablePoints from heteroPort to anchor
                  fujaba__Success = false;
                  fujaba__IterHeteroPortToAnchor = heteroPort.getAddressablePoints().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterHeteroPortToAnchor.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterHeteroPortToAnchor.next ();

                        // ensure correct type and really bound of object anchor
                        if (!( _TmpObject instanceof Anchor )) {throw new Exception("SDMException");};
                        anchor = (Anchor) _TmpObject;


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (!fujaba__Success)
         {
            return false;

         }

      }
      return true;

   }


   public boolean canContribute (){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      HeterogeneousPort port = null;
      Iterator<AddressablePoint> fujaba__IterPortToPrototype = null;
      Prototype prototype = null;
      HomogeneousPort homoPort = null;
      Iterator<AddressablePoint> fujaba__IterHeteroPortToPrototype = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToHeteroPort = null;
      HeterogeneousPort heteroPort = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         _TmpObject = port();

         // ensure correct type and really bound of object port
         if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
         port = (HeterogeneousPort) _TmpObject;

         // iterate to-many link addressablePoints from port to prototype
         fujaba__Success = false;
         fujaba__IterPortToPrototype = port.getAddressablePoints().iterator ();

         while ( !(fujaba__Success) && fujaba__IterPortToPrototype.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterPortToPrototype.next ();

               // ensure correct type and really bound of object prototype
               if (!( _TmpObject instanceof Prototype )) {throw new Exception("SDMException");};
               prototype = (Prototype) _TmpObject;


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            _TmpObject = port();

            // ensure correct type and really bound of object homoPort
            if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
            homoPort = (HomogeneousPort) _TmpObject;

            // iterate to-many link heterogeneousPorts from homoPort to heteroPort
            fujaba__Success = false;
            fujaba__IterHomoPortToHeteroPort = homoPort.getHeterogeneousPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterHomoPortToHeteroPort.hasNext () )
            {
               try
               {
                  heteroPort = (HeterogeneousPort) fujaba__IterHomoPortToHeteroPort.next ();

                  // check object heteroPort is really bound
                  if (!( heteroPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link addressablePoints from heteroPort to prototype
                  fujaba__Success = false;
                  fujaba__IterHeteroPortToPrototype = heteroPort.getAddressablePoints().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterHeteroPortToPrototype.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterHeteroPortToPrototype.next ();

                        // ensure correct type and really bound of object prototype
                        if (!( _TmpObject instanceof Prototype )) {throw new Exception("SDMException");};
                        prototype = (Prototype) _TmpObject;


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (!fujaba__Success)
         {
            return false;

         }

      }
      return true;

   }


   public boolean canReceive (){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      HeterogeneousPort port = null;
      Iterator<AddressablePoint> fujaba__IterPortToPrototype = null;
      Hook prototype = null;
      HomogeneousPort homoPort = null;
      Iterator<AddressablePoint> fujaba__IterHeteroPortToPrototype = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToHeteroPort = null;
      HeterogeneousPort heteroPort = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         _TmpObject = port();

         // ensure correct type and really bound of object port
         if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
         port = (HeterogeneousPort) _TmpObject;

         // iterate to-many link addressablePoints from port to prototype
         fujaba__Success = false;
         fujaba__IterPortToPrototype = port.getAddressablePoints().iterator ();

         while ( !(fujaba__Success) && fujaba__IterPortToPrototype.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterPortToPrototype.next ();

               // ensure correct type and really bound of object prototype
               if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
               prototype = (Hook) _TmpObject;


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            _TmpObject = port();

            // ensure correct type and really bound of object homoPort
            if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
            homoPort = (HomogeneousPort) _TmpObject;

            // iterate to-many link heterogeneousPorts from homoPort to heteroPort
            fujaba__Success = false;
            fujaba__IterHomoPortToHeteroPort = homoPort.getHeterogeneousPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterHomoPortToHeteroPort.hasNext () )
            {
               try
               {
                  heteroPort = (HeterogeneousPort) fujaba__IterHomoPortToHeteroPort.next ();

                  // check object heteroPort is really bound
                  if (!( heteroPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link addressablePoints from heteroPort to prototype
                  fujaba__Success = false;
                  fujaba__IterHeteroPortToPrototype = heteroPort.getAddressablePoints().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterHeteroPortToPrototype.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterHeteroPortToPrototype.next ();

                        // ensure correct type and really bound of object prototype
                        if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                        prototype = (Hook) _TmpObject;


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (!fujaba__Success)
         {
            return false;

         }

      }
      return true;

   }


   public boolean isValue (){
      boolean fujaba__Success = false;
      Iterator<AddressablePoint> fujaba__IterPortToValuePrototype = null;
      Object _TmpObject = null;
      ValuePrototype valuePrototype = null;
      Iterator<?> fujaba__IterThisToPort = null;
      HeterogeneousPort port = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link $link.InstanceOf.Name from this to port
         fujaba__Success = false;
         _TmpObject = this.allPorts();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterThisToPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterThisToPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterThisToPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( !(fujaba__Success) && fujaba__IterThisToPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterThisToPort.next ();

               // ensure correct type and really bound of object port
               if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
               port = (HeterogeneousPort) _TmpObject;

               // check negative bindings
               try
               {
                  fujaba__Success = false;

                  // iterate to-many link addressablePoints from port to valuePrototype
                  fujaba__Success = false;
                  fujaba__IterPortToValuePrototype = port.getAddressablePoints().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterPortToValuePrototype.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterPortToValuePrototype.next ();

                        // ensure correct type and really bound of object valuePrototype
                        if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
                        valuePrototype = (ValuePrototype) _TmpObject;


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               fujaba__Success = !(fujaba__Success);

               if (!( fujaba__Success )) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern Successor of successor
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link $link.InstanceOf.Name from this to port
            fujaba__Success = false;
            _TmpObject = this.allPorts();
            if (_TmpObject instanceof Iterator<?>) {
                fujaba__IterThisToPort = (Iterator<?>)_TmpObject;    
            }
            else if (_TmpObject instanceof Iterable<?>) {
                fujaba__IterThisToPort = ((Iterable<?>)_TmpObject).iterator();
            }
            else {
                fujaba__IterThisToPort = Collections.singletonList(_TmpObject).iterator();
            }
            while ( !(fujaba__Success) && fujaba__IterThisToPort.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterThisToPort.next ();

                  // ensure correct type and really bound of object port
                  if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                  port = (HeterogeneousPort) _TmpObject;

                  // iterate to-many link addressablePoints from port to valuePrototype
                  fujaba__Success = false;
                  fujaba__IterPortToValuePrototype = port.getAddressablePoints().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterPortToValuePrototype.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterPortToValuePrototype.next ();

                        // ensure correct type and really bound of object valuePrototype
                        if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
                        valuePrototype = (ValuePrototype) _TmpObject;


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            return true;

         }

      }
      return false;

   }


   public Port port (){
      boolean fujaba__Success = false;
      Iterator<Port> fujaba__IterCiToPort = null;
      Port port = null;
      FragmentCollaboration cs = null;
      FragmentRole fRole = null;
      Object _TmpObject = null;
      FragmentRoleBinding binding = null;
      Iterator<CompositionInterface> fujaba__IterFragmentToCi = null;
      CompositionInterface ci = null;
      Fragment fragment = null;
      FragmentInstance fInstance = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // bind object
         fInstance = this.getFragmentInstance ();

         // check object fInstance is really bound
         if (!( fInstance != null )) {throw new Exception("SDMException");};

         // bind object
         fragment = fInstance.getFragment ();

         // check object fragment is really bound
         if (!( fragment != null )) {throw new Exception("SDMException");};

         // iterate to-many link compositionInterfaces from fragment to ci
         fujaba__Success = false;
         fujaba__IterFragmentToCi = fragment.getCompositionInterfaces().iterator ();

         while ( !(fujaba__Success) && fujaba__IterFragmentToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterFragmentToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to port
               fujaba__Success = false;
               fujaba__IterCiToPort = ci.getPorts().iterator ();

               while ( !(fujaba__Success) && fujaba__IterCiToPort.hasNext () )
               {
                  try
                  {
                     port = (Port) fujaba__IterCiToPort.next ();

                     // check object port is really bound
                     if (!( port != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( this.portName.equals(port.getName ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = ci.getRoleBinding ();

               // ensure correct type and really bound of object binding
               if (!( _TmpObject instanceof FragmentRoleBinding )) {throw new Exception("SDMException");};
               binding = (FragmentRoleBinding) _TmpObject;


               // bind object
               fRole = binding.getFragmentRole ();

               // check object fRole is really bound
               if (!( fRole != null )) {throw new Exception("SDMException");};

               // attribute condition
               if (!( this.fragmentRoleName.equals(fRole.getName ()) )) {throw new Exception("SDMException");};

               // bind object
               cs = fRole.getFragmentCollaboration ();

               // check object cs is really bound
               if (!( cs != null )) {throw new Exception("SDMException");};

               // attribute condition
               if (!( this.getFracolName().equals(cs.getFracolName ()) )) {throw new Exception("SDMException");};

               // attribute condition
               if (!( cs.getFracolNamespace ().equals(this.getFracolNamespace())
                )) {throw new Exception("SDMException");};





               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};


         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return port;

      }
      else
      {
         return null;

      }

   }


   public void update (){
      boolean fujaba__Success = false;
      Iterator<?> fujaba__IterThisToPort = null;
      Object _TmpObject = null;
      Port port = null;
      Iterator<Setting> fujaba__IterThisToSetting = null;
      Setting setting = null;
      HeterogeneousPort heteroPort = null;
      HomogeneousPort homoPort = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToHeteroPort = null;
      Iterator<AddressablePoint> fujaba__IterHeteroPortToValueHook = null;
      ValueHook valueHook = null;
      Iterator<CompositionLink> fujaba__IterThisToLink = null;
      CompositionLink link = null;
      CompositionProgram cp = null;
      FragmentInstance fi = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link $link.InstanceOf.Name from this to port
         fujaba__Success = false;
         _TmpObject = this.port();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterThisToPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterThisToPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterThisToPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( !(fujaba__Success) && fujaba__IterThisToPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterThisToPort.next ();

               // ensure correct type and really bound of object port
               if (!( _TmpObject instanceof Port )) {throw new Exception("SDMException");};
               port = (Port) _TmpObject;


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern X
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link settings from this to setting
            fujaba__Success = false;
            fujaba__IterThisToSetting = new ArrayList<Setting>(this.getSettings()).iterator ();

            while ( fujaba__IterThisToSetting.hasNext () )
            {
               try
               {
                  setting = (Setting) fujaba__IterThisToSetting.next ();

                  // check object setting is really bound
                  if (!( setting != null )) {throw new Exception("SDMException");};
                  // attribute condition
                  if (!( "".equals(setting.getValue ()) )) {throw new Exception("SDMException");};

                  // delete object
                  setting.removeYou ();


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern Y
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link settings from this to setting
            fujaba__Success = false;
            fujaba__IterThisToSetting = new ArrayList<Setting>(this.getSettings()).iterator ();

            while ( fujaba__IterThisToSetting.hasNext () )
            {
               try
               {
                  setting = (Setting) fujaba__IterThisToSetting.next ();

                  // check object setting is really bound
                  if (!( setting != null )) {throw new Exception("SDMException");};
                  // attribute condition
                  if (!( null == setting.getValue () )) {throw new Exception("SDMException");};

                  // delete object
                  setting.removeYou ();


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern 1.1
         try 
         {
            fujaba__Success = false; 

            _TmpObject = port;

            // ensure correct type and really bound of object heteroPort
            if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
            heteroPort = (HeterogeneousPort) _TmpObject;

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern 1.2
            try 
            {
               fujaba__Success = false; 

               _TmpObject = port;

               // ensure correct type and really bound of object homoPort
               if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
               homoPort = (HomogeneousPort) _TmpObject;

               // iterate to-many link heterogeneousPorts from homoPort to heteroPort
               fujaba__Success = false;
               fujaba__IterHomoPortToHeteroPort = homoPort.getHeterogeneousPorts().iterator ();

               while ( !(fujaba__Success) && fujaba__IterHomoPortToHeteroPort.hasNext () )
               {
                  try
                  {
                     heteroPort = (HeterogeneousPort) fujaba__IterHomoPortToHeteroPort.next ();

                     // check object heteroPort is really bound
                     if (!( heteroPort != null )) {throw new Exception("SDMException");};

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         // story pattern 1.3
         try 
         {
            fujaba__Success = false; 

            // check object heteroPort is really bound
            if (!( heteroPort != null )) {throw new Exception("SDMException");};
            // iterate to-many link addressablePoints from heteroPort to valueHook
            fujaba__Success = false;
            fujaba__IterHeteroPortToValueHook = new ArrayList<AddressablePoint>(heteroPort.getAddressablePoints()).iterator ();

            while ( fujaba__IterHeteroPortToValueHook.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterHeteroPortToValueHook.next ();

                  // ensure correct type and really bound of object valueHook
                  if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
                  valueHook = (ValueHook) _TmpObject;

                  {
                     // story pattern 1.4
                     try 
                     {
                        fujaba__Success = false; 

                        // iterate to-many link settings from this to setting
                        fujaba__Success = false;
                        fujaba__IterThisToSetting = this.getSettings().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterThisToSetting.hasNext () )
                        {
                           try
                           {
                              setting = (Setting) fujaba__IterThisToSetting.next ();

                              // check object setting is really bound
                              if (!( setting != null )) {throw new Exception("SDMException");};
                              // attribute condition
                              if (!( valueHook.getName().equals(setting.getProperty ()) )) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }


                    if (fujaba__Success)
                     {
                        continue;
                     }
                     // story pattern 1.5
                     try 
                     {
                        fujaba__Success = false; 

                        // create object
                        setting = CompositionprogramFactory.eINSTANCE.createSetting();
                        // assign statement
                        setting.setProperty (valueHook.getName());
                        // create link
                        setting.setPortInstance(this);

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }


                  }

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         return ;

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            // bind object
            fi = this.getFragmentInstance ();

            // check object fi is really bound
            if (!( fi != null )) {throw new Exception("SDMException");};

            // bind object
            cp = fi.getCompositionProgram ();

            // check object cp is really bound
            if (!( cp != null )) {throw new Exception("SDMException");};

            // iterate to-many link source from this to link
            fujaba__Success = false;
            fujaba__IterThisToLink = this.getSourceLinks().iterator ();

            while ( !(fujaba__Success) && fujaba__IterThisToLink.hasNext () )
            {
               try
               {
                  link = (CompositionLink) fujaba__IterThisToLink.next ();

                  // check object link is really bound
                  if (!( link != null )) {throw new Exception("SDMException");};
                  // check link compositionLinks from link to cp
                  if (!(cp.equals (link.getCompositionProgram ()))) {throw new Exception("SDMException");};


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};


            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern 3
            try 
            {
               fujaba__Success = false; 

               // check object cp is really bound
               if (!( cp != null )) {throw new Exception("SDMException");};
               // iterate to-many link target from this to link
               fujaba__Success = false;
               fujaba__IterThisToLink = this.getTargetLinks().iterator ();

               while ( !(fujaba__Success) && fujaba__IterThisToLink.hasNext () )
               {
                  try
                  {
                     link = (CompositionLink) fujaba__IterThisToLink.next ();

                     // check object link is really bound
                     if (!( link != null )) {throw new Exception("SDMException");};
                     // check link compositionLinks from link to cp
                     if (!(cp.equals (link.getCompositionProgram ()))) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern 4
               try 
               {
                  fujaba__Success = false; 

                  // iterate to-many link settings from this to setting
                  fujaba__Success = false;
                  fujaba__IterThisToSetting = this.getSettings().iterator ();

                  while ( !(fujaba__Success) && fujaba__IterThisToSetting.hasNext () )
                  {
                     try
                     {
                        setting = (Setting) fujaba__IterThisToSetting.next ();

                        // check object setting is really bound
                        if (!( setting != null )) {throw new Exception("SDMException");};

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (fujaba__Success)
               {

               }
               else
               {
                  // story pattern 5
                  try 
                  {
                     fujaba__Success = false; 

                     // bind object
                     fi = this.getFragmentInstance ();

                     // check object fi is really bound
                     if (!( fi != null )) {throw new Exception("SDMException");};


                     // destroy link
                     this.setFragmentInstance (null);

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }


               }

            }

         }
         return ;

      }

   }


   public void removeYou()
   {
      this.setFragmentInstance (null);
      this.getSettings().clear();
      this.getSourceLinks().clear();
      this.getTargetLinks().clear();
   }
}


