/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import java.util.*;
import org.reuseware.coconut.fragment.CompositionInterface;
import java.util.ArrayList;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.reuseextension.AddressablePointDerivationRule;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.Slot;
import org.reuseware.coconut.fragment.Anchor;
import org.reuseware.coconut.fragment.Hook;
import org.reuseware.coconut.fragment.Prototype;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EClass;
import org.reuseware.coconut.reuseextension.ComponentModelSpecification;
import org.reuseware.coconut.fragment.ComposedFragment;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.fracol.PortType;
import org.reuseware.coconut.fragment.HomogeneousPort;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fracol.StaticPortType;
import org.reuseware.coconut.id.IdFactory;
import org.reuseware.coconut.id.ID;


/**
 * @generated
 **/
public abstract class FragmentImpl
{


   public void computeCompositionInterface (){
      boolean fujaba__Success = false;
      Iterator<CompositionInterface> fujaba__IterThisToCi = null;
      CompositionInterface ci = null;
      java.util.Map<String,String> args = null;
      EStructuralFeature feature = null;
      HeterogeneousPort port = null;
      Slot slot = null;
      Anchor anchor = null;
      Hook hook = null;
      Prototype prototype = null;
      ValueHook vHook = null;
      ValuePrototype vPrototype = null;
      Iterator<?> fujaba__IterThisToElement = null;
      Object _TmpObject = null;
      EObject element = null;
      EClass eClass = null;
      Iterator<AddressablePointDerivationRule> fujaba__IterPortBindingToApRule = null;
      AddressablePointDerivationRule apRule = null;
      Iterator<?> fujaba__IterThisToVarTypedElement = null;
      EObject varTypedElement = null;
      Iterator<PortType2PortBinding> fujaba__IterBindingToPortBinding = null;
      PortType2PortBinding portBinding = null;
      Iterator<FragmentRole2FragmentBinding> fujaba__IterRexToBinding = null;
      FragmentRole2FragmentBinding binding = null;
      ComponentModelSpecification rex = null;
      Iterator<ReuseExtensionActivator> fujaba__IterThisToActivator = null;
      ReuseExtensionActivator activator = null;


      // story pattern Destroy old composition interfaces
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // destroy link
               ci.setFragment (null);

               // delete object
               ci.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern Find Bindings
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link componentModelActivators from this to activator
         fujaba__Success = false;
         fujaba__IterThisToActivator = new ArrayList<ReuseExtensionActivator>(this.getComponentModelActivators()).iterator ();

         while ( fujaba__IterThisToActivator.hasNext () )
         {
            try
            {
               activator = (ReuseExtensionActivator) fujaba__IterThisToActivator.next ();

               // check object activator is really bound
               if (!( activator != null )) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = activator.getReuseExtension ();

               // ensure correct type and really bound of object rex
               if (!( _TmpObject instanceof ComponentModelSpecification )) {throw new Exception("SDMException");};
               rex = (ComponentModelSpecification) _TmpObject;


               // iterate to-many link fragmentRoleBindings from rex to binding
               fujaba__Success = false;
               fujaba__IterRexToBinding = new ArrayList<FragmentRole2FragmentBinding>(rex.getFragmentRoleBindings()).iterator ();

               while ( fujaba__IterRexToBinding.hasNext () )
               {
                  try
                  {
                     binding = (FragmentRole2FragmentBinding) fujaba__IterRexToBinding.next ();

                     // check object binding is really bound
                     if (!( binding != null )) {throw new Exception("SDMException");};
                     // collabStat call
                     args = new java.util.LinkedHashMap<String, String>();
                     // collabStat call
                     for ( int i = 0;i <= activator.getArguments().size()-1;++i )
                     {
                     args.put(activator.getArguments().get(i).getParameter(), activator.getArguments().get(i).getValue());
                     }
                     if (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(getUFI(), getContents(), binding.getIsExpression(), args))
                     {
                        // story pattern Check for Interface
                        try 
                        {
                           fujaba__Success = false; 

                           // check object binding is really bound
                           if (!( binding != null )) {throw new Exception("SDMException");};
                           // create object
                           ci = FragmentFactory.eINSTANCE.createCompositionInterface();
                           // create link
                           ci.setFragment(this);

                           // create link
                           ci.setFragment(this);

                           // create link
                           ci.setRoleBinding(binding);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern Handle Static Port Types
                        try 
                        {
                           fujaba__Success = false; 

                           // check object binding is really bound
                           if (!( binding != null )) {throw new Exception("SDMException");};
                           // iterate to-many link portTypeBindings from binding to portBinding
                           fujaba__Success = false;
                           fujaba__IterBindingToPortBinding = new ArrayList<PortType2PortBinding>(binding.getPortTypeBindings()).iterator ();

                           while ( fujaba__IterBindingToPortBinding.hasNext () )
                           {
                              try
                              {
                                 portBinding = (PortType2PortBinding) fujaba__IterBindingToPortBinding.next ();

                                 // check object portBinding is really bound
                                 if (!( portBinding != null )) {throw new Exception("SDMException");};
                                 // collabStat call
                                 createStaticPorts(ci, portBinding);
                                 // story pattern Visit Each Model Element
                                 try 
                                 {
                                    fujaba__Success = false; 

                                    // iterate to-many link $link.InstanceOf.Name from this to varTypedElement
                                    fujaba__Success = false;
                                    _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.getAllContents(getContents());
                                    if (_TmpObject instanceof Iterator<?>) {
                                        fujaba__IterThisToVarTypedElement = (Iterator<?>)_TmpObject;    
                                    }
                                    else if (_TmpObject instanceof Iterable<?>) {
                                        fujaba__IterThisToVarTypedElement = ((Iterable<?>)_TmpObject).iterator();
                                    }
                                    else {
                                        fujaba__IterThisToVarTypedElement = Collections.singletonList(_TmpObject).iterator();
                                    }
                                    while ( fujaba__IterThisToVarTypedElement.hasNext () )
                                    {
                                       try
                                       {
                                          _TmpObject =  fujaba__IterThisToVarTypedElement.next ();

                                          // ensure correct type and really bound of object varTypedElement
                                          if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                          varTypedElement = (EObject) _TmpObject;

                                          // story pattern Apply Rules
                                          try 
                                          {
                                             fujaba__Success = false; 

                                             // check object portBinding is really bound
                                             if (!( portBinding != null )) {throw new Exception("SDMException");};
                                             // iterate to-many link derivationRules from portBinding to apRule
                                             fujaba__Success = false;
                                             fujaba__IterPortBindingToApRule = new ArrayList<AddressablePointDerivationRule>(portBinding.getDerivationRules()).iterator ();

                                             while ( fujaba__IterPortBindingToApRule.hasNext () )
                                             {
                                                try
                                                {
                                                   apRule = (AddressablePointDerivationRule) fujaba__IterPortBindingToApRule.next ();

                                                   // check object apRule is really bound
                                                   if (!( apRule != null )) {throw new Exception("SDMException");};
                                                   // bind object
                                                   feature = apRule.getEBoundFeature ();



                                                   // bind object
                                                   eClass = apRule.getEBoundClass ();

                                                   // check object eClass is really bound
                                                   if (!( eClass != null )) {throw new Exception("SDMException");};

                                                   if (eClass.isInstance(varTypedElement) && org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(getUFI(), varTypedElement, apRule.getIsExpression(), args))
                                                   {
                                                      // story pattern for each
                                                      try 
                                                      {
                                                         fujaba__Success = false; 

                                                         // iterate to-many link $link.InstanceOf.Name from this to element
                                                         fujaba__Success = false;
                                                         _TmpObject = org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveElementList(getUFI(), varTypedElement, apRule.getForEachExpression(), args);
                                                         if (_TmpObject instanceof Iterator<?>) {
                                                             fujaba__IterThisToElement = (Iterator<?>)_TmpObject;    
                                                         }
                                                         else if (_TmpObject instanceof Iterable<?>) {
                                                             fujaba__IterThisToElement = ((Iterable<?>)_TmpObject).iterator();
                                                         }
                                                         else {
                                                             fujaba__IterThisToElement = Collections.singletonList(_TmpObject).iterator();
                                                         }
                                                         while ( fujaba__IterThisToElement.hasNext () )
                                                         {
                                                            try
                                                            {
                                                               _TmpObject =  fujaba__IterThisToElement.next ();

                                                               // ensure correct type and really bound of object element
                                                               if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                                               element = (EObject) _TmpObject;

                                                               // story pattern create port call
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  port = createPort(ci, element, apRule, portBinding, activator);

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Slot Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};
                                                                  // check optional
                                                                  if (feature != null)
                                                                  {

                                                                     // check isomorphic binding between objects feature and varTypedElement
                                                                     if (!( !feature.equals (varTypedElement) )) {throw new Exception("SDMException");};

                                                                  }// constraint apRule instanceof org.reuseware.coconut.reuseextension.SlotDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.SlotDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  slot = FragmentFactory.eINSTANCE.createSlot();
                                                                  // assign statement
                                                                  slot.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // assign statement
                                                                  slot.setMode (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, ((org.reuseware.coconut.reuseextension.SlotDerivationRule)apRule).getModeExpression(), args));
                                                                  // assign statement
                                                                  slot.setRemove (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(getUFI(), element, ((org.reuseware.coconut.reuseextension.SlotDerivationRule)apRule).getRemoveExpression(), args, false));
                                                                  // create link
                                                                  slot.setVarTypedEObject(varTypedElement);

                                                                  // check optional
                                                                  if (feature != null)
                                                                  {
                                                                     // create link
                                                                     slot.setVarTypedEStructuralFeature(feature);

                                                                  }// create link
                                                                  slot.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Anchor Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};
                                                                  // check optional
                                                                  if (feature != null)
                                                                  {

                                                                     // check isomorphic binding between objects feature and varTypedElement
                                                                     if (!( !feature.equals (varTypedElement) )) {throw new Exception("SDMException");};

                                                                  }// constraint apRule instanceof org.reuseware.coconut.reuseextension.AnchorDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.AnchorDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  anchor = FragmentFactory.eINSTANCE.createAnchor();
                                                                  // assign statement
                                                                  anchor.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // create link
                                                                  anchor.setVarTypedEObject(varTypedElement);

                                                                  // check optional
                                                                  if (feature != null)
                                                                  {
                                                                     // create link
                                                                     anchor.setVarTypedEStructuralFeature(feature);

                                                                  }// create link
                                                                  anchor.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Hook Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};
                                                                  // check optional
                                                                  if (feature != null)
                                                                  {

                                                                     // check isomorphic binding between objects feature and varTypedElement
                                                                     if (!( !feature.equals (varTypedElement) )) {throw new Exception("SDMException");};

                                                                  }// constraint apRule instanceof org.reuseware.coconut.reuseextension.HookDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.HookDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  hook = FragmentFactory.eINSTANCE.createHook();
                                                                  // assign statement
                                                                  hook.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // assign statement
                                                                  hook.setMode (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, ((org.reuseware.coconut.reuseextension.HookDerivationRule)apRule).getModeExpression(), args));
                                                                  // assign statement
                                                                  hook.setRemove (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(getUFI(), element, ((org.reuseware.coconut.reuseextension.HookDerivationRule)apRule).getRemoveExpression(), args, false));
                                                                  // create link
                                                                  hook.setVarTypedEObject(varTypedElement);

                                                                  // check optional
                                                                  if (feature != null)
                                                                  {
                                                                     // create link
                                                                     hook.setVarTypedEStructuralFeature(feature);

                                                                  }// create link
                                                                  hook.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Prototype Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};
                                                                  // check optional
                                                                  if (feature != null)
                                                                  {

                                                                     // check isomorphic binding between objects feature and varTypedElement
                                                                     if (!( !feature.equals (varTypedElement) )) {throw new Exception("SDMException");};

                                                                  }// constraint apRule instanceof org.reuseware.coconut.reuseextension.PrototypeDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.PrototypeDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  prototype = FragmentFactory.eINSTANCE.createPrototype();
                                                                  // assign statement
                                                                  prototype.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // create link
                                                                  prototype.setVarTypedEObject(varTypedElement);

                                                                  // check optional
                                                                  if (feature != null)
                                                                  {
                                                                     // create link
                                                                     prototype.setVarTypedEStructuralFeature(feature);

                                                                  }// create link
                                                                  prototype.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Value Hook Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object feature is really bound
                                                                  if (!( feature != null )) {throw new Exception("SDMException");};
                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};

                                                                  // check isomorphic binding between objects varTypedElement and feature
                                                                  if (!( !varTypedElement.equals (feature) )) {throw new Exception("SDMException");};

                                                                  // constraint apRule instanceof org.reuseware.coconut.reuseextension.ValueHookDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.ValueHookDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  vHook = FragmentFactory.eINSTANCE.createValueHook();
                                                                  // assign statement
                                                                  vHook.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // assign statement
                                                                  vHook.setBeginIndex (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveInt(getUFI(), element, ((org.reuseware.coconut.reuseextension.ValueHookDerivationRule)apRule).getBeginIndexExpression(), args));
                                                                  // assign statement
                                                                  vHook.setEndIndex (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveInt(getUFI(), element, ((org.reuseware.coconut.reuseextension.ValueHookDerivationRule)apRule).getEndIndexExpression(), args));
                                                                  // assign statement
                                                                  vHook.setListIndex (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveInt(getUFI(), element, ((org.reuseware.coconut.reuseextension.ValueHookDerivationRule)apRule).getListIndexExpression(), args));
                                                                  // assign statement
                                                                  vHook.setMode (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, ((org.reuseware.coconut.reuseextension.ValueHookDerivationRule)apRule).getModeExpression(), args));
                                                                  // create link
                                                                  vHook.setVarTypedEObject(varTypedElement);

                                                                  // create link
                                                                  vHook.setVarTypedEStructuralFeature(feature);

                                                                  // create link
                                                                  vHook.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               // story pattern Value Prototype Creation
                                                               try 
                                                               {
                                                                  fujaba__Success = false; 

                                                                  // check object port is really bound
                                                                  if (!( port != null )) {throw new Exception("SDMException");};
                                                                  // check object varTypedElement is really bound
                                                                  if (!( varTypedElement != null )) {throw new Exception("SDMException");};
                                                                  // check optional
                                                                  if (feature != null)
                                                                  {

                                                                     // check isomorphic binding between objects feature and varTypedElement
                                                                     if (!( !feature.equals (varTypedElement) )) {throw new Exception("SDMException");};

                                                                  }// constraint apRule instanceof org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule
                                                                  if (!( apRule instanceof org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule )) {throw new Exception("SDMException");};
                                                                  // create object
                                                                  vPrototype = FragmentFactory.eINSTANCE.createValuePrototype();
                                                                  // assign statement
                                                                  vPrototype.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPointNameExpression(), args));
                                                                  // assign statement
                                                                  vPrototype.setValue (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, ((org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule)apRule).getValueExpression(), args));
                                                                  // create link
                                                                  vPrototype.setVarTypedEObject(varTypedElement);

                                                                  // check optional
                                                                  if (feature != null)
                                                                  {
                                                                     // create link
                                                                     vPrototype.setVarTypedEStructuralFeature(feature);

                                                                  }// create link
                                                                  vPrototype.setHeterogeneousPort(port);

                                                                  fujaba__Success = true;
                                                               }
                                                               catch ( Exception fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false;
                                                               }


                                                               fujaba__Success = true;
                                                            }
                                                            catch ( Exception fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false;
                                                            }
                                                         }
                                                         if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                                         fujaba__Success = true;
                                                      }
                                                      catch ( Exception fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false;
                                                      }


                                                   }
                                                   else
                                                   {

                                                   }


                                                   fujaba__Success = true;
                                                }
                                                catch ( Exception fujaba__InternalException )
                                                {
                                                   fujaba__Success = false;
                                                }
                                             }
                                             if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                             fujaba__Success = true;
                                          }
                                          catch ( Exception fujaba__InternalException )
                                          {
                                             fujaba__Success = false;
                                          }


                                          fujaba__Success = true;
                                       }
                                       catch ( Exception fujaba__InternalException )
                                       {
                                          fujaba__Success = false;
                                       }
                                    }
                                    if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }
                     else
                     {

                     }

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      removeEmptyInterfacesAndPorts();
      return ;

   }


   public ComposedFragment copy (EList<String> copyUFI ){
      boolean fujaba__Success = false;
      org.eclipse.emf.ecore.util.EcoreUtil.Copier copier = null;
      ComposedFragment copy = null;
      EObject contentCopy = null;
      Iterator<EObject> fujaba__IterThisToContent = null;
      EObject content = null;
      EObject diagramCopy = null;
      Iterator<EObject> fujaba__IterThisToDiagram = null;
      EObject diagram = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         copier = new org.eclipse.emf.ecore.util.EcoreUtil.Copier();
         // collabStat call
         copier.copyAll(getContents());
         // collabStat call
         copier.copyAll(getDiagrams());
         // collabStat call
         copier.copyReferences();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // create object
         copy = FragmentFactory.eINSTANCE.createComposedFragment();
         // assign statement
         copy.getUFI ().clear();
         copy.getUFI ().addAll(copyUFI);
         // collabStat call
         org.reuseware.coconut.fragment.util.SyncEcoreUtil.syncCopy(copier, copy);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link contents from this to content
         fujaba__Success = false;
         fujaba__IterThisToContent = new ArrayList<EObject>(this.getContents()).iterator ();

         while ( fujaba__IterThisToContent.hasNext () )
         {
            try
            {
               content = (EObject) fujaba__IterThisToContent.next ();

               // check object content is really bound
               if (!( content != null )) {throw new Exception("SDMException");};
               // story pattern 3.1
               try 
               {
                  fujaba__Success = false; 

                  contentCopy = copier.get(content);

                  // check object contentCopy is really bound
                  if (!( contentCopy != null )) {throw new Exception("SDMException");};
                  // check object copy is really bound
                  if (!( copy != null )) {throw new Exception("SDMException");};
                  // create link
                  copy.getContents().add(contentCopy);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 4
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link diagrams from this to diagram
         fujaba__Success = false;
         fujaba__IterThisToDiagram = new ArrayList<EObject>(this.getDiagrams()).iterator ();

         while ( fujaba__IterThisToDiagram.hasNext () )
         {
            try
            {
               diagram = (EObject) fujaba__IterThisToDiagram.next ();

               // check object diagram is really bound
               if (!( diagram != null )) {throw new Exception("SDMException");};
               // story pattern 4.1
               try 
               {
                  fujaba__Success = false; 

                  diagramCopy = copier.get(diagram);

                  // check object diagramCopy is really bound
                  if (!( diagramCopy != null )) {throw new Exception("SDMException");};
                  // check object copy is really bound
                  if (!( copy != null )) {throw new Exception("SDMException");};
                  // create link
                  copy.getDiagrams().add(diagramCopy);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return copy;

   }


   public HeterogeneousPort createPort (CompositionInterface ci , EObject element , AddressablePointDerivationRule apRule , PortType2PortBinding portBinding , ReuseExtensionActivator activator ){
      boolean fujaba__Success = false;
      java.util.Map<String,String> args = null;
      PortType portType = null;
      Iterator<Port> fujaba__IterCiToHomoPort = null;
      Object _TmpObject = null;
      HomogeneousPort homoPort = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToPort = null;
      HeterogeneousPort port = null;
      Iterator<Port> fujaba__IterCiToPort = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         args = new java.util.LinkedHashMap<String, String>();
         // collabStat call
         for ( int i = 0;i <= activator.getArguments().size()-1;++i )
         {
         args.put(activator.getArguments().get(i).getParameter(), activator.getArguments().get(i).getValue());
         }
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern port type
      try 
      {
         fujaba__Success = false; 

         // check object portBinding is really bound
         if (!( portBinding != null )) {throw new Exception("SDMException");};
         // bind object
         portType = portBinding.getPortType ();

         // check object portType is really bound
         if (!( portType != null )) {throw new Exception("SDMException");};


         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (portBinding instanceof org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding)
      {
         // story pattern Handle Dynamic Homo Ports
         try 
         {
            fujaba__Success = false; 

            // check object ci is really bound
            if (!( ci != null )) {throw new Exception("SDMException");};
            // iterate to-many link ports from ci to homoPort
            fujaba__Success = false;
            fujaba__IterCiToHomoPort = ci.getPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterCiToHomoPort.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterCiToHomoPort.next ();

                  // ensure correct type and really bound of object homoPort
                  if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                  homoPort = (HomogeneousPort) _TmpObject;

                  // attribute condition
                  if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getHomoPortNameExpression(), args).equals(homoPort.getName ()) )) {throw new Exception("SDMException");};

                  // constraint portType instanceof org.reuseware.coconut.fracol.DynamicPortType
                  if (!( portType instanceof org.reuseware.coconut.fracol.DynamicPortType )) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern Create Dynamic Homo Port
            try 
            {
               fujaba__Success = false; 

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // check object portBinding is really bound
               if (!( portBinding != null )) {throw new Exception("SDMException");};
               // constraint portType instanceof org.reuseware.coconut.fracol.DynamicPortType
               if (!( portType instanceof org.reuseware.coconut.fracol.DynamicPortType )) {throw new Exception("SDMException");};
               // create object
               homoPort = FragmentFactory.eINSTANCE.createHomogeneousPort();
               // assign statement
               homoPort.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getHomoPortNameExpression(), args));
               // create link
               homoPort.setPortTypeBinding(portBinding);

               // create link
               homoPort.setCompositionInterface(ci);

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         // story pattern Handle Ports of HomoPorts
         try 
         {
            fujaba__Success = false; 

            // check object homoPort is really bound
            if (!( homoPort != null )) {throw new Exception("SDMException");};
            // iterate to-many link heterogeneousPorts from homoPort to port
            fujaba__Success = false;
            fujaba__IterHomoPortToPort = homoPort.getHeterogeneousPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterHomoPortToPort.hasNext () )
            {
               try
               {
                  port = (HeterogeneousPort) fujaba__IterHomoPortToPort.next ();

                  // check object port is really bound
                  if (!( port != null )) {throw new Exception("SDMException");};
                  // attribute condition
                  if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPortNameExpression(), args).equals(port.getName ()) )) {throw new Exception("SDMException");};


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern Create Port of HomoPort
            try 
            {
               fujaba__Success = false; 

               // check object homoPort is really bound
               if (!( homoPort != null )) {throw new Exception("SDMException");};
               // create object
               port = FragmentFactory.eINSTANCE.createHeterogeneousPort();
               // assign statement
               port.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPortNameExpression(), args));
               // create link
               port.setHomogenousPort(homoPort);

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         return port;

      }
      else
      {
         // story pattern Handle Dynamic Ports
         try 
         {
            fujaba__Success = false; 

            // check object ci is really bound
            if (!( ci != null )) {throw new Exception("SDMException");};
            // iterate to-many link ports from ci to port
            fujaba__Success = false;
            fujaba__IterCiToPort = ci.getPorts().iterator ();

            while ( !(fujaba__Success) && fujaba__IterCiToPort.hasNext () )
            {
               try
               {
                  _TmpObject =  fujaba__IterCiToPort.next ();

                  // ensure correct type and really bound of object port
                  if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                  port = (HeterogeneousPort) _TmpObject;

                  // attribute condition
                  if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPortNameExpression(), args).equals(port.getName ()) )) {throw new Exception("SDMException");};

                  // constraint portType instanceof org.reuseware.coconut.fracol.DynamicPortType
                  if (!( portType instanceof org.reuseware.coconut.fracol.DynamicPortType )) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern Create Dynamic Port
            try 
            {
               fujaba__Success = false; 

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // check object portBinding is really bound
               if (!( portBinding != null )) {throw new Exception("SDMException");};
               // constraint portType instanceof org.reuseware.coconut.fracol.DynamicPortType
               if (!( portType instanceof org.reuseware.coconut.fracol.DynamicPortType )) {throw new Exception("SDMException");};
               // create object
               port = FragmentFactory.eINSTANCE.createHeterogeneousPort();
               // assign statement
               port.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(getUFI(), element, apRule.getPortNameExpression(), args));
               // create link
               port.setPortTypeBinding(portBinding);

               // create link
               port.setCompositionInterface(ci);

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         return port;

      }

   }


   public Port createStaticPorts (CompositionInterface ci , PortType2PortBinding portBinding ){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      StaticPortType staticPortType = null;
      Iterator<Port> fujaba__IterCiToHomoPort = null;
      HomogeneousPort homoPort = null;
      Iterator<AddressablePoint> fujaba__IterPortToAp = null;
      AddressablePoint ap = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToPort = null;
      HeterogeneousPort port = null;
      Iterator<Port> fujaba__IterCiToPort = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // check object portBinding is really bound
         if (!( portBinding != null )) {throw new Exception("SDMException");};
         // bind object
         _TmpObject = portBinding.getPortType ();

         // ensure correct type and really bound of object staticPortType
         if (!( _TmpObject instanceof StaticPortType )) {throw new Exception("SDMException");};
         staticPortType = (StaticPortType) _TmpObject;



         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         if (portBinding instanceof org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding)
         {
            // story pattern Check for HomoPort
            try 
            {
               fujaba__Success = false; 

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // check object portBinding is really bound
               if (!( portBinding != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to homoPort
               fujaba__Success = false;
               fujaba__IterCiToHomoPort = ci.getPorts().iterator ();

               while ( !(fujaba__Success) && fujaba__IterCiToHomoPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToHomoPort.next ();

                     // ensure correct type and really bound of object homoPort
                     if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                     homoPort = (HomogeneousPort) _TmpObject;

                     // check link portTypeBinding from homoPort to portBinding
                     if (!(portBinding.equals (homoPort.getPortTypeBinding ()))) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {
               // story pattern Remove old AddressablePoints (HomoPort)
               try 
               {
                  fujaba__Success = false; 

                  // check object homoPort is really bound
                  if (!( homoPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link heterogeneousPorts from homoPort to port
                  fujaba__Success = false;
                  fujaba__IterHomoPortToPort = new ArrayList<HeterogeneousPort>(homoPort.getHeterogeneousPorts()).iterator ();

                  while ( fujaba__IterHomoPortToPort.hasNext () )
                  {
                     try
                     {
                        port = (HeterogeneousPort) fujaba__IterHomoPortToPort.next ();

                        // check object port is really bound
                        if (!( port != null )) {throw new Exception("SDMException");};
                        // iterate to-many link addressablePoints from port to ap
                        fujaba__Success = false;
                        fujaba__IterPortToAp = new ArrayList<AddressablePoint>(port.getAddressablePoints()).iterator ();

                        while ( fujaba__IterPortToAp.hasNext () )
                        {
                           try
                           {
                              ap = (AddressablePoint) fujaba__IterPortToAp.next ();

                              // check object ap is really bound
                              if (!( ap != null )) {throw new Exception("SDMException");};
                              // destroy link
                              ap.setHeterogeneousPort (null);

                              // delete object
                              ap.removeYou ();


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            else
            {
               // story pattern Create Homo Port
               try 
               {
                  fujaba__Success = false; 

                  // check object ci is really bound
                  if (!( ci != null )) {throw new Exception("SDMException");};
                  // check object portBinding is really bound
                  if (!( portBinding != null )) {throw new Exception("SDMException");};
                  // create object
                  homoPort = FragmentFactory.eINSTANCE.createHomogeneousPort();
                  // assign statement
                  homoPort.setName (staticPortType.getName());
                  // create link
                  homoPort.setPortTypeBinding(portBinding);

                  // create link
                  ci.getPorts().add(homoPort);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            return homoPort;

         }
         else
         {
            // story pattern Find Port
            try 
            {
               fujaba__Success = false; 

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // check object portBinding is really bound
               if (!( portBinding != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to port
               fujaba__Success = false;
               fujaba__IterCiToPort = ci.getPorts().iterator ();

               while ( !(fujaba__Success) && fujaba__IterCiToPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToPort.next ();

                     // ensure correct type and really bound of object port
                     if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                     port = (HeterogeneousPort) _TmpObject;

                     // check link portTypeBinding from port to portBinding
                     if (!(portBinding.equals (port.getPortTypeBinding ()))) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {
               // story pattern Remove old AddressablePoints
               try 
               {
                  fujaba__Success = false; 

                  // check object port is really bound
                  if (!( port != null )) {throw new Exception("SDMException");};
                  // iterate to-many link addressablePoints from port to ap
                  fujaba__Success = false;
                  fujaba__IterPortToAp = new ArrayList<AddressablePoint>(port.getAddressablePoints()).iterator ();

                  while ( fujaba__IterPortToAp.hasNext () )
                  {
                     try
                     {
                        ap = (AddressablePoint) fujaba__IterPortToAp.next ();

                        // check object ap is really bound
                        if (!( ap != null )) {throw new Exception("SDMException");};
                        // destroy link
                        ap.setHeterogeneousPort (null);

                        // delete object
                        ap.removeYou ();


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            else
            {

               // story pattern Create Port
               try 
               {
                  fujaba__Success = false; 

                  // check object ci is really bound
                  if (!( ci != null )) {throw new Exception("SDMException");};
                  // check object portBinding is really bound
                  if (!( portBinding != null )) {throw new Exception("SDMException");};
                  // create object
                  port = FragmentFactory.eINSTANCE.createHeterogeneousPort();
                  // assign statement
                  port.setName (staticPortType.getName());
                  // create link
                  port.setPortTypeBinding(portBinding);

                  // create link
                  port.setCompositionInterface(ci);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            return port;

         }

      }
      else
      {
         return null;

      }

   }


   public EList<AddressablePoint> getAllAddressablePoints (){
      boolean fujaba__Success = false;
      EList<AddressablePoint>  resultList = null;
      Iterator<Port> fujaba__IterCiToHeteroPort = null;
      Object _TmpObject = null;
      HeterogeneousPort heteroPort = null;
      Iterator<CompositionInterface> fujaba__IterThisToCi = null;
      CompositionInterface ci = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToHeteroPort = null;
      Iterator<Port> fujaba__IterCiToHomoPort = null;
      HomogeneousPort homoPort = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // collabStat call
          resultList = new org.eclipse.emf.common.util.BasicEList<AddressablePoint>();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to heteroPort
               fujaba__Success = false;
               fujaba__IterCiToHeteroPort = new ArrayList<Port>(ci.getPorts()).iterator ();

               while ( fujaba__IterCiToHeteroPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToHeteroPort.next ();

                     // ensure correct type and really bound of object heteroPort
                     if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                     heteroPort = (HeterogeneousPort) _TmpObject;

                     // collabStat call
                     resultList.addAll(heteroPort.getAddressablePoints());

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to homoPort
               fujaba__Success = false;
               fujaba__IterCiToHomoPort = new ArrayList<Port>(ci.getPorts()).iterator ();

               while ( fujaba__IterCiToHomoPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToHomoPort.next ();

                     // ensure correct type and really bound of object homoPort
                     if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                     homoPort = (HomogeneousPort) _TmpObject;

                     // iterate to-many link heterogeneousPorts from homoPort to heteroPort
                     fujaba__Success = false;
                     fujaba__IterHomoPortToHeteroPort = new ArrayList<HeterogeneousPort>(homoPort.getHeterogeneousPorts()).iterator ();

                     while ( fujaba__IterHomoPortToHeteroPort.hasNext () )
                     {
                        try
                        {
                           heteroPort = (HeterogeneousPort) fujaba__IterHomoPortToHeteroPort.next ();

                           // check object heteroPort is really bound
                           if (!( heteroPort != null )) {throw new Exception("SDMException");};
                           // collabStat call
                           resultList.addAll(heteroPort.getAddressablePoints());

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return resultList;

   }


   public ID getUFIAsID (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // assign statement
         id.getSegments ().clear();
         id.getSegments ().addAll(getUFI());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public void removeEmptyInterfacesAndPorts (){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      StaticPortType portType = null;
      PortType2PortBinding portBinding = null;
      Iterator<Port> fujaba__IterCiToPort = null;
      HeterogeneousPort port = null;
      Iterator<CompositionInterface> fujaba__IterThisToCi = null;
      CompositionInterface ci = null;
      Iterator<HeterogeneousPort> fujaba__IterHomoPortToPort = null;
      Iterator<Port> fujaba__IterCiToHomoPort = null;
      HomogeneousPort homoPort = null;


      // story pattern ap
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to port
               fujaba__Success = false;
               fujaba__IterCiToPort = new ArrayList<Port>(ci.getPorts()).iterator ();

               while ( fujaba__IterCiToPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToPort.next ();

                     // ensure correct type and really bound of object port
                     if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
                     port = (HeterogeneousPort) _TmpObject;

                     // negative check for link addressablePoints from port
                     if (!( port.getAddressablePoints().size() == 0)) {throw new Exception("SDMException");};
                     // bind object
                     portBinding = port.getPortTypeBinding ();

                     // check object portBinding is really bound
                     if (!( portBinding != null )) {throw new Exception("SDMException");};

                     // check negative bindings
                     try
                     {
                        fujaba__Success = false;

                        // bind object
                        _TmpObject = portBinding.getPortType ();

                        // ensure correct type and really bound of object portType
                        if (!( _TmpObject instanceof StaticPortType )) {throw new Exception("SDMException");};
                        portType = (StaticPortType) _TmpObject;




                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     fujaba__Success = !(fujaba__Success);

                     if (!( fujaba__Success )) {throw new Exception("SDMException");};
                     // destroy link
                     port.setCompositionInterface (null);

                     // delete object
                     port.removeYou ();



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern Delete Empty Ports In HomoPorts
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // story pattern Delete Empty Ports In HomoPorts 2
               try 
               {
                  fujaba__Success = false; 

                  // check object ci is really bound
                  if (!( ci != null )) {throw new Exception("SDMException");};
                  // iterate to-many link ports from ci to homoPort
                  fujaba__Success = false;
                  fujaba__IterCiToHomoPort = new ArrayList<Port>(ci.getPorts()).iterator ();

                  while ( fujaba__IterCiToHomoPort.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterCiToHomoPort.next ();

                        // ensure correct type and really bound of object homoPort
                        if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                        homoPort = (HomogeneousPort) _TmpObject;

                        // iterate to-many link heterogeneousPorts from homoPort to port
                        fujaba__Success = false;
                        fujaba__IterHomoPortToPort = new ArrayList<HeterogeneousPort>(homoPort.getHeterogeneousPorts()).iterator ();

                        while ( fujaba__IterHomoPortToPort.hasNext () )
                        {
                           try
                           {
                              port = (HeterogeneousPort) fujaba__IterHomoPortToPort.next ();

                              // check object port is really bound
                              if (!( port != null )) {throw new Exception("SDMException");};
                              // negative check for link addressablePoints from port
                              if (!( port.getAddressablePoints().size() == 0)) {throw new Exception("SDMException");};
                              // destroy link
                              port.setHomogenousPort (null);

                              // delete object
                              port.removeYou ();


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern Delete Empty Ports In Interfaces (Homo)
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // iterate to-many link ports from ci to homoPort
               fujaba__Success = false;
               fujaba__IterCiToHomoPort = new ArrayList<Port>(ci.getPorts()).iterator ();

               while ( fujaba__IterCiToHomoPort.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterCiToHomoPort.next ();

                     // ensure correct type and really bound of object homoPort
                     if (!( _TmpObject instanceof HomogeneousPort )) {throw new Exception("SDMException");};
                     homoPort = (HomogeneousPort) _TmpObject;

                     // negative check for link heterogeneousPorts from homoPort
                     if (!( homoPort.getHeterogeneousPorts().size() == 0)) {throw new Exception("SDMException");};
                     // destroy link
                     homoPort.setCompositionInterface (null);

                     // delete object
                     homoPort.removeYou ();


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern Delete Empty Interfaces
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionInterfaces from this to ci
         fujaba__Success = false;
         fujaba__IterThisToCi = new ArrayList<CompositionInterface>(this.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterThisToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterThisToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // negative check for link ports from ci
               if (!( ci.getPorts().size() == 0)) {throw new Exception("SDMException");};
               // delete object
               ci.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.getComponentModelActivators().clear();
      this.getCompositionInterfaces().clear();
      this.getCompositionLanguageActivators().clear();
      this.getContents().clear();
      this.getDiagrams().clear();
   }
}


