/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import java.util.*;
import org.eclipse.emf.ecore.EStructuralFeature.Setting;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.common.util.EList;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.ValuePrototype;
import java.lang.Object;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import java.util.Collections;
import java.util.ArrayList;
import org.eclipse.emf.ecore.EReference;
import org.reuseware.coconut.fragment.Hook;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.HomogeneousPort;
import org.reuseware.coconut.fragment.ReferencePoint;
import org.reuseware.coconut.fragment.ComposedFragment;
import org.eclipse.emf.ecore.EClass;


/**
 * @generated
 **/
public abstract class VariationPointImpl extends AddressablePoint
{


   public void append (EObject parent , EStructuralFeature feature , EObject referenceNode , EObject variationNode ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterParentToSetting = null;
      Setting setting = null;
      Object _TmpObject = null;
      ValueHook valueHook = null;
      ValuePrototype valuePrototype = null;
      Object value = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};
         // check object parent is really bound
         if (!( parent != null )) {throw new Exception("SDMException");};

         // check isomorphic binding between objects parent and feature
         if (!( !parent.equals (feature) )) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from parent to setting
         fujaba__Success = false;
         fujaba__IterParentToSetting = Collections.singletonList(((InternalEObject)parent).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterParentToSetting.hasNext () )
         {
            try
            {
               setting = (Setting) fujaba__IterParentToSetting.next ();

               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from setting to feature
               if (!(feature.equals (setting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         _TmpObject = this;

         // ensure correct type and really bound of object valueHook
         if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
         valueHook = (ValueHook) _TmpObject;

         _TmpObject = referenceNode;

         // ensure correct type and really bound of object valuePrototype
         if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
         valuePrototype = (ValuePrototype) _TmpObject;

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 5
         try 
         {
            fujaba__Success = false; 

            _TmpObject = valuePrototype.getValue();

            // ensure correct type and really bound of object value
            if (!( _TmpObject instanceof Object )) {throw new Exception("SDMException");};
            value = (Object) _TmpObject;

            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), value.toString());
            }
            else {
            	__value = value;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = valueHook.getListIndex() + 1;
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern 3
         try 
         {
            fujaba__Success = false; 

            // check object referenceNode is really bound
            if (!( referenceNode != null )) {throw new Exception("SDMException");};
            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // check object variationNode is really bound
            if (!( variationNode != null )) {throw new Exception("SDMException");};

            // disabled isomorphic binding check between EObjects variationNode and referenceNode"

            // check link value from setting to variationNode
            if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).contains(variationNode) : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

            // create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), referenceNode.toString());
            }
            else {
            	__value = referenceNode;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = values.indexOf (variationNode) + 1;
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern 4
            try 
            {
               fujaba__Success = false; 

               // check object referenceNode is really bound
               if (!( referenceNode != null )) {throw new Exception("SDMException");};
               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // create link
               // primitive type conversation if needed
               Object __value;
               if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
               	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), referenceNode.toString());
               }
               else {
               	__value = referenceNode;
               }
               if (setting.getEStructuralFeature().isMany()) {
                   EList<Object> values = ((EList<Object>)setting.get(true));
               	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
               		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
               	}
               	else {
                   	if (__value instanceof String) {
                   		values.addAll(Arrays.asList(((String)__value).split("/")));
                   	}
                   	else {
                   		values.add(__value);
                   	}
               	}
               }
               else {
                   setting.set(__value);
               }

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }

      }
      return ;

   }


   public void basicCompose (EObject parent , EStructuralFeature feature , EObject referenceNode , EObject variationNode ){
      boolean fujaba__Success = false;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // attribute condition
         if (!( "bind".equals(this.getMode ()) )) {throw new Exception("SDMException");};

         // collabStat call
         bind(parent, feature, referenceNode, variationNode);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return ;

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            // check object feature is really bound
            if (!( feature != null )) {throw new Exception("SDMException");};
            // attribute condition
            if (!( feature.getUpperBound () == 1 )) {throw new Exception("SDMException");};

            // collabStat call
            bind(parent, feature, referenceNode, variationNode);
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern 3
            try 
            {
               fujaba__Success = false; 

               // collabStat call
               extend(parent, feature, referenceNode, variationNode);
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }
         return ;

      }

   }


   public void bind (EObject parent , EStructuralFeature feature , EObject referenceNode , EObject variationNode ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterParentToSetting = null;
      Setting setting = null;
      Object _TmpObject = null;
      ValueHook valueHook = null;
      ValuePrototype valuePrototype = null;
      Iterator<Object> fujaba__IterSettingToOtherValue = null;
      Object otherValue = null;
      String otherStringValue = null;
      String stringValue = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};
         // check object parent is really bound
         if (!( parent != null )) {throw new Exception("SDMException");};

         // check isomorphic binding between objects parent and feature
         if (!( !parent.equals (feature) )) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from parent to setting
         fujaba__Success = false;
         fujaba__IterParentToSetting = Collections.singletonList(((InternalEObject)parent).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterParentToSetting.hasNext () )
         {
            try
            {
               setting = (Setting) fujaba__IterParentToSetting.next ();

               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from setting to feature
               if (!(feature.equals (setting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         _TmpObject = this;

         // ensure correct type and really bound of object valueHook
         if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
         valueHook = (ValueHook) _TmpObject;

         _TmpObject = referenceNode;

         // ensure correct type and really bound of object valuePrototype
         if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
         valuePrototype = (ValuePrototype) _TmpObject;

         // check object setting is really bound
         if (!( setting != null )) {throw new Exception("SDMException");};
         // iterate to-many link value from setting to otherValue
         fujaba__Success = false;
         fujaba__IterSettingToOtherValue = (setting.getEStructuralFeature().isMany() ? (EList<Object>)setting.get(true) : Collections.singletonList(setting.get(true))).iterator ();

         while ( !(fujaba__Success) && fujaba__IterSettingToOtherValue.hasNext () )
         {
            try
            {
               otherValue = (Object) fujaba__IterSettingToOtherValue.next ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!fujaba__Success)
         {
            fujaba__Success = true;
            otherValue = null;
         }
         // collabStat call
         otherStringValue = otherValue != null ? otherValue.toString() : "";
         // collabStat call
         stringValue = "";
         // collabStat call
         if ( valueHook.getBeginIndex() != -1 && valueHook.getBeginIndex() < otherStringValue.length() )
         {
         stringValue = stringValue + otherStringValue.substring(0, valueHook.getBeginIndex());
         }
         // collabStat call
         stringValue = stringValue + valuePrototype.getValue();
         // collabStat call
         if ( valueHook.getEndIndex() != -1 && valueHook.getEndIndex() < otherStringValue.length() )
         {
         stringValue = stringValue + otherStringValue.substring(valueHook.getEndIndex() + 1);
         }
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 5
         try 
         {
            fujaba__Success = false; 

            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // check object stringValue is really bound
            if (!( stringValue != null )) {throw new Exception("SDMException");};
            // iterate to-many link value from setting to otherValue
            fujaba__Success = false;
            fujaba__IterSettingToOtherValue = (setting.getEStructuralFeature().isMany() ? (EList<Object>)setting.get(true) : Collections.singletonList(setting.get(true))).iterator ();

            while ( !(fujaba__Success) && fujaba__IterSettingToOtherValue.hasNext () )
            {
               try
               {
                  otherValue = (Object) fujaba__IterSettingToOtherValue.next ();


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!fujaba__Success)
            {
               fujaba__Success = true;
               otherValue = null;
            }
            // create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), stringValue.toString());
            }
            else {
            	__value = stringValue;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = values.indexOf (otherValue) + 1;
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


         // story pattern 6
         try 
         {
            fujaba__Success = false; 

            // collabStat call
            if ( feature.isMany() )
            {
             ((EList<Object>)setting.get(true)).remove(otherValue);
            }
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern 3
         try 
         {
            fujaba__Success = false; 

            // check object referenceNode is really bound
            if (!( referenceNode != null )) {throw new Exception("SDMException");};
            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // check optional
            if (variationNode != null)
            {

               // disabled isomorphic binding check between EObjects variationNode and referenceNode"

               // check link value from setting to variationNode
               if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).contains(variationNode) : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

            }// create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), referenceNode.toString());
            }
            else {
            	__value = referenceNode;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = values.indexOf (variationNode) + 1;
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            // collabStat call
            org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsReplacement(referenceNode, variationNode);
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern 4
         try 
         {
            fujaba__Success = false; 

            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // check object variationNode is really bound
            if (!( variationNode != null )) {throw new Exception("SDMException");};
            // check link value from setting to variationNode
            if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).contains(variationNode) : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

            // destroy link
            if (setting.getEStructuralFeature().isMany()) {
                ((EList<Object>)setting.get(true)).remove(variationNode);
            }
            else {
                setting.set(null);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      return ;

   }


   public void compose (ReferencePoint rp , EObject variationNode , EObject referenceNode , ComposedFragment result , EList<EObject> context ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterReferenceNodeToOtherSetting = null;
      Setting otherSetting = null;
      EStructuralFeature feature = null;
      EStructuralFeature varFeature = null;
      Object _TmpObject = null;
      EReference reference = null;
      EObject container = null;
      Iterator<?> fujaba__IterVariationNodeToSetting = null;
      Setting setting = null;
      Hook hook = null;
      Iterator<?> fujaba__IterVariationNodeToReference = null;
      Iterator<?> fujaba__IterReferenceNodeToReferenceContainer = null;
      EObject referenceContainer = null;
      Iterator<?> fujaba__IterVariationNodeToContainer = null;
      EObject node = null;
      Fragment fragment = null;
      CompositionInterface ci = null;
      HeterogeneousPort heteroPort = null;
      HomogeneousPort homoPort = null;
      int fujabaIndex = 0;
      Iterator<?> fujaba__IterValueToReferenceContainer = null;
      EObject prevNode2 = null;
      Iterator<Object> fujaba__IterOtherSettingToValue = null;
      EObject value = null;
      ValuePrototype valuePrototype = null;
      EReference varReference = null;
      EObject prevNode = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // check object referenceNode is really bound
         if (!( referenceNode != null )) {throw new Exception("SDMException");};
         // check object rp is really bound
         if (!( rp != null )) {throw new Exception("SDMException");};
         // bind object
         feature = this.getVarTypedEStructuralFeature ();

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};


         // check isomorphic binding between objects referenceNode and feature
         if (!( !referenceNode.equals (feature) )) {throw new Exception("SDMException");};

         // check link varTypedEStructuralFeature from rp to feature
         if (!(feature.equals (rp.getVarTypedEStructuralFeature ()))) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from referenceNode to otherSetting
         fujaba__Success = false;
         fujaba__IterReferenceNodeToOtherSetting = Collections.singletonList(((InternalEObject)referenceNode).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterReferenceNodeToOtherSetting.hasNext () )
         {
            try
            {
               otherSetting = (Setting) fujaba__IterReferenceNodeToOtherSetting.next ();

               // check object otherSetting is really bound
               if (!( otherSetting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from otherSetting to feature
               if (!(feature.equals (otherSetting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 1.2
         try 
         {
            fujaba__Success = false; 

            varFeature = feature;

            // check object varFeature is really bound
            if (!( varFeature != null )) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern 1.1
         try 
         {
            fujaba__Success = false; 

            // check object referenceNode is really bound
            if (!( referenceNode != null )) {throw new Exception("SDMException");};
            // check object rp is really bound
            if (!( rp != null )) {throw new Exception("SDMException");};
            // bind object
            feature = rp.getVarTypedEStructuralFeature ();

            // check object feature is really bound
            if (!( feature != null )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects referenceNode and feature
            if (!( !referenceNode.equals (feature) )) {throw new Exception("SDMException");};

            // bind object
            varFeature = this.getVarTypedEStructuralFeature ();

            // check object varFeature is really bound
            if (!( varFeature != null )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects varFeature and feature
            if (!( !varFeature.equals (feature) )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects varFeature and referenceNode
            if (!( !varFeature.equals (referenceNode) )) {throw new Exception("SDMException");};


            // iterate to-many link eSettings from referenceNode to otherSetting
            fujaba__Success = false;
            fujaba__IterReferenceNodeToOtherSetting = Collections.singletonList(((InternalEObject)referenceNode).eSetting(feature)).iterator();
            while ( !(fujaba__Success) && fujaba__IterReferenceNodeToOtherSetting.hasNext () )
            {
               try
               {
                  otherSetting = (Setting) fujaba__IterReferenceNodeToOtherSetting.next ();

                  // check object otherSetting is really bound
                  if (!( otherSetting != null )) {throw new Exception("SDMException");};
                  // check link eStructuralFeature from otherSetting to feature
                  if (!(feature.equals (otherSetting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (!fujaba__Success)
         {
            // story pattern 2
            try 
            {
               fujaba__Success = false; 

               // bind object
               varFeature = this.getVarTypedEStructuralFeature ();

               // check object varFeature is really bound
               if (!( varFeature != null )) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (!fujaba__Success)
            {
               // story pattern 3
               try 
               {
                  fujaba__Success = false; 

                  // check object referenceNode is really bound
                  if (!( referenceNode != null )) {throw new Exception("SDMException");};
                  // check object rp is really bound
                  if (!( rp != null )) {throw new Exception("SDMException");};
                  // bind object
                  feature = rp.getVarTypedEStructuralFeature ();

                  // check object feature is really bound
                  if (!( feature != null )) {throw new Exception("SDMException");};


                  // check isomorphic binding between objects referenceNode and feature
                  if (!( !referenceNode.equals (feature) )) {throw new Exception("SDMException");};

                  // iterate to-many link eSettings from referenceNode to otherSetting
                  fujaba__Success = false;
                  fujaba__IterReferenceNodeToOtherSetting = Collections.singletonList(((InternalEObject)referenceNode).eSetting(feature)).iterator();
                  while ( !(fujaba__Success) && fujaba__IterReferenceNodeToOtherSetting.hasNext () )
                  {
                     try
                     {
                        otherSetting = (Setting) fujaba__IterReferenceNodeToOtherSetting.next ();

                        // check object otherSetting is really bound
                        if (!( otherSetting != null )) {throw new Exception("SDMException");};
                        // check link eStructuralFeature from otherSetting to feature
                        if (!(feature.equals (otherSetting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (!fujaba__Success)
               {
                  // story pattern 4
                  try 
                  {
                     fujaba__Success = false; 

                     // check object variationNode is really bound
                     if (!( variationNode != null )) {throw new Exception("SDMException");};
                     // iterate to-many link $link.InstanceOf.Name from variationNode to setting
                     fujaba__Success = false;
                     _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(context).get(variationNode);
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterVariationNodeToSetting = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterVariationNodeToSetting = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterVariationNodeToSetting = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( fujaba__IterVariationNodeToSetting.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterVariationNodeToSetting.next ();

                           // ensure correct type and really bound of object setting
                           if (!( _TmpObject instanceof Setting )) {throw new Exception("SDMException");};
                           setting = (Setting) _TmpObject;

                           // bind object
                           container = setting.getEObject ();

                           // check object container is really bound
                           if (!( container != null )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects variationNode and container"

                           // bind object
                           _TmpObject = setting.getEStructuralFeature ();

                           // ensure correct type and really bound of object reference
                           if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                           reference = (EReference) _TmpObject;



                           // check isomorphic binding between objects reference and container
                           if (!( !reference.equals (container) )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects variationNode and reference
                           if (!( !variationNode.equals (reference) )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isChangeable () == true )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isContainment () == false )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isDerived () == false )) {throw new Exception("SDMException");};

                           // collabStat call
                           basicCompose(container, reference, referenceNode, variationNode);



                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  // story pattern 5
                  try 
                  {
                     fujaba__Success = false; 

                     _TmpObject = this;

                     // ensure correct type and really bound of object hook
                     if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                     hook = (Hook) _TmpObject;

                     // check object referenceNode is really bound
                     if (!( referenceNode != null )) {throw new Exception("SDMException");};
                     // check object variationNode is really bound
                     if (!( variationNode != null )) {throw new Exception("SDMException");};

                     // disabled isomorphic binding check between EObjects variationNode and referenceNode"

                     // iterate to-many link $link.InstanceOf.Name from variationNode to container
                     fujaba__Success = false;
                     _TmpObject = ((InternalEObject) variationNode).eContainer();
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterVariationNodeToContainer = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterVariationNodeToContainer = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterVariationNodeToContainer = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( !(fujaba__Success) && fujaba__IterVariationNodeToContainer.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterVariationNodeToContainer.next ();

                           // ensure correct type and really bound of object container
                           if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                           container = (EObject) _TmpObject;


                           // disabled isomorphic binding check between EObjects referenceNode and container"


                           // disabled isomorphic binding check between EObjects variationNode and container"

                           // iterate to-many link $link.InstanceOf.Name from referenceNode to referenceContainer
                           fujaba__Success = false;
                           _TmpObject = ((InternalEObject) referenceNode).eContainer();
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterReferenceNodeToReferenceContainer = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterReferenceNodeToReferenceContainer = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterReferenceNodeToReferenceContainer = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterReferenceNodeToReferenceContainer.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterReferenceNodeToReferenceContainer.next ();

                                 // ensure correct type and really bound of object referenceContainer
                                 if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                 referenceContainer = (EObject) _TmpObject;


                                 // disabled isomorphic binding check between EObjects referenceContainer and container"


                                 // disabled isomorphic binding check between EObjects referenceNode and referenceContainer"


                                 // disabled isomorphic binding check between EObjects variationNode and referenceContainer"

                                 // iterate to-many link $link.InstanceOf.Name from variationNode to reference
                                 fujaba__Success = false;
                                 _TmpObject = ((InternalEObject) variationNode).eContainingFeature();
                                 if (_TmpObject instanceof Iterator<?>) {
                                     fujaba__IterVariationNodeToReference = (Iterator<?>)_TmpObject;    
                                 }
                                 else if (_TmpObject instanceof Iterable<?>) {
                                     fujaba__IterVariationNodeToReference = ((Iterable<?>)_TmpObject).iterator();
                                 }
                                 else {
                                     fujaba__IterVariationNodeToReference = Collections.singletonList(_TmpObject).iterator();
                                 }
                                 while ( !(fujaba__Success) && fujaba__IterVariationNodeToReference.hasNext () )
                                 {
                                    try
                                    {
                                       _TmpObject =  fujaba__IterVariationNodeToReference.next ();

                                       // ensure correct type and really bound of object reference
                                       if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                                       reference = (EReference) _TmpObject;


                                       // check isomorphic binding between objects reference and container
                                       if (!( !reference.equals (container) )) {throw new Exception("SDMException");};


                                       // check isomorphic binding between objects referenceContainer and reference
                                       if (!( !referenceContainer.equals (reference) )) {throw new Exception("SDMException");};


                                       // check isomorphic binding between objects referenceNode and reference
                                       if (!( !referenceNode.equals (reference) )) {throw new Exception("SDMException");};


                                       // check isomorphic binding between objects variationNode and reference
                                       if (!( !variationNode.equals (reference) )) {throw new Exception("SDMException");};

                                       // attribute condition
                                       if (!( reference.isContainment () == true )) {throw new Exception("SDMException");};


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};
                     // collabStat call
                     org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsRemovedFrom(referenceNode,  ((InternalEObject)referenceContainer).eSetting(referenceNode.eContainmentFeature()));
                     // collabStat call
                     basicCompose(container, reference, referenceNode, variationNode);
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  if (fujaba__Success)
                  {

                  }
                  else
                  {
                     // story pattern 6
                     try 
                     {
                        fujaba__Success = false; 

                        _TmpObject = this;

                        // ensure correct type and really bound of object hook
                        if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                        hook = (Hook) _TmpObject;

                        // check object referenceNode is really bound
                        if (!( referenceNode != null )) {throw new Exception("SDMException");};
                        // check object result is really bound
                        if (!( result != null )) {throw new Exception("SDMException");};
                        // bind object
                        heteroPort = hook.getHeterogeneousPort ();

                        // check object heteroPort is really bound
                        if (!( heteroPort != null )) {throw new Exception("SDMException");};

                        // bind object
                        ci = heteroPort.getCompositionInterface ();

                        // check object ci is really bound
                        if (!( ci != null )) {throw new Exception("SDMException");};

                        // bind object
                        fragment = ci.getFragment ();

                        // check object fragment is really bound
                        if (!( fragment != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects result and fragment
                        if (!( !result.equals (fragment) )) {throw new Exception("SDMException");};

                        // bind object
                        node = hook.getVarTypedEObject ();

                        // check object node is really bound
                        if (!( node != null )) {throw new Exception("SDMException");};


                        // disabled isomorphic binding check between EObjects referenceNode and node"

                        // check link contents from fragment to node
                        if (!(fragment.getContents ().contains (node))) {throw new Exception("SDMException");};





                        // create link
                        result.getContents().add(referenceNode);

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        // story pattern 7
                        try 
                        {
                           fujaba__Success = false; 

                           _TmpObject = this;

                           // ensure correct type and really bound of object hook
                           if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                           hook = (Hook) _TmpObject;

                           // check object referenceNode is really bound
                           if (!( referenceNode != null )) {throw new Exception("SDMException");};
                           // check object result is really bound
                           if (!( result != null )) {throw new Exception("SDMException");};
                           // bind object
                           node = hook.getVarTypedEObject ();

                           // check object node is really bound
                           if (!( node != null )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects referenceNode and node"

                           // bind object
                           heteroPort = hook.getHeterogeneousPort ();

                           // check object heteroPort is really bound
                           if (!( heteroPort != null )) {throw new Exception("SDMException");};

                           // bind object
                           homoPort = heteroPort.getHomogenousPort ();

                           // check object homoPort is really bound
                           if (!( homoPort != null )) {throw new Exception("SDMException");};

                           // bind object
                           ci = homoPort.getCompositionInterface ();

                           // check object ci is really bound
                           if (!( ci != null )) {throw new Exception("SDMException");};

                           // bind object
                           fragment = ci.getFragment ();

                           // check object fragment is really bound
                           if (!( fragment != null )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects result and fragment
                           if (!( !result.equals (fragment) )) {throw new Exception("SDMException");};

                           // check link contents from fragment to node
                           if (!(fragment.getContents ().contains (node))) {throw new Exception("SDMException");};






                           // create link
                           result.getContents().add(referenceNode);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }

                  }
                  // story pattern 8
                  try 
                  {
                     fujaba__Success = false; 

                     // attribute condition
                     if (!( "bind".equals(this.getMode ()) )) {throw new Exception("SDMException");};

                     // collabStat call
                     org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsReplacement(referenceNode, variationNode);
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  return ;

               }

               // story pattern 3.1
               try 
               {
                  fujaba__Success = false; 

                  // check object otherSetting is really bound
                  if (!( otherSetting != null )) {throw new Exception("SDMException");};
                  // iterate to-many link value from otherSetting to value
                  fujaba__Success = false;
                  fujaba__IterOtherSettingToValue = new ArrayList<Object>((otherSetting.getEStructuralFeature().isMany() ? (EList<Object>)otherSetting.get(true) : Collections.singletonList(otherSetting.get(true)))).iterator ();

                  while ( fujaba__IterOtherSettingToValue.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterOtherSettingToValue.next ();

                        // ensure correct type and really bound of object value
                        if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                        value = (EObject) _TmpObject;

                        // story pattern 3.2
                        try 
                        {
                           fujaba__Success = false; 

                           // check object setting is really bound
                           if (!( setting != null )) {throw new Exception("SDMException");};
                           // check object variationNode is really bound
                           if (!( variationNode != null )) {throw new Exception("SDMException");};
                           // bind object
                           container = setting.getEObject ();

                           // check object container is really bound
                           if (!( container != null )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects variationNode and container"

                           // bind object
                           _TmpObject = setting.getEStructuralFeature ();

                           // ensure correct type and really bound of object reference
                           if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                           reference = (EReference) _TmpObject;



                           // check isomorphic binding between objects reference and container
                           if (!( !reference.equals (container) )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects variationNode and reference
                           if (!( !variationNode.equals (reference) )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isChangeable () == true )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isContainment () == false )) {throw new Exception("SDMException");};

                           // attribute condition
                           if (!( reference.isDerived () == false )) {throw new Exception("SDMException");};

                           // check path expresion org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(context).get(variationNode) from variationNode to setting
                           // iterate to-many link $link.InstanceOf.Name from variationNode to setting
                           fujaba__Success = false;
                           _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(context).get(variationNode);
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterVariationNodeToSetting = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterVariationNodeToSetting = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterVariationNodeToSetting = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterVariationNodeToSetting.hasNext () )
                           {
                              try
                              {
                                 if (!( setting.equals (fujaba__IterVariationNodeToSetting.next ()) )) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // story pattern 3.2.1
                           try 
                           {
                              fujaba__Success = false; 

                              // check object otherSetting is really bound
                              if (!( otherSetting != null )) {throw new Exception("SDMException");};
                              // check object value is really bound
                              if (!( value != null )) {throw new Exception("SDMException");};
                              fujabaIndex = 0;
                              if (!((fujabaIndex >= 0) && (fujabaIndex < (otherSetting.getEStructuralFeature().isMany() ? ((EList<Object>)otherSetting.get(true)).size() : 0)))) {throw new Exception("SDMException");};
                              // check link value from otherSetting to value
                              if (!(otherSetting.getEStructuralFeature().isMany() ? ((EList<Object>)otherSetting.get(true)).indexOf(value) == 0 : otherSetting.get(true).equals(value))) {throw new Exception("SDMException");};

                              // collabStat call
                              basicCompose(container, reference, value, variationNode);
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           if (fujaba__Success)
                           {

                           }
                           else
                           {
                              // story pattern 3.2.2
                              try 
                              {
                                 fujaba__Success = false; 

                                 // collabStat call
                                 append(container, reference, value, prevNode);
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                           }


                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.3
                        try 
                        {
                           fujaba__Success = false; 

                           _TmpObject = this;

                           // ensure correct type and really bound of object hook
                           if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                           hook = (Hook) _TmpObject;

                           // check object variationNode is really bound
                           if (!( variationNode != null )) {throw new Exception("SDMException");};
                           // iterate to-many link $link.InstanceOf.Name from variationNode to container
                           fujaba__Success = false;
                           _TmpObject = ((InternalEObject) variationNode).eContainer();
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterVariationNodeToContainer = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterVariationNodeToContainer = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterVariationNodeToContainer = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterVariationNodeToContainer.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterVariationNodeToContainer.next ();

                                 // ensure correct type and really bound of object container
                                 if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                 container = (EObject) _TmpObject;


                                 // disabled isomorphic binding check between EObjects variationNode and container"

                                 // iterate to-many link $link.InstanceOf.Name from variationNode to reference
                                 fujaba__Success = false;
                                 _TmpObject = ((InternalEObject) variationNode).eContainingFeature();
                                 if (_TmpObject instanceof Iterator<?>) {
                                     fujaba__IterVariationNodeToReference = (Iterator<?>)_TmpObject;    
                                 }
                                 else if (_TmpObject instanceof Iterable<?>) {
                                     fujaba__IterVariationNodeToReference = ((Iterable<?>)_TmpObject).iterator();
                                 }
                                 else {
                                     fujaba__IterVariationNodeToReference = Collections.singletonList(_TmpObject).iterator();
                                 }
                                 while ( !(fujaba__Success) && fujaba__IterVariationNodeToReference.hasNext () )
                                 {
                                    try
                                    {
                                       _TmpObject =  fujaba__IterVariationNodeToReference.next ();

                                       // ensure correct type and really bound of object reference
                                       if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                                       reference = (EReference) _TmpObject;


                                       // check isomorphic binding between objects reference and container
                                       if (!( !reference.equals (container) )) {throw new Exception("SDMException");};


                                       // check isomorphic binding between objects variationNode and reference
                                       if (!( !variationNode.equals (reference) )) {throw new Exception("SDMException");};

                                       // attribute condition
                                       if (!( reference.isContainment () == true )) {throw new Exception("SDMException");};


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        if (fujaba__Success)
                        {
                           // story pattern 
                           try 
                           {
                              fujaba__Success = false; 

                              // check object value is really bound
                              if (!( value != null )) {throw new Exception("SDMException");};
                              // iterate to-many link $link.InstanceOf.Name from value to referenceContainer
                              fujaba__Success = false;
                              _TmpObject = ((InternalEObject) value).eContainer();
                              if (_TmpObject instanceof Iterator<?>) {
                                  fujaba__IterValueToReferenceContainer = (Iterator<?>)_TmpObject;    
                              }
                              else if (_TmpObject instanceof Iterable<?>) {
                                  fujaba__IterValueToReferenceContainer = ((Iterable<?>)_TmpObject).iterator();
                              }
                              else {
                                  fujaba__IterValueToReferenceContainer = Collections.singletonList(_TmpObject).iterator();
                              }
                              while ( !(fujaba__Success) && fujaba__IterValueToReferenceContainer.hasNext () )
                              {
                                 try
                                 {
                                    _TmpObject =  fujaba__IterValueToReferenceContainer.next ();

                                    // ensure correct type and really bound of object referenceContainer
                                    if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                    referenceContainer = (EObject) _TmpObject;


                                    // disabled isomorphic binding check between EObjects value and referenceContainer"


                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};
                              // collabStat call
                              org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsRemovedFrom(value, ((InternalEObject)referenceContainer).eSetting(value.eContainmentFeature()));
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           // story pattern 3.3.1
                           try 
                           {
                              fujaba__Success = false; 

                              // check object prevNode2 is really bound
                              if (!( prevNode2 != null )) {throw new Exception("SDMException");};
                              // collabStat call
                              append(container, reference, value, prevNode2);
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           if (fujaba__Success)
                           {

                           }
                           else
                           {
                              // story pattern 3.3.2
                              try 
                              {
                                 fujaba__Success = false; 

                                 // collabStat call
                                 basicCompose(container, reference, value, variationNode);
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                           }

                        }
                        else
                        {

                        }
                        // story pattern 3.4
                        try 
                        {
                           fujaba__Success = false; 

                           _TmpObject = this;

                           // ensure correct type and really bound of object hook
                           if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                           hook = (Hook) _TmpObject;

                           // check object value is really bound
                           if (!( value != null )) {throw new Exception("SDMException");};

                           // check isomorphic binding between objects this and hook
                           if (!( !this.equals (hook) )) {throw new Exception("SDMException");};

                           // bind object
                           heteroPort = this.getHeterogeneousPort ();

                           // check object heteroPort is really bound
                           if (!( heteroPort != null )) {throw new Exception("SDMException");};

                           // bind object
                           ci = heteroPort.getCompositionInterface ();

                           // check object ci is really bound
                           if (!( ci != null )) {throw new Exception("SDMException");};

                           // bind object
                           fragment = ci.getFragment ();

                           // check object fragment is really bound
                           if (!( fragment != null )) {throw new Exception("SDMException");};

                           // bind object
                           node = hook.getVarTypedEObject ();

                           // check object node is really bound
                           if (!( node != null )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects value and node"

                           // check link contents from fragment to node
                           if (!(fragment.getContents ().contains (node))) {throw new Exception("SDMException");};





                           // create link
                           fragment.getContents().add(value);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        if (fujaba__Success)
                        {

                        }
                        else
                        {
                           // story pattern 3.5
                           try 
                           {
                              fujaba__Success = false; 

                              _TmpObject = this;

                              // ensure correct type and really bound of object hook
                              if (!( _TmpObject instanceof Hook )) {throw new Exception("SDMException");};
                              hook = (Hook) _TmpObject;

                              // check object value is really bound
                              if (!( value != null )) {throw new Exception("SDMException");};

                              // check isomorphic binding between objects this and hook
                              if (!( !this.equals (hook) )) {throw new Exception("SDMException");};

                              // bind object
                              node = hook.getVarTypedEObject ();

                              // check object node is really bound
                              if (!( node != null )) {throw new Exception("SDMException");};


                              // disabled isomorphic binding check between EObjects value and node"

                              // bind object
                              heteroPort = this.getHeterogeneousPort ();

                              // check object heteroPort is really bound
                              if (!( heteroPort != null )) {throw new Exception("SDMException");};

                              // bind object
                              homoPort = heteroPort.getHomogenousPort ();

                              // check object homoPort is really bound
                              if (!( homoPort != null )) {throw new Exception("SDMException");};

                              // bind object
                              ci = homoPort.getCompositionInterface ();

                              // check object ci is really bound
                              if (!( ci != null )) {throw new Exception("SDMException");};

                              // bind object
                              fragment = ci.getFragment ();

                              // check object fragment is really bound
                              if (!( fragment != null )) {throw new Exception("SDMException");};

                              // check link contents from fragment to node
                              if (!(fragment.getContents ().contains (node))) {throw new Exception("SDMException");};






                              // create link
                              fragment.getContents().add(value);

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }


                        }
                        // story pattern 3.6
                        try 
                        {
                           fujaba__Success = false; 

                           // attribute condition
                           if (!( "bind".equals(this.getMode ()) )) {throw new Exception("SDMException");};

                           // collabStat call
                           org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsReplacement(referenceNode, variationNode);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        // story pattern 3.7
                        try 
                        {
                           fujaba__Success = false; 

                           prevNode2 = value;

                           // check object prevNode2 is really bound
                           if (!( prevNode2 != null )) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               return ;

            }
            // story pattern 2.1
            try 
            {
               fujaba__Success = false; 

               _TmpObject = rp;

               // ensure correct type and really bound of object valuePrototype
               if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
               valuePrototype = (ValuePrototype) _TmpObject;

               // collabStat call
               basicCompose(variationNode, varFeature, valuePrototype, null);
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern 
               try 
               {
                  fujaba__Success = false; 

                  _TmpObject = varFeature;

                  // ensure correct type and really bound of object varReference
                  if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                  varReference = (EReference) _TmpObject;

                  // check object referenceNode is really bound
                  if (!( referenceNode != null )) {throw new Exception("SDMException");};

                  // check isomorphic binding between objects varReference and referenceNode
                  if (!( !varReference.equals (referenceNode) )) {throw new Exception("SDMException");};

                  // attribute condition
                  if (!( varReference.isContainment () == true )) {throw new Exception("SDMException");};

                  // iterate to-many link $link.InstanceOf.Name from referenceNode to referenceContainer
                  fujaba__Success = false;
                  _TmpObject = ((InternalEObject) referenceNode).eContainer();
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterReferenceNodeToReferenceContainer = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterReferenceNodeToReferenceContainer = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterReferenceNodeToReferenceContainer = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( !(fujaba__Success) && fujaba__IterReferenceNodeToReferenceContainer.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterReferenceNodeToReferenceContainer.next ();

                        // ensure correct type and really bound of object referenceContainer
                        if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                        referenceContainer = (EObject) _TmpObject;


                        // disabled isomorphic binding check between EObjects referenceNode and referenceContainer"


                        // check isomorphic binding between objects varReference and referenceContainer
                        if (!( !varReference.equals (referenceContainer) )) {throw new Exception("SDMException");};


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  // collabStat call
                  org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsRemovedFrom(referenceNode, ((InternalEObject)referenceContainer).eSetting(referenceNode.eContainmentFeature()));
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               // story pattern 2.2
               try 
               {
                  fujaba__Success = false; 

                  // collabStat call
                  basicCompose(variationNode, varFeature, referenceNode, null);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            return ;

         }

      }
      // story pattern 1.3
      try 
      {
         fujaba__Success = false; 

         // check object otherSetting is really bound
         if (!( otherSetting != null )) {throw new Exception("SDMException");};
         // iterate to-many link value from otherSetting to value
         fujaba__Success = false;
         fujaba__IterOtherSettingToValue = new ArrayList<Object>((otherSetting.getEStructuralFeature().isMany() ? (EList<Object>)otherSetting.get(true) : Collections.singletonList(otherSetting.get(true)))).iterator ();

         while ( fujaba__IterOtherSettingToValue.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterOtherSettingToValue.next ();

               // ensure correct type and really bound of object value
               if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
               value = (EObject) _TmpObject;

               // story pattern 
               try 
               {
                  fujaba__Success = false; 

                  _TmpObject = varFeature;

                  // ensure correct type and really bound of object varReference
                  if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                  varReference = (EReference) _TmpObject;

                  // check object value is really bound
                  if (!( value != null )) {throw new Exception("SDMException");};

                  // check isomorphic binding between objects varReference and value
                  if (!( !varReference.equals (value) )) {throw new Exception("SDMException");};

                  // attribute condition
                  if (!( varReference.isContainment () == true )) {throw new Exception("SDMException");};

                  // iterate to-many link $link.InstanceOf.Name from value to referenceContainer
                  fujaba__Success = false;
                  _TmpObject = ((InternalEObject) value).eContainer();
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterValueToReferenceContainer = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterValueToReferenceContainer = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterValueToReferenceContainer = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( !(fujaba__Success) && fujaba__IterValueToReferenceContainer.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterValueToReferenceContainer.next ();

                        // ensure correct type and really bound of object referenceContainer
                        if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                        referenceContainer = (EObject) _TmpObject;


                        // disabled isomorphic binding check between EObjects value and referenceContainer"


                        // check isomorphic binding between objects varReference and referenceContainer
                        if (!( !varReference.equals (referenceContainer) )) {throw new Exception("SDMException");};


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  // collabStat call
                  org.reuseware.coconut.fragment.util.SyncEcoreUtil.markAsRemovedFrom(value, ((InternalEObject)referenceContainer).eSetting(value.eContainmentFeature()));
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               // story pattern 1.4
               try 
               {
                  fujaba__Success = false; 

                  // check object prevNode is really bound
                  if (!( prevNode != null )) {throw new Exception("SDMException");};
                  // collabStat call
                  append(variationNode, varFeature, value, prevNode);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (fujaba__Success)
               {

               }
               else
               {
                  // story pattern 1.5
                  try 
                  {
                     fujaba__Success = false; 

                     // collabStat call
                     basicCompose(variationNode, varFeature, value, null);
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }


               }
               // story pattern 1.6
               try 
               {
                  fujaba__Success = false; 

                  prevNode = value;

                  // check object prevNode is really bound
                  if (!( prevNode != null )) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void extend (EObject parent , EStructuralFeature feature , EObject referenceNode , EObject variationNode ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterParentToSetting = null;
      Setting setting = null;
      Object _TmpObject = null;
      ValueHook valueHook = null;
      int fujabaIndex = 0;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};
         // check object parent is really bound
         if (!( parent != null )) {throw new Exception("SDMException");};

         // check isomorphic binding between objects parent and feature
         if (!( !parent.equals (feature) )) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from parent to setting
         fujaba__Success = false;
         fujaba__IterParentToSetting = Collections.singletonList(((InternalEObject)parent).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterParentToSetting.hasNext () )
         {
            try
            {
               setting = (Setting) fujaba__IterParentToSetting.next ();

               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from setting to feature
               if (!(feature.equals (setting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // attribute condition
         if (!( "prepend".equals(this.getMode ()) )) {throw new Exception("SDMException");};

         // collabStat call
         prepend(parent, feature, referenceNode, variationNode);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return ;

      }
      else
      {
         // story pattern 3
         try 
         {
            fujaba__Success = false; 

            // attribute condition
            if (!( "append".equals(this.getMode ()) )) {throw new Exception("SDMException");};

            // collabStat call
            append(parent, feature, referenceNode, variationNode);
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            return ;

         }
         else
         {
            // story pattern 4
            try 
            {
               fujaba__Success = false; 

               _TmpObject = this;

               // ensure correct type and really bound of object valueHook
               if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
               valueHook = (ValueHook) _TmpObject;

               // attribute condition
               if (!( valueHook.getListIndex () == 0 )) {throw new Exception("SDMException");};

               // collabStat call
               prepend(parent, feature, referenceNode, variationNode);
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern 5
               try 
               {
                  fujaba__Success = false; 

                  // check object setting is really bound
                  if (!( setting != null )) {throw new Exception("SDMException");};
                  // check object variationNode is really bound
                  if (!( variationNode != null )) {throw new Exception("SDMException");};
                  fujabaIndex = 0;
                  if (!((fujabaIndex >= 0) && (fujabaIndex < (setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).size() : 0)))) {throw new Exception("SDMException");};
                  // check link value from setting to variationNode
                  if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).indexOf(variationNode) == 0 : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

                  // collabStat call
                  prepend(parent, feature, referenceNode, variationNode);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (fujaba__Success)
               {

               }
               else
               {
                  // story pattern 7
                  try 
                  {
                     fujaba__Success = false; 

                     // collabStat call
                     append(parent, feature, referenceNode, variationNode);
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }


               }

            }
            return ;

         }

      }

   }


   public void prepend (EObject parent , EStructuralFeature feature , EObject referenceNode , EObject variationNode ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterParentToSetting = null;
      Setting setting = null;
      Object _TmpObject = null;
      ValueHook valueHook = null;
      ValuePrototype valuePrototype = null;
      Object value = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};
         // check object parent is really bound
         if (!( parent != null )) {throw new Exception("SDMException");};

         // check isomorphic binding between objects parent and feature
         if (!( !parent.equals (feature) )) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from parent to setting
         fujaba__Success = false;
         fujaba__IterParentToSetting = Collections.singletonList(((InternalEObject)parent).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterParentToSetting.hasNext () )
         {
            try
            {
               setting = (Setting) fujaba__IterParentToSetting.next ();

               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from setting to feature
               if (!(feature.equals (setting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         _TmpObject = this;

         // ensure correct type and really bound of object valueHook
         if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
         valueHook = (ValueHook) _TmpObject;

         _TmpObject = referenceNode;

         // ensure correct type and really bound of object valuePrototype
         if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
         valuePrototype = (ValuePrototype) _TmpObject;

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 5
         try 
         {
            fujaba__Success = false; 

            _TmpObject = valuePrototype.getValue();

            // ensure correct type and really bound of object value
            if (!( _TmpObject instanceof Object )) {throw new Exception("SDMException");};
            value = (Object) _TmpObject;

            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), value.toString());
            }
            else {
            	__value = value;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = valueHook.getListIndex();
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern 3
         try 
         {
            fujaba__Success = false; 

            // check object referenceNode is really bound
            if (!( referenceNode != null )) {throw new Exception("SDMException");};
            // check object setting is really bound
            if (!( setting != null )) {throw new Exception("SDMException");};
            // check object variationNode is really bound
            if (!( variationNode != null )) {throw new Exception("SDMException");};

            // disabled isomorphic binding check between EObjects variationNode and referenceNode"

            // check link value from setting to variationNode
            if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).contains(variationNode) : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

            // create link
            // primitive type conversation if needed
            Object __value;
            if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
            	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), referenceNode.toString());
            }
            else {
            	__value = referenceNode;
            }
            if (setting.getEStructuralFeature().isMany()) {
                EList<Object> values = ((EList<Object>)setting.get(true));
                int idx = values.indexOf (variationNode);
                if (values.size() <= idx) {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(__value);
                		}
                	}
                }
                else {
                	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                	}
                	else {
                		if (__value instanceof String) {
                			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                		}
                		else {
                			values.add(idx, __value);
                		}
                	}
                }
            }
            else {
                setting.set(__value);
            }

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {

         }
         else
         {
            // story pattern 4
            try 
            {
               fujaba__Success = false; 

               // check object referenceNode is really bound
               if (!( referenceNode != null )) {throw new Exception("SDMException");};
               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // create link
               // primitive type conversation if needed
               Object __value;
               if ((setting.getEStructuralFeature() instanceof org.eclipse.emf.ecore.EAttribute)  && !(setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap)) {
               	__value = org.eclipse.emf.ecore.util.EcoreUtil.createFromString((org.eclipse.emf.ecore.EDataType)setting.getEStructuralFeature().getEType(), referenceNode.toString());
               }
               else {
               	__value = referenceNode;
               }
               if (setting.getEStructuralFeature().isMany()) {
                   EList<Object> values = ((EList<Object>)setting.get(true));
                   int idx = 0;
                   if (values.size() <= idx) {
                   	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                   		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), __value.toString()); 
                   	}
                   	else {
                   		if (__value instanceof String) {
                   			values.addAll(Arrays.asList(((String)__value).split("/")));
                   		}
                   		else {
                   			values.add(__value);
                   		}
                   	}
                   }
                   else {
                   	if (setting.get(true) instanceof org.eclipse.emf.ecore.util.FeatureMap) {
                   		org.eclipse.emf.ecore.util.FeatureMapUtil.addText((org.eclipse.emf.ecore.util.FeatureMap)setting.get(true), idx, __value.toString()); 
                   	}
                   	else {
                   		if (__value instanceof String) {
                   			values.addAll(idx, Arrays.asList(((String)__value).split("/")));
                   		}
                   		else {
                   			values.add(idx, __value);
                   		}
                   	}
                   }
               }
               else {
                   setting.set(__value);
               }

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }


         }

      }
      return ;

   }


   public void primitiveCompose (){

   }


   public void remove (EObject parent , EStructuralFeature feature , EObject variationNode ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterParentToSetting = null;
      Setting setting = null;

      // story pattern storypatternwithparams
      try 
      {
         fujaba__Success = false; 

         // check object feature is really bound
         if (!( feature != null )) {throw new Exception("SDMException");};
         // check object parent is really bound
         if (!( parent != null )) {throw new Exception("SDMException");};

         // check isomorphic binding between objects parent and feature
         if (!( !parent.equals (feature) )) {throw new Exception("SDMException");};

         // iterate to-many link eSettings from parent to setting
         fujaba__Success = false;
         fujaba__IterParentToSetting = Collections.singletonList(((InternalEObject)parent).eSetting(feature)).iterator();
         while ( !(fujaba__Success) && fujaba__IterParentToSetting.hasNext () )
         {
            try
            {
               setting = (Setting) fujaba__IterParentToSetting.next ();

               // check object setting is really bound
               if (!( setting != null )) {throw new Exception("SDMException");};
               // check link eStructuralFeature from setting to feature
               if (!(feature.equals (setting.getEStructuralFeature ()))) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // check object setting is really bound
         if (!( setting != null )) {throw new Exception("SDMException");};
         // check object variationNode is really bound
         if (!( variationNode != null )) {throw new Exception("SDMException");};
         // check link value from setting to variationNode
         if (!(setting.getEStructuralFeature().isMany() ? ((EList<Object>)setting.get(true)).contains(variationNode) : setting.get(true).equals(variationNode))) {throw new Exception("SDMException");};

         // attribute condition
         if (!( this.isRemove () == true )) {throw new Exception("SDMException");};

         // destroy link
         if (setting.getEStructuralFeature().isMany()) {
             ((EList<Object>)setting.get(true)).remove(variationNode);
         }
         else {
             setting.set(null);
         }

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public boolean typeMatch (ReferencePoint rp ){
      boolean fujaba__Success = false;
      Fragment fragment = null;
      CompositionInterface ci = null;
      HeterogeneousPort heteroPort = null;
      HomogeneousPort homoPort = null;
      EObject node = null;
      EObject otherNode = null;
      Object _TmpObject = null;
      EReference reference = null;
      EReference otherReference = null;
      EClass type = null;
      EClass otherType = null;
      Iterator<?> fujaba__IterOtherNodeToOtherType = null;
      Iterator<?> fujaba__IterNodeToSetting = null;
      Setting setting = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // bind object
         heteroPort = this.getHeterogeneousPort ();

         // check object heteroPort is really bound
         if (!( heteroPort != null )) {throw new Exception("SDMException");};

         // bind object
         ci = heteroPort.getCompositionInterface ();

         // check object ci is really bound
         if (!( ci != null )) {throw new Exception("SDMException");};

         // bind object
         fragment = ci.getFragment ();

         // check object fragment is really bound
         if (!( fragment != null )) {throw new Exception("SDMException");};




         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            // bind object
            heteroPort = this.getHeterogeneousPort ();

            // check object heteroPort is really bound
            if (!( heteroPort != null )) {throw new Exception("SDMException");};

            // bind object
            homoPort = heteroPort.getHomogenousPort ();

            // check object homoPort is really bound
            if (!( homoPort != null )) {throw new Exception("SDMException");};

            // bind object
            ci = homoPort.getCompositionInterface ();

            // check object ci is really bound
            if (!( ci != null )) {throw new Exception("SDMException");};

            // bind object
            fragment = ci.getFragment ();

            // check object fragment is really bound
            if (!( fragment != null )) {throw new Exception("SDMException");};





            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (!fujaba__Success)
         {
            return false;

         }

      }
      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // check object rp is really bound
         if (!( rp != null )) {throw new Exception("SDMException");};
         // bind object
         _TmpObject = this.getVarTypedEStructuralFeature ();

         // ensure correct type and really bound of object reference
         if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
         reference = (EReference) _TmpObject;


         // check link varTypedEStructuralFeature from rp to reference
         if (!(reference.equals (rp.getVarTypedEStructuralFeature ()))) {throw new Exception("SDMException");};

         // bind object
         otherNode = rp.getVarTypedEObject ();

         // check object otherNode is really bound
         if (!( otherNode != null )) {throw new Exception("SDMException");};


         // check isomorphic binding between objects reference and otherNode
         if (!( !reference.equals (otherNode) )) {throw new Exception("SDMException");};

         // bind object
         node = this.getVarTypedEObject ();

         // check object node is really bound
         if (!( node != null )) {throw new Exception("SDMException");};


         // disabled isomorphic binding check between EObjects otherNode and node"


         // check isomorphic binding between objects reference and node
         if (!( !reference.equals (node) )) {throw new Exception("SDMException");};




         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return true;

      }
      else
      {
         // story pattern 4
         try 
         {
            fujaba__Success = false; 

            // check object rp is really bound
            if (!( rp != null )) {throw new Exception("SDMException");};
            // bind object
            _TmpObject = rp.getVarTypedEStructuralFeature ();

            // ensure correct type and really bound of object otherReference
            if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
            otherReference = (EReference) _TmpObject;


            // bind object
            _TmpObject = this.getVarTypedEStructuralFeature ();

            // ensure correct type and really bound of object reference
            if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
            reference = (EReference) _TmpObject;



            // check isomorphic binding between objects reference and otherReference
            if (!( !reference.equals (otherReference) )) {throw new Exception("SDMException");};

            // bind object
            otherNode = rp.getVarTypedEObject ();

            // check object otherNode is really bound
            if (!( otherNode != null )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects otherReference and otherNode
            if (!( !otherReference.equals (otherNode) )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects reference and otherNode
            if (!( !reference.equals (otherNode) )) {throw new Exception("SDMException");};

            // bind object
            node = this.getVarTypedEObject ();

            // check object node is really bound
            if (!( node != null )) {throw new Exception("SDMException");};


            // disabled isomorphic binding check between EObjects otherNode and node"


            // check isomorphic binding between objects otherReference and node
            if (!( !otherReference.equals (node) )) {throw new Exception("SDMException");};


            // check isomorphic binding between objects reference and node
            if (!( !reference.equals (node) )) {throw new Exception("SDMException");};





            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            // story pattern 4.1
            try 
            {
               fujaba__Success = false; 

               // check object otherReference is really bound
               if (!( otherReference != null )) {throw new Exception("SDMException");};
               // check object reference is really bound
               if (!( reference != null )) {throw new Exception("SDMException");};

               // check isomorphic binding between objects reference and otherReference
               if (!( !reference.equals (otherReference) )) {throw new Exception("SDMException");};

               // bind object
               _TmpObject = otherReference.getEType ();

               // ensure correct type and really bound of object otherType
               if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
               otherType = (EClass) _TmpObject;


               // bind object
               _TmpObject = reference.getEType ();

               // ensure correct type and really bound of object type
               if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
               type = (EClass) _TmpObject;



               // check isomorphic binding between objects type and otherType
               if (!( !type.equals (otherType) )) {throw new Exception("SDMException");};

               // check link eAllSuperTypes from otherType to type
               if (!(!(otherType.getEAllSuperTypes ().contains (type)))) {throw new Exception("SDMException");};



               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {
               return type == org.eclipse.emf.ecore.EcorePackage.Literals.EOBJECT;

            }
            else
            {
               return true;

            }

         }
         else
         {
            // story pattern 5
            try 
            {
               fujaba__Success = false; 

               // check object rp is really bound
               if (!( rp != null )) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = this.getVarTypedEStructuralFeature ();

               // ensure correct type and really bound of object reference
               if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
               reference = (EReference) _TmpObject;


               // bind object
               otherNode = rp.getVarTypedEObject ();

               // check object otherNode is really bound
               if (!( otherNode != null )) {throw new Exception("SDMException");};


               // check isomorphic binding between objects reference and otherNode
               if (!( !reference.equals (otherNode) )) {throw new Exception("SDMException");};

               // bind object
               node = this.getVarTypedEObject ();

               // check object node is really bound
               if (!( node != null )) {throw new Exception("SDMException");};


               // disabled isomorphic binding check between EObjects otherNode and node"


               // check isomorphic binding between objects reference and node
               if (!( !reference.equals (node) )) {throw new Exception("SDMException");};




               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {
               // story pattern 5.1
               try 
               {
                  fujaba__Success = false; 

                  // check object otherNode is really bound
                  if (!( otherNode != null )) {throw new Exception("SDMException");};
                  // check object reference is really bound
                  if (!( reference != null )) {throw new Exception("SDMException");};

                  // check isomorphic binding between objects reference and otherNode
                  if (!( !reference.equals (otherNode) )) {throw new Exception("SDMException");};

                  // bind object
                  _TmpObject = reference.getEType ();

                  // ensure correct type and really bound of object type
                  if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                  type = (EClass) _TmpObject;



                  // check isomorphic binding between objects type and otherNode
                  if (!( !type.equals (otherNode) )) {throw new Exception("SDMException");};

                  // iterate to-many link $link.InstanceOf.Name from otherNode to otherType
                  fujaba__Success = false;
                  _TmpObject = ((InternalEObject) otherNode).eClass();
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterOtherNodeToOtherType = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterOtherNodeToOtherType = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterOtherNodeToOtherType = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( !(fujaba__Success) && fujaba__IterOtherNodeToOtherType.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterOtherNodeToOtherType.next ();

                        // ensure correct type and really bound of object otherType
                        if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                        otherType = (EClass) _TmpObject;


                        // check isomorphic binding between objects otherType and otherNode
                        if (!( !otherType.equals (otherNode) )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects type and otherType
                        if (!( !type.equals (otherType) )) {throw new Exception("SDMException");};

                        // check link eAllSuperTypes from otherType to type
                        if (!(!(otherType.getEAllSuperTypes ().contains (type)))) {throw new Exception("SDMException");};


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (fujaba__Success)
               {
                  return type == org.eclipse.emf.ecore.EcorePackage.Literals.EOBJECT;

               }
               else
               {
                  return true;

               }

            }
            else
            {
               // story pattern 6
               try 
               {
                  fujaba__Success = false; 

                  // check object rp is really bound
                  if (!( rp != null )) {throw new Exception("SDMException");};
                  // bind object
                  _TmpObject = rp.getVarTypedEStructuralFeature ();

                  // ensure correct type and really bound of object otherReference
                  if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                  otherReference = (EReference) _TmpObject;


                  // bind object
                  otherNode = rp.getVarTypedEObject ();

                  // check object otherNode is really bound
                  if (!( otherNode != null )) {throw new Exception("SDMException");};


                  // check isomorphic binding between objects otherReference and otherNode
                  if (!( !otherReference.equals (otherNode) )) {throw new Exception("SDMException");};

                  // bind object
                  node = this.getVarTypedEObject ();

                  // check object node is really bound
                  if (!( node != null )) {throw new Exception("SDMException");};


                  // disabled isomorphic binding check between EObjects otherNode and node"


                  // check isomorphic binding between objects otherReference and node
                  if (!( !otherReference.equals (node) )) {throw new Exception("SDMException");};




                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (fujaba__Success)
               {
                  // story pattern 6.1
                  try 
                  {
                     fujaba__Success = false; 

                     // check object node is really bound
                     if (!( node != null )) {throw new Exception("SDMException");};
                     // check object otherReference is really bound
                     if (!( otherReference != null )) {throw new Exception("SDMException");};

                     // check isomorphic binding between objects otherReference and node
                     if (!( !otherReference.equals (node) )) {throw new Exception("SDMException");};

                     // bind object
                     _TmpObject = otherReference.getEType ();

                     // ensure correct type and really bound of object otherType
                     if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                     otherType = (EClass) _TmpObject;



                     // check isomorphic binding between objects otherType and node
                     if (!( !otherType.equals (node) )) {throw new Exception("SDMException");};

                     // iterate to-many link $link.InstanceOf.Name from node to setting
                     fujaba__Success = false;
                     _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(fragment.getContents()).get(node);
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterNodeToSetting = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterNodeToSetting = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterNodeToSetting = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( !(fujaba__Success) && fujaba__IterNodeToSetting.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterNodeToSetting.next ();

                           // ensure correct type and really bound of object setting
                           if (!( _TmpObject instanceof Setting )) {throw new Exception("SDMException");};
                           setting = (Setting) _TmpObject;

                           // bind object
                           _TmpObject = setting.getEStructuralFeature ();

                           // ensure correct type and really bound of object reference
                           if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                           reference = (EReference) _TmpObject;



                           // check isomorphic binding between objects reference and node
                           if (!( !reference.equals (node) )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects reference and otherReference
                           if (!( !reference.equals (otherReference) )) {throw new Exception("SDMException");};

                           // bind object
                           _TmpObject = reference.getEType ();

                           // ensure correct type and really bound of object type
                           if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                           type = (EClass) _TmpObject;



                           // check isomorphic binding between objects type and node
                           if (!( !type.equals (node) )) {throw new Exception("SDMException");};


                           // check isomorphic binding between objects type and otherType
                           if (!( !type.equals (otherType) )) {throw new Exception("SDMException");};

                           // check link eAllSuperTypes from otherType to type
                           if (!(!(otherType.getEAllSuperTypes ().contains (type)))) {throw new Exception("SDMException");};




                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  if (fujaba__Success)
                  {
                     return type == org.eclipse.emf.ecore.EcorePackage.Literals.EOBJECT;

                  }
                  else
                  {
                     return true;

                  }

               }
               else
               {
                  // story pattern 7
                  try 
                  {
                     fujaba__Success = false; 

                     // check object rp is really bound
                     if (!( rp != null )) {throw new Exception("SDMException");};
                     // bind object
                     otherNode = rp.getVarTypedEObject ();

                     // check object otherNode is really bound
                     if (!( otherNode != null )) {throw new Exception("SDMException");};

                     // bind object
                     node = this.getVarTypedEObject ();

                     // check object node is really bound
                     if (!( node != null )) {throw new Exception("SDMException");};


                     // disabled isomorphic binding check between EObjects otherNode and node"



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  if (fujaba__Success)
                  {
                     // story pattern 7.1
                     try 
                     {
                        fujaba__Success = false; 

                        // check object node is really bound
                        if (!( node != null )) {throw new Exception("SDMException");};
                        // check object otherNode is really bound
                        if (!( otherNode != null )) {throw new Exception("SDMException");};

                        // disabled isomorphic binding check between EObjects otherNode and node"

                        // iterate to-many link $link.InstanceOf.Name from otherNode to otherType
                        fujaba__Success = false;
                        _TmpObject = ((InternalEObject) otherNode).eClass();
                        if (_TmpObject instanceof Iterator<?>) {
                            fujaba__IterOtherNodeToOtherType = (Iterator<?>)_TmpObject;    
                        }
                        else if (_TmpObject instanceof Iterable<?>) {
                            fujaba__IterOtherNodeToOtherType = ((Iterable<?>)_TmpObject).iterator();
                        }
                        else {
                            fujaba__IterOtherNodeToOtherType = Collections.singletonList(_TmpObject).iterator();
                        }
                        while ( !(fujaba__Success) && fujaba__IterOtherNodeToOtherType.hasNext () )
                        {
                           try
                           {
                              _TmpObject =  fujaba__IterOtherNodeToOtherType.next ();

                              // ensure correct type and really bound of object otherType
                              if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                              otherType = (EClass) _TmpObject;


                              // check isomorphic binding between objects otherType and node
                              if (!( !otherType.equals (node) )) {throw new Exception("SDMException");};


                              // check isomorphic binding between objects otherType and otherNode
                              if (!( !otherType.equals (otherNode) )) {throw new Exception("SDMException");};

                              // iterate to-many link $link.InstanceOf.Name from node to setting
                              fujaba__Success = false;
                              _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(fragment.getContents()).get(node);
                              if (_TmpObject instanceof Iterator<?>) {
                                  fujaba__IterNodeToSetting = (Iterator<?>)_TmpObject;    
                              }
                              else if (_TmpObject instanceof Iterable<?>) {
                                  fujaba__IterNodeToSetting = ((Iterable<?>)_TmpObject).iterator();
                              }
                              else {
                                  fujaba__IterNodeToSetting = Collections.singletonList(_TmpObject).iterator();
                              }
                              while ( !(fujaba__Success) && fujaba__IterNodeToSetting.hasNext () )
                              {
                                 try
                                 {
                                    _TmpObject =  fujaba__IterNodeToSetting.next ();

                                    // ensure correct type and really bound of object setting
                                    if (!( _TmpObject instanceof Setting )) {throw new Exception("SDMException");};
                                    setting = (Setting) _TmpObject;

                                    // bind object
                                    _TmpObject = setting.getEStructuralFeature ();

                                    // ensure correct type and really bound of object reference
                                    if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                                    reference = (EReference) _TmpObject;



                                    // check isomorphic binding between objects reference and node
                                    if (!( !reference.equals (node) )) {throw new Exception("SDMException");};


                                    // check isomorphic binding between objects reference and otherNode
                                    if (!( !reference.equals (otherNode) )) {throw new Exception("SDMException");};

                                    // bind object
                                    _TmpObject = reference.getEType ();

                                    // ensure correct type and really bound of object type
                                    if (!( _TmpObject instanceof EClass )) {throw new Exception("SDMException");};
                                    type = (EClass) _TmpObject;



                                    // check isomorphic binding between objects type and node
                                    if (!( !type.equals (node) )) {throw new Exception("SDMException");};


                                    // check isomorphic binding between objects type and otherNode
                                    if (!( !type.equals (otherNode) )) {throw new Exception("SDMException");};


                                    // check isomorphic binding between objects type and otherType
                                    if (!( !type.equals (otherType) )) {throw new Exception("SDMException");};

                                    // check link eAllSuperTypes from otherType to type
                                    if (!(!(otherType.getEAllSuperTypes ().contains (type)))) {throw new Exception("SDMException");};




                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {
                        return type == org.eclipse.emf.ecore.EcorePackage.Literals.EOBJECT;

                     }
                     else
                     {
                        return true;

                     }

                  }
                  else
                  {
                     return false;

                  }

               }

            }

         }

      }

   }


}


