/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramFactory
 * @model kind="package"
 * @generated
 */
public interface CompositionprogramPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "compositionprogram";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://reuseware.org/coconut/compositionprogram";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "org.reuseware.coconut.compositionprogram";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  CompositionprogramPackage eINSTANCE = org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl.init();

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.CompositionLinkImpl <em>Composition Link</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionLinkImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getCompositionLink()
   * @generated
   */
  int COMPOSITION_LINK = 0;

  /**
   * The feature id for the '<em><b>Composition Program</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__COMPOSITION_PROGRAM = 0;

  /**
   * The feature id for the '<em><b>Contributes</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__CONTRIBUTES = 1;

  /**
   * The feature id for the '<em><b>Derived From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__DERIVED_FROM = 2;

  /**
   * The feature id for the '<em><b>Empty</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__EMPTY = 3;

  /**
   * The feature id for the '<em><b>Matches</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__MATCHES = 4;

  /**
   * The feature id for the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__SOURCE = 5;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__TARGET = 6;

  /**
   * The feature id for the '<em><b>Valid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK__VALID = 7;

  /**
   * The number of structural features of the '<em>Composition Link</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LINK_FEATURE_COUNT = 8;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.CompositionProgramImpl <em>Composition Program</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionProgramImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getCompositionProgram()
   * @generated
   */
  int COMPOSITION_PROGRAM = 1;

  /**
   * The feature id for the '<em><b>UCPI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_PROGRAM__UCPI = 0;

  /**
   * The feature id for the '<em><b>Composed Fragments</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS = 1;

  /**
   * The feature id for the '<em><b>Composition Links</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_PROGRAM__COMPOSITION_LINKS = 2;

  /**
   * The feature id for the '<em><b>Fragment Instances</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_PROGRAM__FRAGMENT_INSTANCES = 3;

  /**
   * The number of structural features of the '<em>Composition Program</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_PROGRAM_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.DerivedCompositionProgramImpl <em>Derived Composition Program</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.DerivedCompositionProgramImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getDerivedCompositionProgram()
   * @generated
   */
  int DERIVED_COMPOSITION_PROGRAM = 2;

  /**
   * The feature id for the '<em><b>UCPI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM__UCPI = COMPOSITION_PROGRAM__UCPI;

  /**
   * The feature id for the '<em><b>Composed Fragments</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS = COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS;

  /**
   * The feature id for the '<em><b>Composition Links</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM__COMPOSITION_LINKS = COMPOSITION_PROGRAM__COMPOSITION_LINKS;

  /**
   * The feature id for the '<em><b>Fragment Instances</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM__FRAGMENT_INSTANCES = COMPOSITION_PROGRAM__FRAGMENT_INSTANCES;

  /**
   * The feature id for the '<em><b>Derive From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM__DERIVE_FROM = COMPOSITION_PROGRAM_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Derived Composition Program</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DERIVED_COMPOSITION_PROGRAM_FEATURE_COUNT = COMPOSITION_PROGRAM_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.FragmentInstanceImpl <em>Fragment Instance</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.FragmentInstanceImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getFragmentInstance()
   * @generated
   */
  int FRAGMENT_INSTANCE = 3;

  /**
   * The feature id for the '<em><b>UFI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__UFI = 0;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' map.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__ARGUMENTS = 1;

  /**
   * The feature id for the '<em><b>Composition Program</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__COMPOSITION_PROGRAM = 2;

  /**
   * The feature id for the '<em><b>Derived From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__DERIVED_FROM = 3;

  /**
   * The feature id for the '<em><b>Fragment</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__FRAGMENT = 4;

  /**
   * The feature id for the '<em><b>Instantiations</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__INSTANTIATIONS = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__NAME = 6;

  /**
   * The feature id for the '<em><b>Port Instances</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__PORT_INSTANCES = 7;

  /**
   * The feature id for the '<em><b>Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__REFERENCE = 8;

  /**
   * The feature id for the '<em><b>Target Physical Location</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION = 9;

  /**
   * The feature id for the '<em><b>Target UFI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__TARGET_UFI = 10;

  /**
   * The feature id for the '<em><b>Target</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE__TARGET = 11;

  /**
   * The number of structural features of the '<em>Fragment Instance</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_INSTANCE_FEATURE_COUNT = 12;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.PhysicalCompositionProgramImpl <em>Physical Composition Program</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.PhysicalCompositionProgramImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getPhysicalCompositionProgram()
   * @generated
   */
  int PHYSICAL_COMPOSITION_PROGRAM = 4;

  /**
   * The feature id for the '<em><b>UCPI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_COMPOSITION_PROGRAM__UCPI = COMPOSITION_PROGRAM__UCPI;

  /**
   * The feature id for the '<em><b>Composed Fragments</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS = COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS;

  /**
   * The feature id for the '<em><b>Composition Links</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_COMPOSITION_PROGRAM__COMPOSITION_LINKS = COMPOSITION_PROGRAM__COMPOSITION_LINKS;

  /**
   * The feature id for the '<em><b>Fragment Instances</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_COMPOSITION_PROGRAM__FRAGMENT_INSTANCES = COMPOSITION_PROGRAM__FRAGMENT_INSTANCES;

  /**
   * The number of structural features of the '<em>Physical Composition Program</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_COMPOSITION_PROGRAM_FEATURE_COUNT = COMPOSITION_PROGRAM_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.PortInstanceImpl <em>Port Instance</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.PortInstanceImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getPortInstance()
   * @generated
   */
  int PORT_INSTANCE = 5;

  /**
   * The feature id for the '<em><b>Fracol Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__FRACOL_NAME = 0;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__FRACOL_NAMESPACE = 1;

  /**
   * The feature id for the '<em><b>Fragment Instance</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__FRAGMENT_INSTANCE = 2;

  /**
   * The feature id for the '<em><b>Fragment Role Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__FRAGMENT_ROLE_NAME = 3;

  /**
   * The feature id for the '<em><b>Port Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__PORT_NAME = 4;

  /**
   * The feature id for the '<em><b>Settings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__SETTINGS = 5;

  /**
   * The feature id for the '<em><b>Source Links</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__SOURCE_LINKS = 6;

  /**
   * The feature id for the '<em><b>Target Links</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE__TARGET_LINKS = 7;

  /**
   * The number of structural features of the '<em>Port Instance</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_INSTANCE_FEATURE_COUNT = 8;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.compositionprogram.impl.SettingImpl <em>Setting</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.compositionprogram.impl.SettingImpl
   * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getSetting()
   * @generated
   */
  int SETTING = 6;

  /**
   * The feature id for the '<em><b>Port Instance</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING__PORT_INSTANCE = 0;

  /**
   * The feature id for the '<em><b>Property</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING__PROPERTY = 1;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING__VALUE = 2;

  /**
   * The number of structural features of the '<em>Setting</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING_FEATURE_COUNT = 3;


  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.CompositionLink <em>Composition Link</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Link</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink
   * @generated
   */
  EClass getCompositionLink();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram <em>Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Program</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram()
   * @see #getCompositionLink()
   * @generated
   */
  EReference getCompositionLink_CompositionProgram();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isContributes <em>Contributes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Contributes</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#isContributes()
   * @see #getCompositionLink()
   * @generated
   */
  EAttribute getCompositionLink_Contributes();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getDerivedFrom <em>Derived From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Derived From</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getDerivedFrom()
   * @see #getCompositionLink()
   * @generated
   */
  EReference getCompositionLink_DerivedFrom();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isEmpty <em>Empty</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Empty</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#isEmpty()
   * @see #getCompositionLink()
   * @generated
   */
  EAttribute getCompositionLink_Empty();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getMatches <em>Matches</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Matches</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getMatches()
   * @see #getCompositionLink()
   * @generated
   */
  EReference getCompositionLink_Matches();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Source</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getSource()
   * @see #getCompositionLink()
   * @generated
   */
  EReference getCompositionLink_Source();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getTarget()
   * @see #getCompositionLink()
   * @generated
   */
  EReference getCompositionLink_Target();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isValid <em>Valid</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Valid</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#isValid()
   * @see #getCompositionLink()
   * @generated
   */
  EAttribute getCompositionLink_Valid();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.CompositionProgram <em>Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Program</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram
   * @generated
   */
  EClass getCompositionProgram();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getUCPI <em>UCPI</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>UCPI</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getUCPI()
   * @see #getCompositionProgram()
   * @generated
   */
  EAttribute getCompositionProgram_UCPI();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getComposedFragments <em>Composed Fragments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Composed Fragments</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getComposedFragments()
   * @see #getCompositionProgram()
   * @generated
   */
  EReference getCompositionProgram_ComposedFragments();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getCompositionLinks <em>Composition Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composition Links</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getCompositionLinks()
   * @see #getCompositionProgram()
   * @generated
   */
  EReference getCompositionProgram_CompositionLinks();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getFragmentInstances <em>Fragment Instances</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Fragment Instances</em>'.
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getFragmentInstances()
   * @see #getCompositionProgram()
   * @generated
   */
  EReference getCompositionProgram_FragmentInstances();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.DerivedCompositionProgram <em>Derived Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Derived Composition Program</em>'.
   * @see org.reuseware.coconut.compositionprogram.DerivedCompositionProgram
   * @generated
   */
  EClass getDerivedCompositionProgram();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.DerivedCompositionProgram#getDeriveFrom <em>Derive From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Derive From</em>'.
   * @see org.reuseware.coconut.compositionprogram.DerivedCompositionProgram#getDeriveFrom()
   * @see #getDerivedCompositionProgram()
   * @generated
   */
  EReference getDerivedCompositionProgram_DeriveFrom();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.FragmentInstance <em>Fragment Instance</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Instance</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance
   * @generated
   */
  EClass getFragmentInstance();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getUFI <em>UFI</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>UFI</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getUFI()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_UFI();

  /**
   * Returns the meta object for the map '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getArguments <em>Arguments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the map '<em>Arguments</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getArguments()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_Arguments();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram <em>Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Program</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_CompositionProgram();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getDerivedFrom <em>Derived From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Derived From</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getDerivedFrom()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_DerivedFrom();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getFragment <em>Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Fragment</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getFragment()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_Fragment();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getInstantiations <em>Instantiations</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Instantiations</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getInstantiations()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_Instantiations();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getName()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_Name();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getPortInstances <em>Port Instances</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Port Instances</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getPortInstances()
   * @see #getFragmentInstance()
   * @generated
   */
  EReference getFragmentInstance_PortInstances();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isReference <em>Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Reference</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#isReference()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_Reference();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetPhysicalLocation <em>Target Physical Location</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Physical Location</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetPhysicalLocation()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_TargetPhysicalLocation();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetUFI <em>Target UFI</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Target UFI</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetUFI()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_TargetUFI();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target</em>'.
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#isTarget()
   * @see #getFragmentInstance()
   * @generated
   */
  EAttribute getFragmentInstance_Target();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.PhysicalCompositionProgram <em>Physical Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Physical Composition Program</em>'.
   * @see org.reuseware.coconut.compositionprogram.PhysicalCompositionProgram
   * @generated
   */
  EClass getPhysicalCompositionProgram();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.PortInstance <em>Port Instance</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Instance</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance
   * @generated
   */
  EClass getPortInstance();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFracolName <em>Fracol Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fracol Name</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getFracolName()
   * @see #getPortInstance()
   * @generated
   */
  EAttribute getPortInstance_FracolName();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFracolNamespace <em>Fracol Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Fracol Namespace</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getFracolNamespace()
   * @see #getPortInstance()
   * @generated
   */
  EAttribute getPortInstance_FracolNamespace();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance <em>Fragment Instance</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Instance</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance()
   * @see #getPortInstance()
   * @generated
   */
  EReference getPortInstance_FragmentInstance();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentRoleName <em>Fragment Role Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fragment Role Name</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getFragmentRoleName()
   * @see #getPortInstance()
   * @generated
   */
  EAttribute getPortInstance_FragmentRoleName();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.PortInstance#getPortName <em>Port Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port Name</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getPortName()
   * @see #getPortInstance()
   * @generated
   */
  EAttribute getPortInstance_PortName();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.compositionprogram.PortInstance#getSettings <em>Settings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Settings</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getSettings()
   * @see #getPortInstance()
   * @generated
   */
  EReference getPortInstance_Settings();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.PortInstance#getSourceLinks <em>Source Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Source Links</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getSourceLinks()
   * @see #getPortInstance()
   * @generated
   */
  EReference getPortInstance_SourceLinks();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.compositionprogram.PortInstance#getTargetLinks <em>Target Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Target Links</em>'.
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getTargetLinks()
   * @see #getPortInstance()
   * @generated
   */
  EReference getPortInstance_TargetLinks();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.compositionprogram.Setting <em>Setting</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Setting</em>'.
   * @see org.reuseware.coconut.compositionprogram.Setting
   * @generated
   */
  EClass getSetting();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.compositionprogram.Setting#getPortInstance <em>Port Instance</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Port Instance</em>'.
   * @see org.reuseware.coconut.compositionprogram.Setting#getPortInstance()
   * @see #getSetting()
   * @generated
   */
  EReference getSetting_PortInstance();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.Setting#getProperty <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Property</em>'.
   * @see org.reuseware.coconut.compositionprogram.Setting#getProperty()
   * @see #getSetting()
   * @generated
   */
  EAttribute getSetting_Property();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.compositionprogram.Setting#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.reuseware.coconut.compositionprogram.Setting#getValue()
   * @see #getSetting()
   * @generated
   */
  EAttribute getSetting_Value();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  CompositionprogramFactory getCompositionprogramFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.CompositionLinkImpl <em>Composition Link</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionLinkImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getCompositionLink()
     * @generated
     */
    EClass COMPOSITION_LINK = eINSTANCE.getCompositionLink();

    /**
     * The meta object literal for the '<em><b>Composition Program</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LINK__COMPOSITION_PROGRAM = eINSTANCE.getCompositionLink_CompositionProgram();

    /**
     * The meta object literal for the '<em><b>Contributes</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_LINK__CONTRIBUTES = eINSTANCE.getCompositionLink_Contributes();

    /**
     * The meta object literal for the '<em><b>Derived From</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LINK__DERIVED_FROM = eINSTANCE.getCompositionLink_DerivedFrom();

    /**
     * The meta object literal for the '<em><b>Empty</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_LINK__EMPTY = eINSTANCE.getCompositionLink_Empty();

    /**
     * The meta object literal for the '<em><b>Matches</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LINK__MATCHES = eINSTANCE.getCompositionLink_Matches();

    /**
     * The meta object literal for the '<em><b>Source</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LINK__SOURCE = eINSTANCE.getCompositionLink_Source();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LINK__TARGET = eINSTANCE.getCompositionLink_Target();

    /**
     * The meta object literal for the '<em><b>Valid</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_LINK__VALID = eINSTANCE.getCompositionLink_Valid();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.CompositionProgramImpl <em>Composition Program</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionProgramImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getCompositionProgram()
     * @generated
     */
    EClass COMPOSITION_PROGRAM = eINSTANCE.getCompositionProgram();

    /**
     * The meta object literal for the '<em><b>UCPI</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_PROGRAM__UCPI = eINSTANCE.getCompositionProgram_UCPI();

    /**
     * The meta object literal for the '<em><b>Composed Fragments</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS = eINSTANCE.getCompositionProgram_ComposedFragments();

    /**
     * The meta object literal for the '<em><b>Composition Links</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_PROGRAM__COMPOSITION_LINKS = eINSTANCE.getCompositionProgram_CompositionLinks();

    /**
     * The meta object literal for the '<em><b>Fragment Instances</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_PROGRAM__FRAGMENT_INSTANCES = eINSTANCE.getCompositionProgram_FragmentInstances();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.DerivedCompositionProgramImpl <em>Derived Composition Program</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.DerivedCompositionProgramImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getDerivedCompositionProgram()
     * @generated
     */
    EClass DERIVED_COMPOSITION_PROGRAM = eINSTANCE.getDerivedCompositionProgram();

    /**
     * The meta object literal for the '<em><b>Derive From</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DERIVED_COMPOSITION_PROGRAM__DERIVE_FROM = eINSTANCE.getDerivedCompositionProgram_DeriveFrom();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.FragmentInstanceImpl <em>Fragment Instance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.FragmentInstanceImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getFragmentInstance()
     * @generated
     */
    EClass FRAGMENT_INSTANCE = eINSTANCE.getFragmentInstance();

    /**
     * The meta object literal for the '<em><b>UFI</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__UFI = eINSTANCE.getFragmentInstance_UFI();

    /**
     * The meta object literal for the '<em><b>Arguments</b></em>' map feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__ARGUMENTS = eINSTANCE.getFragmentInstance_Arguments();

    /**
     * The meta object literal for the '<em><b>Composition Program</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__COMPOSITION_PROGRAM = eINSTANCE.getFragmentInstance_CompositionProgram();

    /**
     * The meta object literal for the '<em><b>Derived From</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__DERIVED_FROM = eINSTANCE.getFragmentInstance_DerivedFrom();

    /**
     * The meta object literal for the '<em><b>Fragment</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__FRAGMENT = eINSTANCE.getFragmentInstance_Fragment();

    /**
     * The meta object literal for the '<em><b>Instantiations</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__INSTANTIATIONS = eINSTANCE.getFragmentInstance_Instantiations();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__NAME = eINSTANCE.getFragmentInstance_Name();

    /**
     * The meta object literal for the '<em><b>Port Instances</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_INSTANCE__PORT_INSTANCES = eINSTANCE.getFragmentInstance_PortInstances();

    /**
     * The meta object literal for the '<em><b>Reference</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__REFERENCE = eINSTANCE.getFragmentInstance_Reference();

    /**
     * The meta object literal for the '<em><b>Target Physical Location</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION = eINSTANCE.getFragmentInstance_TargetPhysicalLocation();

    /**
     * The meta object literal for the '<em><b>Target UFI</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__TARGET_UFI = eINSTANCE.getFragmentInstance_TargetUFI();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_INSTANCE__TARGET = eINSTANCE.getFragmentInstance_Target();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.PhysicalCompositionProgramImpl <em>Physical Composition Program</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.PhysicalCompositionProgramImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getPhysicalCompositionProgram()
     * @generated
     */
    EClass PHYSICAL_COMPOSITION_PROGRAM = eINSTANCE.getPhysicalCompositionProgram();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.PortInstanceImpl <em>Port Instance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.PortInstanceImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getPortInstance()
     * @generated
     */
    EClass PORT_INSTANCE = eINSTANCE.getPortInstance();

    /**
     * The meta object literal for the '<em><b>Fracol Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_INSTANCE__FRACOL_NAME = eINSTANCE.getPortInstance_FracolName();

    /**
     * The meta object literal for the '<em><b>Fracol Namespace</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_INSTANCE__FRACOL_NAMESPACE = eINSTANCE.getPortInstance_FracolNamespace();

    /**
     * The meta object literal for the '<em><b>Fragment Instance</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_INSTANCE__FRAGMENT_INSTANCE = eINSTANCE.getPortInstance_FragmentInstance();

    /**
     * The meta object literal for the '<em><b>Fragment Role Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_INSTANCE__FRAGMENT_ROLE_NAME = eINSTANCE.getPortInstance_FragmentRoleName();

    /**
     * The meta object literal for the '<em><b>Port Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_INSTANCE__PORT_NAME = eINSTANCE.getPortInstance_PortName();

    /**
     * The meta object literal for the '<em><b>Settings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_INSTANCE__SETTINGS = eINSTANCE.getPortInstance_Settings();

    /**
     * The meta object literal for the '<em><b>Source Links</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_INSTANCE__SOURCE_LINKS = eINSTANCE.getPortInstance_SourceLinks();

    /**
     * The meta object literal for the '<em><b>Target Links</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_INSTANCE__TARGET_LINKS = eINSTANCE.getPortInstance_TargetLinks();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.compositionprogram.impl.SettingImpl <em>Setting</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.compositionprogram.impl.SettingImpl
     * @see org.reuseware.coconut.compositionprogram.impl.CompositionprogramPackageImpl#getSetting()
     * @generated
     */
    EClass SETTING = eINSTANCE.getSetting();

    /**
     * The meta object literal for the '<em><b>Port Instance</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SETTING__PORT_INSTANCE = eINSTANCE.getSetting_PortInstance();

    /**
     * The meta object literal for the '<em><b>Property</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SETTING__PROPERTY = eINSTANCE.getSetting_Property();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SETTING__VALUE = eINSTANCE.getSetting_Value();

  }

} //CompositionprogramPackage
