/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fragment.Fragment;

import org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;

import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Derived Composition Program</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.DerivedCompositionProgram#getDeriveFrom <em>Derive From</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getDerivedCompositionProgram()
 * @model
 * @generated
 */
public interface DerivedCompositionProgram extends CompositionProgram
{
  /**
   * Returns the value of the '<em><b>Derive From</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.Fragment}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Derive From</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Derive From</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getDerivedCompositionProgram_DeriveFrom()
   * @model transient="true" ordered="false"
   * @generated
   */
  EList<Fragment> getDeriveFrom();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  CompositionLink createCompositionLink(Fragment fragment, EObject source, EObject target, CompositionAssociation2CompositionLinkBinding assocBinding, ReuseExtensionActivator activator);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  FragmentInstance createFragmentInstance(Fragment fragment, EObject element, FragmentRole2FragmentInstanceBinding roleBinding, ReuseExtensionActivator activator);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void extractCompositionProgram();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // DerivedCompositionProgram
