/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fragment.ComposedFragment;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.fragment.InstantiationSet;

import org.reuseware.coconut.id.ID;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getUFI <em>UFI</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getArguments <em>Arguments</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram <em>Composition Program</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getDerivedFrom <em>Derived From</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getFragment <em>Fragment</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getInstantiations <em>Instantiations</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getName <em>Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getPortInstances <em>Port Instances</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isReference <em>Reference</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetPhysicalLocation <em>Target Physical Location</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetUFI <em>Target UFI</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance()
 * @model
 * @generated
 */
public interface FragmentInstance extends EObject
{
  /**
   * Returns the value of the '<em><b>UFI</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>UFI</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>UFI</em>' attribute list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_UFI()
   * @model unique="false" required="true"
   * @generated
   */
  EList<String> getUFI();

  /**
   * Returns the value of the '<em><b>Arguments</b></em>' map.
   * The key is of type {@link java.lang.String},
   * and the value is of type {@link java.lang.String},
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Arguments</em>' map isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Arguments</em>' map.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Arguments()
   * @model mapType="org.eclipse.emf.ecore.EStringToStringMapEntry<org.eclipse.emf.ecore.EString, org.eclipse.emf.ecore.EString>"
   * @generated
   */
  EMap<String, String> getArguments();

  /**
   * Returns the value of the '<em><b>Composition Program</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getFragmentInstances <em>Fragment Instances</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Program</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Program</em>' container reference.
   * @see #setCompositionProgram(CompositionProgram)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_CompositionProgram()
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getFragmentInstances
   * @model opposite="fragmentInstances" transient="false" ordered="false"
   * @generated
   */
  CompositionProgram getCompositionProgram();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram <em>Composition Program</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Program</em>' container reference.
   * @see #getCompositionProgram()
   * @generated
   */
  void setCompositionProgram(CompositionProgram value);

  /**
   * Returns the value of the '<em><b>Derived From</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Derived From</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Derived From</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_DerivedFrom()
   * @model ordered="false"
   * @generated
   */
  EList<EObject> getDerivedFrom();

  /**
   * Returns the value of the '<em><b>Fragment</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment</em>' reference.
   * @see #setFragment(Fragment)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Fragment()
   * @model required="true" transient="true" ordered="false"
   * @generated
   */
  Fragment getFragment();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getFragment <em>Fragment</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment</em>' reference.
   * @see #getFragment()
   * @generated
   */
  void setFragment(Fragment value);

  /**
   * Returns the value of the '<em><b>Instantiations</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.Fragment}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Instantiations</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Instantiations</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Instantiations()
   * @model transient="true" ordered="false"
   * @generated
   */
  EList<Fragment> getInstantiations();

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Port Instances</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.PortInstance}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance <em>Fragment Instance</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Instances</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Instances</em>' containment reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_PortInstances()
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance
   * @model opposite="fragmentInstance" containment="true" keys="portName fragmentRoleName fracolNamespace" ordered="false"
   * @generated
   */
  EList<PortInstance> getPortInstances();

  /**
   * Returns the value of the '<em><b>Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reference</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reference</em>' attribute.
   * @see #setReference(boolean)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Reference()
   * @model required="true"
   * @generated
   */
  boolean isReference();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isReference <em>Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Reference</em>' attribute.
   * @see #isReference()
   * @generated
   */
  void setReference(boolean value);

  /**
   * Returns the value of the '<em><b>Target Physical Location</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Physical Location</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Physical Location</em>' attribute.
   * @see #setTargetPhysicalLocation(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_TargetPhysicalLocation()
   * @model
   * @generated
   */
  String getTargetPhysicalLocation();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getTargetPhysicalLocation <em>Target Physical Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Physical Location</em>' attribute.
   * @see #getTargetPhysicalLocation()
   * @generated
   */
  void setTargetPhysicalLocation(String value);

  /**
   * Returns the value of the '<em><b>Target UFI</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target UFI</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target UFI</em>' attribute list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_TargetUFI()
   * @model unique="false"
   * @generated
   */
  EList<String> getTargetUFI();

  /**
   * Returns the value of the '<em><b>Target</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' attribute.
   * @see #setTarget(boolean)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getFragmentInstance_Target()
   * @model required="true"
   * @generated
   */
  boolean isTarget();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#isTarget <em>Target</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' attribute.
   * @see #isTarget()
   * @generated
   */
  void setTarget(boolean value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model additionalContextMany="true"
   * @generated
   */
  void completeInstantiation(InstantiationSet is, ComposedFragment result, InstantiationSet additionalInstantiations, EList<EObject> additionalContext);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model additionalContextMany="true"
   * @generated
   */
  ComposedFragment compose(InstantiationSet additionalInstantiations, EList<EObject> additionalContext);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  Setting getSetting(String port, String property);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  ID getTargetUFIAsID();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  ID getUFIAsID();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void setTargetUFIAsString(String targetUFIString);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void setUFIAsString(String ufiString);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void update();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentInstance
