/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fragment.FragmentFactory;
import java.util.*;
import org.reuseware.coconut.fragment.ComposedFragment;
import java.util.ArrayList;
import org.reuseware.coconut.compositionprogram.CompositionLink;
import org.reuseware.coconut.compositionprogram.CompositionProgram;
import org.reuseware.coconut.compositionprogram.CompositionprogramPackage;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.fragment.InstantiationSet;
import org.reuseware.coconut.id.IdFactory;
import org.reuseware.coconut.id.ID;


/**
 * @generated
 **/
public abstract class CompositionProgramImpl extends EObjectImpl implements CompositionProgram
{


   /**
   * The cached value of the '{@link #getUCPI() <em>UCPI</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUCPI()
   * @generated
   * @ordered
   */
  protected EList<String> ucpi;
  /**
   * The cached value of the '{@link #getComposedFragments() <em>Composed Fragments</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComposedFragments()
   * @generated
   * @ordered
   */
  protected EList<ComposedFragment> composedFragments;
  /**
   * The cached value of the '{@link #getCompositionLinks() <em>Composition Links</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionLinks()
   * @generated
   * @ordered
   */
  protected EList<CompositionLink> compositionLinks;
  /**
   * The cached value of the '{@link #getFragmentInstances() <em>Fragment Instances</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFragmentInstances()
   * @generated
   * @ordered
   */
  protected EList<FragmentInstance> fragmentInstances;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionProgramImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return CompositionprogramPackage.Literals.COMPOSITION_PROGRAM;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getUCPI()
  {
    if (ucpi == null)
    {
      ucpi = new EDataTypeEList<String>(String.class, this, CompositionprogramPackage.COMPOSITION_PROGRAM__UCPI);
    }
    return ucpi;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ComposedFragment> getComposedFragments()
  {
    if (composedFragments == null)
    {
      composedFragments = new EObjectResolvingEList<ComposedFragment>(ComposedFragment.class, this, CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS);
    }
    return composedFragments;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CompositionLink> getCompositionLinks()
  {
    if (compositionLinks == null)
    {
      compositionLinks = new EObjectContainmentWithInverseEList<CompositionLink>(CompositionLink.class, this, CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS, CompositionprogramPackage.COMPOSITION_LINK__COMPOSITION_PROGRAM);
    }
    return compositionLinks;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FragmentInstance> getFragmentInstances()
  {
    if (fragmentInstances == null)
    {
      fragmentInstances = new EObjectContainmentWithInverseEList<FragmentInstance>(FragmentInstance.class, this, CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES, CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM);
    }
    return fragmentInstances;
  }


  public void compose (){
      boolean fujaba__Success = false;
      InstantiationSet is = null;
      EList<org.eclipse.emf.ecore.EObject> context = null;
      Iterator<ComposedFragment> fujaba__IterThisToComposedFragment = null;
      ComposedFragment composedFragment = null;
      Iterator<CompositionLink> fujaba__IterThisToLink = null;
      CompositionLink link = null;
      Object _TmpObject = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi = null;
      FragmentInstance fi = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // create object
         is = FragmentFactory.eINSTANCE.createInstantiationSet();
         // collabStat call
         context = new org.eclipse.emf.common.util.BasicEList<org.eclipse.emf.ecore.EObject>();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link composedFragments from this to composedFragment
         fujaba__Success = false;
         fujaba__IterThisToComposedFragment = new ArrayList<ComposedFragment>(this.getComposedFragments()).iterator ();

         while ( fujaba__IterThisToComposedFragment.hasNext () )
         {
            try
            {
               composedFragment = (ComposedFragment) fujaba__IterThisToComposedFragment.next ();

               // check object composedFragment is really bound
               if (!( composedFragment != null )) {throw new Exception("SDMException");};
               // destroy link
               this.getComposedFragments().remove (composedFragment);


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionLinks from this to link
         fujaba__Success = false;
         fujaba__IterThisToLink = new ArrayList<CompositionLink>(this.getCompositionLinks()).iterator ();

         while ( fujaba__IterThisToLink.hasNext () )
         {
            try
            {
               link = (CompositionLink) fujaba__IterThisToLink.next ();

               // check object link is really bound
               if (!( link != null )) {throw new Exception("SDMException");};
               // collabStat call
               link.match();

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link fragmentInstances from this to fi
         fujaba__Success = false;
         fujaba__IterThisToFi = new ArrayList<FragmentInstance>(this.getFragmentInstances()).iterator ();

         while ( fujaba__IterThisToFi.hasNext () )
         {
            try
            {
               fi = (FragmentInstance) fujaba__IterThisToFi.next ();

               // check object fi is really bound
               if (!( fi != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( fi.isTarget () == true )) {throw new Exception("SDMException");};

               // story pattern 3
               try 
               {
                  fujaba__Success = false; 

                  _TmpObject = fi.compose(is, context);

                  // ensure correct type and really bound of object composedFragment
                  if (!( _TmpObject instanceof ComposedFragment )) {throw new Exception("SDMException");};
                  composedFragment = (ComposedFragment) _TmpObject;

                  // create link
                  this.getComposedFragments().add(composedFragment);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (composedFragment != null) {
               context.addAll(composedFragment.getContents());
               for(FragmentInstance instantiated : this.getFragmentInstances()) {
               	if (instantiated.getInstantiations().size() == 1) {
               		if (!is.getInstantiations().contains(instantiated.getInstantiations().get(0))) {
               			is.getInstantiations().add(instantiated.getInstantiations().get(0));															
               		}
               	}
               	else if (instantiated.getInstantiations().size() > 1) {
               		instantiated.getInstantiations().clear();
               	}
               }
               }

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public ID getUCPIAsID (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // assign statement
         id.getSegments ().clear();
         id.getSegments ().addAll(this.getUCPI());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public void removeYou()
   {
      this.getComposedFragments().clear();
      this.getCompositionLinks().clear();
      this.getFragmentInstances().clear();
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getCompositionLinks()).basicAdd(otherEnd, msgs);
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getFragmentInstances()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        return ((InternalEList<?>)getCompositionLinks()).basicRemove(otherEnd, msgs);
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        return ((InternalEList<?>)getFragmentInstances()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__UCPI:
        return getUCPI();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS:
        return getComposedFragments();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        return getCompositionLinks();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        return getFragmentInstances();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__UCPI:
        getUCPI().clear();
        getUCPI().addAll((Collection<? extends String>)newValue);
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS:
        getComposedFragments().clear();
        getComposedFragments().addAll((Collection<? extends ComposedFragment>)newValue);
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        getCompositionLinks().clear();
        getCompositionLinks().addAll((Collection<? extends CompositionLink>)newValue);
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        getFragmentInstances().clear();
        getFragmentInstances().addAll((Collection<? extends FragmentInstance>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__UCPI:
        getUCPI().clear();
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS:
        getComposedFragments().clear();
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        getCompositionLinks().clear();
        return;
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        getFragmentInstances().clear();
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.COMPOSITION_PROGRAM__UCPI:
        return ucpi != null && !ucpi.isEmpty();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS:
        return composedFragments != null && !composedFragments.isEmpty();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__COMPOSITION_LINKS:
        return compositionLinks != null && !compositionLinks.isEmpty();
      case CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES:
        return fragmentInstances != null && !fragmentInstances.isEmpty();
    }
    return super.eIsSet(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (UCPI: ");
    result.append(ucpi);
    result.append(')');
    return result.toString();
  }
}


