/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import java.util.*;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.compositionprogram.CompositionLink;
import java.util.ArrayList;
import org.reuseware.coconut.compositionprogram.CompositionProgram;
import org.reuseware.coconut.compositionprogram.CompositionprogramPackage;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.fragment.InstantiationSet;
import org.reuseware.coconut.fragment.ComposedFragment;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.impl.EStringToStringMapEntryImpl;
import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.compositionprogram.Setting;
import org.reuseware.coconut.fragment.APMatchGroup;
import org.reuseware.coconut.id.IdFactory;
import org.reuseware.coconut.id.ID;
import org.reuseware.coconut.compositionprogram.CompositionprogramFactory;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.reuseextension.FragmentRoleBinding;


/**
 * @generated
 **/
public class FragmentInstanceImpl extends EObjectImpl implements FragmentInstance
{


   /**
   * The cached value of the '{@link #getUFI() <em>UFI</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUFI()
   * @generated
   * @ordered
   */
  protected EList<String> ufi;
  /**
   * The cached value of the '{@link #getArguments() <em>Arguments</em>}' map.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArguments()
   * @generated
   * @ordered
   */
  protected EMap<String, String> arguments;
  /**
   * The cached value of the '{@link #getDerivedFrom() <em>Derived From</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDerivedFrom()
   * @generated
   * @ordered
   */
  protected EList<EObject> derivedFrom;
  /**
   * The cached value of the '{@link #getFragment() <em>Fragment</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFragment()
   * @generated
   * @ordered
   */
  protected Fragment fragment;
  /**
   * The cached value of the '{@link #getInstantiations() <em>Instantiations</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInstantiations()
   * @generated
   * @ordered
   */
  protected EList<Fragment> instantiations;
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortInstances() <em>Port Instances</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortInstances()
   * @generated
   * @ordered
   */
  protected EList<PortInstance> portInstances;
  /**
   * The default value of the '{@link #isReference() <em>Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isReference()
   * @generated
   * @ordered
   */
  protected static final boolean REFERENCE_EDEFAULT = false;
  /**
   * The cached value of the '{@link #isReference() <em>Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isReference()
   * @generated
   * @ordered
   */
  protected boolean reference = REFERENCE_EDEFAULT;
  /**
   * The default value of the '{@link #getTargetPhysicalLocation() <em>Target Physical Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocation()
   * @generated
   * @ordered
   */
  protected static final String TARGET_PHYSICAL_LOCATION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getTargetPhysicalLocation() <em>Target Physical Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocation()
   * @generated
   * @ordered
   */
  protected String targetPhysicalLocation = TARGET_PHYSICAL_LOCATION_EDEFAULT;
  /**
   * The cached value of the '{@link #getTargetUFI() <em>Target UFI</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetUFI()
   * @generated
   * @ordered
   */
  protected EList<String> targetUFI;
  /**
   * The default value of the '{@link #isTarget() <em>Target</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isTarget()
   * @generated
   * @ordered
   */
  protected static final boolean TARGET_EDEFAULT = false;
  /**
   * The cached value of the '{@link #isTarget() <em>Target</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isTarget()
   * @generated
   * @ordered
   */
  protected boolean target = TARGET_EDEFAULT;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FragmentInstanceImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return CompositionprogramPackage.Literals.FRAGMENT_INSTANCE;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getUFI()
  {
    if (ufi == null)
    {
      ufi = new EDataTypeEList<String>(String.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__UFI);
    }
    return ufi;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMap<String, String> getArguments()
  {
    if (arguments == null)
    {
      arguments = new EcoreEMap<String,String>(EcorePackage.Literals.ESTRING_TO_STRING_MAP_ENTRY, EStringToStringMapEntryImpl.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS);
    }
    return arguments;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionProgram getCompositionProgram()
  {
    if (eContainerFeatureID() != CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM) return null;
    return (CompositionProgram)eContainer();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCompositionProgram(CompositionProgram newCompositionProgram, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newCompositionProgram, CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM, msgs);
    return msgs;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionProgram(CompositionProgram newCompositionProgram)
  {
    if (newCompositionProgram != eInternalContainer() || (eContainerFeatureID() != CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM && newCompositionProgram != null))
    {
      if (EcoreUtil.isAncestor(this, newCompositionProgram))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newCompositionProgram != null)
        msgs = ((InternalEObject)newCompositionProgram).eInverseAdd(this, CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES, CompositionProgram.class, msgs);
      msgs = basicSetCompositionProgram(newCompositionProgram, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM, newCompositionProgram, newCompositionProgram));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<EObject> getDerivedFrom()
  {
    if (derivedFrom == null)
    {
      derivedFrom = new EObjectResolvingEList<EObject>(EObject.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__DERIVED_FROM);
    }
    return derivedFrom;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fragment getFragment()
  {
    if (fragment != null && fragment.eIsProxy())
    {
      InternalEObject oldFragment = (InternalEObject)fragment;
      fragment = (Fragment)eResolveProxy(oldFragment);
      if (fragment != oldFragment)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT, oldFragment, fragment));
      }
    }
    return fragment;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fragment basicGetFragment()
  {
    return fragment;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragment(Fragment newFragment)
  {
    Fragment oldFragment = fragment;
    fragment = newFragment;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT, oldFragment, fragment));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Fragment> getInstantiations()
  {
    if (instantiations == null)
    {
      instantiations = new EObjectResolvingEList<Fragment>(Fragment.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__INSTANTIATIONS);
    }
    return instantiations;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__NAME, oldName, name));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PortInstance> getPortInstances()
  {
    if (portInstances == null)
    {
      portInstances = new EObjectContainmentWithInverseEList<PortInstance>(PortInstance.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES, CompositionprogramPackage.PORT_INSTANCE__FRAGMENT_INSTANCE);
    }
    return portInstances;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isReference()
  {
    return reference;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setReference(boolean newReference)
  {
    boolean oldReference = reference;
    reference = newReference;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__REFERENCE, oldReference, reference));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetPhysicalLocation()
  {
    return targetPhysicalLocation;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetPhysicalLocation(String newTargetPhysicalLocation)
  {
    String oldTargetPhysicalLocation = targetPhysicalLocation;
    targetPhysicalLocation = newTargetPhysicalLocation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION, oldTargetPhysicalLocation, targetPhysicalLocation));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getTargetUFI()
  {
    if (targetUFI == null)
    {
      targetUFI = new EDataTypeEList<String>(String.class, this, CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_UFI);
    }
    return targetUFI;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isTarget()
  {
    return target;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTarget(boolean newTarget)
  {
    boolean oldTarget = target;
    target = newTarget;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET, oldTarget, target));
  }


  public void completeInstantiation (InstantiationSet is , ComposedFragment result , InstantiationSet additionalInstantiations , EList<EObject> additionalContext ){
      boolean fujaba__Success = false;
      CompositionProgram cp = null;
      Iterator<Fragment> fujaba__IterContributor2ToContribution2 = null;
      Fragment contribution2 = null;
      Fragment reference = null;
      FragmentInstance contributor2 = null;
      PortInstance tPort = null;
      FragmentInstance contributor1 = null;
      PortInstance sPort = null;
      Iterator<CompositionLink> fujaba__IterCpToLink = null;
      CompositionLink link = null;
      Iterator<Fragment> fujaba__IterIsToContribution1 = null;
      Fragment contribution1 = null;
      Iterator<Fragment> fujaba__IterContributor1ToContribution1 = null;
      Iterator<Fragment> fujaba__IterIsToContribution2 = null;

      int oldISSize = is.getInstantiations().size();
      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // bind object
         cp = this.getCompositionProgram ();

         // check object cp is really bound
         if (!( cp != null )) {throw new Exception("SDMException");};


         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern only linked by configuration 1
      try 
      {
         fujaba__Success = false; 

         // check object cp is really bound
         if (!( cp != null )) {throw new Exception("SDMException");};
         // check object is is really bound
         if (!( is != null )) {throw new Exception("SDMException");};
         // check object result is really bound
         if (!( result != null )) {throw new Exception("SDMException");};
         // check link instantiations from is to result
         if (!(is.getInstantiations ().contains (result))) {throw new Exception("SDMException");};

         // iterate to-many link instantiations from is to contribution1
         fujaba__Success = false;
         fujaba__IterIsToContribution1 = new ArrayList<Fragment>(is.getInstantiations()).iterator ();

         while ( fujaba__IterIsToContribution1.hasNext () )
         {
            try
            {
               contribution1 = (Fragment) fujaba__IterIsToContribution1.next ();

               // check object contribution1 is really bound
               if (!( contribution1 != null )) {throw new Exception("SDMException");};

               // check isomorphic binding between objects result and contribution1
               if (!( !result.equals (contribution1) )) {throw new Exception("SDMException");};

               // iterate to-many link compositionLinks from cp to link
               fujaba__Success = false;
               fujaba__IterCpToLink = new ArrayList<CompositionLink>(cp.getCompositionLinks()).iterator ();

               while ( fujaba__IterCpToLink.hasNext () )
               {
                  try
                  {
                     link = (CompositionLink) fujaba__IterCpToLink.next ();

                     // check object link is really bound
                     if (!( link != null )) {throw new Exception("SDMException");};
                     // bind object
                     sPort = link.getSource ();

                     // check object sPort is really bound
                     if (!( sPort != null )) {throw new Exception("SDMException");};

                     // bind object
                     contributor1 = sPort.getFragmentInstance ();

                     // check object contributor1 is really bound
                     if (!( contributor1 != null )) {throw new Exception("SDMException");};

                     // bind object
                     tPort = link.getTarget ();

                     // check object tPort is really bound
                     if (!( tPort != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects tPort and sPort
                     if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                     // bind object
                     contributor2 = tPort.getFragmentInstance ();

                     // check object contributor2 is really bound
                     if (!( contributor2 != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects contributor2 and contributor1
                     if (!( !contributor2.equals (contributor1) )) {throw new Exception("SDMException");};

                     // check link instantiations from contributor1 to contribution1
                     if (!(contributor1.getInstantiations ().contains (contribution1))) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( link.isContributes () == false )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                     // story pattern 
                     try 
                     {
                        fujaba__Success = false; 

                        // check object contributor2 is really bound
                        if (!( contributor2 != null )) {throw new Exception("SDMException");};
                        // check object is is really bound
                        if (!( is != null )) {throw new Exception("SDMException");};
                        // iterate to-many link instantiations from contributor2 to contribution2
                        fujaba__Success = false;
                        fujaba__IterContributor2ToContribution2 = contributor2.getInstantiations().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterContributor2ToContribution2.hasNext () )
                        {
                           try
                           {
                              contribution2 = (Fragment) fujaba__IterContributor2ToContribution2.next ();

                              // check object contribution2 is really bound
                              if (!( contribution2 != null )) {throw new Exception("SDMException");};
                              // check link instantiations from is to contribution2
                              if (!(is.getInstantiations ().contains (contribution2))) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        if (tPort.canContribute())
                        {
                           // story pattern successor
                           try 
                           {
                              fujaba__Success = false; 

                              contribution2 = contributor2.compose(additionalInstantiations, additionalContext);

                              // check object contribution2 is really bound
                              if (!( contribution2 != null )) {throw new Exception("SDMException");};
                              // check object contributor2 is really bound
                              if (!( contributor2 != null )) {throw new Exception("SDMException");};
                              // check object is is really bound
                              if (!( is != null )) {throw new Exception("SDMException");};
                              // create link
                              contributor2.getInstantiations().add(contribution2);

                              // create link
                              is.getInstantiations().add(contribution2);

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }


                        }
                        else
                        {
                           // story pattern YYYY
                           try 
                           {
                              fujaba__Success = false; 

                              // check object contributor2 is really bound
                              if (!( contributor2 != null )) {throw new Exception("SDMException");};
                              // check object is is really bound
                              if (!( is != null )) {throw new Exception("SDMException");};
                              // attribute condition
                              if (!( contributor2.isReference () == true )) {throw new Exception("SDMException");};

                              // bind object
                              reference = contributor2.getFragment ();

                              // check object reference is really bound
                              if (!( reference != null )) {throw new Exception("SDMException");};

                              // constraint tPort.canBeReferenced()
                              if (!( tPort.canBeReferenced() )) {throw new Exception("SDMException");};

                              // create link
                              contributor2.getInstantiations().add(reference);

                              // create link
                              is.getInstantiations().add(reference);

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }


                        }

                     }





                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern only linked by configuration 2
      try 
      {
         fujaba__Success = false; 

         // check object cp is really bound
         if (!( cp != null )) {throw new Exception("SDMException");};
         // check object is is really bound
         if (!( is != null )) {throw new Exception("SDMException");};
         // check object result is really bound
         if (!( result != null )) {throw new Exception("SDMException");};
         // check link instantiations from is to result
         if (!(is.getInstantiations ().contains (result))) {throw new Exception("SDMException");};

         // iterate to-many link instantiations from is to contribution2
         fujaba__Success = false;
         fujaba__IterIsToContribution2 = new ArrayList<Fragment>(is.getInstantiations()).iterator ();

         while ( fujaba__IterIsToContribution2.hasNext () )
         {
            try
            {
               contribution2 = (Fragment) fujaba__IterIsToContribution2.next ();

               // check object contribution2 is really bound
               if (!( contribution2 != null )) {throw new Exception("SDMException");};

               // check isomorphic binding between objects result and contribution2
               if (!( !result.equals (contribution2) )) {throw new Exception("SDMException");};

               // iterate to-many link compositionLinks from cp to link
               fujaba__Success = false;
               fujaba__IterCpToLink = new ArrayList<CompositionLink>(cp.getCompositionLinks()).iterator ();

               while ( fujaba__IterCpToLink.hasNext () )
               {
                  try
                  {
                     link = (CompositionLink) fujaba__IterCpToLink.next ();

                     // check object link is really bound
                     if (!( link != null )) {throw new Exception("SDMException");};
                     // bind object
                     sPort = link.getSource ();

                     // check object sPort is really bound
                     if (!( sPort != null )) {throw new Exception("SDMException");};

                     // bind object
                     contributor1 = sPort.getFragmentInstance ();

                     // check object contributor1 is really bound
                     if (!( contributor1 != null )) {throw new Exception("SDMException");};

                     // bind object
                     tPort = link.getTarget ();

                     // check object tPort is really bound
                     if (!( tPort != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects tPort and sPort
                     if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                     // bind object
                     contributor2 = tPort.getFragmentInstance ();

                     // check object contributor2 is really bound
                     if (!( contributor2 != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects contributor2 and contributor1
                     if (!( !contributor2.equals (contributor1) )) {throw new Exception("SDMException");};

                     // check link instantiations from contributor2 to contribution2
                     if (!(contributor2.getInstantiations ().contains (contribution2))) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( link.isContributes () == false )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                     // story pattern 
                     try 
                     {
                        fujaba__Success = false; 

                        // check object contributor1 is really bound
                        if (!( contributor1 != null )) {throw new Exception("SDMException");};
                        // check object is is really bound
                        if (!( is != null )) {throw new Exception("SDMException");};
                        // iterate to-many link instantiations from contributor1 to contribution1
                        fujaba__Success = false;
                        fujaba__IterContributor1ToContribution1 = contributor1.getInstantiations().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterContributor1ToContribution1.hasNext () )
                        {
                           try
                           {
                              contribution1 = (Fragment) fujaba__IterContributor1ToContribution1.next ();

                              // check object contribution1 is really bound
                              if (!( contribution1 != null )) {throw new Exception("SDMException");};
                              // check link instantiations from is to contribution1
                              if (!(is.getInstantiations ().contains (contribution1))) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        if (sPort.canContribute())
                        {
                           // story pattern X
                           try 
                           {
                              fujaba__Success = false; 

                              contribution1 = contributor1.compose(additionalInstantiations, additionalContext);

                              // check object contribution1 is really bound
                              if (!( contribution1 != null )) {throw new Exception("SDMException");};
                              // check object contributor1 is really bound
                              if (!( contributor1 != null )) {throw new Exception("SDMException");};
                              // check object is is really bound
                              if (!( is != null )) {throw new Exception("SDMException");};
                              // create link
                              is.getInstantiations().add(contribution1);

                              // create link
                              contributor1.getInstantiations().add(contribution1);

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }


                        }
                        else
                        {
                           // story pattern XXXX
                           try 
                           {
                              fujaba__Success = false; 

                              // check object contributor1 is really bound
                              if (!( contributor1 != null )) {throw new Exception("SDMException");};
                              // check object is is really bound
                              if (!( is != null )) {throw new Exception("SDMException");};
                              // attribute condition
                              if (!( contributor1.isReference () == true )) {throw new Exception("SDMException");};

                              // bind object
                              reference = contributor1.getFragment ();

                              // check object reference is really bound
                              if (!( reference != null )) {throw new Exception("SDMException");};

                              // constraint sPort.canBeReferenced()
                              if (!( sPort.canBeReferenced() )) {throw new Exception("SDMException");};

                              // create link
                              contributor1.getInstantiations().add(reference);

                              // create link
                              is.getInstantiations().add(reference);

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }


                        }

                     }





                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (oldISSize < is.getInstantiations().size()) {
         completeInstantiation(is, result, additionalInstantiations, additionalContext);
      } 
      return ;

   }


   public ComposedFragment compose (InstantiationSet additionalInstantiations , EList<EObject> additionalContext ){
      boolean fujaba__Success = false;
      ComposedFragment result = null;
      InstantiationSet theIS = null;
      Iterator<Setting> fujaba__IterPortInstanceToSetting = null;
      Setting setting = null;
      Iterator<PortInstance> fujaba__IterThisToPortInstance = null;
      PortInstance portInstance = null;
      PortInstance contributingPort = null;
      Iterator<CompositionLink> fujaba__IterReceivingPortToPrimaryLink = null;
      CompositionLink primaryLink = null;
      Iterator<PortInstance> fujaba__IterThisToReceivingPort = null;
      PortInstance receivingPort = null;
      ComposedFragment contribution = null;
      Iterator<CompositionLink> fujaba__IterReceivingPortToLink = null;
      CompositionLink link = null;
      Iterator<APMatchGroup> fujaba__IterPrimaryLinkToApMatchGroup = null;
      APMatchGroup apMatchGroup = null;
      Iterator<FragmentInstance> fujaba__IterCpToContributor = null;
      FragmentInstance contributor = null;
      CompositionProgram cp = null;
      Iterator<Fragment> fujaba__IterOtherFIToSomeInstantiation = null;
      Fragment someInstantiation = null;
      Iterator<Fragment> fujaba__IterOtherFIToAddInstantiation = null;
      Fragment addInstantiation = null;
      Iterator<APMatchGroup> fujaba__IterLinkToMatchGroup = null;
      APMatchGroup matchGroup = null;
      FragmentInstance otherFI = null;
      PortInstance tPort = null;
      Iterator<CompositionLink> fujaba__IterSPortToLink = null;
      Iterator<PortInstance> fujaba__IterThisToSPort = null;
      PortInstance sPort = null;
      Iterator<CompositionLink> fujaba__IterTPortToLink = null;
      Iterator<PortInstance> fujaba__IterThisToTPort = null;
      Iterator<Fragment> fujaba__IterTheISToContribution2 = null;
      Fragment contribution2 = null;
      FragmentInstance contributor1 = null;
      FragmentInstance contributor2 = null;
      Iterator<CompositionLink> fujaba__IterCpToLink = null;
      Iterator<Fragment> fujaba__IterTheISToContribution1 = null;
      Fragment contribution1 = null;
      Iterator<Fragment> fujaba__IterTheISToSomeFragment = null;
      Fragment someFragment = null;

      if (getFragment() != null)
      {

         // story pattern Copy Fragment
         try 
         {
            fujaba__Success = false; 

            result = getFragment().copy(getTargetUFI());

            // check object result is really bound
            if (!( result != null )) {throw new Exception("SDMException");};
            // create object
            theIS = FragmentFactory.eINSTANCE.createInstantiationSet();
            // create link
            this.getInstantiations().add(result);

            // create link
            theIS.getInstantiations().add(result);

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern Bind Settings
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link portInstances from this to portInstance
            fujaba__Success = false;
            fujaba__IterThisToPortInstance = new ArrayList<PortInstance>(this.getPortInstances()).iterator ();

            while ( fujaba__IterThisToPortInstance.hasNext () )
            {
               try
               {
                  portInstance = (PortInstance) fujaba__IterThisToPortInstance.next ();

                  // check object portInstance is really bound
                  if (!( portInstance != null )) {throw new Exception("SDMException");};
                  // iterate to-many link settings from portInstance to setting
                  fujaba__Success = false;
                  fujaba__IterPortInstanceToSetting = new ArrayList<Setting>(portInstance.getSettings()).iterator ();

                  while ( fujaba__IterPortInstanceToSetting.hasNext () )
                  {
                     try
                     {
                        setting = (Setting) fujaba__IterPortInstanceToSetting.next ();

                        // check object setting is really bound
                        if (!( setting != null )) {throw new Exception("SDMException");};
                        // collabStat call
                        setting.execute(result);

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern Find contributors
         try 
         {
            fujaba__Success = false; 

            // bind object
            cp = this.getCompositionProgram ();

            // check object cp is really bound
            if (!( cp != null )) {throw new Exception("SDMException");};

            // iterate to-many link fragmentInstances from cp to contributor
            fujaba__Success = false;
            fujaba__IterCpToContributor = new ArrayList<FragmentInstance>(cp.getFragmentInstances()).iterator ();

            while ( fujaba__IterCpToContributor.hasNext () )
            {
               try
               {
                  contributor = (FragmentInstance) fujaba__IterCpToContributor.next ();

                  // check object contributor is really bound
                  if (!( contributor != null )) {throw new Exception("SDMException");};

                  // check isomorphic binding between objects this and contributor
                  if (!( !this.equals (contributor) )) {throw new Exception("SDMException");};

                  // story pattern select one contributing link
                  try 
                  {
                     fujaba__Success = false; 

                     // check object contributor is really bound
                     if (!( contributor != null )) {throw new Exception("SDMException");};

                     // check isomorphic binding between objects this and contributor
                     if (!( !this.equals (contributor) )) {throw new Exception("SDMException");};

                     // iterate to-many link portInstances from this to receivingPort
                     fujaba__Success = false;
                     fujaba__IterThisToReceivingPort = this.getPortInstances().iterator ();

                     while ( !(fujaba__Success) && fujaba__IterThisToReceivingPort.hasNext () )
                     {
                        try
                        {
                           receivingPort = (PortInstance) fujaba__IterThisToReceivingPort.next ();

                           // check object receivingPort is really bound
                           if (!( receivingPort != null )) {throw new Exception("SDMException");};
                           // iterate to-many link target from receivingPort to primaryLink
                           fujaba__Success = false;
                           fujaba__IterReceivingPortToPrimaryLink = receivingPort.getTargetLinks().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterReceivingPortToPrimaryLink.hasNext () )
                           {
                              try
                              {
                                 primaryLink = (CompositionLink) fujaba__IterReceivingPortToPrimaryLink.next ();

                                 // check object primaryLink is really bound
                                 if (!( primaryLink != null )) {throw new Exception("SDMException");};
                                 // bind object
                                 contributingPort = primaryLink.getSource ();

                                 // check object contributingPort is really bound
                                 if (!( contributingPort != null )) {throw new Exception("SDMException");};


                                 // check isomorphic binding between objects receivingPort and contributingPort
                                 if (!( !receivingPort.equals (contributingPort) )) {throw new Exception("SDMException");};

                                 // check link portInstances from contributingPort to contributor
                                 if (!(contributor.equals (contributingPort.getFragmentInstance ()))) {throw new Exception("SDMException");};


                                 // attribute condition
                                 if (!( primaryLink.isContributes () == true )) {throw new Exception("SDMException");};

                                 // attribute condition
                                 if (!( primaryLink.isValid () == true )) {throw new Exception("SDMException");};


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};
                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }

                  if (fujaba__Success)
                  {
                     // story pattern do compose for each match group
                     try 
                     {
                        fujaba__Success = false; 

                        contribution = contributor.compose(additionalInstantiations, additionalContext);

                        // check object contribution is really bound
                        if (!( contribution != null )) {throw new Exception("SDMException");};
                        // check object contributor is really bound
                        if (!( contributor != null )) {throw new Exception("SDMException");};
                        // check object primaryLink is really bound
                        if (!( primaryLink != null )) {throw new Exception("SDMException");};
                        // check object theIS is really bound
                        if (!( theIS != null )) {throw new Exception("SDMException");};
                        // iterate to-many link matches from primaryLink to apMatchGroup
                        fujaba__Success = false;
                        fujaba__IterPrimaryLinkToApMatchGroup = new ArrayList<APMatchGroup>(primaryLink.getMatches()).iterator ();

                        while ( fujaba__IterPrimaryLinkToApMatchGroup.hasNext () )
                        {
                           try
                           {
                              apMatchGroup = (APMatchGroup) fujaba__IterPrimaryLinkToApMatchGroup.next ();

                              // check object apMatchGroup is really bound
                              if (!( apMatchGroup != null )) {throw new Exception("SDMException");};
                              // create link
                              contributor.getInstantiations().add(contribution);

                              // create link
                              theIS.getInstantiations().add(contribution);

                              // story pattern collect links
                              try 
                              {
                                 fujaba__Success = false; 

                                 // check object contributor is really bound
                                 if (!( contributor != null )) {throw new Exception("SDMException");};

                                 // check isomorphic binding between objects this and contributor
                                 if (!( !this.equals (contributor) )) {throw new Exception("SDMException");};

                                 // iterate to-many link portInstances from this to receivingPort
                                 fujaba__Success = false;
                                 fujaba__IterThisToReceivingPort = new ArrayList<PortInstance>(this.getPortInstances()).iterator ();

                                 while ( fujaba__IterThisToReceivingPort.hasNext () )
                                 {
                                    try
                                    {
                                       receivingPort = (PortInstance) fujaba__IterThisToReceivingPort.next ();

                                       // check object receivingPort is really bound
                                       if (!( receivingPort != null )) {throw new Exception("SDMException");};
                                       // iterate to-many link target from receivingPort to link
                                       fujaba__Success = false;
                                       fujaba__IterReceivingPortToLink = new ArrayList<CompositionLink>(receivingPort.getTargetLinks()).iterator ();

                                       while ( fujaba__IterReceivingPortToLink.hasNext () )
                                       {
                                          try
                                          {
                                             link = (CompositionLink) fujaba__IterReceivingPortToLink.next ();

                                             // check object link is really bound
                                             if (!( link != null )) {throw new Exception("SDMException");};
                                             // bind object
                                             contributingPort = link.getSource ();

                                             // check object contributingPort is really bound
                                             if (!( contributingPort != null )) {throw new Exception("SDMException");};


                                             // check isomorphic binding between objects receivingPort and contributingPort
                                             if (!( !receivingPort.equals (contributingPort) )) {throw new Exception("SDMException");};

                                             // check link portInstances from contributingPort to contributor
                                             if (!(contributor.equals (contributingPort.getFragmentInstance ()))) {throw new Exception("SDMException");};

                                             // attribute condition
                                             if (!( link.isContributes () == true )) {throw new Exception("SDMException");};

                                             // attribute condition
                                             if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                                             // collabStat call
                                             link.getMatches().get(primaryLink.getMatches().indexOf(apMatchGroup)).execute(contribution, result, result, additionalContext);


                                             fujaba__Success = true;
                                          }
                                          catch ( Exception fujaba__InternalException )
                                          {
                                             fujaba__Success = false;
                                          }
                                       }
                                       if (!(fujaba__Success)) {throw new Exception("SDMException");};

                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }


                  }
                  else
                  {

                  }

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         completeInstantiation(theIS, result, additionalInstantiations, additionalContext);
         // story pattern EXTRA 1
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link portInstances from this to sPort
            fujaba__Success = false;
            fujaba__IterThisToSPort = new ArrayList<PortInstance>(this.getPortInstances()).iterator ();

            while ( fujaba__IterThisToSPort.hasNext () )
            {
               try
               {
                  sPort = (PortInstance) fujaba__IterThisToSPort.next ();

                  // check object sPort is really bound
                  if (!( sPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link source from sPort to link
                  fujaba__Success = false;
                  fujaba__IterSPortToLink = new ArrayList<CompositionLink>(sPort.getSourceLinks()).iterator ();

                  while ( fujaba__IterSPortToLink.hasNext () )
                  {
                     try
                     {
                        link = (CompositionLink) fujaba__IterSPortToLink.next ();

                        // check object link is really bound
                        if (!( link != null )) {throw new Exception("SDMException");};
                        // bind object
                        tPort = link.getTarget ();

                        // check object tPort is really bound
                        if (!( tPort != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects tPort and sPort
                        if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                        // bind object
                        otherFI = tPort.getFragmentInstance ();

                        // check object otherFI is really bound
                        if (!( otherFI != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects this and otherFI
                        if (!( !this.equals (otherFI) )) {throw new Exception("SDMException");};

                        // attribute condition
                        if (!( link.isContributes () == false )) {throw new Exception("SDMException");};

                        // attribute condition
                        if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                        // story pattern EXTRA 1.1
                        try 
                        {
                           fujaba__Success = false; 

                           // check object otherFI is really bound
                           if (!( otherFI != null )) {throw new Exception("SDMException");};
                           // check object theIS is really bound
                           if (!( theIS != null )) {throw new Exception("SDMException");};
                           // iterate to-many link instantiations from otherFI to someInstantiation
                           fujaba__Success = false;
                           fujaba__IterOtherFIToSomeInstantiation = otherFI.getInstantiations().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterOtherFIToSomeInstantiation.hasNext () )
                           {
                              try
                              {
                                 someInstantiation = (Fragment) fujaba__IterOtherFIToSomeInstantiation.next ();

                                 // check object someInstantiation is really bound
                                 if (!( someInstantiation != null )) {throw new Exception("SDMException");};
                                 // check link instantiations from theIS to someInstantiation
                                 if (!(theIS.getInstantiations ().contains (someInstantiation))) {throw new Exception("SDMException");};


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        if (fujaba__Success)
                        {

                        }
                        else
                        {
                           // story pattern EXTRA 1.2
                           try 
                           {
                              fujaba__Success = false; 

                              // check object additionalInstantiations is really bound
                              if (!( additionalInstantiations != null )) {throw new Exception("SDMException");};
                              // check object otherFI is really bound
                              if (!( otherFI != null )) {throw new Exception("SDMException");};
                              // iterate to-many link instantiations from otherFI to addInstantiation
                              fujaba__Success = false;
                              fujaba__IterOtherFIToAddInstantiation = otherFI.getInstantiations().iterator ();

                              while ( !(fujaba__Success) && fujaba__IterOtherFIToAddInstantiation.hasNext () )
                              {
                                 try
                                 {
                                    addInstantiation = (Fragment) fujaba__IterOtherFIToAddInstantiation.next ();

                                    // check object addInstantiation is really bound
                                    if (!( addInstantiation != null )) {throw new Exception("SDMException");};
                                    // check link instantiations from additionalInstantiations to addInstantiation
                                    if (!(additionalInstantiations.getInstantiations ().contains (addInstantiation))) {throw new Exception("SDMException");};


                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           if (fujaba__Success)
                           {
                              // story pattern EXTRA 1.3
                              try 
                              {
                                 fujaba__Success = false; 

                                 // check object link is really bound
                                 if (!( link != null )) {throw new Exception("SDMException");};
                                 // iterate to-many link matches from link to matchGroup
                                 fujaba__Success = false;
                                 fujaba__IterLinkToMatchGroup = new ArrayList<APMatchGroup>(link.getMatches()).iterator ();

                                 while ( fujaba__IterLinkToMatchGroup.hasNext () )
                                 {
                                    try
                                    {
                                       matchGroup = (APMatchGroup) fujaba__IterLinkToMatchGroup.next ();

                                       // check object matchGroup is really bound
                                       if (!( matchGroup != null )) {throw new Exception("SDMException");};
                                       // collabStat call
                                       matchGroup.execute(result, addInstantiation, result, additionalContext);

                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                           }
                           else
                           {
                              if (sPort.isValue() || tPort.isValue())
                              {
                                 // story pattern EXTRA 1.6
                                 try 
                                 {
                                    fujaba__Success = false; 

                                    // check object link is really bound
                                    if (!( link != null )) {throw new Exception("SDMException");};
                                    // iterate to-many link matches from link to matchGroup
                                    fujaba__Success = false;
                                    fujaba__IterLinkToMatchGroup = new ArrayList<APMatchGroup>(link.getMatches()).iterator ();

                                    while ( fujaba__IterLinkToMatchGroup.hasNext () )
                                    {
                                       try
                                       {
                                          matchGroup = (APMatchGroup) fujaba__IterLinkToMatchGroup.next ();

                                          // check object matchGroup is really bound
                                          if (!( matchGroup != null )) {throw new Exception("SDMException");};
                                          // collabStat call
                                          matchGroup.execute(result, otherFI.getFragment().copy(getTargetUFI()), result, additionalContext);

                                          fujaba__Success = true;
                                       }
                                       catch ( Exception fujaba__InternalException )
                                       {
                                          fujaba__Success = false;
                                       }
                                    }
                                    if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }


                              }
                              else
                              {

                              }

                           }

                        }



                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern EXTRA 2
         try 
         {
            fujaba__Success = false; 

            // iterate to-many link portInstances from this to tPort
            fujaba__Success = false;
            fujaba__IterThisToTPort = new ArrayList<PortInstance>(this.getPortInstances()).iterator ();

            while ( fujaba__IterThisToTPort.hasNext () )
            {
               try
               {
                  tPort = (PortInstance) fujaba__IterThisToTPort.next ();

                  // check object tPort is really bound
                  if (!( tPort != null )) {throw new Exception("SDMException");};
                  // iterate to-many link target from tPort to link
                  fujaba__Success = false;
                  fujaba__IterTPortToLink = new ArrayList<CompositionLink>(tPort.getTargetLinks()).iterator ();

                  while ( fujaba__IterTPortToLink.hasNext () )
                  {
                     try
                     {
                        link = (CompositionLink) fujaba__IterTPortToLink.next ();

                        // check object link is really bound
                        if (!( link != null )) {throw new Exception("SDMException");};
                        // bind object
                        sPort = link.getSource ();

                        // check object sPort is really bound
                        if (!( sPort != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects tPort and sPort
                        if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                        // bind object
                        otherFI = sPort.getFragmentInstance ();

                        // check object otherFI is really bound
                        if (!( otherFI != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects this and otherFI
                        if (!( !this.equals (otherFI) )) {throw new Exception("SDMException");};

                        // attribute condition
                        if (!( link.isContributes () == false )) {throw new Exception("SDMException");};

                        // attribute condition
                        if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                        // story pattern EXTRA 2.1
                        try 
                        {
                           fujaba__Success = false; 

                           // check object otherFI is really bound
                           if (!( otherFI != null )) {throw new Exception("SDMException");};
                           // check object theIS is really bound
                           if (!( theIS != null )) {throw new Exception("SDMException");};
                           // iterate to-many link instantiations from otherFI to someInstantiation
                           fujaba__Success = false;
                           fujaba__IterOtherFIToSomeInstantiation = otherFI.getInstantiations().iterator ();

                           while ( !(fujaba__Success) && fujaba__IterOtherFIToSomeInstantiation.hasNext () )
                           {
                              try
                              {
                                 someInstantiation = (Fragment) fujaba__IterOtherFIToSomeInstantiation.next ();

                                 // check object someInstantiation is really bound
                                 if (!( someInstantiation != null )) {throw new Exception("SDMException");};
                                 // check link instantiations from theIS to someInstantiation
                                 if (!(theIS.getInstantiations ().contains (someInstantiation))) {throw new Exception("SDMException");};


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }

                        if (fujaba__Success)
                        {

                        }
                        else
                        {
                           // story pattern EXTRA 2.2
                           try 
                           {
                              fujaba__Success = false; 

                              // check object additionalInstantiations is really bound
                              if (!( additionalInstantiations != null )) {throw new Exception("SDMException");};
                              // check object otherFI is really bound
                              if (!( otherFI != null )) {throw new Exception("SDMException");};
                              // iterate to-many link instantiations from otherFI to addInstantiation
                              fujaba__Success = false;
                              fujaba__IterOtherFIToAddInstantiation = otherFI.getInstantiations().iterator ();

                              while ( !(fujaba__Success) && fujaba__IterOtherFIToAddInstantiation.hasNext () )
                              {
                                 try
                                 {
                                    addInstantiation = (Fragment) fujaba__IterOtherFIToAddInstantiation.next ();

                                    // check object addInstantiation is really bound
                                    if (!( addInstantiation != null )) {throw new Exception("SDMException");};
                                    // check link instantiations from additionalInstantiations to addInstantiation
                                    if (!(additionalInstantiations.getInstantiations ().contains (addInstantiation))) {throw new Exception("SDMException");};


                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};
                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }

                           if (fujaba__Success)
                           {
                              // story pattern EXTRA 2.3
                              try 
                              {
                                 fujaba__Success = false; 

                                 // check object link is really bound
                                 if (!( link != null )) {throw new Exception("SDMException");};
                                 // iterate to-many link matches from link to matchGroup
                                 fujaba__Success = false;
                                 fujaba__IterLinkToMatchGroup = new ArrayList<APMatchGroup>(link.getMatches()).iterator ();

                                 while ( fujaba__IterLinkToMatchGroup.hasNext () )
                                 {
                                    try
                                    {
                                       matchGroup = (APMatchGroup) fujaba__IterLinkToMatchGroup.next ();

                                       // check object matchGroup is really bound
                                       if (!( matchGroup != null )) {throw new Exception("SDMException");};
                                       // collabStat call
                                       matchGroup.execute(addInstantiation, result, result, additionalContext);

                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                           }
                           else
                           {
                              if (sPort.isValue() || tPort.isValue())
                              {
                                 // story pattern EXTRA 2.6
                                 try 
                                 {
                                    fujaba__Success = false; 

                                    // check object link is really bound
                                    if (!( link != null )) {throw new Exception("SDMException");};
                                    // iterate to-many link matches from link to matchGroup
                                    fujaba__Success = false;
                                    fujaba__IterLinkToMatchGroup = new ArrayList<APMatchGroup>(link.getMatches()).iterator ();

                                    while ( fujaba__IterLinkToMatchGroup.hasNext () )
                                    {
                                       try
                                       {
                                          matchGroup = (APMatchGroup) fujaba__IterLinkToMatchGroup.next ();

                                          // check object matchGroup is really bound
                                          if (!( matchGroup != null )) {throw new Exception("SDMException");};
                                          // collabStat call
                                          matchGroup.execute(otherFI.getFragment().copy(getTargetUFI()), result, result, additionalContext);

                                          fujaba__Success = true;
                                       }
                                       catch ( Exception fujaba__InternalException )
                                       {
                                          fujaba__Success = false;
                                       }
                                    }
                                    if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }


                              }
                              else
                              {

                              }

                           }

                        }



                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         // story pattern Process configurations
         try 
         {
            fujaba__Success = false; 

            // check object cp is really bound
            if (!( cp != null )) {throw new Exception("SDMException");};
            // check object theIS is really bound
            if (!( theIS != null )) {throw new Exception("SDMException");};
            // iterate to-many link instantiations from theIS to contribution1
            fujaba__Success = false;
            fujaba__IterTheISToContribution1 = new ArrayList<Fragment>(theIS.getInstantiations()).iterator ();

            while ( fujaba__IterTheISToContribution1.hasNext () )
            {
               try
               {
                  contribution1 = (Fragment) fujaba__IterTheISToContribution1.next ();

                  // check object contribution1 is really bound
                  if (!( contribution1 != null )) {throw new Exception("SDMException");};
                  // iterate to-many link compositionLinks from cp to link
                  fujaba__Success = false;
                  fujaba__IterCpToLink = new ArrayList<CompositionLink>(cp.getCompositionLinks()).iterator ();

                  while ( fujaba__IterCpToLink.hasNext () )
                  {
                     try
                     {
                        link = (CompositionLink) fujaba__IterCpToLink.next ();

                        // check object link is really bound
                        if (!( link != null )) {throw new Exception("SDMException");};
                        // bind object
                        tPort = link.getTarget ();

                        // check object tPort is really bound
                        if (!( tPort != null )) {throw new Exception("SDMException");};

                        // bind object
                        contributor2 = tPort.getFragmentInstance ();

                        // check object contributor2 is really bound
                        if (!( contributor2 != null )) {throw new Exception("SDMException");};

                        // bind object
                        sPort = link.getSource ();

                        // check object sPort is really bound
                        if (!( sPort != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects tPort and sPort
                        if (!( !tPort.equals (sPort) )) {throw new Exception("SDMException");};

                        // bind object
                        contributor1 = sPort.getFragmentInstance ();

                        // check object contributor1 is really bound
                        if (!( contributor1 != null )) {throw new Exception("SDMException");};


                        // check isomorphic binding between objects contributor2 and contributor1
                        if (!( !contributor2.equals (contributor1) )) {throw new Exception("SDMException");};

                        // check link instantiations from contributor1 to contribution1
                        if (!(contributor1.getInstantiations ().contains (contribution1))) {throw new Exception("SDMException");};

                        // iterate to-many link instantiations from theIS to contribution2
                        fujaba__Success = false;
                        fujaba__IterTheISToContribution2 = new ArrayList<Fragment>(theIS.getInstantiations()).iterator ();

                        while ( fujaba__IterTheISToContribution2.hasNext () )
                        {
                           try
                           {
                              contribution2 = (Fragment) fujaba__IterTheISToContribution2.next ();

                              // check object contribution2 is really bound
                              if (!( contribution2 != null )) {throw new Exception("SDMException");};

                              // check isomorphic binding between objects contribution2 and contribution1
                              if (!( !contribution2.equals (contribution1) )) {throw new Exception("SDMException");};

                              // check link instantiations from contributor2 to contribution2
                              if (!(contributor2.getInstantiations ().contains (contribution2))) {throw new Exception("SDMException");};

                              // iterate to-many link matches from link to matchGroup
                              fujaba__Success = false;
                              fujaba__IterLinkToMatchGroup = new ArrayList<APMatchGroup>(link.getMatches()).iterator ();

                              while ( fujaba__IterLinkToMatchGroup.hasNext () )
                              {
                                 try
                                 {
                                    matchGroup = (APMatchGroup) fujaba__IterLinkToMatchGroup.next ();

                                    // check object matchGroup is really bound
                                    if (!( matchGroup != null )) {throw new Exception("SDMException");};
                                    // attribute condition
                                    if (!( link.isContributes () == false )) {throw new Exception("SDMException");};

                                    // attribute condition
                                    if (!( link.isValid () == true )) {throw new Exception("SDMException");};

                                    // collabStat call
                                    matchGroup.execute(contribution1, contribution2, result, additionalContext);

                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};





                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         org.reuseware.coconut.compositionprogram.util.CompositionStepPostProcessorUtil.process(result, this, theIS.getInstantiations());
         // story pattern 6
         try 
         {
            fujaba__Success = false; 

            // check object theIS is really bound
            if (!( theIS != null )) {throw new Exception("SDMException");};
            // iterate to-many link instantiations from theIS to someFragment
            fujaba__Success = false;
            fujaba__IterTheISToSomeFragment = new ArrayList<Fragment>(theIS.getInstantiations()).iterator ();

            while ( fujaba__IterTheISToSomeFragment.hasNext () )
            {
               try
               {
                  someFragment = (Fragment) fujaba__IterTheISToSomeFragment.next ();

                  // check object someFragment is really bound
                  if (!( someFragment != null )) {throw new Exception("SDMException");};
                  // destroy link
                  theIS.getInstantiations().remove (someFragment);


                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }
            }
            if (!(fujaba__Success)) {throw new Exception("SDMException");};
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         return result;

      }
      else
      {
         return null;

      }

   }


   public Setting getSetting (String port , String property ){
      boolean fujaba__Success = false;
      Iterator<Setting> fujaba__IterPortInstanceToSetting = null;
      Setting setting = null;
      Iterator<PortInstance> fujaba__IterThisToPortInstance = null;
      PortInstance portInstance = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link portInstances from this to portInstance
         fujaba__Success = false;
         fujaba__IterThisToPortInstance = this.getPortInstances().iterator ();

         while ( !(fujaba__Success) && fujaba__IterThisToPortInstance.hasNext () )
         {
            try
            {
               portInstance = (PortInstance) fujaba__IterThisToPortInstance.next ();

               // check object portInstance is really bound
               if (!( portInstance != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( port.equals(portInstance.getPortName ()) )) {throw new Exception("SDMException");};

               // iterate to-many link settings from portInstance to setting
               fujaba__Success = false;
               fujaba__IterPortInstanceToSetting = portInstance.getSettings().iterator ();

               while ( !(fujaba__Success) && fujaba__IterPortInstanceToSetting.hasNext () )
               {
                  try
                  {
                     setting = (Setting) fujaba__IterPortInstanceToSetting.next ();

                     // check object setting is really bound
                     if (!( setting != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( property.equals(setting.getProperty ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return setting;

      }
      else
      {
         return null;

      }

   }


   public ID getTargetUFIAsID (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // assign statement
         id.getSegments ().clear();
         id.getSegments ().addAll(getTargetUFI());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public ID getUFIAsID (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // assign statement
         id.getSegments ().clear();
         id.getSegments ().addAll(getUFI());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public void setTargetUFIAsString (String targetUFIString ){

      String[] idArray = targetUFIString.split("/");
      getTargetUFI().clear();
      getTargetUFI().addAll(java.util.Arrays.asList(idArray));
      return ;

   }


   public void setUFIAsString (String ufiString ){

      String[] idArray = ufiString.split("/");
      getUFI().clear();
      getUFI().addAll(java.util.Arrays.asList(idArray));
      return ;

   }


   public void update (){
      boolean fujaba__Success = false;
      Iterator<?> fujaba__IterPortInstanceToPort = null;
      Iterator<PortInstance> fujaba__IterThisToPortInstance = null;
      PortInstance portInstance = null;
      Iterator<Port> fujaba__IterCiToPort = null;
      Port port = null;
      FragmentCollaboration cs = null;
      FragmentRole fRole = null;
      Object _TmpObject = null;
      FragmentRoleBinding binding = null;
      Iterator<CompositionInterface> fujaba__IterFragmentToCi = null;
      CompositionInterface ci = null;
      Fragment fragment = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // bind object
         fragment = this.getFragment ();

         // check object fragment is really bound
         if (!( fragment != null )) {throw new Exception("SDMException");};

         // iterate to-many link compositionInterfaces from fragment to ci
         fujaba__Success = false;
         fujaba__IterFragmentToCi = new ArrayList<CompositionInterface>(fragment.getCompositionInterfaces()).iterator ();

         while ( fujaba__IterFragmentToCi.hasNext () )
         {
            try
            {
               ci = (CompositionInterface) fujaba__IterFragmentToCi.next ();

               // check object ci is really bound
               if (!( ci != null )) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = ci.getRoleBinding ();

               // ensure correct type and really bound of object binding
               if (!( _TmpObject instanceof FragmentRoleBinding )) {throw new Exception("SDMException");};
               binding = (FragmentRoleBinding) _TmpObject;


               // bind object
               fRole = binding.getFragmentRole ();

               // check object fRole is really bound
               if (!( fRole != null )) {throw new Exception("SDMException");};

               // bind object
               cs = fRole.getFragmentCollaboration ();

               // check object cs is really bound
               if (!( cs != null )) {throw new Exception("SDMException");};

               // iterate to-many link ports from ci to port
               fujaba__Success = false;
               fujaba__IterCiToPort = new ArrayList<Port>(ci.getPorts()).iterator ();

               while ( fujaba__IterCiToPort.hasNext () )
               {
                  try
                  {
                     port = (Port) fujaba__IterCiToPort.next ();

                     // check object port is really bound
                     if (!( port != null )) {throw new Exception("SDMException");};
                     // story pattern 2
                     try 
                     {
                        fujaba__Success = false; 

                        // check object port is really bound
                        if (!( port != null )) {throw new Exception("SDMException");};
                        // iterate to-many link portInstances from this to portInstance
                        fujaba__Success = false;
                        fujaba__IterThisToPortInstance = this.getPortInstances().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterThisToPortInstance.hasNext () )
                        {
                           try
                           {
                              portInstance = (PortInstance) fujaba__IterThisToPortInstance.next ();

                              // check object portInstance is really bound
                              if (!( portInstance != null )) {throw new Exception("SDMException");};
                              // check path expresion port() from portInstance to port
                              // iterate to-many link $link.InstanceOf.Name from portInstance to port
                              fujaba__Success = false;
                              _TmpObject = portInstance.port();
                              if (_TmpObject instanceof Iterator<?>) {
                                  fujaba__IterPortInstanceToPort = (Iterator<?>)_TmpObject;    
                              }
                              else if (_TmpObject instanceof Iterable<?>) {
                                  fujaba__IterPortInstanceToPort = ((Iterable<?>)_TmpObject).iterator();
                              }
                              else {
                                  fujaba__IterPortInstanceToPort = Collections.singletonList(_TmpObject).iterator();
                              }
                              while ( !(fujaba__Success) && fujaba__IterPortInstanceToPort.hasNext () )
                              {
                                 try
                                 {
                                    if (!( port.equals (fujaba__IterPortInstanceToPort.next ()) )) {throw new Exception("SDMException");};

                                    fujaba__Success = true;
                                 }
                                 catch ( Exception fujaba__InternalException )
                                 {
                                    fujaba__Success = false;
                                 }
                              }
                              if (!(fujaba__Success)) {throw new Exception("SDMException");};

                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        // story pattern 3
                        try 
                        {
                           fujaba__Success = false; 

                           // create object
                           portInstance = CompositionprogramFactory.eINSTANCE.createPortInstance();
                           // assign statement
                           portInstance.setPortName (port.getName());
                           // assign statement
                           portInstance.setFragmentRoleName (fRole.getName());
                           // assign statement
                           portInstance.getFracolNamespace ().clear();
                           portInstance.getFracolNamespace ().addAll(cs.getFracolNamespace());
                           // assign statement
                           portInstance.setFracolName (cs.getFracolName());
                           // create link
                           portInstance.setFragmentInstance(this);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};




               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 7
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link portInstances from this to portInstance
         fujaba__Success = false;
         fujaba__IterThisToPortInstance = new ArrayList<PortInstance>(this.getPortInstances()).iterator ();

         while ( fujaba__IterThisToPortInstance.hasNext () )
         {
            try
            {
               portInstance = (PortInstance) fujaba__IterThisToPortInstance.next ();

               // check object portInstance is really bound
               if (!( portInstance != null )) {throw new Exception("SDMException");};
               // collabStat call
               portInstance.update();

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.setCompositionProgram (null);
      this.getDerivedFrom().clear();
      this.setFragment (null);
      this.getInstantiations().clear();
      this.getPortInstances().clear();
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetCompositionProgram((CompositionProgram)otherEnd, msgs);
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPortInstances()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS:
        return ((InternalEList<?>)getArguments()).basicRemove(otherEnd, msgs);
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        return basicSetCompositionProgram(null, msgs);
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        return ((InternalEList<?>)getPortInstances()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        return eInternalContainer().eInverseRemove(this, CompositionprogramPackage.COMPOSITION_PROGRAM__FRAGMENT_INSTANCES, CompositionProgram.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__UFI:
        return getUFI();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS:
        if (coreType) return getArguments();
        else return getArguments().map();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        return getCompositionProgram();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__DERIVED_FROM:
        return getDerivedFrom();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT:
        if (resolve) return getFragment();
        return basicGetFragment();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__INSTANTIATIONS:
        return getInstantiations();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__NAME:
        return getName();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        return getPortInstances();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__REFERENCE:
        return isReference();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION:
        return getTargetPhysicalLocation();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_UFI:
        return getTargetUFI();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET:
        return isTarget();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__UFI:
        getUFI().clear();
        getUFI().addAll((Collection<? extends String>)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS:
        ((EStructuralFeature.Setting)getArguments()).set(newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        setCompositionProgram((CompositionProgram)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__DERIVED_FROM:
        getDerivedFrom().clear();
        getDerivedFrom().addAll((Collection<? extends EObject>)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT:
        setFragment((Fragment)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__INSTANTIATIONS:
        getInstantiations().clear();
        getInstantiations().addAll((Collection<? extends Fragment>)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__NAME:
        setName((String)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        getPortInstances().clear();
        getPortInstances().addAll((Collection<? extends PortInstance>)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__REFERENCE:
        setReference((Boolean)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION:
        setTargetPhysicalLocation((String)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_UFI:
        getTargetUFI().clear();
        getTargetUFI().addAll((Collection<? extends String>)newValue);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET:
        setTarget((Boolean)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__UFI:
        getUFI().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS:
        getArguments().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        setCompositionProgram((CompositionProgram)null);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__DERIVED_FROM:
        getDerivedFrom().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT:
        setFragment((Fragment)null);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__INSTANTIATIONS:
        getInstantiations().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__NAME:
        setName(NAME_EDEFAULT);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        getPortInstances().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__REFERENCE:
        setReference(REFERENCE_EDEFAULT);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION:
        setTargetPhysicalLocation(TARGET_PHYSICAL_LOCATION_EDEFAULT);
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_UFI:
        getTargetUFI().clear();
        return;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET:
        setTarget(TARGET_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.FRAGMENT_INSTANCE__UFI:
        return ufi != null && !ufi.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__ARGUMENTS:
        return arguments != null && !arguments.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__COMPOSITION_PROGRAM:
        return getCompositionProgram() != null;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__DERIVED_FROM:
        return derivedFrom != null && !derivedFrom.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__FRAGMENT:
        return fragment != null;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__INSTANTIATIONS:
        return instantiations != null && !instantiations.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case CompositionprogramPackage.FRAGMENT_INSTANCE__PORT_INSTANCES:
        return portInstances != null && !portInstances.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__REFERENCE:
        return reference != REFERENCE_EDEFAULT;
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION:
        return TARGET_PHYSICAL_LOCATION_EDEFAULT == null ? targetPhysicalLocation != null : !TARGET_PHYSICAL_LOCATION_EDEFAULT.equals(targetPhysicalLocation);
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET_UFI:
        return targetUFI != null && !targetUFI.isEmpty();
      case CompositionprogramPackage.FRAGMENT_INSTANCE__TARGET:
        return target != TARGET_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (UFI: ");
    result.append(ufi);
    result.append(", name: ");
    result.append(name);
    result.append(", reference: ");
    result.append(reference);
    result.append(", targetPhysicalLocation: ");
    result.append(targetPhysicalLocation);
    result.append(", targetUFI: ");
    result.append(targetUFI);
    result.append(", target: ");
    result.append(target);
    result.append(')');
    return result.toString();
  }
}


