/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.fracol.FracolFactory
 * @model kind="package"
 * @generated
 */
public interface FracolPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "fracol";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://reuseware.org/coconut/fracol";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "org.reuseware.coconut.fracol";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  FracolPackage eINSTANCE = org.reuseware.coconut.fracol.impl.FracolPackageImpl.init();

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.CompositionAssociationImpl <em>Composition Association</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.CompositionAssociationImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getCompositionAssociation()
   * @generated
   */
  int COMPOSITION_ASSOCIATION = 0;

  /**
   * The feature id for the '<em><b>End1 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__END1_ROLE = 0;

  /**
   * The feature id for the '<em><b>End1</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__END1 = 1;

  /**
   * The feature id for the '<em><b>End2 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__END2_ROLE = 2;

  /**
   * The feature id for the '<em><b>End2</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__END2 = 3;

  /**
   * The feature id for the '<em><b>Fragment Collaboration</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION__NAME = 5;

  /**
   * The number of structural features of the '<em>Composition Association</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_FEATURE_COUNT = 6;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.ConfigurationImpl <em>Configuration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.ConfigurationImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getConfiguration()
   * @generated
   */
  int CONFIGURATION = 1;

  /**
   * The feature id for the '<em><b>End1 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__END1_ROLE = COMPOSITION_ASSOCIATION__END1_ROLE;

  /**
   * The feature id for the '<em><b>End1</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__END1 = COMPOSITION_ASSOCIATION__END1;

  /**
   * The feature id for the '<em><b>End2 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__END2_ROLE = COMPOSITION_ASSOCIATION__END2_ROLE;

  /**
   * The feature id for the '<em><b>End2</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__END2 = COMPOSITION_ASSOCIATION__END2;

  /**
   * The feature id for the '<em><b>Fragment Collaboration</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__FRAGMENT_COLLABORATION = COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__NAME = COMPOSITION_ASSOCIATION__NAME;

  /**
   * The number of structural features of the '<em>Configuration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_FEATURE_COUNT = COMPOSITION_ASSOCIATION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.ContributionImpl <em>Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.ContributionImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getContribution()
   * @generated
   */
  int CONTRIBUTION = 2;

  /**
   * The feature id for the '<em><b>End1 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__END1_ROLE = COMPOSITION_ASSOCIATION__END1_ROLE;

  /**
   * The feature id for the '<em><b>End1</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__END1 = COMPOSITION_ASSOCIATION__END1;

  /**
   * The feature id for the '<em><b>End2 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__END2_ROLE = COMPOSITION_ASSOCIATION__END2_ROLE;

  /**
   * The feature id for the '<em><b>End2</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__END2 = COMPOSITION_ASSOCIATION__END2;

  /**
   * The feature id for the '<em><b>Fragment Collaboration</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__FRAGMENT_COLLABORATION = COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__NAME = COMPOSITION_ASSOCIATION__NAME;

  /**
   * The number of structural features of the '<em>Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION_FEATURE_COUNT = COMPOSITION_ASSOCIATION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.PortTypeImpl <em>Port Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.PortTypeImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getPortType()
   * @generated
   */
  int PORT_TYPE = 6;

  /**
   * The feature id for the '<em><b>Composition Associations2</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE__COMPOSITION_ASSOCIATIONS2 = 0;

  /**
   * The feature id for the '<em><b>Composition Associations</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE__COMPOSITION_ASSOCIATIONS = 1;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE__FRAGMENT_ROLE = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE__NAME = 3;

  /**
   * The number of structural features of the '<em>Port Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.DynamicPortTypeImpl <em>Dynamic Port Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.DynamicPortTypeImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getDynamicPortType()
   * @generated
   */
  int DYNAMIC_PORT_TYPE = 3;

  /**
   * The feature id for the '<em><b>Composition Associations2</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DYNAMIC_PORT_TYPE__COMPOSITION_ASSOCIATIONS2 = PORT_TYPE__COMPOSITION_ASSOCIATIONS2;

  /**
   * The feature id for the '<em><b>Composition Associations</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DYNAMIC_PORT_TYPE__COMPOSITION_ASSOCIATIONS = PORT_TYPE__COMPOSITION_ASSOCIATIONS;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DYNAMIC_PORT_TYPE__FRAGMENT_ROLE = PORT_TYPE__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DYNAMIC_PORT_TYPE__NAME = PORT_TYPE__NAME;

  /**
   * The number of structural features of the '<em>Dynamic Port Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DYNAMIC_PORT_TYPE_FEATURE_COUNT = PORT_TYPE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.FragmentCollaborationImpl <em>Fragment Collaboration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.FragmentCollaborationImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getFragmentCollaboration()
   * @generated
   */
  int FRAGMENT_COLLABORATION = 4;

  /**
   * The feature id for the '<em><b>Composition Associations</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS = 0;

  /**
   * The feature id for the '<em><b>Fracol Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_COLLABORATION__FRACOL_NAME = 1;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_COLLABORATION__FRACOL_NAMESPACE = 2;

  /**
   * The feature id for the '<em><b>Fragment Roles</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_COLLABORATION__FRAGMENT_ROLES = 3;

  /**
   * The number of structural features of the '<em>Fragment Collaboration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_COLLABORATION_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.FragmentRoleImpl <em>Fragment Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.FragmentRoleImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getFragmentRole()
   * @generated
   */
  int FRAGMENT_ROLE = 5;

  /**
   * The feature id for the '<em><b>Fragment Collaboration</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE__FRAGMENT_COLLABORATION = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE__NAME = 1;

  /**
   * The feature id for the '<em><b>Port Types</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE__PORT_TYPES = 2;

  /**
   * The number of structural features of the '<em>Fragment Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fracol.impl.StaticPortTypeImpl <em>Static Port Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fracol.impl.StaticPortTypeImpl
   * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getStaticPortType()
   * @generated
   */
  int STATIC_PORT_TYPE = 7;

  /**
   * The feature id for the '<em><b>Composition Associations2</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STATIC_PORT_TYPE__COMPOSITION_ASSOCIATIONS2 = PORT_TYPE__COMPOSITION_ASSOCIATIONS2;

  /**
   * The feature id for the '<em><b>Composition Associations</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STATIC_PORT_TYPE__COMPOSITION_ASSOCIATIONS = PORT_TYPE__COMPOSITION_ASSOCIATIONS;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STATIC_PORT_TYPE__FRAGMENT_ROLE = PORT_TYPE__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STATIC_PORT_TYPE__NAME = PORT_TYPE__NAME;

  /**
   * The number of structural features of the '<em>Static Port Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STATIC_PORT_TYPE_FEATURE_COUNT = PORT_TYPE_FEATURE_COUNT + 0;


  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.CompositionAssociation <em>Composition Association</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Association</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation
   * @generated
   */
  EClass getCompositionAssociation();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1Role <em>End1 Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>End1 Role</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd1Role()
   * @see #getCompositionAssociation()
   * @generated
   */
  EReference getCompositionAssociation_End1Role();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1 <em>End1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>End1</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd1()
   * @see #getCompositionAssociation()
   * @generated
   */
  EReference getCompositionAssociation_End1();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2Role <em>End2 Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>End2 Role</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd2Role()
   * @see #getCompositionAssociation()
   * @generated
   */
  EReference getCompositionAssociation_End2Role();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2 <em>End2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>End2</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd2()
   * @see #getCompositionAssociation()
   * @generated
   */
  EReference getCompositionAssociation_End2();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration <em>Fragment Collaboration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Collaboration</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration()
   * @see #getCompositionAssociation()
   * @generated
   */
  EReference getCompositionAssociation_FragmentCollaboration();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fracol.CompositionAssociation#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getName()
   * @see #getCompositionAssociation()
   * @generated
   */
  EAttribute getCompositionAssociation_Name();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.Configuration <em>Configuration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Configuration</em>'.
   * @see org.reuseware.coconut.fracol.Configuration
   * @generated
   */
  EClass getConfiguration();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.Contribution <em>Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Contribution</em>'.
   * @see org.reuseware.coconut.fracol.Contribution
   * @generated
   */
  EClass getContribution();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.DynamicPortType <em>Dynamic Port Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Dynamic Port Type</em>'.
   * @see org.reuseware.coconut.fracol.DynamicPortType
   * @generated
   */
  EClass getDynamicPortType();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.FragmentCollaboration <em>Fragment Collaboration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Collaboration</em>'.
   * @see org.reuseware.coconut.fracol.FragmentCollaboration
   * @generated
   */
  EClass getFragmentCollaboration();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getCompositionAssociations <em>Composition Associations</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composition Associations</em>'.
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getCompositionAssociations()
   * @see #getFragmentCollaboration()
   * @generated
   */
  EReference getFragmentCollaboration_CompositionAssociations();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFracolName <em>Fracol Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fracol Name</em>'.
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getFracolName()
   * @see #getFragmentCollaboration()
   * @generated
   */
  EAttribute getFragmentCollaboration_FracolName();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFracolNamespace <em>Fracol Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Fracol Namespace</em>'.
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getFracolNamespace()
   * @see #getFragmentCollaboration()
   * @generated
   */
  EAttribute getFragmentCollaboration_FracolNamespace();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFragmentRoles <em>Fragment Roles</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Fragment Roles</em>'.
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getFragmentRoles()
   * @see #getFragmentCollaboration()
   * @generated
   */
  EReference getFragmentCollaboration_FragmentRoles();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.FragmentRole <em>Fragment Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role</em>'.
   * @see org.reuseware.coconut.fracol.FragmentRole
   * @generated
   */
  EClass getFragmentRole();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration <em>Fragment Collaboration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Collaboration</em>'.
   * @see org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration()
   * @see #getFragmentRole()
   * @generated
   */
  EReference getFragmentRole_FragmentCollaboration();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fracol.FragmentRole#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.fracol.FragmentRole#getName()
   * @see #getFragmentRole()
   * @generated
   */
  EAttribute getFragmentRole_Name();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fracol.FragmentRole#getPortTypes <em>Port Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Port Types</em>'.
   * @see org.reuseware.coconut.fracol.FragmentRole#getPortTypes()
   * @see #getFragmentRole()
   * @generated
   */
  EReference getFragmentRole_PortTypes();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.PortType <em>Port Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type</em>'.
   * @see org.reuseware.coconut.fracol.PortType
   * @generated
   */
  EClass getPortType();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations2 <em>Composition Associations2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Composition Associations2</em>'.
   * @see org.reuseware.coconut.fracol.PortType#getCompositionAssociations2()
   * @see #getPortType()
   * @generated
   */
  EReference getPortType_CompositionAssociations2();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations <em>Composition Associations</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Composition Associations</em>'.
   * @see org.reuseware.coconut.fracol.PortType#getCompositionAssociations()
   * @see #getPortType()
   * @generated
   */
  EReference getPortType_CompositionAssociations();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fracol.PortType#getFragmentRole <em>Fragment Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Role</em>'.
   * @see org.reuseware.coconut.fracol.PortType#getFragmentRole()
   * @see #getPortType()
   * @generated
   */
  EReference getPortType_FragmentRole();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fracol.PortType#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.fracol.PortType#getName()
   * @see #getPortType()
   * @generated
   */
  EAttribute getPortType_Name();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fracol.StaticPortType <em>Static Port Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Static Port Type</em>'.
   * @see org.reuseware.coconut.fracol.StaticPortType
   * @generated
   */
  EClass getStaticPortType();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  FracolFactory getFracolFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.CompositionAssociationImpl <em>Composition Association</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.CompositionAssociationImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getCompositionAssociation()
     * @generated
     */
    EClass COMPOSITION_ASSOCIATION = eINSTANCE.getCompositionAssociation();

    /**
     * The meta object literal for the '<em><b>End1 Role</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION__END1_ROLE = eINSTANCE.getCompositionAssociation_End1Role();

    /**
     * The meta object literal for the '<em><b>End1</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION__END1 = eINSTANCE.getCompositionAssociation_End1();

    /**
     * The meta object literal for the '<em><b>End2 Role</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION__END2_ROLE = eINSTANCE.getCompositionAssociation_End2Role();

    /**
     * The meta object literal for the '<em><b>End2</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION__END2 = eINSTANCE.getCompositionAssociation_End2();

    /**
     * The meta object literal for the '<em><b>Fragment Collaboration</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION = eINSTANCE.getCompositionAssociation_FragmentCollaboration();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION__NAME = eINSTANCE.getCompositionAssociation_Name();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.ConfigurationImpl <em>Configuration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.ConfigurationImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getConfiguration()
     * @generated
     */
    EClass CONFIGURATION = eINSTANCE.getConfiguration();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.ContributionImpl <em>Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.ContributionImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getContribution()
     * @generated
     */
    EClass CONTRIBUTION = eINSTANCE.getContribution();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.DynamicPortTypeImpl <em>Dynamic Port Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.DynamicPortTypeImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getDynamicPortType()
     * @generated
     */
    EClass DYNAMIC_PORT_TYPE = eINSTANCE.getDynamicPortType();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.FragmentCollaborationImpl <em>Fragment Collaboration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.FragmentCollaborationImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getFragmentCollaboration()
     * @generated
     */
    EClass FRAGMENT_COLLABORATION = eINSTANCE.getFragmentCollaboration();

    /**
     * The meta object literal for the '<em><b>Composition Associations</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS = eINSTANCE.getFragmentCollaboration_CompositionAssociations();

    /**
     * The meta object literal for the '<em><b>Fracol Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_COLLABORATION__FRACOL_NAME = eINSTANCE.getFragmentCollaboration_FracolName();

    /**
     * The meta object literal for the '<em><b>Fracol Namespace</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_COLLABORATION__FRACOL_NAMESPACE = eINSTANCE.getFragmentCollaboration_FracolNamespace();

    /**
     * The meta object literal for the '<em><b>Fragment Roles</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_COLLABORATION__FRAGMENT_ROLES = eINSTANCE.getFragmentCollaboration_FragmentRoles();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.FragmentRoleImpl <em>Fragment Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.FragmentRoleImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getFragmentRole()
     * @generated
     */
    EClass FRAGMENT_ROLE = eINSTANCE.getFragmentRole();

    /**
     * The meta object literal for the '<em><b>Fragment Collaboration</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE__FRAGMENT_COLLABORATION = eINSTANCE.getFragmentRole_FragmentCollaboration();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE__NAME = eINSTANCE.getFragmentRole_Name();

    /**
     * The meta object literal for the '<em><b>Port Types</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE__PORT_TYPES = eINSTANCE.getFragmentRole_PortTypes();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.PortTypeImpl <em>Port Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.PortTypeImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getPortType()
     * @generated
     */
    EClass PORT_TYPE = eINSTANCE.getPortType();

    /**
     * The meta object literal for the '<em><b>Composition Associations2</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE__COMPOSITION_ASSOCIATIONS2 = eINSTANCE.getPortType_CompositionAssociations2();

    /**
     * The meta object literal for the '<em><b>Composition Associations</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE__COMPOSITION_ASSOCIATIONS = eINSTANCE.getPortType_CompositionAssociations();

    /**
     * The meta object literal for the '<em><b>Fragment Role</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE__FRAGMENT_ROLE = eINSTANCE.getPortType_FragmentRole();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_TYPE__NAME = eINSTANCE.getPortType_Name();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fracol.impl.StaticPortTypeImpl <em>Static Port Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fracol.impl.StaticPortTypeImpl
     * @see org.reuseware.coconut.fracol.impl.FracolPackageImpl#getStaticPortType()
     * @generated
     */
    EClass STATIC_PORT_TYPE = eINSTANCE.getStaticPortType();

  }

} //FracolPackage
