/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Role</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration <em>Fragment Collaboration</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentRole#getName <em>Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentRole#getPortTypes <em>Port Types</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentRole()
 * @model
 * @generated
 */
public interface FragmentRole extends EObject
{
  /**
   * Returns the value of the '<em><b>Fragment Collaboration</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFragmentRoles <em>Fragment Roles</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Collaboration</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Collaboration</em>' container reference.
   * @see #setFragmentCollaboration(FragmentCollaboration)
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentRole_FragmentCollaboration()
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getFragmentRoles
   * @model opposite="fragmentRoles" transient="false" ordered="false"
   * @generated
   */
  FragmentCollaboration getFragmentCollaboration();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration <em>Fragment Collaboration</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Collaboration</em>' container reference.
   * @see #getFragmentCollaboration()
   * @generated
   */
  void setFragmentCollaboration(FragmentCollaboration value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentRole_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.FragmentRole#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Port Types</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fracol.PortType}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.PortType#getFragmentRole <em>Fragment Role</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Types</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Types</em>' containment reference list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentRole_PortTypes()
   * @see org.reuseware.coconut.fracol.PortType#getFragmentRole
   * @model opposite="fragmentRole" containment="true" keys="name" ordered="false"
   * @generated
   */
  EList<PortType> getPortTypes();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  PortType getPortType(String portTypeName);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentRole
