/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.reuseware.coconut.fracol.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FracolFactoryImpl extends EFactoryImpl implements FracolFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static FracolFactory init()
  {
    try
    {
      FracolFactory theFracolFactory = (FracolFactory)EPackage.Registry.INSTANCE.getEFactory("http://reuseware.org/coconut/fracol"); 
      if (theFracolFactory != null)
      {
        return theFracolFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new FracolFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FracolFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case FracolPackage.CONFIGURATION: return createConfiguration();
      case FracolPackage.CONTRIBUTION: return createContribution();
      case FracolPackage.DYNAMIC_PORT_TYPE: return createDynamicPortType();
      case FracolPackage.FRAGMENT_COLLABORATION: return createFragmentCollaboration();
      case FracolPackage.FRAGMENT_ROLE: return createFragmentRole();
      case FracolPackage.STATIC_PORT_TYPE: return createStaticPortType();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Configuration createConfiguration()
  {
    ConfigurationImpl configuration = new ConfigurationImpl();
    return configuration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Contribution createContribution()
  {
    ContributionImpl contribution = new ContributionImpl();
    return contribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DynamicPortType createDynamicPortType()
  {
    DynamicPortTypeImpl dynamicPortType = new DynamicPortTypeImpl();
    return dynamicPortType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentCollaboration createFragmentCollaboration()
  {
    FragmentCollaborationImpl fragmentCollaboration = new FragmentCollaborationImpl();
    return fragmentCollaboration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole createFragmentRole()
  {
    FragmentRoleImpl fragmentRole = new FragmentRoleImpl();
    return fragmentRole;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StaticPortType createStaticPortType()
  {
    StaticPortTypeImpl staticPortType = new StaticPortTypeImpl();
    return staticPortType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FracolPackage getFracolPackage()
  {
    return (FracolPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static FracolPackage getPackage()
  {
    return FracolPackage.eINSTANCE;
  }

} //FracolFactoryImpl
