/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.grammar;

/**
 * A class to represent a rules in the grammar.
 */
public class FracolRule extends org.reuseware.coconut.fracol.resource.fracol.grammar.FracolSyntaxElement {
	
	private final org.eclipse.emf.ecore.EClass metaclass;
	
	public FracolRule(org.eclipse.emf.ecore.EClass metaclass, org.reuseware.coconut.fracol.resource.fracol.grammar.FracolChoice choice, org.reuseware.coconut.fracol.resource.fracol.grammar.FracolCardinality cardinality) {
		super(cardinality, new org.reuseware.coconut.fracol.resource.fracol.grammar.FracolSyntaxElement[] {choice});
		this.metaclass = metaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getMetaclass() {
		return metaclass;
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.grammar.FracolChoice getDefinition() {
		return (org.reuseware.coconut.fracol.resource.fracol.grammar.FracolChoice) getChildren()[0];
	}
	
}

