/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.mopp;

/**
 * Abstract super class for all expected elements. Provides methods to add
 * followers.
 */
public abstract class FracolAbstractExpectedElement implements org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement {
	
	private org.eclipse.emf.ecore.EClass ruleMetaclass;
	
	private java.util.Set<org.reuseware.coconut.fracol.resource.fracol.util.FracolPair<org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement, org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[]>> followers = new java.util.LinkedHashSet<org.reuseware.coconut.fracol.resource.fracol.util.FracolPair<org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement, org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[]>>();
	
	public FracolAbstractExpectedElement(org.eclipse.emf.ecore.EClass ruleMetaclass) {
		super();
		this.ruleMetaclass = ruleMetaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getRuleMetaclass() {
		return ruleMetaclass;
	}
	
	public void addFollower(org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement follower, org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] path) {
		followers.add(new org.reuseware.coconut.fracol.resource.fracol.util.FracolPair<org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement, org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[]>(follower, path));
	}
	
	public java.util.Collection<org.reuseware.coconut.fracol.resource.fracol.util.FracolPair<org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement, org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[]>> getFollowers() {
		return followers;
	}
	
}
