/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.mopp;

public class FracolProblem implements org.reuseware.coconut.fracol.resource.fracol.IFracolProblem {
	
	private String message;
	private org.reuseware.coconut.fracol.resource.fracol.FracolEProblemType type;
	private org.reuseware.coconut.fracol.resource.fracol.FracolEProblemSeverity severity;
	private java.util.Collection<org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix> quickFixes;
	
	public FracolProblem(String message, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemType type, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix>emptySet());
	}
	
	public FracolProblem(String message, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemType type, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemSeverity severity, org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public FracolProblem(String message, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemType type, org.reuseware.coconut.fracol.resource.fracol.FracolEProblemSeverity severity, java.util.Collection<org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.FracolEProblemType getType() {
		return type;
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.FracolEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.reuseware.coconut.fracol.resource.fracol.IFracolQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
