/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AP Match</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.APMatch#isInverse <em>Inverse</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.APMatch#getMatchGroup <em>Match Group</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.APMatch#getSource <em>Source</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.APMatch#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatch()
 * @model
 * @generated
 */
public interface APMatch extends EObject
{
  /**
   * Returns the value of the '<em><b>Inverse</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Inverse</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Inverse</em>' attribute.
   * @see #setInverse(boolean)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatch_Inverse()
   * @model default="false" required="true"
   * @generated
   */
  boolean isInverse();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.APMatch#isInverse <em>Inverse</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Inverse</em>' attribute.
   * @see #isInverse()
   * @generated
   */
  void setInverse(boolean value);

  /**
   * Returns the value of the '<em><b>Match Group</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.APMatchGroup#getSingleMatches <em>Single Matches</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Match Group</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Match Group</em>' container reference.
   * @see #setMatchGroup(APMatchGroup)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatch_MatchGroup()
   * @see org.reuseware.coconut.fragment.APMatchGroup#getSingleMatches
   * @model opposite="singleMatches" transient="false" ordered="false"
   * @generated
   */
  APMatchGroup getMatchGroup();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.APMatch#getMatchGroup <em>Match Group</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Match Group</em>' container reference.
   * @see #getMatchGroup()
   * @generated
   */
  void setMatchGroup(APMatchGroup value);

  /**
   * Returns the value of the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source</em>' reference.
   * @see #setSource(ReferencePoint)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatch_Source()
   * @model required="true" ordered="false"
   * @generated
   */
  ReferencePoint getSource();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.APMatch#getSource <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' reference.
   * @see #getSource()
   * @generated
   */
  void setSource(ReferencePoint value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(VariationPoint)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatch_Target()
   * @model required="true" ordered="false"
   * @generated
   */
  VariationPoint getTarget();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.APMatch#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(VariationPoint value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // APMatch
