/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.fragment.FragmentFactory
 * @model kind="package"
 * @generated
 */
public interface FragmentPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "fragment";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://reuseware.org/coconut/fragment";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "org.reuseware.coconut.fragment";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  FragmentPackage eINSTANCE = org.reuseware.coconut.fragment.impl.FragmentPackageImpl.init();

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.APMatchGroupImpl <em>AP Match Group</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.APMatchGroupImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAPMatchGroup()
   * @generated
   */
  int AP_MATCH_GROUP = 0;

  /**
   * The feature id for the '<em><b>Single Matches</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH_GROUP__SINGLE_MATCHES = 0;

  /**
   * The number of structural features of the '<em>AP Match Group</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH_GROUP_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.APMatchImpl <em>AP Match</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.APMatchImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAPMatch()
   * @generated
   */
  int AP_MATCH = 1;

  /**
   * The feature id for the '<em><b>Inverse</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH__INVERSE = 0;

  /**
   * The feature id for the '<em><b>Match Group</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH__MATCH_GROUP = 1;

  /**
   * The feature id for the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH__SOURCE = 2;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH__TARGET = 3;

  /**
   * The number of structural features of the '<em>AP Match</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AP_MATCH_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.AddressablePointImpl <em>Addressable Point</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.AddressablePointImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAddressablePoint()
   * @generated
   */
  int ADDRESSABLE_POINT = 2;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT__HETEROGENEOUS_PORT = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT__NAME = 1;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT__VAR_TYPED_EOBJECT = 2;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE = 3;

  /**
   * The number of structural features of the '<em>Addressable Point</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.ReferencePointImpl <em>Reference Point</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.ReferencePointImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getReferencePoint()
   * @generated
   */
  int REFERENCE_POINT = 14;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT__HETEROGENEOUS_PORT = ADDRESSABLE_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT__NAME = ADDRESSABLE_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT__VAR_TYPED_EOBJECT = ADDRESSABLE_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE = ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The number of structural features of the '<em>Reference Point</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_FEATURE_COUNT = ADDRESSABLE_POINT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.AnchorImpl <em>Anchor</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.AnchorImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAnchor()
   * @generated
   */
  int ANCHOR = 3;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR__HETEROGENEOUS_PORT = REFERENCE_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR__NAME = REFERENCE_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR__VAR_TYPED_EOBJECT = REFERENCE_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR__VAR_TYPED_ESTRUCTURAL_FEATURE = REFERENCE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The number of structural features of the '<em>Anchor</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_FEATURE_COUNT = REFERENCE_POINT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.FragmentImpl <em>Fragment</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.FragmentImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getFragment()
   * @generated
   */
  int FRAGMENT = 6;

  /**
   * The feature id for the '<em><b>UFI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__UFI = 0;

  /**
   * The feature id for the '<em><b>Component Model Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__COMPONENT_MODEL_ACTIVATORS = 1;

  /**
   * The feature id for the '<em><b>Composition Interfaces</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__COMPOSITION_INTERFACES = 2;

  /**
   * The feature id for the '<em><b>Composition Language Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS = 3;

  /**
   * The feature id for the '<em><b>Contents</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__CONTENTS = 4;

  /**
   * The feature id for the '<em><b>Diagrams</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT__DIAGRAMS = 5;

  /**
   * The number of structural features of the '<em>Fragment</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_FEATURE_COUNT = 6;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.ComposedFragmentImpl <em>Composed Fragment</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.ComposedFragmentImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getComposedFragment()
   * @generated
   */
  int COMPOSED_FRAGMENT = 4;

  /**
   * The feature id for the '<em><b>UFI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__UFI = FRAGMENT__UFI;

  /**
   * The feature id for the '<em><b>Component Model Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__COMPONENT_MODEL_ACTIVATORS = FRAGMENT__COMPONENT_MODEL_ACTIVATORS;

  /**
   * The feature id for the '<em><b>Composition Interfaces</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__COMPOSITION_INTERFACES = FRAGMENT__COMPOSITION_INTERFACES;

  /**
   * The feature id for the '<em><b>Composition Language Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS = FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS;

  /**
   * The feature id for the '<em><b>Contents</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__CONTENTS = FRAGMENT__CONTENTS;

  /**
   * The feature id for the '<em><b>Diagrams</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT__DIAGRAMS = FRAGMENT__DIAGRAMS;

  /**
   * The number of structural features of the '<em>Composed Fragment</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSED_FRAGMENT_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.CompositionInterfaceImpl <em>Composition Interface</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.CompositionInterfaceImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getCompositionInterface()
   * @generated
   */
  int COMPOSITION_INTERFACE = 5;

  /**
   * The feature id for the '<em><b>Fragment</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_INTERFACE__FRAGMENT = 0;

  /**
   * The feature id for the '<em><b>Ports</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_INTERFACE__PORTS = 1;

  /**
   * The feature id for the '<em><b>Role Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_INTERFACE__ROLE_BINDING = 2;

  /**
   * The number of structural features of the '<em>Composition Interface</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_INTERFACE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.PortImpl <em>Port</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.PortImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPort()
   * @generated
   */
  int PORT = 12;

  /**
   * The feature id for the '<em><b>Composition Interface</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT__COMPOSITION_INTERFACE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT__NAME = 1;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT__PORT_TYPE_BINDING = 2;

  /**
   * The number of structural features of the '<em>Port</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.HeterogeneousPortImpl <em>Heterogeneous Port</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.HeterogeneousPortImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHeterogeneousPort()
   * @generated
   */
  int HETEROGENEOUS_PORT = 7;

  /**
   * The feature id for the '<em><b>Composition Interface</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT__COMPOSITION_INTERFACE = PORT__COMPOSITION_INTERFACE;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT__NAME = PORT__NAME;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT__PORT_TYPE_BINDING = PORT__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Addressable Points</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT__ADDRESSABLE_POINTS = PORT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Homogenous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT__HOMOGENOUS_PORT = PORT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Heterogeneous Port</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HETEROGENEOUS_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.HomogeneousPortImpl <em>Homogeneous Port</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.HomogeneousPortImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHomogeneousPort()
   * @generated
   */
  int HOMOGENEOUS_PORT = 8;

  /**
   * The feature id for the '<em><b>Composition Interface</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOMOGENEOUS_PORT__COMPOSITION_INTERFACE = PORT__COMPOSITION_INTERFACE;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOMOGENEOUS_PORT__NAME = PORT__NAME;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOMOGENEOUS_PORT__PORT_TYPE_BINDING = PORT__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Heterogeneous Ports</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS = PORT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Homogeneous Port</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOMOGENEOUS_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.VariationPointImpl <em>Variation Point</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.VariationPointImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getVariationPoint()
   * @generated
   */
  int VARIATION_POINT = 18;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__HETEROGENEOUS_PORT = ADDRESSABLE_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__NAME = ADDRESSABLE_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__VAR_TYPED_EOBJECT = ADDRESSABLE_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE = ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__MODE = ADDRESSABLE_POINT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Remove</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT__REMOVE = ADDRESSABLE_POINT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Variation Point</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_FEATURE_COUNT = ADDRESSABLE_POINT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.HookImpl <em>Hook</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.HookImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHook()
   * @generated
   */
  int HOOK = 9;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__HETEROGENEOUS_PORT = VARIATION_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__NAME = VARIATION_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__VAR_TYPED_EOBJECT = VARIATION_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__VAR_TYPED_ESTRUCTURAL_FEATURE = VARIATION_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__MODE = VARIATION_POINT__MODE;

  /**
   * The feature id for the '<em><b>Remove</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK__REMOVE = VARIATION_POINT__REMOVE;

  /**
   * The number of structural features of the '<em>Hook</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_FEATURE_COUNT = VARIATION_POINT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.InstantiationSetImpl <em>Instantiation Set</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.InstantiationSetImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getInstantiationSet()
   * @generated
   */
  int INSTANTIATION_SET = 10;

  /**
   * The feature id for the '<em><b>Instantiations</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANTIATION_SET__INSTANTIATIONS = 0;

  /**
   * The number of structural features of the '<em>Instantiation Set</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANTIATION_SET_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.PhysicalFragmentImpl <em>Physical Fragment</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.PhysicalFragmentImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPhysicalFragment()
   * @generated
   */
  int PHYSICAL_FRAGMENT = 11;

  /**
   * The feature id for the '<em><b>UFI</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__UFI = FRAGMENT__UFI;

  /**
   * The feature id for the '<em><b>Component Model Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__COMPONENT_MODEL_ACTIVATORS = FRAGMENT__COMPONENT_MODEL_ACTIVATORS;

  /**
   * The feature id for the '<em><b>Composition Interfaces</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__COMPOSITION_INTERFACES = FRAGMENT__COMPOSITION_INTERFACES;

  /**
   * The feature id for the '<em><b>Composition Language Activators</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS = FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS;

  /**
   * The feature id for the '<em><b>Contents</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__CONTENTS = FRAGMENT__CONTENTS;

  /**
   * The feature id for the '<em><b>Diagrams</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT__DIAGRAMS = FRAGMENT__DIAGRAMS;

  /**
   * The number of structural features of the '<em>Physical Fragment</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PHYSICAL_FRAGMENT_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.PrototypeImpl <em>Prototype</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.PrototypeImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPrototype()
   * @generated
   */
  int PROTOTYPE = 13;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE__HETEROGENEOUS_PORT = REFERENCE_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE__NAME = REFERENCE_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE__VAR_TYPED_EOBJECT = REFERENCE_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE__VAR_TYPED_ESTRUCTURAL_FEATURE = REFERENCE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The number of structural features of the '<em>Prototype</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_FEATURE_COUNT = REFERENCE_POINT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.SlotImpl <em>Slot</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.SlotImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getSlot()
   * @generated
   */
  int SLOT = 15;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__HETEROGENEOUS_PORT = VARIATION_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__NAME = VARIATION_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__VAR_TYPED_EOBJECT = VARIATION_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__VAR_TYPED_ESTRUCTURAL_FEATURE = VARIATION_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__MODE = VARIATION_POINT__MODE;

  /**
   * The feature id for the '<em><b>Remove</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT__REMOVE = VARIATION_POINT__REMOVE;

  /**
   * The number of structural features of the '<em>Slot</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_FEATURE_COUNT = VARIATION_POINT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.ValueHookImpl <em>Value Hook</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.ValueHookImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getValueHook()
   * @generated
   */
  int VALUE_HOOK = 16;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__HETEROGENEOUS_PORT = VARIATION_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__NAME = VARIATION_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__VAR_TYPED_EOBJECT = VARIATION_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__VAR_TYPED_ESTRUCTURAL_FEATURE = VARIATION_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__MODE = VARIATION_POINT__MODE;

  /**
   * The feature id for the '<em><b>Remove</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__REMOVE = VARIATION_POINT__REMOVE;

  /**
   * The feature id for the '<em><b>Begin Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__BEGIN_INDEX = VARIATION_POINT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>End Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__END_INDEX = VARIATION_POINT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>List Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK__LIST_INDEX = VARIATION_POINT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Value Hook</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_FEATURE_COUNT = VARIATION_POINT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.fragment.impl.ValuePrototypeImpl <em>Value Prototype</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.fragment.impl.ValuePrototypeImpl
   * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getValuePrototype()
   * @generated
   */
  int VALUE_PROTOTYPE = 17;

  /**
   * The feature id for the '<em><b>Heterogeneous Port</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE__HETEROGENEOUS_PORT = REFERENCE_POINT__HETEROGENEOUS_PORT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE__NAME = REFERENCE_POINT__NAME;

  /**
   * The feature id for the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE__VAR_TYPED_EOBJECT = REFERENCE_POINT__VAR_TYPED_EOBJECT;

  /**
   * The feature id for the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE__VAR_TYPED_ESTRUCTURAL_FEATURE = REFERENCE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE__VALUE = REFERENCE_POINT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Value Prototype</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_FEATURE_COUNT = REFERENCE_POINT_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.APMatchGroup <em>AP Match Group</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>AP Match Group</em>'.
   * @see org.reuseware.coconut.fragment.APMatchGroup
   * @generated
   */
  EClass getAPMatchGroup();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fragment.APMatchGroup#getSingleMatches <em>Single Matches</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Single Matches</em>'.
   * @see org.reuseware.coconut.fragment.APMatchGroup#getSingleMatches()
   * @see #getAPMatchGroup()
   * @generated
   */
  EReference getAPMatchGroup_SingleMatches();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.APMatch <em>AP Match</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>AP Match</em>'.
   * @see org.reuseware.coconut.fragment.APMatch
   * @generated
   */
  EClass getAPMatch();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.APMatch#isInverse <em>Inverse</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Inverse</em>'.
   * @see org.reuseware.coconut.fragment.APMatch#isInverse()
   * @see #getAPMatch()
   * @generated
   */
  EAttribute getAPMatch_Inverse();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fragment.APMatch#getMatchGroup <em>Match Group</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Match Group</em>'.
   * @see org.reuseware.coconut.fragment.APMatch#getMatchGroup()
   * @see #getAPMatch()
   * @generated
   */
  EReference getAPMatch_MatchGroup();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.APMatch#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Source</em>'.
   * @see org.reuseware.coconut.fragment.APMatch#getSource()
   * @see #getAPMatch()
   * @generated
   */
  EReference getAPMatch_Source();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.APMatch#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see org.reuseware.coconut.fragment.APMatch#getTarget()
   * @see #getAPMatch()
   * @generated
   */
  EReference getAPMatch_Target();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.AddressablePoint <em>Addressable Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Addressable Point</em>'.
   * @see org.reuseware.coconut.fragment.AddressablePoint
   * @generated
   */
  EClass getAddressablePoint();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort <em>Heterogeneous Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Heterogeneous Port</em>'.
   * @see org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort()
   * @see #getAddressablePoint()
   * @generated
   */
  EReference getAddressablePoint_HeterogeneousPort();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.AddressablePoint#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.fragment.AddressablePoint#getName()
   * @see #getAddressablePoint()
   * @generated
   */
  EAttribute getAddressablePoint_Name();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEObject <em>Var Typed EObject</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Var Typed EObject</em>'.
   * @see org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEObject()
   * @see #getAddressablePoint()
   * @generated
   */
  EReference getAddressablePoint_VarTypedEObject();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEStructuralFeature <em>Var Typed EStructural Feature</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Var Typed EStructural Feature</em>'.
   * @see org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEStructuralFeature()
   * @see #getAddressablePoint()
   * @generated
   */
  EReference getAddressablePoint_VarTypedEStructuralFeature();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Anchor <em>Anchor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Anchor</em>'.
   * @see org.reuseware.coconut.fragment.Anchor
   * @generated
   */
  EClass getAnchor();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.ComposedFragment <em>Composed Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composed Fragment</em>'.
   * @see org.reuseware.coconut.fragment.ComposedFragment
   * @generated
   */
  EClass getComposedFragment();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.CompositionInterface <em>Composition Interface</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Interface</em>'.
   * @see org.reuseware.coconut.fragment.CompositionInterface
   * @generated
   */
  EClass getCompositionInterface();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fragment.CompositionInterface#getFragment <em>Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment</em>'.
   * @see org.reuseware.coconut.fragment.CompositionInterface#getFragment()
   * @see #getCompositionInterface()
   * @generated
   */
  EReference getCompositionInterface_Fragment();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fragment.CompositionInterface#getPorts <em>Ports</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Ports</em>'.
   * @see org.reuseware.coconut.fragment.CompositionInterface#getPorts()
   * @see #getCompositionInterface()
   * @generated
   */
  EReference getCompositionInterface_Ports();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.CompositionInterface#getRoleBinding <em>Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Role Binding</em>'.
   * @see org.reuseware.coconut.fragment.CompositionInterface#getRoleBinding()
   * @see #getCompositionInterface()
   * @generated
   */
  EReference getCompositionInterface_RoleBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Fragment <em>Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment</em>'.
   * @see org.reuseware.coconut.fragment.Fragment
   * @generated
   */
  EClass getFragment();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.fragment.Fragment#getUFI <em>UFI</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>UFI</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getUFI()
   * @see #getFragment()
   * @generated
   */
  EAttribute getFragment_UFI();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fragment.Fragment#getComponentModelActivators <em>Component Model Activators</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Component Model Activators</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getComponentModelActivators()
   * @see #getFragment()
   * @generated
   */
  EReference getFragment_ComponentModelActivators();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fragment.Fragment#getCompositionInterfaces <em>Composition Interfaces</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composition Interfaces</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getCompositionInterfaces()
   * @see #getFragment()
   * @generated
   */
  EReference getFragment_CompositionInterfaces();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fragment.Fragment#getCompositionLanguageActivators <em>Composition Language Activators</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Composition Language Activators</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getCompositionLanguageActivators()
   * @see #getFragment()
   * @generated
   */
  EReference getFragment_CompositionLanguageActivators();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fragment.Fragment#getContents <em>Contents</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Contents</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getContents()
   * @see #getFragment()
   * @generated
   */
  EReference getFragment_Contents();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fragment.Fragment#getDiagrams <em>Diagrams</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Diagrams</em>'.
   * @see org.reuseware.coconut.fragment.Fragment#getDiagrams()
   * @see #getFragment()
   * @generated
   */
  EReference getFragment_Diagrams();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.HeterogeneousPort <em>Heterogeneous Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Heterogeneous Port</em>'.
   * @see org.reuseware.coconut.fragment.HeterogeneousPort
   * @generated
   */
  EClass getHeterogeneousPort();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fragment.HeterogeneousPort#getAddressablePoints <em>Addressable Points</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Addressable Points</em>'.
   * @see org.reuseware.coconut.fragment.HeterogeneousPort#getAddressablePoints()
   * @see #getHeterogeneousPort()
   * @generated
   */
  EReference getHeterogeneousPort_AddressablePoints();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fragment.HeterogeneousPort#getHomogenousPort <em>Homogenous Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Homogenous Port</em>'.
   * @see org.reuseware.coconut.fragment.HeterogeneousPort#getHomogenousPort()
   * @see #getHeterogeneousPort()
   * @generated
   */
  EReference getHeterogeneousPort_HomogenousPort();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.HomogeneousPort <em>Homogeneous Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Homogeneous Port</em>'.
   * @see org.reuseware.coconut.fragment.HomogeneousPort
   * @generated
   */
  EClass getHomogeneousPort();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.fragment.HomogeneousPort#getHeterogeneousPorts <em>Heterogeneous Ports</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Heterogeneous Ports</em>'.
   * @see org.reuseware.coconut.fragment.HomogeneousPort#getHeterogeneousPorts()
   * @see #getHomogeneousPort()
   * @generated
   */
  EReference getHomogeneousPort_HeterogeneousPorts();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Hook <em>Hook</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Hook</em>'.
   * @see org.reuseware.coconut.fragment.Hook
   * @generated
   */
  EClass getHook();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.InstantiationSet <em>Instantiation Set</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Instantiation Set</em>'.
   * @see org.reuseware.coconut.fragment.InstantiationSet
   * @generated
   */
  EClass getInstantiationSet();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.fragment.InstantiationSet#getInstantiations <em>Instantiations</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Instantiations</em>'.
   * @see org.reuseware.coconut.fragment.InstantiationSet#getInstantiations()
   * @see #getInstantiationSet()
   * @generated
   */
  EReference getInstantiationSet_Instantiations();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.PhysicalFragment <em>Physical Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Physical Fragment</em>'.
   * @see org.reuseware.coconut.fragment.PhysicalFragment
   * @generated
   */
  EClass getPhysicalFragment();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Port <em>Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port</em>'.
   * @see org.reuseware.coconut.fragment.Port
   * @generated
   */
  EClass getPort();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.fragment.Port#getCompositionInterface <em>Composition Interface</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Interface</em>'.
   * @see org.reuseware.coconut.fragment.Port#getCompositionInterface()
   * @see #getPort()
   * @generated
   */
  EReference getPort_CompositionInterface();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.Port#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.reuseware.coconut.fragment.Port#getName()
   * @see #getPort()
   * @generated
   */
  EAttribute getPort_Name();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.fragment.Port#getPortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Port Type Binding</em>'.
   * @see org.reuseware.coconut.fragment.Port#getPortTypeBinding()
   * @see #getPort()
   * @generated
   */
  EReference getPort_PortTypeBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Prototype <em>Prototype</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Prototype</em>'.
   * @see org.reuseware.coconut.fragment.Prototype
   * @generated
   */
  EClass getPrototype();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.ReferencePoint <em>Reference Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reference Point</em>'.
   * @see org.reuseware.coconut.fragment.ReferencePoint
   * @generated
   */
  EClass getReferencePoint();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.Slot <em>Slot</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Slot</em>'.
   * @see org.reuseware.coconut.fragment.Slot
   * @generated
   */
  EClass getSlot();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.ValueHook <em>Value Hook</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Value Hook</em>'.
   * @see org.reuseware.coconut.fragment.ValueHook
   * @generated
   */
  EClass getValueHook();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.ValueHook#getBeginIndex <em>Begin Index</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Begin Index</em>'.
   * @see org.reuseware.coconut.fragment.ValueHook#getBeginIndex()
   * @see #getValueHook()
   * @generated
   */
  EAttribute getValueHook_BeginIndex();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.ValueHook#getEndIndex <em>End Index</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>End Index</em>'.
   * @see org.reuseware.coconut.fragment.ValueHook#getEndIndex()
   * @see #getValueHook()
   * @generated
   */
  EAttribute getValueHook_EndIndex();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.ValueHook#getListIndex <em>List Index</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>List Index</em>'.
   * @see org.reuseware.coconut.fragment.ValueHook#getListIndex()
   * @see #getValueHook()
   * @generated
   */
  EAttribute getValueHook_ListIndex();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.ValuePrototype <em>Value Prototype</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Value Prototype</em>'.
   * @see org.reuseware.coconut.fragment.ValuePrototype
   * @generated
   */
  EClass getValuePrototype();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.ValuePrototype#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.reuseware.coconut.fragment.ValuePrototype#getValue()
   * @see #getValuePrototype()
   * @generated
   */
  EAttribute getValuePrototype_Value();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.fragment.VariationPoint <em>Variation Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Variation Point</em>'.
   * @see org.reuseware.coconut.fragment.VariationPoint
   * @generated
   */
  EClass getVariationPoint();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.VariationPoint#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see org.reuseware.coconut.fragment.VariationPoint#getMode()
   * @see #getVariationPoint()
   * @generated
   */
  EAttribute getVariationPoint_Mode();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.fragment.VariationPoint#isRemove <em>Remove</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Remove</em>'.
   * @see org.reuseware.coconut.fragment.VariationPoint#isRemove()
   * @see #getVariationPoint()
   * @generated
   */
  EAttribute getVariationPoint_Remove();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  FragmentFactory getFragmentFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.APMatchGroupImpl <em>AP Match Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.APMatchGroupImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAPMatchGroup()
     * @generated
     */
    EClass AP_MATCH_GROUP = eINSTANCE.getAPMatchGroup();

    /**
     * The meta object literal for the '<em><b>Single Matches</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AP_MATCH_GROUP__SINGLE_MATCHES = eINSTANCE.getAPMatchGroup_SingleMatches();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.APMatchImpl <em>AP Match</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.APMatchImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAPMatch()
     * @generated
     */
    EClass AP_MATCH = eINSTANCE.getAPMatch();

    /**
     * The meta object literal for the '<em><b>Inverse</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute AP_MATCH__INVERSE = eINSTANCE.getAPMatch_Inverse();

    /**
     * The meta object literal for the '<em><b>Match Group</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AP_MATCH__MATCH_GROUP = eINSTANCE.getAPMatch_MatchGroup();

    /**
     * The meta object literal for the '<em><b>Source</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AP_MATCH__SOURCE = eINSTANCE.getAPMatch_Source();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AP_MATCH__TARGET = eINSTANCE.getAPMatch_Target();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.AddressablePointImpl <em>Addressable Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.AddressablePointImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAddressablePoint()
     * @generated
     */
    EClass ADDRESSABLE_POINT = eINSTANCE.getAddressablePoint();

    /**
     * The meta object literal for the '<em><b>Heterogeneous Port</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ADDRESSABLE_POINT__HETEROGENEOUS_PORT = eINSTANCE.getAddressablePoint_HeterogeneousPort();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ADDRESSABLE_POINT__NAME = eINSTANCE.getAddressablePoint_Name();

    /**
     * The meta object literal for the '<em><b>Var Typed EObject</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ADDRESSABLE_POINT__VAR_TYPED_EOBJECT = eINSTANCE.getAddressablePoint_VarTypedEObject();

    /**
     * The meta object literal for the '<em><b>Var Typed EStructural Feature</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE = eINSTANCE.getAddressablePoint_VarTypedEStructuralFeature();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.AnchorImpl <em>Anchor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.AnchorImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getAnchor()
     * @generated
     */
    EClass ANCHOR = eINSTANCE.getAnchor();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.ComposedFragmentImpl <em>Composed Fragment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.ComposedFragmentImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getComposedFragment()
     * @generated
     */
    EClass COMPOSED_FRAGMENT = eINSTANCE.getComposedFragment();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.CompositionInterfaceImpl <em>Composition Interface</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.CompositionInterfaceImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getCompositionInterface()
     * @generated
     */
    EClass COMPOSITION_INTERFACE = eINSTANCE.getCompositionInterface();

    /**
     * The meta object literal for the '<em><b>Fragment</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_INTERFACE__FRAGMENT = eINSTANCE.getCompositionInterface_Fragment();

    /**
     * The meta object literal for the '<em><b>Ports</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_INTERFACE__PORTS = eINSTANCE.getCompositionInterface_Ports();

    /**
     * The meta object literal for the '<em><b>Role Binding</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_INTERFACE__ROLE_BINDING = eINSTANCE.getCompositionInterface_RoleBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.FragmentImpl <em>Fragment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.FragmentImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getFragment()
     * @generated
     */
    EClass FRAGMENT = eINSTANCE.getFragment();

    /**
     * The meta object literal for the '<em><b>UFI</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT__UFI = eINSTANCE.getFragment_UFI();

    /**
     * The meta object literal for the '<em><b>Component Model Activators</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT__COMPONENT_MODEL_ACTIVATORS = eINSTANCE.getFragment_ComponentModelActivators();

    /**
     * The meta object literal for the '<em><b>Composition Interfaces</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT__COMPOSITION_INTERFACES = eINSTANCE.getFragment_CompositionInterfaces();

    /**
     * The meta object literal for the '<em><b>Composition Language Activators</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS = eINSTANCE.getFragment_CompositionLanguageActivators();

    /**
     * The meta object literal for the '<em><b>Contents</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT__CONTENTS = eINSTANCE.getFragment_Contents();

    /**
     * The meta object literal for the '<em><b>Diagrams</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT__DIAGRAMS = eINSTANCE.getFragment_Diagrams();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.HeterogeneousPortImpl <em>Heterogeneous Port</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.HeterogeneousPortImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHeterogeneousPort()
     * @generated
     */
    EClass HETEROGENEOUS_PORT = eINSTANCE.getHeterogeneousPort();

    /**
     * The meta object literal for the '<em><b>Addressable Points</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference HETEROGENEOUS_PORT__ADDRESSABLE_POINTS = eINSTANCE.getHeterogeneousPort_AddressablePoints();

    /**
     * The meta object literal for the '<em><b>Homogenous Port</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference HETEROGENEOUS_PORT__HOMOGENOUS_PORT = eINSTANCE.getHeterogeneousPort_HomogenousPort();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.HomogeneousPortImpl <em>Homogeneous Port</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.HomogeneousPortImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHomogeneousPort()
     * @generated
     */
    EClass HOMOGENEOUS_PORT = eINSTANCE.getHomogeneousPort();

    /**
     * The meta object literal for the '<em><b>Heterogeneous Ports</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS = eINSTANCE.getHomogeneousPort_HeterogeneousPorts();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.HookImpl <em>Hook</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.HookImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getHook()
     * @generated
     */
    EClass HOOK = eINSTANCE.getHook();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.InstantiationSetImpl <em>Instantiation Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.InstantiationSetImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getInstantiationSet()
     * @generated
     */
    EClass INSTANTIATION_SET = eINSTANCE.getInstantiationSet();

    /**
     * The meta object literal for the '<em><b>Instantiations</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INSTANTIATION_SET__INSTANTIATIONS = eINSTANCE.getInstantiationSet_Instantiations();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.PhysicalFragmentImpl <em>Physical Fragment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.PhysicalFragmentImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPhysicalFragment()
     * @generated
     */
    EClass PHYSICAL_FRAGMENT = eINSTANCE.getPhysicalFragment();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.PortImpl <em>Port</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.PortImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPort()
     * @generated
     */
    EClass PORT = eINSTANCE.getPort();

    /**
     * The meta object literal for the '<em><b>Composition Interface</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT__COMPOSITION_INTERFACE = eINSTANCE.getPort_CompositionInterface();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT__NAME = eINSTANCE.getPort_Name();

    /**
     * The meta object literal for the '<em><b>Port Type Binding</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT__PORT_TYPE_BINDING = eINSTANCE.getPort_PortTypeBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.PrototypeImpl <em>Prototype</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.PrototypeImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getPrototype()
     * @generated
     */
    EClass PROTOTYPE = eINSTANCE.getPrototype();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.ReferencePointImpl <em>Reference Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.ReferencePointImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getReferencePoint()
     * @generated
     */
    EClass REFERENCE_POINT = eINSTANCE.getReferencePoint();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.SlotImpl <em>Slot</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.SlotImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getSlot()
     * @generated
     */
    EClass SLOT = eINSTANCE.getSlot();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.ValueHookImpl <em>Value Hook</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.ValueHookImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getValueHook()
     * @generated
     */
    EClass VALUE_HOOK = eINSTANCE.getValueHook();

    /**
     * The meta object literal for the '<em><b>Begin Index</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK__BEGIN_INDEX = eINSTANCE.getValueHook_BeginIndex();

    /**
     * The meta object literal for the '<em><b>End Index</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK__END_INDEX = eINSTANCE.getValueHook_EndIndex();

    /**
     * The meta object literal for the '<em><b>List Index</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK__LIST_INDEX = eINSTANCE.getValueHook_ListIndex();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.ValuePrototypeImpl <em>Value Prototype</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.ValuePrototypeImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getValuePrototype()
     * @generated
     */
    EClass VALUE_PROTOTYPE = eINSTANCE.getValuePrototype();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_PROTOTYPE__VALUE = eINSTANCE.getValuePrototype_Value();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.fragment.impl.VariationPointImpl <em>Variation Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.fragment.impl.VariationPointImpl
     * @see org.reuseware.coconut.fragment.impl.FragmentPackageImpl#getVariationPoint()
     * @generated
     */
    EClass VARIATION_POINT = eINSTANCE.getVariationPoint();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIATION_POINT__MODE = eINSTANCE.getVariationPoint_Mode();

    /**
     * The meta object literal for the '<em><b>Remove</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIATION_POINT__REMOVE = eINSTANCE.getVariationPoint_Remove();

  }

} //FragmentPackage
