/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.reuseextension.PortType2PortBinding;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.Port#getCompositionInterface <em>Composition Interface</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Port#getName <em>Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Port#getPortTypeBinding <em>Port Type Binding</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getPort()
 * @model abstract="true"
 * @generated
 */
public interface Port extends EObject
{
  /**
   * Returns the value of the '<em><b>Composition Interface</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.CompositionInterface#getPorts <em>Ports</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Interface</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Interface</em>' container reference.
   * @see #setCompositionInterface(CompositionInterface)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getPort_CompositionInterface()
   * @see org.reuseware.coconut.fragment.CompositionInterface#getPorts
   * @model opposite="ports" transient="false" ordered="false"
   * @generated
   */
  CompositionInterface getCompositionInterface();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.Port#getCompositionInterface <em>Composition Interface</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Interface</em>' container reference.
   * @see #getCompositionInterface()
   * @generated
   */
  void setCompositionInterface(CompositionInterface value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getPort_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.Port#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Port Type Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Binding</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Binding</em>' reference.
   * @see #setPortTypeBinding(PortType2PortBinding)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getPort_PortTypeBinding()
   * @model required="true" ordered="false"
   * @generated
   */
  PortType2PortBinding getPortTypeBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.Port#getPortTypeBinding <em>Port Type Binding</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Type Binding</em>' reference.
   * @see #getPortTypeBinding()
   * @generated
   */
  void setPortTypeBinding(PortType2PortBinding value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // Port
