/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.APMatchGroup;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.ReferencePoint;
import org.reuseware.coconut.fragment.VariationPoint;




/**
 * @generated
 **/
public class APMatchImpl extends EObjectImpl implements APMatch
{


   /**
   * The default value of the '{@link #isInverse() <em>Inverse</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isInverse()
   * @generated
   * @ordered
   */
  protected static final boolean INVERSE_EDEFAULT = false;
  /**
   * The cached value of the '{@link #isInverse() <em>Inverse</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isInverse()
   * @generated
   * @ordered
   */
  protected boolean inverse = INVERSE_EDEFAULT;
  /**
   * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSource()
   * @generated
   * @ordered
   */
  protected ReferencePoint source;
  /**
   * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTarget()
   * @generated
   * @ordered
   */
  protected VariationPoint target;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected APMatchImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.AP_MATCH;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isInverse()
  {
    return inverse;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInverse(boolean newInverse)
  {
    boolean oldInverse = inverse;
    inverse = newInverse;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.AP_MATCH__INVERSE, oldInverse, inverse));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public APMatchGroup getMatchGroup()
  {
    if (eContainerFeatureID() != FragmentPackage.AP_MATCH__MATCH_GROUP) return null;
    return (APMatchGroup)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMatchGroup(APMatchGroup newMatchGroup, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newMatchGroup, FragmentPackage.AP_MATCH__MATCH_GROUP, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMatchGroup(APMatchGroup newMatchGroup)
  {
    if (newMatchGroup != eInternalContainer() || (eContainerFeatureID() != FragmentPackage.AP_MATCH__MATCH_GROUP && newMatchGroup != null))
    {
      if (EcoreUtil.isAncestor(this, newMatchGroup))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newMatchGroup != null)
        msgs = ((InternalEObject)newMatchGroup).eInverseAdd(this, FragmentPackage.AP_MATCH_GROUP__SINGLE_MATCHES, APMatchGroup.class, msgs);
      msgs = basicSetMatchGroup(newMatchGroup, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.AP_MATCH__MATCH_GROUP, newMatchGroup, newMatchGroup));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReferencePoint getSource()
  {
    if (source != null && source.eIsProxy())
    {
      InternalEObject oldSource = (InternalEObject)source;
      source = (ReferencePoint)eResolveProxy(oldSource);
      if (source != oldSource)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.AP_MATCH__SOURCE, oldSource, source));
      }
    }
    return source;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReferencePoint basicGetSource()
  {
    return source;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSource(ReferencePoint newSource)
  {
    ReferencePoint oldSource = source;
    source = newSource;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.AP_MATCH__SOURCE, oldSource, source));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariationPoint getTarget()
  {
    if (target != null && target.eIsProxy())
    {
      InternalEObject oldTarget = (InternalEObject)target;
      target = (VariationPoint)eResolveProxy(oldTarget);
      if (target != oldTarget)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.AP_MATCH__TARGET, oldTarget, target));
      }
    }
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariationPoint basicGetTarget()
  {
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTarget(VariationPoint newTarget)
  {
    VariationPoint oldTarget = target;
    target = newTarget;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.AP_MATCH__TARGET, oldTarget, target));
  }

  public void removeYou()
   {
      this.setMatchGroup (null);
      this.setSource (null);
      this.setTarget (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetMatchGroup((APMatchGroup)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        return basicSetMatchGroup(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        return eInternalContainer().eInverseRemove(this, FragmentPackage.AP_MATCH_GROUP__SINGLE_MATCHES, APMatchGroup.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__INVERSE:
        return isInverse();
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        return getMatchGroup();
      case FragmentPackage.AP_MATCH__SOURCE:
        if (resolve) return getSource();
        return basicGetSource();
      case FragmentPackage.AP_MATCH__TARGET:
        if (resolve) return getTarget();
        return basicGetTarget();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__INVERSE:
        setInverse((Boolean)newValue);
        return;
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        setMatchGroup((APMatchGroup)newValue);
        return;
      case FragmentPackage.AP_MATCH__SOURCE:
        setSource((ReferencePoint)newValue);
        return;
      case FragmentPackage.AP_MATCH__TARGET:
        setTarget((VariationPoint)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__INVERSE:
        setInverse(INVERSE_EDEFAULT);
        return;
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        setMatchGroup((APMatchGroup)null);
        return;
      case FragmentPackage.AP_MATCH__SOURCE:
        setSource((ReferencePoint)null);
        return;
      case FragmentPackage.AP_MATCH__TARGET:
        setTarget((VariationPoint)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.AP_MATCH__INVERSE:
        return inverse != INVERSE_EDEFAULT;
      case FragmentPackage.AP_MATCH__MATCH_GROUP:
        return getMatchGroup() != null;
      case FragmentPackage.AP_MATCH__SOURCE:
        return source != null;
      case FragmentPackage.AP_MATCH__TARGET:
        return target != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (inverse: ");
    result.append(inverse);
    result.append(')');
    return result.toString();
  }
}


