/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.HeterogeneousPort;


/**
 * @generated
 **/
public abstract class AddressablePointImpl extends EObjectImpl implements AddressablePoint
{


   /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;
  /**
   * The cached value of the '{@link #getVarTypedEObject() <em>Var Typed EObject</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarTypedEObject()
   * @generated
   * @ordered
   */
  protected EObject varTypedEObject;
  /**
   * The cached value of the '{@link #getVarTypedEStructuralFeature() <em>Var Typed EStructural Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarTypedEStructuralFeature()
   * @generated
   * @ordered
   */
  protected EStructuralFeature varTypedEStructuralFeature;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AddressablePointImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.ADDRESSABLE_POINT;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeterogeneousPort getHeterogeneousPort()
  {
    if (eContainerFeatureID() != FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT) return null;
    return (HeterogeneousPort)eContainer();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHeterogeneousPort(HeterogeneousPort newHeterogeneousPort, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newHeterogeneousPort, FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT, msgs);
    return msgs;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHeterogeneousPort(HeterogeneousPort newHeterogeneousPort)
  {
    if (newHeterogeneousPort != eInternalContainer() || (eContainerFeatureID() != FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT && newHeterogeneousPort != null))
    {
      if (EcoreUtil.isAncestor(this, newHeterogeneousPort))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newHeterogeneousPort != null)
        msgs = ((InternalEObject)newHeterogeneousPort).eInverseAdd(this, FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS, HeterogeneousPort.class, msgs);
      msgs = basicSetHeterogeneousPort(newHeterogeneousPort, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT, newHeterogeneousPort, newHeterogeneousPort));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.ADDRESSABLE_POINT__NAME, oldName, name));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject getVarTypedEObject()
  {
    if (varTypedEObject != null && varTypedEObject.eIsProxy())
    {
      InternalEObject oldVarTypedEObject = (InternalEObject)varTypedEObject;
      varTypedEObject = eResolveProxy(oldVarTypedEObject);
      if (varTypedEObject != oldVarTypedEObject)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT, oldVarTypedEObject, varTypedEObject));
      }
    }
    return varTypedEObject;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject basicGetVarTypedEObject()
  {
    return varTypedEObject;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVarTypedEObject(EObject newVarTypedEObject)
  {
    EObject oldVarTypedEObject = varTypedEObject;
    varTypedEObject = newVarTypedEObject;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT, oldVarTypedEObject, varTypedEObject));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature getVarTypedEStructuralFeature()
  {
    if (varTypedEStructuralFeature != null && varTypedEStructuralFeature.eIsProxy())
    {
      InternalEObject oldVarTypedEStructuralFeature = (InternalEObject)varTypedEStructuralFeature;
      varTypedEStructuralFeature = (EStructuralFeature)eResolveProxy(oldVarTypedEStructuralFeature);
      if (varTypedEStructuralFeature != oldVarTypedEStructuralFeature)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE, oldVarTypedEStructuralFeature, varTypedEStructuralFeature));
      }
    }
    return varTypedEStructuralFeature;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature basicGetVarTypedEStructuralFeature()
  {
    return varTypedEStructuralFeature;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVarTypedEStructuralFeature(EStructuralFeature newVarTypedEStructuralFeature)
  {
    EStructuralFeature oldVarTypedEStructuralFeature = varTypedEStructuralFeature;
    varTypedEStructuralFeature = newVarTypedEStructuralFeature;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE, oldVarTypedEStructuralFeature, varTypedEStructuralFeature));
  }


  public APMatch match (AddressablePoint ap ){

      throw new UnsupportedOperationException();

   }


   public void removeYou()
   {
      this.setHeterogeneousPort (null);
      this.setVarTypedEObject (null);
      this.setVarTypedEStructuralFeature (null);
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetHeterogeneousPort((HeterogeneousPort)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        return basicSetHeterogeneousPort(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        return eInternalContainer().eInverseRemove(this, FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS, HeterogeneousPort.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        return getHeterogeneousPort();
      case FragmentPackage.ADDRESSABLE_POINT__NAME:
        return getName();
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT:
        if (resolve) return getVarTypedEObject();
        return basicGetVarTypedEObject();
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE:
        if (resolve) return getVarTypedEStructuralFeature();
        return basicGetVarTypedEStructuralFeature();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        setHeterogeneousPort((HeterogeneousPort)newValue);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__NAME:
        setName((String)newValue);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT:
        setVarTypedEObject((EObject)newValue);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE:
        setVarTypedEStructuralFeature((EStructuralFeature)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        setHeterogeneousPort((HeterogeneousPort)null);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__NAME:
        setName(NAME_EDEFAULT);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT:
        setVarTypedEObject((EObject)null);
        return;
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE:
        setVarTypedEStructuralFeature((EStructuralFeature)null);
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT:
        return getHeterogeneousPort() != null;
      case FragmentPackage.ADDRESSABLE_POINT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_EOBJECT:
        return varTypedEObject != null;
      case FragmentPackage.ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE:
        return varTypedEStructuralFeature != null;
    }
    return super.eIsSet(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }
}


