/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.APMatchGroup;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fragment.Anchor;
import org.reuseware.coconut.fragment.ComposedFragment;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.HomogeneousPort;
import org.reuseware.coconut.fragment.Hook;
import org.reuseware.coconut.fragment.InstantiationSet;
import org.reuseware.coconut.fragment.PhysicalFragment;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.fragment.Prototype;
import org.reuseware.coconut.fragment.ReferencePoint;
import org.reuseware.coconut.fragment.Slot;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.reuseware.coconut.fragment.VariationPoint;

import org.reuseware.coconut.id.IdPackage;

import org.reuseware.coconut.reuseextension.ReuseextensionPackage;

import org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FragmentPackageImpl extends EPackageImpl implements FragmentPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass apMatchGroupEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass apMatchEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass addressablePointEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass anchorEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass composedFragmentEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionInterfaceEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass heterogeneousPortEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass homogeneousPortEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass hookEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass instantiationSetEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass physicalFragmentEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass prototypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass referencePointEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass slotEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass valueHookEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass valuePrototypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass variationPointEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.reuseware.coconut.fragment.FragmentPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private FragmentPackageImpl()
  {
    super(eNS_URI, FragmentFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link FragmentPackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static FragmentPackage init()
  {
    if (isInited) return (FragmentPackage)EPackage.Registry.INSTANCE.getEPackage(FragmentPackage.eNS_URI);

    // Obtain or create and register package
    FragmentPackageImpl theFragmentPackage = (FragmentPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof FragmentPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new FragmentPackageImpl());

    isInited = true;

    // Initialize simple dependencies
    IdPackage.eINSTANCE.eClass();
    ReuseextensionactivatorPackage.eINSTANCE.eClass();

    // Create package meta-data objects
    theFragmentPackage.createPackageContents();

    // Initialize created meta-data
    theFragmentPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theFragmentPackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(FragmentPackage.eNS_URI, theFragmentPackage);
    return theFragmentPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAPMatchGroup()
  {
    return apMatchGroupEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAPMatchGroup_SingleMatches()
  {
    return (EReference)apMatchGroupEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAPMatch()
  {
    return apMatchEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAPMatch_Inverse()
  {
    return (EAttribute)apMatchEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAPMatch_MatchGroup()
  {
    return (EReference)apMatchEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAPMatch_Source()
  {
    return (EReference)apMatchEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAPMatch_Target()
  {
    return (EReference)apMatchEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAddressablePoint()
  {
    return addressablePointEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAddressablePoint_HeterogeneousPort()
  {
    return (EReference)addressablePointEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAddressablePoint_Name()
  {
    return (EAttribute)addressablePointEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAddressablePoint_VarTypedEObject()
  {
    return (EReference)addressablePointEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAddressablePoint_VarTypedEStructuralFeature()
  {
    return (EReference)addressablePointEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAnchor()
  {
    return anchorEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getComposedFragment()
  {
    return composedFragmentEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionInterface()
  {
    return compositionInterfaceEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionInterface_Fragment()
  {
    return (EReference)compositionInterfaceEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionInterface_Ports()
  {
    return (EReference)compositionInterfaceEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionInterface_RoleBinding()
  {
    return (EReference)compositionInterfaceEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragment()
  {
    return fragmentEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragment_UFI()
  {
    return (EAttribute)fragmentEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragment_ComponentModelActivators()
  {
    return (EReference)fragmentEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragment_CompositionInterfaces()
  {
    return (EReference)fragmentEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragment_CompositionLanguageActivators()
  {
    return (EReference)fragmentEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragment_Contents()
  {
    return (EReference)fragmentEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragment_Diagrams()
  {
    return (EReference)fragmentEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getHeterogeneousPort()
  {
    return heterogeneousPortEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getHeterogeneousPort_AddressablePoints()
  {
    return (EReference)heterogeneousPortEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getHeterogeneousPort_HomogenousPort()
  {
    return (EReference)heterogeneousPortEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getHomogeneousPort()
  {
    return homogeneousPortEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getHomogeneousPort_HeterogeneousPorts()
  {
    return (EReference)homogeneousPortEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getHook()
  {
    return hookEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getInstantiationSet()
  {
    return instantiationSetEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getInstantiationSet_Instantiations()
  {
    return (EReference)instantiationSetEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPhysicalFragment()
  {
    return physicalFragmentEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPort()
  {
    return portEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPort_CompositionInterface()
  {
    return (EReference)portEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPort_Name()
  {
    return (EAttribute)portEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPort_PortTypeBinding()
  {
    return (EReference)portEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPrototype()
  {
    return prototypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getReferencePoint()
  {
    return referencePointEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSlot()
  {
    return slotEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getValueHook()
  {
    return valueHookEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHook_BeginIndex()
  {
    return (EAttribute)valueHookEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHook_EndIndex()
  {
    return (EAttribute)valueHookEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHook_ListIndex()
  {
    return (EAttribute)valueHookEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getValuePrototype()
  {
    return valuePrototypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValuePrototype_Value()
  {
    return (EAttribute)valuePrototypeEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getVariationPoint()
  {
    return variationPointEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVariationPoint_Mode()
  {
    return (EAttribute)variationPointEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVariationPoint_Remove()
  {
    return (EAttribute)variationPointEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentFactory getFragmentFactory()
  {
    return (FragmentFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    apMatchGroupEClass = createEClass(AP_MATCH_GROUP);
    createEReference(apMatchGroupEClass, AP_MATCH_GROUP__SINGLE_MATCHES);

    apMatchEClass = createEClass(AP_MATCH);
    createEAttribute(apMatchEClass, AP_MATCH__INVERSE);
    createEReference(apMatchEClass, AP_MATCH__MATCH_GROUP);
    createEReference(apMatchEClass, AP_MATCH__SOURCE);
    createEReference(apMatchEClass, AP_MATCH__TARGET);

    addressablePointEClass = createEClass(ADDRESSABLE_POINT);
    createEReference(addressablePointEClass, ADDRESSABLE_POINT__HETEROGENEOUS_PORT);
    createEAttribute(addressablePointEClass, ADDRESSABLE_POINT__NAME);
    createEReference(addressablePointEClass, ADDRESSABLE_POINT__VAR_TYPED_EOBJECT);
    createEReference(addressablePointEClass, ADDRESSABLE_POINT__VAR_TYPED_ESTRUCTURAL_FEATURE);

    anchorEClass = createEClass(ANCHOR);

    composedFragmentEClass = createEClass(COMPOSED_FRAGMENT);

    compositionInterfaceEClass = createEClass(COMPOSITION_INTERFACE);
    createEReference(compositionInterfaceEClass, COMPOSITION_INTERFACE__FRAGMENT);
    createEReference(compositionInterfaceEClass, COMPOSITION_INTERFACE__PORTS);
    createEReference(compositionInterfaceEClass, COMPOSITION_INTERFACE__ROLE_BINDING);

    fragmentEClass = createEClass(FRAGMENT);
    createEAttribute(fragmentEClass, FRAGMENT__UFI);
    createEReference(fragmentEClass, FRAGMENT__COMPONENT_MODEL_ACTIVATORS);
    createEReference(fragmentEClass, FRAGMENT__COMPOSITION_INTERFACES);
    createEReference(fragmentEClass, FRAGMENT__COMPOSITION_LANGUAGE_ACTIVATORS);
    createEReference(fragmentEClass, FRAGMENT__CONTENTS);
    createEReference(fragmentEClass, FRAGMENT__DIAGRAMS);

    heterogeneousPortEClass = createEClass(HETEROGENEOUS_PORT);
    createEReference(heterogeneousPortEClass, HETEROGENEOUS_PORT__ADDRESSABLE_POINTS);
    createEReference(heterogeneousPortEClass, HETEROGENEOUS_PORT__HOMOGENOUS_PORT);

    homogeneousPortEClass = createEClass(HOMOGENEOUS_PORT);
    createEReference(homogeneousPortEClass, HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS);

    hookEClass = createEClass(HOOK);

    instantiationSetEClass = createEClass(INSTANTIATION_SET);
    createEReference(instantiationSetEClass, INSTANTIATION_SET__INSTANTIATIONS);

    physicalFragmentEClass = createEClass(PHYSICAL_FRAGMENT);

    portEClass = createEClass(PORT);
    createEReference(portEClass, PORT__COMPOSITION_INTERFACE);
    createEAttribute(portEClass, PORT__NAME);
    createEReference(portEClass, PORT__PORT_TYPE_BINDING);

    prototypeEClass = createEClass(PROTOTYPE);

    referencePointEClass = createEClass(REFERENCE_POINT);

    slotEClass = createEClass(SLOT);

    valueHookEClass = createEClass(VALUE_HOOK);
    createEAttribute(valueHookEClass, VALUE_HOOK__BEGIN_INDEX);
    createEAttribute(valueHookEClass, VALUE_HOOK__END_INDEX);
    createEAttribute(valueHookEClass, VALUE_HOOK__LIST_INDEX);

    valuePrototypeEClass = createEClass(VALUE_PROTOTYPE);
    createEAttribute(valuePrototypeEClass, VALUE_PROTOTYPE__VALUE);

    variationPointEClass = createEClass(VARIATION_POINT);
    createEAttribute(variationPointEClass, VARIATION_POINT__MODE);
    createEAttribute(variationPointEClass, VARIATION_POINT__REMOVE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);
    ReuseextensionPackage theReuseextensionPackage = (ReuseextensionPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionPackage.eNS_URI);
    ReuseextensionactivatorPackage theReuseextensionactivatorPackage = (ReuseextensionactivatorPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionactivatorPackage.eNS_URI);
    IdPackage theIdPackage = (IdPackage)EPackage.Registry.INSTANCE.getEPackage(IdPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    anchorEClass.getESuperTypes().add(this.getReferencePoint());
    composedFragmentEClass.getESuperTypes().add(this.getFragment());
    heterogeneousPortEClass.getESuperTypes().add(this.getPort());
    homogeneousPortEClass.getESuperTypes().add(this.getPort());
    hookEClass.getESuperTypes().add(this.getVariationPoint());
    physicalFragmentEClass.getESuperTypes().add(this.getFragment());
    prototypeEClass.getESuperTypes().add(this.getReferencePoint());
    referencePointEClass.getESuperTypes().add(this.getAddressablePoint());
    slotEClass.getESuperTypes().add(this.getVariationPoint());
    valueHookEClass.getESuperTypes().add(this.getVariationPoint());
    valuePrototypeEClass.getESuperTypes().add(this.getReferencePoint());
    variationPointEClass.getESuperTypes().add(this.getAddressablePoint());

    // Initialize classes and features; add operations and parameters
    initEClass(apMatchGroupEClass, APMatchGroup.class, "APMatchGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getAPMatchGroup_SingleMatches(), this.getAPMatch(), this.getAPMatch_MatchGroup(), "singleMatches", null, 0, -1, APMatchGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    EOperation op = addEOperation(apMatchGroupEClass, null, "execute", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getFragment(), "composedSource", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getFragment(), "composedTarget", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getComposedFragment(), "result", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "additionalContext", 0, -1, IS_UNIQUE, IS_ORDERED);

    addEOperation(apMatchGroupEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(apMatchEClass, APMatch.class, "APMatch", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getAPMatch_Inverse(), ecorePackage.getEBoolean(), "inverse", "false", 1, 1, APMatch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getAPMatch_MatchGroup(), this.getAPMatchGroup(), this.getAPMatchGroup_SingleMatches(), "matchGroup", null, 0, 1, APMatch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getAPMatch_Source(), this.getReferencePoint(), null, "source", null, 1, 1, APMatch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getAPMatch_Target(), this.getVariationPoint(), null, "target", null, 1, 1, APMatch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(apMatchEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(addressablePointEClass, AddressablePoint.class, "AddressablePoint", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getAddressablePoint_HeterogeneousPort(), this.getHeterogeneousPort(), this.getHeterogeneousPort_AddressablePoints(), "heterogeneousPort", null, 0, 1, AddressablePoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getAddressablePoint_Name(), ecorePackage.getEString(), "name", null, 1, 1, AddressablePoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getAddressablePoint_VarTypedEObject(), theEcorePackage.getEObject(), null, "varTypedEObject", null, 1, 1, AddressablePoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getAddressablePoint_VarTypedEStructuralFeature(), theEcorePackage.getEStructuralFeature(), null, "varTypedEStructuralFeature", null, 0, 1, AddressablePoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    op = addEOperation(addressablePointEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(addressablePointEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(anchorEClass, Anchor.class, "Anchor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    op = addEOperation(anchorEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(anchorEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(composedFragmentEClass, ComposedFragment.class, "ComposedFragment", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(composedFragmentEClass, null, "removeVariationPoints", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(composedFragmentEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionInterfaceEClass, CompositionInterface.class, "CompositionInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionInterface_Fragment(), this.getFragment(), this.getFragment_CompositionInterfaces(), "fragment", null, 0, 1, CompositionInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionInterface_Ports(), this.getPort(), this.getPort_CompositionInterface(), "ports", null, 0, -1, CompositionInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionInterface_RoleBinding(), theReuseextensionPackage.getFragmentRole2FragmentBinding(), null, "roleBinding", null, 1, 1, CompositionInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(compositionInterfaceEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentEClass, Fragment.class, "Fragment", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getFragment_UFI(), ecorePackage.getEString(), "UFI", null, 1, -1, Fragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragment_ComponentModelActivators(), theReuseextensionactivatorPackage.getReuseExtensionActivator(), null, "componentModelActivators", null, 0, -1, Fragment.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragment_CompositionInterfaces(), this.getCompositionInterface(), this.getCompositionInterface_Fragment(), "compositionInterfaces", null, 0, -1, Fragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragment_CompositionLanguageActivators(), theReuseextensionactivatorPackage.getReuseExtensionActivator(), null, "compositionLanguageActivators", null, 0, -1, Fragment.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragment_Contents(), theEcorePackage.getEObject(), null, "contents", null, 0, -1, Fragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragment_Diagrams(), theEcorePackage.getEObject(), null, "diagrams", null, 0, -1, Fragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(fragmentEClass, null, "computeCompositionInterface", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentEClass, this.getComposedFragment(), "copy", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "copyUFI", 0, -1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentEClass, this.getHeterogeneousPort(), "createPort", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getCompositionInterface(), "ci", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "element", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionPackage.getAddressablePointDerivationRule(), "apRule", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionPackage.getPortType2PortBinding(), "portBinding", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionactivatorPackage.getReuseExtensionActivator(), "activator", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentEClass, this.getPort(), "createStaticPorts", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getCompositionInterface(), "ci", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionPackage.getPortType2PortBinding(), "portBinding", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentEClass, this.getAddressablePoint(), "getAllAddressablePoints", 0, -1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentEClass, theIdPackage.getID(), "getUFIAsID", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentEClass, null, "removeEmptyInterfacesAndPorts", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(heterogeneousPortEClass, HeterogeneousPort.class, "HeterogeneousPort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getHeterogeneousPort_AddressablePoints(), this.getAddressablePoint(), this.getAddressablePoint_HeterogeneousPort(), "addressablePoints", null, 0, -1, HeterogeneousPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getHeterogeneousPort_HomogenousPort(), this.getHomogeneousPort(), this.getHomogeneousPort_HeterogeneousPorts(), "homogenousPort", null, 0, 1, HeterogeneousPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(heterogeneousPortEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(homogeneousPortEClass, HomogeneousPort.class, "HomogeneousPort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getHomogeneousPort_HeterogeneousPorts(), this.getHeterogeneousPort(), this.getHeterogeneousPort_HomogenousPort(), "heterogeneousPorts", null, 0, -1, HomogeneousPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(homogeneousPortEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(hookEClass, Hook.class, "Hook", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    op = addEOperation(hookEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(hookEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(instantiationSetEClass, InstantiationSet.class, "InstantiationSet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getInstantiationSet_Instantiations(), this.getFragment(), null, "instantiations", null, 0, -1, InstantiationSet.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(instantiationSetEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(physicalFragmentEClass, PhysicalFragment.class, "PhysicalFragment", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(physicalFragmentEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portEClass, Port.class, "Port", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPort_CompositionInterface(), this.getCompositionInterface(), this.getCompositionInterface_Ports(), "compositionInterface", null, 0, 1, Port.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getPort_Name(), ecorePackage.getEString(), "name", null, 1, 1, Port.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getPort_PortTypeBinding(), theReuseextensionPackage.getPortType2PortBinding(), null, "portTypeBinding", null, 1, 1, Port.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(portEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(prototypeEClass, Prototype.class, "Prototype", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    op = addEOperation(prototypeEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(prototypeEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(referencePointEClass, ReferencePoint.class, "ReferencePoint", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(referencePointEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(slotEClass, Slot.class, "Slot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    op = addEOperation(slotEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(slotEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(valueHookEClass, ValueHook.class, "ValueHook", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getValueHook_BeginIndex(), ecorePackage.getEInt(), "beginIndex", "-1", 1, 1, ValueHook.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getValueHook_EndIndex(), ecorePackage.getEInt(), "endIndex", "-1", 1, 1, ValueHook.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getValueHook_ListIndex(), ecorePackage.getEInt(), "listIndex", "0", 1, 1, ValueHook.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    op = addEOperation(valueHookEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(valueHookEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(valuePrototypeEClass, ValuePrototype.class, "ValuePrototype", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getValuePrototype_Value(), ecorePackage.getEString(), "value", null, 1, 1, ValuePrototype.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    op = addEOperation(valuePrototypeEClass, this.getAPMatch(), "match", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getAddressablePoint(), "ap", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(valuePrototypeEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(variationPointEClass, VariationPoint.class, "VariationPoint", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getVariationPoint_Mode(), ecorePackage.getEString(), "mode", "default", 1, 1, VariationPoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVariationPoint_Remove(), ecorePackage.getEBoolean(), "remove", "false", 1, 1, VariationPoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "append", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "basicCompose", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "bind", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "compose", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getReferencePoint(), "rp", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getComposedFragment(), "result", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "context", 0, -1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "extend", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "prepend", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "referenceNode", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(variationPointEClass, null, "primitiveCompose", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, null, "remove", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "parent", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEStructuralFeature(), "feature", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "variationNode", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(variationPointEClass, ecorePackage.getEBoolean(), "typeMatch", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, this.getReferencePoint(), "rp", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(variationPointEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);
  }

} //FragmentPackageImpl
