/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fragment.AddressablePoint;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.HomogeneousPort;




/**
 * @generated
 **/
public class HeterogeneousPortImpl extends PortImpl implements HeterogeneousPort
{


   /**
   * The cached value of the '{@link #getAddressablePoints() <em>Addressable Points</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAddressablePoints()
   * @generated
   * @ordered
   */
  protected EList<AddressablePoint> addressablePoints;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HeterogeneousPortImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.HETEROGENEOUS_PORT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AddressablePoint> getAddressablePoints()
  {
    if (addressablePoints == null)
    {
      addressablePoints = new EObjectContainmentWithInverseEList<AddressablePoint>(AddressablePoint.class, this, FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS, FragmentPackage.ADDRESSABLE_POINT__HETEROGENEOUS_PORT);
    }
    return addressablePoints;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HomogeneousPort getHomogenousPort()
  {
    if (eContainerFeatureID() != FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT) return null;
    return (HomogeneousPort)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHomogenousPort(HomogeneousPort newHomogenousPort, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newHomogenousPort, FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHomogenousPort(HomogeneousPort newHomogenousPort)
  {
    if (newHomogenousPort != eInternalContainer() || (eContainerFeatureID() != FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT && newHomogenousPort != null))
    {
      if (EcoreUtil.isAncestor(this, newHomogenousPort))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newHomogenousPort != null)
        msgs = ((InternalEObject)newHomogenousPort).eInverseAdd(this, FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS, HomogeneousPort.class, msgs);
      msgs = basicSetHomogenousPort(newHomogenousPort, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT, newHomogenousPort, newHomogenousPort));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getAddressablePoints()).basicAdd(otherEnd, msgs);
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetHomogenousPort((HomogeneousPort)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        return ((InternalEList<?>)getAddressablePoints()).basicRemove(otherEnd, msgs);
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        return basicSetHomogenousPort(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        return eInternalContainer().eInverseRemove(this, FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS, HomogeneousPort.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        return getAddressablePoints();
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        return getHomogenousPort();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        getAddressablePoints().clear();
        getAddressablePoints().addAll((Collection<? extends AddressablePoint>)newValue);
        return;
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        setHomogenousPort((HomogeneousPort)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        getAddressablePoints().clear();
        return;
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        setHomogenousPort((HomogeneousPort)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.HETEROGENEOUS_PORT__ADDRESSABLE_POINTS:
        return addressablePoints != null && !addressablePoints.isEmpty();
      case FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT:
        return getHomogenousPort() != null;
    }
    return super.eIsSet(featureID);
  }

  public void removeYou()
   {
      this.getAddressablePoints().clear();
      this.setHomogenousPort (null);
super.removeYou ();   }
}


