/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.HomogeneousPort;




/**
 * @generated
 **/
public class HomogeneousPortImpl extends PortImpl implements HomogeneousPort
{


   /**
   * The cached value of the '{@link #getHeterogeneousPorts() <em>Heterogeneous Ports</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeterogeneousPorts()
   * @generated
   * @ordered
   */
  protected EList<HeterogeneousPort> heterogeneousPorts;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HomogeneousPortImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.HOMOGENEOUS_PORT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HeterogeneousPort> getHeterogeneousPorts()
  {
    if (heterogeneousPorts == null)
    {
      heterogeneousPorts = new EObjectContainmentWithInverseEList<HeterogeneousPort>(HeterogeneousPort.class, this, FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS, FragmentPackage.HETEROGENEOUS_PORT__HOMOGENOUS_PORT);
    }
    return heterogeneousPorts;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getHeterogeneousPorts()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        return ((InternalEList<?>)getHeterogeneousPorts()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        return getHeterogeneousPorts();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        getHeterogeneousPorts().clear();
        getHeterogeneousPorts().addAll((Collection<? extends HeterogeneousPort>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        getHeterogeneousPorts().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.HOMOGENEOUS_PORT__HETEROGENEOUS_PORTS:
        return heterogeneousPorts != null && !heterogeneousPorts.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  public void removeYou()
   {
      this.getHeterogeneousPorts().clear();
super.removeYou ();   }
}


