/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;




/**
 * @generated
 **/
public abstract class PortImpl extends EObjectImpl implements Port
{


   /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortTypeBinding() <em>Port Type Binding</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortTypeBinding()
   * @generated
   * @ordered
   */
  protected PortType2PortBinding portTypeBinding;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PortImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.PORT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionInterface getCompositionInterface()
  {
    if (eContainerFeatureID() != FragmentPackage.PORT__COMPOSITION_INTERFACE) return null;
    return (CompositionInterface)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCompositionInterface(CompositionInterface newCompositionInterface, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newCompositionInterface, FragmentPackage.PORT__COMPOSITION_INTERFACE, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionInterface(CompositionInterface newCompositionInterface)
  {
    if (newCompositionInterface != eInternalContainer() || (eContainerFeatureID() != FragmentPackage.PORT__COMPOSITION_INTERFACE && newCompositionInterface != null))
    {
      if (EcoreUtil.isAncestor(this, newCompositionInterface))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newCompositionInterface != null)
        msgs = ((InternalEObject)newCompositionInterface).eInverseAdd(this, FragmentPackage.COMPOSITION_INTERFACE__PORTS, CompositionInterface.class, msgs);
      msgs = basicSetCompositionInterface(newCompositionInterface, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.PORT__COMPOSITION_INTERFACE, newCompositionInterface, newCompositionInterface));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.PORT__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2PortBinding getPortTypeBinding()
  {
    if (portTypeBinding != null && portTypeBinding.eIsProxy())
    {
      InternalEObject oldPortTypeBinding = (InternalEObject)portTypeBinding;
      portTypeBinding = (PortType2PortBinding)eResolveProxy(oldPortTypeBinding);
      if (portTypeBinding != oldPortTypeBinding)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.PORT__PORT_TYPE_BINDING, oldPortTypeBinding, portTypeBinding));
      }
    }
    return portTypeBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2PortBinding basicGetPortTypeBinding()
  {
    return portTypeBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortTypeBinding(PortType2PortBinding newPortTypeBinding)
  {
    PortType2PortBinding oldPortTypeBinding = portTypeBinding;
    portTypeBinding = newPortTypeBinding;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.PORT__PORT_TYPE_BINDING, oldPortTypeBinding, portTypeBinding));
  }

  public void removeYou()
   {
      this.setCompositionInterface (null);
      this.setPortTypeBinding (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetCompositionInterface((CompositionInterface)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        return basicSetCompositionInterface(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        return eInternalContainer().eInverseRemove(this, FragmentPackage.COMPOSITION_INTERFACE__PORTS, CompositionInterface.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        return getCompositionInterface();
      case FragmentPackage.PORT__NAME:
        return getName();
      case FragmentPackage.PORT__PORT_TYPE_BINDING:
        if (resolve) return getPortTypeBinding();
        return basicGetPortTypeBinding();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        setCompositionInterface((CompositionInterface)newValue);
        return;
      case FragmentPackage.PORT__NAME:
        setName((String)newValue);
        return;
      case FragmentPackage.PORT__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2PortBinding)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        setCompositionInterface((CompositionInterface)null);
        return;
      case FragmentPackage.PORT__NAME:
        setName(NAME_EDEFAULT);
        return;
      case FragmentPackage.PORT__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2PortBinding)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.PORT__COMPOSITION_INTERFACE:
        return getCompositionInterface() != null;
      case FragmentPackage.PORT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case FragmentPackage.PORT__PORT_TYPE_BINDING:
        return portTypeBinding != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }
}


