/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.AddressablePoint;


/**
 * @generated
 **/
public class ValueHookImpl extends VariationPointImpl implements ValueHook
{


   /**
   * The default value of the '{@link #getBeginIndex() <em>Begin Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBeginIndex()
   * @generated
   * @ordered
   */
  protected static final int BEGIN_INDEX_EDEFAULT = -1;
  /**
   * The cached value of the '{@link #getBeginIndex() <em>Begin Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBeginIndex()
   * @generated
   * @ordered
   */
  protected int beginIndex = BEGIN_INDEX_EDEFAULT;
  /**
   * The default value of the '{@link #getEndIndex() <em>End Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEndIndex()
   * @generated
   * @ordered
   */
  protected static final int END_INDEX_EDEFAULT = -1;
  /**
   * The cached value of the '{@link #getEndIndex() <em>End Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEndIndex()
   * @generated
   * @ordered
   */
  protected int endIndex = END_INDEX_EDEFAULT;
  /**
   * The default value of the '{@link #getListIndex() <em>List Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getListIndex()
   * @generated
   * @ordered
   */
  protected static final int LIST_INDEX_EDEFAULT = 0;
  /**
   * The cached value of the '{@link #getListIndex() <em>List Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getListIndex()
   * @generated
   * @ordered
   */
  protected int listIndex = LIST_INDEX_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ValueHookImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.VALUE_HOOK;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getBeginIndex()
  {
    return beginIndex;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBeginIndex(int newBeginIndex)
  {
    int oldBeginIndex = beginIndex;
    beginIndex = newBeginIndex;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.VALUE_HOOK__BEGIN_INDEX, oldBeginIndex, beginIndex));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getEndIndex()
  {
    return endIndex;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEndIndex(int newEndIndex)
  {
    int oldEndIndex = endIndex;
    endIndex = newEndIndex;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.VALUE_HOOK__END_INDEX, oldEndIndex, endIndex));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getListIndex()
  {
    return listIndex;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setListIndex(int newListIndex)
  {
    int oldListIndex = listIndex;
    listIndex = newListIndex;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.VALUE_HOOK__LIST_INDEX, oldListIndex, listIndex));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.VALUE_HOOK__BEGIN_INDEX:
        return getBeginIndex();
      case FragmentPackage.VALUE_HOOK__END_INDEX:
        return getEndIndex();
      case FragmentPackage.VALUE_HOOK__LIST_INDEX:
        return getListIndex();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.VALUE_HOOK__BEGIN_INDEX:
        setBeginIndex((Integer)newValue);
        return;
      case FragmentPackage.VALUE_HOOK__END_INDEX:
        setEndIndex((Integer)newValue);
        return;
      case FragmentPackage.VALUE_HOOK__LIST_INDEX:
        setListIndex((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.VALUE_HOOK__BEGIN_INDEX:
        setBeginIndex(BEGIN_INDEX_EDEFAULT);
        return;
      case FragmentPackage.VALUE_HOOK__END_INDEX:
        setEndIndex(END_INDEX_EDEFAULT);
        return;
      case FragmentPackage.VALUE_HOOK__LIST_INDEX:
        setListIndex(LIST_INDEX_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.VALUE_HOOK__BEGIN_INDEX:
        return beginIndex != BEGIN_INDEX_EDEFAULT;
      case FragmentPackage.VALUE_HOOK__END_INDEX:
        return endIndex != END_INDEX_EDEFAULT;
      case FragmentPackage.VALUE_HOOK__LIST_INDEX:
        return listIndex != LIST_INDEX_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (beginIndex: ");
    result.append(beginIndex);
    result.append(", endIndex: ");
    result.append(endIndex);
    result.append(", listIndex: ");
    result.append(listIndex);
    result.append(')');
    return result.toString();
  }

  public APMatch match (AddressablePoint ap ){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      ValuePrototype vPrototype = null;
      APMatch match = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         _TmpObject = ap;

         // ensure correct type and really bound of object vPrototype
         if (!( _TmpObject instanceof ValuePrototype )) {throw new Exception("SDMException");};
         vPrototype = (ValuePrototype) _TmpObject;

         // attribute condition
         if (!( this.name.equals(vPrototype.getName ()) )) {throw new Exception("SDMException");};

         // create object
         match = FragmentFactory.eINSTANCE.createAPMatch();
         // assign statement
         match.setInverse (true);
         // create link
         match.setTarget(this);

         // create link
         match.setSource(vPrototype);

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return match;

      }
      else
      {
         return null;

      }

   }


}


