/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.id.impl;


import java.util.Collection;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.reuseware.coconut.id.IdFactory;
import org.reuseware.coconut.id.ID;
import org.reuseware.coconut.id.IdPackage;


/**
 * @generated
 **/
public class IDImpl extends EObjectImpl implements ID
{


   /**
   * The cached value of the '{@link #getSegments() <em>Segments</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSegments()
   * @generated
   * @ordered
   */
  protected EList<String> segments;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IDImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return IdPackage.Literals.ID;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getSegments()
  {
    if (segments == null)
    {
      segments = new EDataTypeEList<String>(String.class, this, IdPackage.ID__SEGMENTS);
    }
    return segments;
  }


  public ID appendAll (EList<String> segments ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern create id
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // collabStat call
         id.getSegments().addAll(this.getSegments());
         // collabStat call
         id.getSegments().addAll(segments);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public ID appendExtension (String extension ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern create id
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if(extension == null) extension = "";
      for(int j = 0; j < getSegments().size(); j++) {
        if(getSegments().size() == j + 1) {
          String last = getSegments().get(j);
          last = last + "." + extension;
          id.getSegments().add(last);
       }
        else {
          id.getSegments().add(getSegments().get(j)); 
       }
      }
      return id;

   }


   public ID append (String segment ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern create id
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // collabStat call
         id.getSegments().addAll(this.getSegments());
         // collabStat call
         id.getSegments().add(segment);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public String extension (){

      String value = "";
      int idx = this.segment(-1).lastIndexOf(".");
      if (idx != -1) {
        value = this.segment(-1).substring(idx + 1);
      }
      return value;

   }


   public ID prefix (int i ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      for (int j = 0; j < i; j++) {
      	if (j < getSegments().size()) {
      		id.getSegments().add(getSegments().get(j));
      	}
      }
      return id;

   }


   public ID replace (String segment1 , String segment2 ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern create id
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      for(int j = 0; j < getSegments().size(); j++) {
        if(getSegments().get(j).equals(segment1)) {
          id.getSegments().add(segment2); 
       }
        else {
          id.getSegments().add(getSegments().get(j)); 
       }
      }
      return id;

   }


   public String segment (int i ){

      String s = "";
      if (i < 0) {
        i = getSegments().size() + i;
      }
      if (i > -1) {
        s = getSegments().get(i);
      }
      return s;

   }


   public boolean startsWith (ID prefix ){

      boolean result = true;

      if (prefix.getSegments().size() > getSegments().size()) {
      	result = false;
      } else {
      	for (int j = 0; j < getSegments().size(); j++) {
      		String s1 = prefix.getSegments().get(j);
      		String s2 = getSegments().get(j);
      		if (!s1.equals(s2)) {
      			result = false;
      			break;
      		}
      	}
      }
      return result;

   }


   public String toString (){

      String result = "";
      java.util.Iterator<String> stringIt = getSegments().iterator();
      while(stringIt.hasNext()) {
      	result += stringIt.next();
      	if (stringIt.hasNext()) {
      		result += "/";
      	}
      }
      return result;

   }


   public ID trimExtension (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      for(int j = 0; j < getSegments().size(); j++) {
        if(getSegments().size() == j + 1) {
          String last = getSegments().get(j);
          int idx = last.lastIndexOf('.');
          if(idx != -1) {
            last = last.substring(0,idx);
          }
          id.getSegments().add(last);
       }
        else {
          id.getSegments().add(getSegments().get(j)); 
       }
      }
      return id;

   }


   public ID trim (int i ){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern create id
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      for(int j=0; j < getSegments().size() - i; j++) {
          id.getSegments().add(getSegments().get(j));
      }
      return id;

   }


   public void removeYou()
   {
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case IdPackage.ID__SEGMENTS:
        return getSegments();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case IdPackage.ID__SEGMENTS:
        getSegments().clear();
        getSegments().addAll((Collection<? extends String>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case IdPackage.ID__SEGMENTS:
        getSegments().clear();
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case IdPackage.ID__SEGMENTS:
        return segments != null && !segments.isEmpty();
    }
    return super.eIsSet(featureID);
  }
}


