/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Addressable Point Derivation Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getForEachExpression <em>For Each Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getHomoPortNameExpression <em>Homo Port Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPointNameExpression <em>Point Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortNameExpression <em>Port Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule()
 * @model abstract="true"
 * @generated
 */
public interface AddressablePointDerivationRule extends RuleContext
{
  /**
   * Returns the value of the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Each Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Each Expression</em>' attribute.
   * @see #setForEachExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule_ForEachExpression()
   * @model
   * @generated
   */
  String getForEachExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getForEachExpression <em>For Each Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Each Expression</em>' attribute.
   * @see #getForEachExpression()
   * @generated
   */
  void setForEachExpression(String value);

  /**
   * Returns the value of the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Homo Port Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Homo Port Name Expression</em>' attribute.
   * @see #setHomoPortNameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule_HomoPortNameExpression()
   * @model
   * @generated
   */
  String getHomoPortNameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getHomoPortNameExpression <em>Homo Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Homo Port Name Expression</em>' attribute.
   * @see #getHomoPortNameExpression()
   * @generated
   */
  void setHomoPortNameExpression(String value);

  /**
   * Returns the value of the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Point Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Point Name Expression</em>' attribute.
   * @see #setPointNameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule_PointNameExpression()
   * @model
   * @generated
   */
  String getPointNameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPointNameExpression <em>Point Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Point Name Expression</em>' attribute.
   * @see #getPointNameExpression()
   * @generated
   */
  void setPointNameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Name Expression</em>' attribute.
   * @see #setPortNameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule_PortNameExpression()
   * @model
   * @generated
   */
  String getPortNameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortNameExpression <em>Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Name Expression</em>' attribute.
   * @see #getPortNameExpression()
   * @generated
   */
  void setPortNameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Type Binding</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding#getDerivationRules <em>Derivation Rules</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Binding</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Binding</em>' container reference.
   * @see #setPortTypeBinding(PortType2PortBinding)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getAddressablePointDerivationRule_PortTypeBinding()
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding#getDerivationRules
   * @model opposite="derivationRules" transient="false" ordered="false"
   * @generated
   */
  PortType2PortBinding getPortTypeBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Type Binding</em>' container reference.
   * @see #getPortTypeBinding()
   * @generated
   */
  void setPortTypeBinding(PortType2PortBinding value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // AddressablePointDerivationRule
