/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Type2 Setting Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getDerivationRules <em>Derivation Rules</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SettingBinding()
 * @model
 * @generated
 */
public interface PortType2SettingBinding extends PortTypeBinding
{
  /**
   * Returns the value of the '<em><b>Derivation Rules</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.SettingDerivationRule}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Derivation Rules</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Derivation Rules</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SettingBinding_DerivationRules()
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding
   * @model opposite="portTypeBinding" containment="true" ordered="false"
   * @generated
   */
  EList<SettingDerivationRule> getDerivationRules();

  /**
   * Returns the value of the '<em><b>Fragment Role Binding</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getPortTypeBindings <em>Port Type Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Role Binding</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Role Binding</em>' container reference.
   * @see #setFragmentRoleBinding(FragmentRole2FragmentInstanceBinding)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SettingBinding_FragmentRoleBinding()
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getPortTypeBindings
   * @model opposite="portTypeBindings" transient="false" ordered="false"
   * @generated
   */
  FragmentRole2FragmentInstanceBinding getFragmentRoleBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Role Binding</em>' container reference.
   * @see #getFragmentRoleBinding()
   * @generated
   */
  void setFragmentRoleBinding(FragmentRole2FragmentInstanceBinding value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // PortType2SettingBinding
