/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Type2 Syntax Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getLabelExpression <em>Label Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SyntaxBinding()
 * @model
 * @generated
 */
public interface PortType2SyntaxBinding extends SyntaxDerivationRule, PortTypeBinding
{
  /**
   * Returns the value of the '<em><b>Fragment Role2 Syntax Binding</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getPortTypeBindings <em>Port Type Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Role2 Syntax Binding</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Role2 Syntax Binding</em>' container reference.
   * @see #setFragmentRole2SyntaxBinding(FragmentRole2SyntaxBinding)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SyntaxBinding_FragmentRole2SyntaxBinding()
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getPortTypeBindings
   * @model opposite="portTypeBindings" transient="false" ordered="false"
   * @generated
   */
  FragmentRole2SyntaxBinding getFragmentRole2SyntaxBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Role2 Syntax Binding</em>' container reference.
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  void setFragmentRole2SyntaxBinding(FragmentRole2SyntaxBinding value);

  /**
   * Returns the value of the '<em><b>Label Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Label Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Label Expression</em>' attribute.
   * @see #setLabelExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getPortType2SyntaxBinding_LabelExpression()
   * @model
   * @generated
   */
  String getLabelExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getLabelExpression <em>Label Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Label Expression</em>' attribute.
   * @see #getLabelExpression()
   * @generated
   */
  void setLabelExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // PortType2SyntaxBinding
