/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage
 * @generated
 */
public interface ReuseextensionFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ReuseextensionFactory eINSTANCE = org.reuseware.coconut.reuseextension.impl.ReuseextensionFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Anchor Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Anchor Derivation Rule</em>'.
   * @generated
   */
  AnchorDerivationRule createAnchorDerivationRule();

  /**
   * Returns a new object of class '<em>Component Model Specification</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Component Model Specification</em>'.
   * @generated
   */
  ComponentModelSpecification createComponentModelSpecification();

  /**
   * Returns a new object of class '<em>Composition Association2 Composition Link Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Association2 Composition Link Binding</em>'.
   * @generated
   */
  CompositionAssociation2CompositionLinkBinding createCompositionAssociation2CompositionLinkBinding();

  /**
   * Returns a new object of class '<em>Composition Language Specification</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Language Specification</em>'.
   * @generated
   */
  CompositionLanguageSpecification createCompositionLanguageSpecification();

  /**
   * Returns a new object of class '<em>Composition Language Syntax Specification</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Language Syntax Specification</em>'.
   * @generated
   */
  CompositionLanguageSyntaxSpecification createCompositionLanguageSyntaxSpecification();

  /**
   * Returns a new object of class '<em>Fragment Role2 Fragment Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Fragment Role2 Fragment Binding</em>'.
   * @generated
   */
  FragmentRole2FragmentBinding createFragmentRole2FragmentBinding();

  /**
   * Returns a new object of class '<em>Fragment Role2 Fragment Instance Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Fragment Role2 Fragment Instance Binding</em>'.
   * @generated
   */
  FragmentRole2FragmentInstanceBinding createFragmentRole2FragmentInstanceBinding();

  /**
   * Returns a new object of class '<em>Fragment Role2 Fragment Reference Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Fragment Role2 Fragment Reference Binding</em>'.
   * @generated
   */
  FragmentRole2FragmentReferenceBinding createFragmentRole2FragmentReferenceBinding();

  /**
   * Returns a new object of class '<em>Fragment Role2 Syntax Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Fragment Role2 Syntax Binding</em>'.
   * @generated
   */
  FragmentRole2SyntaxBinding createFragmentRole2SyntaxBinding();

  /**
   * Returns a new object of class '<em>Hook Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Hook Derivation Rule</em>'.
   * @generated
   */
  HookDerivationRule createHookDerivationRule();

  /**
   * Returns a new object of class '<em>Port Type2 Heterogeneous Port Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Port Type2 Heterogeneous Port Binding</em>'.
   * @generated
   */
  PortType2HeterogeneousPortBinding createPortType2HeterogeneousPortBinding();

  /**
   * Returns a new object of class '<em>Port Type2 Homogenous Port Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Port Type2 Homogenous Port Binding</em>'.
   * @generated
   */
  PortType2HomogenousPortBinding createPortType2HomogenousPortBinding();

  /**
   * Returns a new object of class '<em>Port Type2 Setting Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Port Type2 Setting Binding</em>'.
   * @generated
   */
  PortType2SettingBinding createPortType2SettingBinding();

  /**
   * Returns a new object of class '<em>Port Type2 Syntax Binding</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Port Type2 Syntax Binding</em>'.
   * @generated
   */
  PortType2SyntaxBinding createPortType2SyntaxBinding();

  /**
   * Returns a new object of class '<em>Prototype Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Prototype Derivation Rule</em>'.
   * @generated
   */
  PrototypeDerivationRule createPrototypeDerivationRule();

  /**
   * Returns a new object of class '<em>Root Element Context</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Root Element Context</em>'.
   * @generated
   */
  RootElementContext createRootElementContext();

  /**
   * Returns a new object of class '<em>Setting Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Setting Derivation Rule</em>'.
   * @generated
   */
  SettingDerivationRule createSettingDerivationRule();

  /**
   * Returns a new object of class '<em>Slot Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Slot Derivation Rule</em>'.
   * @generated
   */
  SlotDerivationRule createSlotDerivationRule();

  /**
   * Returns a new object of class '<em>Value Hook Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Value Hook Derivation Rule</em>'.
   * @generated
   */
  ValueHookDerivationRule createValueHookDerivationRule();

  /**
   * Returns a new object of class '<em>Value Prototype Derivation Rule</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Value Prototype Derivation Rule</em>'.
   * @generated
   */
  ValuePrototypeDerivationRule createValuePrototypeDerivationRule();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  ReuseextensionPackage getReuseextensionPackage();

} //ReuseextensionFactory
