/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextension.ReuseextensionFactory
 * @model kind="package"
 * @generated
 */
public interface ReuseextensionPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "reuseextension";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://reuseware.org/coconut/reuseextension";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "org.reuseware.coconut.reuseextension";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ReuseextensionPackage eINSTANCE = org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl.init();

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.RuleContext <em>Rule Context</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.RuleContext
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getRuleContext()
   * @generated
   */
  int RULE_CONTEXT = 23;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RULE_CONTEXT__EBOUND_CLASS = 0;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RULE_CONTEXT__EBOUND_FEATURE = 1;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RULE_CONTEXT__IS_EXPRESSION = 2;

  /**
   * The number of structural features of the '<em>Rule Context</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RULE_CONTEXT_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.AddressablePointDerivationRuleImpl <em>Addressable Point Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.AddressablePointDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getAddressablePointDerivationRule()
   * @generated
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE = 0;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS = RULE_CONTEXT__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE = RULE_CONTEXT__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION = RULE_CONTEXT__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION = RULE_CONTEXT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = RULE_CONTEXT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION = RULE_CONTEXT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION = RULE_CONTEXT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING = RULE_CONTEXT_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Addressable Point Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ADDRESSABLE_POINT_DERIVATION_RULE_FEATURE_COUNT = RULE_CONTEXT_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.ReferencePointDerivationRuleImpl <em>Reference Point Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.ReferencePointDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getReferencePointDerivationRule()
   * @generated
   */
  int REFERENCE_POINT_DERIVATION_RULE = 20;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__EBOUND_CLASS = ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__EBOUND_FEATURE = ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__IS_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING = ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The number of structural features of the '<em>Reference Point Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REFERENCE_POINT_DERIVATION_RULE_FEATURE_COUNT = ADDRESSABLE_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.AnchorDerivationRuleImpl <em>Anchor Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.AnchorDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getAnchorDerivationRule()
   * @generated
   */
  int ANCHOR_DERIVATION_RULE = 1;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__EBOUND_CLASS = REFERENCE_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__EBOUND_FEATURE = REFERENCE_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__IS_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__FOR_EACH_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__POINT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE__PORT_TYPE_BINDING = REFERENCE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The number of structural features of the '<em>Anchor Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ANCHOR_DERIVATION_RULE_FEATURE_COUNT = REFERENCE_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.ReuseExtensionImpl <em>Reuse Extension</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.ReuseExtensionImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getReuseExtension()
   * @generated
   */
  int REUSE_EXTENSION = 21;

  /**
   * The feature id for the '<em><b>EPackages</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__EPACKAGES = 0;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__FRACOL_NAMESPACE = 1;

  /**
   * The feature id for the '<em><b>Fracol</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__FRACOL = 2;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__PARAMETERS = 3;

  /**
   * The feature id for the '<em><b>Rex Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__REX_NAME = 4;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__REX_NAMESPACE = 5;

  /**
   * The feature id for the '<em><b>Root Element Contexts</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS = 6;

  /**
   * The number of structural features of the '<em>Reuse Extension</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_FEATURE_COUNT = 7;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.ComponentModelSpecificationImpl <em>Component Model Specification</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.ComponentModelSpecificationImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getComponentModelSpecification()
   * @generated
   */
  int COMPONENT_MODEL_SPECIFICATION = 2;

  /**
   * The feature id for the '<em><b>EPackages</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__EPACKAGES = REUSE_EXTENSION__EPACKAGES;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__FRACOL_NAMESPACE = REUSE_EXTENSION__FRACOL_NAMESPACE;

  /**
   * The feature id for the '<em><b>Fracol</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__FRACOL = REUSE_EXTENSION__FRACOL;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__PARAMETERS = REUSE_EXTENSION__PARAMETERS;

  /**
   * The feature id for the '<em><b>Rex Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__REX_NAME = REUSE_EXTENSION__REX_NAME;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__REX_NAMESPACE = REUSE_EXTENSION__REX_NAMESPACE;

  /**
   * The feature id for the '<em><b>Root Element Contexts</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__ROOT_ELEMENT_CONTEXTS = REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS;

  /**
   * The feature id for the '<em><b>Fragment Role Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = REUSE_EXTENSION_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Component Model Specification</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_FEATURE_COUNT = REUSE_EXTENSION_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionAssociationBindingImpl <em>Composition Association Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.CompositionAssociationBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionAssociationBinding()
   * @generated
   */
  int COMPOSITION_ASSOCIATION_BINDING = 4;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS = RULE_CONTEXT__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE = RULE_CONTEXT__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION = RULE_CONTEXT__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>Composition Association</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION = RULE_CONTEXT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Composition Association Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT = RULE_CONTEXT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionAssociation2CompositionLinkBindingImpl <em>Composition Association2 Composition Link Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.CompositionAssociation2CompositionLinkBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING = 3;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__EBOUND_CLASS = COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__EBOUND_FEATURE = COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__IS_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>Composition Association</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__COMPOSITION_ASSOCIATION = COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION;

  /**
   * The feature id for the '<em><b>Composition Language Specification</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>For Each1 Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH1_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>For Each2 Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH2_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Fragment Instance1 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE1_NAME_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Fragment Instance2 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE2_NAME_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Port Instance1 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE1_NAME_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Port Instance2 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE2_NAME_EXPRESSION = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 6;

  /**
   * The number of structural features of the '<em>Composition Association2 Composition Link Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING_FEATURE_COUNT = COMPOSITION_ASSOCIATION_BINDING_FEATURE_COUNT + 7;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionLanguageSpecificationImpl <em>Composition Language Specification</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.CompositionLanguageSpecificationImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionLanguageSpecification()
   * @generated
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION = 5;

  /**
   * The feature id for the '<em><b>EPackages</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__EPACKAGES = REUSE_EXTENSION__EPACKAGES;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__FRACOL_NAMESPACE = REUSE_EXTENSION__FRACOL_NAMESPACE;

  /**
   * The feature id for the '<em><b>Fracol</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__FRACOL = REUSE_EXTENSION__FRACOL;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__PARAMETERS = REUSE_EXTENSION__PARAMETERS;

  /**
   * The feature id for the '<em><b>Rex Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__REX_NAME = REUSE_EXTENSION__REX_NAME;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__REX_NAMESPACE = REUSE_EXTENSION__REX_NAMESPACE;

  /**
   * The feature id for the '<em><b>Root Element Contexts</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__ROOT_ELEMENT_CONTEXTS = REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS;

  /**
   * The feature id for the '<em><b>Composition Association Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS = REUSE_EXTENSION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Composition Program Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION = REUSE_EXTENSION_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Fragment Role Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = REUSE_EXTENSION_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Ucpi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION = REUSE_EXTENSION_FEATURE_COUNT + 3;

  /**
   * The number of structural features of the '<em>Composition Language Specification</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_FEATURE_COUNT = REUSE_EXTENSION_FEATURE_COUNT + 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionLanguageSyntaxSpecificationImpl <em>Composition Language Syntax Specification</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.CompositionLanguageSyntaxSpecificationImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionLanguageSyntaxSpecification()
   * @generated
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION = 6;

  /**
   * The feature id for the '<em><b>EPackages</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__EPACKAGES = REUSE_EXTENSION__EPACKAGES;

  /**
   * The feature id for the '<em><b>Fracol Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRACOL_NAMESPACE = REUSE_EXTENSION__FRACOL_NAMESPACE;

  /**
   * The feature id for the '<em><b>Fracol</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRACOL = REUSE_EXTENSION__FRACOL;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__PARAMETERS = REUSE_EXTENSION__PARAMETERS;

  /**
   * The feature id for the '<em><b>Rex Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__REX_NAME = REUSE_EXTENSION__REX_NAME;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__REX_NAMESPACE = REUSE_EXTENSION__REX_NAMESPACE;

  /**
   * The feature id for the '<em><b>Root Element Contexts</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__ROOT_ELEMENT_CONTEXTS = REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS;

  /**
   * The feature id for the '<em><b>Fragment Role Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = REUSE_EXTENSION_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Composition Language Syntax Specification</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_FEATURE_COUNT = REUSE_EXTENSION_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRoleBindingImpl <em>Fragment Role Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.FragmentRoleBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRoleBinding()
   * @generated
   */
  int FRAGMENT_ROLE_BINDING = 11;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE = 0;

  /**
   * The number of structural features of the '<em>Fragment Role Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE_BINDING_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentBindingImpl <em>Fragment Role2 Fragment Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentBinding()
   * @generated
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING = 7;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING__FRAGMENT_ROLE = FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>Component Model Specification</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Fragment Role2 Fragment Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_BINDING_FEATURE_COUNT = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentInstanceBindingImpl <em>Fragment Role2 Fragment Instance Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentInstanceBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING = 8;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__FRAGMENT_ROLE = FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Composition Language Specification</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Target Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Target Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 8;

  /**
   * The number of structural features of the '<em>Fragment Role2 Fragment Instance Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING_FEATURE_COUNT = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 9;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentReferenceBindingImpl <em>Fragment Role2 Fragment Reference Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentReferenceBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentReferenceBinding()
   * @generated
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING = 9;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__FRAGMENT_ROLE = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__EBOUND_CLASS = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__EBOUND_FEATURE = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__IS_EXPRESSION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>Composition Language Specification</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION;

  /**
   * The feature id for the '<em><b>Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__NAME_EXPRESSION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__PORT_TYPE_BINDINGS = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS;

  /**
   * The feature id for the '<em><b>Target Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION;

  /**
   * The feature id for the '<em><b>Target Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__TARGET_UFI_EXPRESSION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION;

  /**
   * The feature id for the '<em><b>Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING__UFI_EXPRESSION = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION;

  /**
   * The number of structural features of the '<em>Fragment Role2 Fragment Reference Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING_FEATURE_COUNT = FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2SyntaxBindingImpl <em>Fragment Role2 Syntax Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2SyntaxBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2SyntaxBinding()
   * @generated
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING = 10;

  /**
   * The feature id for the '<em><b>Fragment Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__FRAGMENT_ROLE = FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE;

  /**
   * The feature id for the '<em><b>Height Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Icon Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Visible Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Width Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Composition Language Syntax</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Target Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Target Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 9;

  /**
   * The number of structural features of the '<em>Fragment Role2 Syntax Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FRAGMENT_ROLE2_SYNTAX_BINDING_FEATURE_COUNT = FRAGMENT_ROLE_BINDING_FEATURE_COUNT + 10;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.VariationPointDerivationRuleImpl <em>Variation Point Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.VariationPointDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getVariationPointDerivationRule()
   * @generated
   */
  int VARIATION_POINT_DERIVATION_RULE = 29;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__EBOUND_CLASS = ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__EBOUND_FEATURE = ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__IS_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__PORT_TYPE_BINDING = ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Mode Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Remove Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION = ADDRESSABLE_POINT_DERIVATION_RULE_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Variation Point Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT = ADDRESSABLE_POINT_DERIVATION_RULE_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.HookDerivationRuleImpl <em>Hook Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.HookDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getHookDerivationRule()
   * @generated
   */
  int HOOK_DERIVATION_RULE = 12;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__EBOUND_CLASS = VARIATION_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__EBOUND_FEATURE = VARIATION_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__IS_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__FOR_EACH_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__POINT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__PORT_TYPE_BINDING = VARIATION_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Mode Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__MODE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION;

  /**
   * The feature id for the '<em><b>Remove Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE__REMOVE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION;

  /**
   * The number of structural features of the '<em>Hook Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HOOK_DERIVATION_RULE_FEATURE_COUNT = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortTypeBindingImpl <em>Port Type Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortTypeBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortTypeBinding()
   * @generated
   */
  int PORT_TYPE_BINDING = 18;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE_BINDING__PORT_TYPE = 0;

  /**
   * The number of structural features of the '<em>Port Type Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE_BINDING_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2PortBindingImpl <em>Port Type2 Port Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortType2PortBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2PortBinding()
   * @generated
   */
  int PORT_TYPE2_PORT_BINDING = 15;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_PORT_BINDING__PORT_TYPE = PORT_TYPE_BINDING__PORT_TYPE;

  /**
   * The feature id for the '<em><b>Derivation Rules</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_PORT_BINDING__DERIVATION_RULES = PORT_TYPE_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Fragment Role Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING = PORT_TYPE_BINDING_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Port Type2 Port Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_PORT_BINDING_FEATURE_COUNT = PORT_TYPE_BINDING_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2HeterogeneousPortBindingImpl <em>Port Type2 Heterogeneous Port Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortType2HeterogeneousPortBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2HeterogeneousPortBinding()
   * @generated
   */
  int PORT_TYPE2_HETEROGENEOUS_PORT_BINDING = 13;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HETEROGENEOUS_PORT_BINDING__PORT_TYPE = PORT_TYPE2_PORT_BINDING__PORT_TYPE;

  /**
   * The feature id for the '<em><b>Derivation Rules</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HETEROGENEOUS_PORT_BINDING__DERIVATION_RULES = PORT_TYPE2_PORT_BINDING__DERIVATION_RULES;

  /**
   * The feature id for the '<em><b>Fragment Role Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HETEROGENEOUS_PORT_BINDING__FRAGMENT_ROLE_BINDING = PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING;

  /**
   * The number of structural features of the '<em>Port Type2 Heterogeneous Port Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HETEROGENEOUS_PORT_BINDING_FEATURE_COUNT = PORT_TYPE2_PORT_BINDING_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2HomogenousPortBindingImpl <em>Port Type2 Homogenous Port Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortType2HomogenousPortBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2HomogenousPortBinding()
   * @generated
   */
  int PORT_TYPE2_HOMOGENOUS_PORT_BINDING = 14;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HOMOGENOUS_PORT_BINDING__PORT_TYPE = PORT_TYPE2_PORT_BINDING__PORT_TYPE;

  /**
   * The feature id for the '<em><b>Derivation Rules</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HOMOGENOUS_PORT_BINDING__DERIVATION_RULES = PORT_TYPE2_PORT_BINDING__DERIVATION_RULES;

  /**
   * The feature id for the '<em><b>Fragment Role Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HOMOGENOUS_PORT_BINDING__FRAGMENT_ROLE_BINDING = PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING;

  /**
   * The number of structural features of the '<em>Port Type2 Homogenous Port Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_HOMOGENOUS_PORT_BINDING_FEATURE_COUNT = PORT_TYPE2_PORT_BINDING_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2SettingBindingImpl <em>Port Type2 Setting Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortType2SettingBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2SettingBinding()
   * @generated
   */
  int PORT_TYPE2_SETTING_BINDING = 16;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SETTING_BINDING__PORT_TYPE = PORT_TYPE_BINDING__PORT_TYPE;

  /**
   * The feature id for the '<em><b>Derivation Rules</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES = PORT_TYPE_BINDING_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Fragment Role Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING = PORT_TYPE_BINDING_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Port Type2 Setting Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SETTING_BINDING_FEATURE_COUNT = PORT_TYPE_BINDING_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.SyntaxDerivationRuleImpl <em>Syntax Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.SyntaxDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSyntaxDerivationRule()
   * @generated
   */
  int SYNTAX_DERIVATION_RULE = 26;

  /**
   * The feature id for the '<em><b>Height Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION = 0;

  /**
   * The feature id for the '<em><b>Icon Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SYNTAX_DERIVATION_RULE__ICON_EXPRESSION = 1;

  /**
   * The feature id for the '<em><b>Visible Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION = 2;

  /**
   * The feature id for the '<em><b>Width Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION = 3;

  /**
   * The number of structural features of the '<em>Syntax Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SYNTAX_DERIVATION_RULE_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2SyntaxBindingImpl <em>Port Type2 Syntax Binding</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PortType2SyntaxBindingImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2SyntaxBinding()
   * @generated
   */
  int PORT_TYPE2_SYNTAX_BINDING = 17;

  /**
   * The feature id for the '<em><b>Height Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__HEIGHT_EXPRESSION = SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION;

  /**
   * The feature id for the '<em><b>Icon Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__ICON_EXPRESSION = SYNTAX_DERIVATION_RULE__ICON_EXPRESSION;

  /**
   * The feature id for the '<em><b>Visible Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__VISIBLE_EXPRESSION = SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION;

  /**
   * The feature id for the '<em><b>Width Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__WIDTH_EXPRESSION = SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE = SYNTAX_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Fragment Role2 Syntax Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING = SYNTAX_DERIVATION_RULE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Label Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION = SYNTAX_DERIVATION_RULE_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Port Type2 Syntax Binding</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_TYPE2_SYNTAX_BINDING_FEATURE_COUNT = SYNTAX_DERIVATION_RULE_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.PrototypeDerivationRuleImpl <em>Prototype Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.PrototypeDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPrototypeDerivationRule()
   * @generated
   */
  int PROTOTYPE_DERIVATION_RULE = 19;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__EBOUND_CLASS = REFERENCE_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__EBOUND_FEATURE = REFERENCE_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__IS_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__FOR_EACH_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__POINT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE__PORT_TYPE_BINDING = REFERENCE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The number of structural features of the '<em>Prototype Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTOTYPE_DERIVATION_RULE_FEATURE_COUNT = REFERENCE_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.RootElementContextImpl <em>Root Element Context</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.RootElementContextImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getRootElementContext()
   * @generated
   */
  int ROOT_ELEMENT_CONTEXT = 22;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROOT_ELEMENT_CONTEXT__EBOUND_CLASS = RULE_CONTEXT__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROOT_ELEMENT_CONTEXT__EBOUND_FEATURE = RULE_CONTEXT__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROOT_ELEMENT_CONTEXT__IS_EXPRESSION = RULE_CONTEXT__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>Reuse Extension</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROOT_ELEMENT_CONTEXT__REUSE_EXTENSION = RULE_CONTEXT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Root Element Context</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROOT_ELEMENT_CONTEXT_FEATURE_COUNT = RULE_CONTEXT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.SettingDerivationRuleImpl <em>Setting Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.SettingDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSettingDerivationRule()
   * @generated
   */
  int SETTING_DERIVATION_RULE = 24;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING_DERIVATION_RULE__PORT_TYPE_BINDING = 0;

  /**
   * The feature id for the '<em><b>Property Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION = 1;

  /**
   * The feature id for the '<em><b>Value Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING_DERIVATION_RULE__VALUE_EXPRESSION = 2;

  /**
   * The number of structural features of the '<em>Setting Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SETTING_DERIVATION_RULE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.SlotDerivationRuleImpl <em>Slot Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.SlotDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSlotDerivationRule()
   * @generated
   */
  int SLOT_DERIVATION_RULE = 25;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__EBOUND_CLASS = VARIATION_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__EBOUND_FEATURE = VARIATION_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__IS_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__FOR_EACH_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__POINT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__PORT_TYPE_BINDING = VARIATION_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Mode Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__MODE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION;

  /**
   * The feature id for the '<em><b>Remove Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE__REMOVE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION;

  /**
   * The number of structural features of the '<em>Slot Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SLOT_DERIVATION_RULE_FEATURE_COUNT = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.ValueHookDerivationRuleImpl <em>Value Hook Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.ValueHookDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getValueHookDerivationRule()
   * @generated
   */
  int VALUE_HOOK_DERIVATION_RULE = 27;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__EBOUND_CLASS = VARIATION_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__EBOUND_FEATURE = VARIATION_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__IS_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__FOR_EACH_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__POINT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__PORT_NAME_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__PORT_TYPE_BINDING = VARIATION_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Mode Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__MODE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION;

  /**
   * The feature id for the '<em><b>Remove Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__REMOVE_EXPRESSION = VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION;

  /**
   * The feature id for the '<em><b>Begin Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>End Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>List Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Value Hook Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_HOOK_DERIVATION_RULE_FEATURE_COUNT = VARIATION_POINT_DERIVATION_RULE_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextension.impl.ValuePrototypeDerivationRuleImpl <em>Value Prototype Derivation Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextension.impl.ValuePrototypeDerivationRuleImpl
   * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getValuePrototypeDerivationRule()
   * @generated
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE = 28;

  /**
   * The feature id for the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__EBOUND_CLASS = REFERENCE_POINT_DERIVATION_RULE__EBOUND_CLASS;

  /**
   * The feature id for the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__EBOUND_FEATURE = REFERENCE_POINT_DERIVATION_RULE__EBOUND_FEATURE;

  /**
   * The feature id for the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__IS_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__IS_EXPRESSION;

  /**
   * The feature id for the '<em><b>For Each Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__FOR_EACH_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION;

  /**
   * The feature id for the '<em><b>Homo Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Point Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__POINT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__PORT_NAME_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION;

  /**
   * The feature id for the '<em><b>Port Type Binding</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__PORT_TYPE_BINDING = REFERENCE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING;

  /**
   * The feature id for the '<em><b>Value Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE__VALUE_EXPRESSION = REFERENCE_POINT_DERIVATION_RULE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Value Prototype Derivation Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_PROTOTYPE_DERIVATION_RULE_FEATURE_COUNT = REFERENCE_POINT_DERIVATION_RULE_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule <em>Addressable Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Addressable Point Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule
   * @generated
   */
  EClass getAddressablePointDerivationRule();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getForEachExpression <em>For Each Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>For Each Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getForEachExpression()
   * @see #getAddressablePointDerivationRule()
   * @generated
   */
  EAttribute getAddressablePointDerivationRule_ForEachExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getHomoPortNameExpression <em>Homo Port Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Homo Port Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getHomoPortNameExpression()
   * @see #getAddressablePointDerivationRule()
   * @generated
   */
  EAttribute getAddressablePointDerivationRule_HomoPortNameExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPointNameExpression <em>Point Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Point Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPointNameExpression()
   * @see #getAddressablePointDerivationRule()
   * @generated
   */
  EAttribute getAddressablePointDerivationRule_PointNameExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortNameExpression <em>Port Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortNameExpression()
   * @see #getAddressablePointDerivationRule()
   * @generated
   */
  EAttribute getAddressablePointDerivationRule_PortNameExpression();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Port Type Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule#getPortTypeBinding()
   * @see #getAddressablePointDerivationRule()
   * @generated
   */
  EReference getAddressablePointDerivationRule_PortTypeBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.AnchorDerivationRule <em>Anchor Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Anchor Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.AnchorDerivationRule
   * @generated
   */
  EClass getAnchorDerivationRule();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.ComponentModelSpecification <em>Component Model Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Component Model Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.ComponentModelSpecification
   * @generated
   */
  EClass getComponentModelSpecification();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.ComponentModelSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Fragment Role Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.ComponentModelSpecification#getFragmentRoleBindings()
   * @see #getComponentModelSpecification()
   * @generated
   */
  EReference getComponentModelSpecification_FragmentRoleBindings();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding <em>Composition Association2 Composition Link Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Association2 Composition Link Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding
   * @generated
   */
  EClass getCompositionAssociation2CompositionLinkBinding();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Language Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EReference getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach1Expression <em>For Each1 Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>For Each1 Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach1Expression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_ForEach1Expression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach2Expression <em>For Each2 Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>For Each2 Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach2Expression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_ForEach2Expression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance1NameExpression <em>Fragment Instance1 Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fragment Instance1 Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance1NameExpression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_FragmentInstance1NameExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance2NameExpression <em>Fragment Instance2 Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fragment Instance2 Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance2NameExpression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_FragmentInstance2NameExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance1NameExpression <em>Port Instance1 Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port Instance1 Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance1NameExpression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_PortInstance1NameExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance2NameExpression <em>Port Instance2 Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port Instance2 Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance2NameExpression()
   * @see #getCompositionAssociation2CompositionLinkBinding()
   * @generated
   */
  EAttribute getCompositionAssociation2CompositionLinkBinding_PortInstance2NameExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.CompositionAssociationBinding <em>Composition Association Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Association Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociationBinding
   * @generated
   */
  EClass getCompositionAssociationBinding();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.CompositionAssociationBinding#getCompositionAssociation <em>Composition Association</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Composition Association</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociationBinding#getCompositionAssociation()
   * @see #getCompositionAssociationBinding()
   * @generated
   */
  EReference getCompositionAssociationBinding_CompositionAssociation();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Language Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification
   * @generated
   */
  EClass getCompositionLanguageSpecification();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionAssociationBindings <em>Composition Association Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composition Association Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionAssociationBindings()
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  EReference getCompositionLanguageSpecification_CompositionAssociationBindings();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionProgramPhysicalLocationExpression <em>Composition Program Physical Location Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Composition Program Physical Location Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionProgramPhysicalLocationExpression()
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  EAttribute getCompositionLanguageSpecification_CompositionProgramPhysicalLocationExpression();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Fragment Role Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getFragmentRoleBindings()
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  EReference getCompositionLanguageSpecification_FragmentRoleBindings();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getUcpiExpression <em>Ucpi Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Ucpi Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getUcpiExpression()
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  EAttribute getCompositionLanguageSpecification_UcpiExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification <em>Composition Language Syntax Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Language Syntax Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification
   * @generated
   */
  EClass getCompositionLanguageSyntaxSpecification();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Fragment Role Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification#getFragmentRoleBindings()
   * @see #getCompositionLanguageSyntaxSpecification()
   * @generated
   */
  EReference getCompositionLanguageSyntaxSpecification_FragmentRoleBindings();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding <em>Fragment Role2 Fragment Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role2 Fragment Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding
   * @generated
   */
  EClass getFragmentRole2FragmentBinding();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getComponentModelSpecification <em>Component Model Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Component Model Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getComponentModelSpecification()
   * @see #getFragmentRole2FragmentBinding()
   * @generated
   */
  EReference getFragmentRole2FragmentBinding_ComponentModelSpecification();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getIsExpression <em>Is Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Is Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getIsExpression()
   * @see #getFragmentRole2FragmentBinding()
   * @generated
   */
  EAttribute getFragmentRole2FragmentBinding_IsExpression();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getPortTypeBindings <em>Port Type Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Port Type Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getPortTypeBindings()
   * @see #getFragmentRole2FragmentBinding()
   * @generated
   */
  EReference getFragmentRole2FragmentBinding_PortTypeBindings();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding <em>Fragment Role2 Fragment Instance Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role2 Fragment Instance Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding
   * @generated
   */
  EClass getFragmentRole2FragmentInstanceBinding();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Language Specification</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EReference getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getNameExpression <em>Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getNameExpression()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EAttribute getFragmentRole2FragmentInstanceBinding_NameExpression();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getPortTypeBindings <em>Port Type Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Port Type Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getPortTypeBindings()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EReference getFragmentRole2FragmentInstanceBinding_PortTypeBindings();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Physical Location Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetPhysicalLocationExpression()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EAttribute getFragmentRole2FragmentInstanceBinding_TargetPhysicalLocationExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Ufi Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetUfiExpression()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EAttribute getFragmentRole2FragmentInstanceBinding_TargetUfiExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getUfiExpression <em>Ufi Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Ufi Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getUfiExpression()
   * @see #getFragmentRole2FragmentInstanceBinding()
   * @generated
   */
  EAttribute getFragmentRole2FragmentInstanceBinding_UfiExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding <em>Fragment Role2 Fragment Reference Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role2 Fragment Reference Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding
   * @generated
   */
  EClass getFragmentRole2FragmentReferenceBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role2 Syntax Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding
   * @generated
   */
  EClass getFragmentRole2SyntaxBinding();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getCompositionLanguageSyntax <em>Composition Language Syntax</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Composition Language Syntax</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getCompositionLanguageSyntax()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EReference getFragmentRole2SyntaxBinding_CompositionLanguageSyntax();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getNameExpression <em>Name Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getNameExpression()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EAttribute getFragmentRole2SyntaxBinding_NameExpression();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getPortTypeBindings <em>Port Type Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Port Type Bindings</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getPortTypeBindings()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EReference getFragmentRole2SyntaxBinding_PortTypeBindings();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Physical Location Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetPhysicalLocationExpression()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EAttribute getFragmentRole2SyntaxBinding_TargetPhysicalLocationExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Ufi Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetUfiExpression()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EAttribute getFragmentRole2SyntaxBinding_TargetUfiExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getUfiExpression <em>Ufi Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Ufi Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getUfiExpression()
   * @see #getFragmentRole2SyntaxBinding()
   * @generated
   */
  EAttribute getFragmentRole2SyntaxBinding_UfiExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.FragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fragment Role Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRoleBinding
   * @generated
   */
  EClass getFragmentRoleBinding();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.FragmentRoleBinding#getFragmentRole <em>Fragment Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Fragment Role</em>'.
   * @see org.reuseware.coconut.reuseextension.FragmentRoleBinding#getFragmentRole()
   * @see #getFragmentRoleBinding()
   * @generated
   */
  EReference getFragmentRoleBinding_FragmentRole();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.HookDerivationRule <em>Hook Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Hook Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.HookDerivationRule
   * @generated
   */
  EClass getHookDerivationRule();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortType2HeterogeneousPortBinding <em>Port Type2 Heterogeneous Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type2 Heterogeneous Port Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2HeterogeneousPortBinding
   * @generated
   */
  EClass getPortType2HeterogeneousPortBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding <em>Port Type2 Homogenous Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type2 Homogenous Port Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding
   * @generated
   */
  EClass getPortType2HomogenousPortBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding <em>Port Type2 Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type2 Port Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding
   * @generated
   */
  EClass getPortType2PortBinding();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding#getDerivationRules <em>Derivation Rules</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Derivation Rules</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding#getDerivationRules()
   * @see #getPortType2PortBinding()
   * @generated
   */
  EReference getPortType2PortBinding_DerivationRules();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Role Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding#getFragmentRoleBinding()
   * @see #getPortType2PortBinding()
   * @generated
   */
  EReference getPortType2PortBinding_FragmentRoleBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding <em>Port Type2 Setting Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type2 Setting Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding
   * @generated
   */
  EClass getPortType2SettingBinding();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getDerivationRules <em>Derivation Rules</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Derivation Rules</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding#getDerivationRules()
   * @see #getPortType2SettingBinding()
   * @generated
   */
  EReference getPortType2SettingBinding_DerivationRules();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Role Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding()
   * @see #getPortType2SettingBinding()
   * @generated
   */
  EReference getPortType2SettingBinding_FragmentRoleBinding();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding <em>Port Type2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type2 Syntax Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SyntaxBinding
   * @generated
   */
  EClass getPortType2SyntaxBinding();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Fragment Role2 Syntax Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding()
   * @see #getPortType2SyntaxBinding()
   * @generated
   */
  EReference getPortType2SyntaxBinding_FragmentRole2SyntaxBinding();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getLabelExpression <em>Label Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Label Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getLabelExpression()
   * @see #getPortType2SyntaxBinding()
   * @generated
   */
  EAttribute getPortType2SyntaxBinding_LabelExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Type Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.PortTypeBinding
   * @generated
   */
  EClass getPortTypeBinding();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.PortTypeBinding#getPortType <em>Port Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Port Type</em>'.
   * @see org.reuseware.coconut.reuseextension.PortTypeBinding#getPortType()
   * @see #getPortTypeBinding()
   * @generated
   */
  EReference getPortTypeBinding_PortType();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.PrototypeDerivationRule <em>Prototype Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Prototype Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.PrototypeDerivationRule
   * @generated
   */
  EClass getPrototypeDerivationRule();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.ReferencePointDerivationRule <em>Reference Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reference Point Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.ReferencePointDerivationRule
   * @generated
   */
  EClass getReferencePointDerivationRule();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.ReuseExtension <em>Reuse Extension</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reuse Extension</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension
   * @generated
   */
  EClass getReuseExtension();

  /**
   * Returns the meta object for the reference list '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getEPackages <em>EPackages</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>EPackages</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getEPackages()
   * @see #getReuseExtension()
   * @generated
   */
  EReference getReuseExtension_EPackages();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getFracolNamespace <em>Fracol Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Fracol Namespace</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getFracolNamespace()
   * @see #getReuseExtension()
   * @generated
   */
  EAttribute getReuseExtension_FracolNamespace();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getFracol <em>Fracol</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Fracol</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getFracol()
   * @see #getReuseExtension()
   * @generated
   */
  EReference getReuseExtension_Fracol();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getParameters <em>Parameters</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Parameters</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getParameters()
   * @see #getReuseExtension()
   * @generated
   */
  EAttribute getReuseExtension_Parameters();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRexName <em>Rex Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Rex Name</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getRexName()
   * @see #getReuseExtension()
   * @generated
   */
  EAttribute getReuseExtension_RexName();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRexNamespace <em>Rex Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Rex Namespace</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getRexNamespace()
   * @see #getReuseExtension()
   * @generated
   */
  EAttribute getReuseExtension_RexNamespace();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRootElementContexts <em>Root Element Contexts</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Root Element Contexts</em>'.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getRootElementContexts()
   * @see #getReuseExtension()
   * @generated
   */
  EReference getReuseExtension_RootElementContexts();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.RootElementContext <em>Root Element Context</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Root Element Context</em>'.
   * @see org.reuseware.coconut.reuseextension.RootElementContext
   * @generated
   */
  EClass getRootElementContext();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension <em>Reuse Extension</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Reuse Extension</em>'.
   * @see org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension()
   * @see #getRootElementContext()
   * @generated
   */
  EReference getRootElementContext_ReuseExtension();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.RuleContext <em>Rule Context</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Rule Context</em>'.
   * @see org.reuseware.coconut.reuseextension.RuleContext
   * @generated
   */
  EClass getRuleContext();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundClass <em>EBound Class</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>EBound Class</em>'.
   * @see org.reuseware.coconut.reuseextension.RuleContext#getEBoundClass()
   * @see #getRuleContext()
   * @generated
   */
  EReference getRuleContext_EBoundClass();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundFeature <em>EBound Feature</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>EBound Feature</em>'.
   * @see org.reuseware.coconut.reuseextension.RuleContext#getEBoundFeature()
   * @see #getRuleContext()
   * @generated
   */
  EReference getRuleContext_EBoundFeature();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.RuleContext#getIsExpression <em>Is Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Is Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.RuleContext#getIsExpression()
   * @see #getRuleContext()
   * @generated
   */
  EAttribute getRuleContext_IsExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule <em>Setting Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Setting Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule
   * @generated
   */
  EClass getSettingDerivationRule();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Port Type Binding</em>'.
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding()
   * @see #getSettingDerivationRule()
   * @generated
   */
  EReference getSettingDerivationRule_PortTypeBinding();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPropertyExpression <em>Property Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Property Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule#getPropertyExpression()
   * @see #getSettingDerivationRule()
   * @generated
   */
  EAttribute getSettingDerivationRule_PropertyExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getValueExpression <em>Value Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule#getValueExpression()
   * @see #getSettingDerivationRule()
   * @generated
   */
  EAttribute getSettingDerivationRule_ValueExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.SlotDerivationRule <em>Slot Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Slot Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.SlotDerivationRule
   * @generated
   */
  EClass getSlotDerivationRule();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule <em>Syntax Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Syntax Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule
   * @generated
   */
  EClass getSyntaxDerivationRule();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getHeightExpression <em>Height Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Height Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getHeightExpression()
   * @see #getSyntaxDerivationRule()
   * @generated
   */
  EAttribute getSyntaxDerivationRule_HeightExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getIconExpression <em>Icon Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Icon Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getIconExpression()
   * @see #getSyntaxDerivationRule()
   * @generated
   */
  EAttribute getSyntaxDerivationRule_IconExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getVisibleExpression <em>Visible Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Visible Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getVisibleExpression()
   * @see #getSyntaxDerivationRule()
   * @generated
   */
  EAttribute getSyntaxDerivationRule_VisibleExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getWidthExpression <em>Width Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Width Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getWidthExpression()
   * @see #getSyntaxDerivationRule()
   * @generated
   */
  EAttribute getSyntaxDerivationRule_WidthExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule <em>Value Hook Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Value Hook Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.ValueHookDerivationRule
   * @generated
   */
  EClass getValueHookDerivationRule();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getBeginIndexExpression <em>Begin Index Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Begin Index Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getBeginIndexExpression()
   * @see #getValueHookDerivationRule()
   * @generated
   */
  EAttribute getValueHookDerivationRule_BeginIndexExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getEndIndexExpression <em>End Index Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>End Index Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getEndIndexExpression()
   * @see #getValueHookDerivationRule()
   * @generated
   */
  EAttribute getValueHookDerivationRule_EndIndexExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getListIndexExpression <em>List Index Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>List Index Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getListIndexExpression()
   * @see #getValueHookDerivationRule()
   * @generated
   */
  EAttribute getValueHookDerivationRule_ListIndexExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule <em>Value Prototype Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Value Prototype Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule
   * @generated
   */
  EClass getValuePrototypeDerivationRule();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule#getValueExpression <em>Value Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule#getValueExpression()
   * @see #getValuePrototypeDerivationRule()
   * @generated
   */
  EAttribute getValuePrototypeDerivationRule_ValueExpression();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule <em>Variation Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Variation Point Derivation Rule</em>'.
   * @see org.reuseware.coconut.reuseextension.VariationPointDerivationRule
   * @generated
   */
  EClass getVariationPointDerivationRule();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getModeExpression <em>Mode Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getModeExpression()
   * @see #getVariationPointDerivationRule()
   * @generated
   */
  EAttribute getVariationPointDerivationRule_ModeExpression();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getRemoveExpression <em>Remove Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Remove Expression</em>'.
   * @see org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getRemoveExpression()
   * @see #getVariationPointDerivationRule()
   * @generated
   */
  EAttribute getVariationPointDerivationRule_RemoveExpression();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ReuseextensionFactory getReuseextensionFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.AddressablePointDerivationRuleImpl <em>Addressable Point Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.AddressablePointDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getAddressablePointDerivationRule()
     * @generated
     */
    EClass ADDRESSABLE_POINT_DERIVATION_RULE = eINSTANCE.getAddressablePointDerivationRule();

    /**
     * The meta object literal for the '<em><b>For Each Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION = eINSTANCE.getAddressablePointDerivationRule_ForEachExpression();

    /**
     * The meta object literal for the '<em><b>Homo Port Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION = eINSTANCE.getAddressablePointDerivationRule_HomoPortNameExpression();

    /**
     * The meta object literal for the '<em><b>Point Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION = eINSTANCE.getAddressablePointDerivationRule_PointNameExpression();

    /**
     * The meta object literal for the '<em><b>Port Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION = eINSTANCE.getAddressablePointDerivationRule_PortNameExpression();

    /**
     * The meta object literal for the '<em><b>Port Type Binding</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING = eINSTANCE.getAddressablePointDerivationRule_PortTypeBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.AnchorDerivationRuleImpl <em>Anchor Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.AnchorDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getAnchorDerivationRule()
     * @generated
     */
    EClass ANCHOR_DERIVATION_RULE = eINSTANCE.getAnchorDerivationRule();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.ComponentModelSpecificationImpl <em>Component Model Specification</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.ComponentModelSpecificationImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getComponentModelSpecification()
     * @generated
     */
    EClass COMPONENT_MODEL_SPECIFICATION = eINSTANCE.getComponentModelSpecification();

    /**
     * The meta object literal for the '<em><b>Fragment Role Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPONENT_MODEL_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = eINSTANCE.getComponentModelSpecification_FragmentRoleBindings();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionAssociation2CompositionLinkBindingImpl <em>Composition Association2 Composition Link Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.CompositionAssociation2CompositionLinkBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionAssociation2CompositionLinkBinding()
     * @generated
     */
    EClass COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING = eINSTANCE.getCompositionAssociation2CompositionLinkBinding();

    /**
     * The meta object literal for the '<em><b>Composition Language Specification</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification();

    /**
     * The meta object literal for the '<em><b>For Each1 Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH1_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_ForEach1Expression();

    /**
     * The meta object literal for the '<em><b>For Each2 Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH2_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_ForEach2Expression();

    /**
     * The meta object literal for the '<em><b>Fragment Instance1 Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE1_NAME_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_FragmentInstance1NameExpression();

    /**
     * The meta object literal for the '<em><b>Fragment Instance2 Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE2_NAME_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_FragmentInstance2NameExpression();

    /**
     * The meta object literal for the '<em><b>Port Instance1 Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE1_NAME_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_PortInstance1NameExpression();

    /**
     * The meta object literal for the '<em><b>Port Instance2 Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE2_NAME_EXPRESSION = eINSTANCE.getCompositionAssociation2CompositionLinkBinding_PortInstance2NameExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionAssociationBindingImpl <em>Composition Association Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.CompositionAssociationBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionAssociationBinding()
     * @generated
     */
    EClass COMPOSITION_ASSOCIATION_BINDING = eINSTANCE.getCompositionAssociationBinding();

    /**
     * The meta object literal for the '<em><b>Composition Association</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION = eINSTANCE.getCompositionAssociationBinding_CompositionAssociation();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionLanguageSpecificationImpl <em>Composition Language Specification</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.CompositionLanguageSpecificationImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionLanguageSpecification()
     * @generated
     */
    EClass COMPOSITION_LANGUAGE_SPECIFICATION = eINSTANCE.getCompositionLanguageSpecification();

    /**
     * The meta object literal for the '<em><b>Composition Association Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS = eINSTANCE.getCompositionLanguageSpecification_CompositionAssociationBindings();

    /**
     * The meta object literal for the '<em><b>Composition Program Physical Location Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION = eINSTANCE.getCompositionLanguageSpecification_CompositionProgramPhysicalLocationExpression();

    /**
     * The meta object literal for the '<em><b>Fragment Role Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = eINSTANCE.getCompositionLanguageSpecification_FragmentRoleBindings();

    /**
     * The meta object literal for the '<em><b>Ucpi Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION = eINSTANCE.getCompositionLanguageSpecification_UcpiExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.CompositionLanguageSyntaxSpecificationImpl <em>Composition Language Syntax Specification</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.CompositionLanguageSyntaxSpecificationImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getCompositionLanguageSyntaxSpecification()
     * @generated
     */
    EClass COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION = eINSTANCE.getCompositionLanguageSyntaxSpecification();

    /**
     * The meta object literal for the '<em><b>Fragment Role Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS = eINSTANCE.getCompositionLanguageSyntaxSpecification_FragmentRoleBindings();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentBindingImpl <em>Fragment Role2 Fragment Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentBinding()
     * @generated
     */
    EClass FRAGMENT_ROLE2_FRAGMENT_BINDING = eINSTANCE.getFragmentRole2FragmentBinding();

    /**
     * The meta object literal for the '<em><b>Component Model Specification</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION = eINSTANCE.getFragmentRole2FragmentBinding_ComponentModelSpecification();

    /**
     * The meta object literal for the '<em><b>Is Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION = eINSTANCE.getFragmentRole2FragmentBinding_IsExpression();

    /**
     * The meta object literal for the '<em><b>Port Type Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS = eINSTANCE.getFragmentRole2FragmentBinding_PortTypeBindings();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentInstanceBindingImpl <em>Fragment Role2 Fragment Instance Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentInstanceBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentInstanceBinding()
     * @generated
     */
    EClass FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING = eINSTANCE.getFragmentRole2FragmentInstanceBinding();

    /**
     * The meta object literal for the '<em><b>Composition Language Specification</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION = eINSTANCE.getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification();

    /**
     * The meta object literal for the '<em><b>Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION = eINSTANCE.getFragmentRole2FragmentInstanceBinding_NameExpression();

    /**
     * The meta object literal for the '<em><b>Port Type Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS = eINSTANCE.getFragmentRole2FragmentInstanceBinding_PortTypeBindings();

    /**
     * The meta object literal for the '<em><b>Target Physical Location Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION = eINSTANCE.getFragmentRole2FragmentInstanceBinding_TargetPhysicalLocationExpression();

    /**
     * The meta object literal for the '<em><b>Target Ufi Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION = eINSTANCE.getFragmentRole2FragmentInstanceBinding_TargetUfiExpression();

    /**
     * The meta object literal for the '<em><b>Ufi Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION = eINSTANCE.getFragmentRole2FragmentInstanceBinding_UfiExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentReferenceBindingImpl <em>Fragment Role2 Fragment Reference Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2FragmentReferenceBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2FragmentReferenceBinding()
     * @generated
     */
    EClass FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING = eINSTANCE.getFragmentRole2FragmentReferenceBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRole2SyntaxBindingImpl <em>Fragment Role2 Syntax Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.FragmentRole2SyntaxBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRole2SyntaxBinding()
     * @generated
     */
    EClass FRAGMENT_ROLE2_SYNTAX_BINDING = eINSTANCE.getFragmentRole2SyntaxBinding();

    /**
     * The meta object literal for the '<em><b>Composition Language Syntax</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX = eINSTANCE.getFragmentRole2SyntaxBinding_CompositionLanguageSyntax();

    /**
     * The meta object literal for the '<em><b>Name Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION = eINSTANCE.getFragmentRole2SyntaxBinding_NameExpression();

    /**
     * The meta object literal for the '<em><b>Port Type Bindings</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS = eINSTANCE.getFragmentRole2SyntaxBinding_PortTypeBindings();

    /**
     * The meta object literal for the '<em><b>Target Physical Location Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION = eINSTANCE.getFragmentRole2SyntaxBinding_TargetPhysicalLocationExpression();

    /**
     * The meta object literal for the '<em><b>Target Ufi Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION = eINSTANCE.getFragmentRole2SyntaxBinding_TargetUfiExpression();

    /**
     * The meta object literal for the '<em><b>Ufi Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION = eINSTANCE.getFragmentRole2SyntaxBinding_UfiExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.FragmentRoleBindingImpl <em>Fragment Role Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.FragmentRoleBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getFragmentRoleBinding()
     * @generated
     */
    EClass FRAGMENT_ROLE_BINDING = eINSTANCE.getFragmentRoleBinding();

    /**
     * The meta object literal for the '<em><b>Fragment Role</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE = eINSTANCE.getFragmentRoleBinding_FragmentRole();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.HookDerivationRuleImpl <em>Hook Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.HookDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getHookDerivationRule()
     * @generated
     */
    EClass HOOK_DERIVATION_RULE = eINSTANCE.getHookDerivationRule();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2HeterogeneousPortBindingImpl <em>Port Type2 Heterogeneous Port Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortType2HeterogeneousPortBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2HeterogeneousPortBinding()
     * @generated
     */
    EClass PORT_TYPE2_HETEROGENEOUS_PORT_BINDING = eINSTANCE.getPortType2HeterogeneousPortBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2HomogenousPortBindingImpl <em>Port Type2 Homogenous Port Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortType2HomogenousPortBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2HomogenousPortBinding()
     * @generated
     */
    EClass PORT_TYPE2_HOMOGENOUS_PORT_BINDING = eINSTANCE.getPortType2HomogenousPortBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2PortBindingImpl <em>Port Type2 Port Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortType2PortBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2PortBinding()
     * @generated
     */
    EClass PORT_TYPE2_PORT_BINDING = eINSTANCE.getPortType2PortBinding();

    /**
     * The meta object literal for the '<em><b>Derivation Rules</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE2_PORT_BINDING__DERIVATION_RULES = eINSTANCE.getPortType2PortBinding_DerivationRules();

    /**
     * The meta object literal for the '<em><b>Fragment Role Binding</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING = eINSTANCE.getPortType2PortBinding_FragmentRoleBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2SettingBindingImpl <em>Port Type2 Setting Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortType2SettingBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2SettingBinding()
     * @generated
     */
    EClass PORT_TYPE2_SETTING_BINDING = eINSTANCE.getPortType2SettingBinding();

    /**
     * The meta object literal for the '<em><b>Derivation Rules</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES = eINSTANCE.getPortType2SettingBinding_DerivationRules();

    /**
     * The meta object literal for the '<em><b>Fragment Role Binding</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING = eINSTANCE.getPortType2SettingBinding_FragmentRoleBinding();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortType2SyntaxBindingImpl <em>Port Type2 Syntax Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortType2SyntaxBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortType2SyntaxBinding()
     * @generated
     */
    EClass PORT_TYPE2_SYNTAX_BINDING = eINSTANCE.getPortType2SyntaxBinding();

    /**
     * The meta object literal for the '<em><b>Fragment Role2 Syntax Binding</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING = eINSTANCE.getPortType2SyntaxBinding_FragmentRole2SyntaxBinding();

    /**
     * The meta object literal for the '<em><b>Label Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION = eINSTANCE.getPortType2SyntaxBinding_LabelExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PortTypeBindingImpl <em>Port Type Binding</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PortTypeBindingImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPortTypeBinding()
     * @generated
     */
    EClass PORT_TYPE_BINDING = eINSTANCE.getPortTypeBinding();

    /**
     * The meta object literal for the '<em><b>Port Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_TYPE_BINDING__PORT_TYPE = eINSTANCE.getPortTypeBinding_PortType();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.PrototypeDerivationRuleImpl <em>Prototype Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.PrototypeDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getPrototypeDerivationRule()
     * @generated
     */
    EClass PROTOTYPE_DERIVATION_RULE = eINSTANCE.getPrototypeDerivationRule();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.ReferencePointDerivationRuleImpl <em>Reference Point Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.ReferencePointDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getReferencePointDerivationRule()
     * @generated
     */
    EClass REFERENCE_POINT_DERIVATION_RULE = eINSTANCE.getReferencePointDerivationRule();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.ReuseExtensionImpl <em>Reuse Extension</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.ReuseExtensionImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getReuseExtension()
     * @generated
     */
    EClass REUSE_EXTENSION = eINSTANCE.getReuseExtension();

    /**
     * The meta object literal for the '<em><b>EPackages</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION__EPACKAGES = eINSTANCE.getReuseExtension_EPackages();

    /**
     * The meta object literal for the '<em><b>Fracol Namespace</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REUSE_EXTENSION__FRACOL_NAMESPACE = eINSTANCE.getReuseExtension_FracolNamespace();

    /**
     * The meta object literal for the '<em><b>Fracol</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION__FRACOL = eINSTANCE.getReuseExtension_Fracol();

    /**
     * The meta object literal for the '<em><b>Parameters</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REUSE_EXTENSION__PARAMETERS = eINSTANCE.getReuseExtension_Parameters();

    /**
     * The meta object literal for the '<em><b>Rex Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REUSE_EXTENSION__REX_NAME = eINSTANCE.getReuseExtension_RexName();

    /**
     * The meta object literal for the '<em><b>Rex Namespace</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REUSE_EXTENSION__REX_NAMESPACE = eINSTANCE.getReuseExtension_RexNamespace();

    /**
     * The meta object literal for the '<em><b>Root Element Contexts</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS = eINSTANCE.getReuseExtension_RootElementContexts();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.RootElementContextImpl <em>Root Element Context</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.RootElementContextImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getRootElementContext()
     * @generated
     */
    EClass ROOT_ELEMENT_CONTEXT = eINSTANCE.getRootElementContext();

    /**
     * The meta object literal for the '<em><b>Reuse Extension</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROOT_ELEMENT_CONTEXT__REUSE_EXTENSION = eINSTANCE.getRootElementContext_ReuseExtension();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.RuleContext <em>Rule Context</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.RuleContext
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getRuleContext()
     * @generated
     */
    EClass RULE_CONTEXT = eINSTANCE.getRuleContext();

    /**
     * The meta object literal for the '<em><b>EBound Class</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RULE_CONTEXT__EBOUND_CLASS = eINSTANCE.getRuleContext_EBoundClass();

    /**
     * The meta object literal for the '<em><b>EBound Feature</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RULE_CONTEXT__EBOUND_FEATURE = eINSTANCE.getRuleContext_EBoundFeature();

    /**
     * The meta object literal for the '<em><b>Is Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RULE_CONTEXT__IS_EXPRESSION = eINSTANCE.getRuleContext_IsExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.SettingDerivationRuleImpl <em>Setting Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.SettingDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSettingDerivationRule()
     * @generated
     */
    EClass SETTING_DERIVATION_RULE = eINSTANCE.getSettingDerivationRule();

    /**
     * The meta object literal for the '<em><b>Port Type Binding</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SETTING_DERIVATION_RULE__PORT_TYPE_BINDING = eINSTANCE.getSettingDerivationRule_PortTypeBinding();

    /**
     * The meta object literal for the '<em><b>Property Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION = eINSTANCE.getSettingDerivationRule_PropertyExpression();

    /**
     * The meta object literal for the '<em><b>Value Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SETTING_DERIVATION_RULE__VALUE_EXPRESSION = eINSTANCE.getSettingDerivationRule_ValueExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.SlotDerivationRuleImpl <em>Slot Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.SlotDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSlotDerivationRule()
     * @generated
     */
    EClass SLOT_DERIVATION_RULE = eINSTANCE.getSlotDerivationRule();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.SyntaxDerivationRuleImpl <em>Syntax Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.SyntaxDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getSyntaxDerivationRule()
     * @generated
     */
    EClass SYNTAX_DERIVATION_RULE = eINSTANCE.getSyntaxDerivationRule();

    /**
     * The meta object literal for the '<em><b>Height Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION = eINSTANCE.getSyntaxDerivationRule_HeightExpression();

    /**
     * The meta object literal for the '<em><b>Icon Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SYNTAX_DERIVATION_RULE__ICON_EXPRESSION = eINSTANCE.getSyntaxDerivationRule_IconExpression();

    /**
     * The meta object literal for the '<em><b>Visible Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION = eINSTANCE.getSyntaxDerivationRule_VisibleExpression();

    /**
     * The meta object literal for the '<em><b>Width Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION = eINSTANCE.getSyntaxDerivationRule_WidthExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.ValueHookDerivationRuleImpl <em>Value Hook Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.ValueHookDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getValueHookDerivationRule()
     * @generated
     */
    EClass VALUE_HOOK_DERIVATION_RULE = eINSTANCE.getValueHookDerivationRule();

    /**
     * The meta object literal for the '<em><b>Begin Index Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION = eINSTANCE.getValueHookDerivationRule_BeginIndexExpression();

    /**
     * The meta object literal for the '<em><b>End Index Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION = eINSTANCE.getValueHookDerivationRule_EndIndexExpression();

    /**
     * The meta object literal for the '<em><b>List Index Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION = eINSTANCE.getValueHookDerivationRule_ListIndexExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.ValuePrototypeDerivationRuleImpl <em>Value Prototype Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.ValuePrototypeDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getValuePrototypeDerivationRule()
     * @generated
     */
    EClass VALUE_PROTOTYPE_DERIVATION_RULE = eINSTANCE.getValuePrototypeDerivationRule();

    /**
     * The meta object literal for the '<em><b>Value Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_PROTOTYPE_DERIVATION_RULE__VALUE_EXPRESSION = eINSTANCE.getValuePrototypeDerivationRule_ValueExpression();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextension.impl.VariationPointDerivationRuleImpl <em>Variation Point Derivation Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextension.impl.VariationPointDerivationRuleImpl
     * @see org.reuseware.coconut.reuseextension.impl.ReuseextensionPackageImpl#getVariationPointDerivationRule()
     * @generated
     */
    EClass VARIATION_POINT_DERIVATION_RULE = eINSTANCE.getVariationPointDerivationRule();

    /**
     * The meta object literal for the '<em><b>Mode Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION = eINSTANCE.getVariationPointDerivationRule_ModeExpression();

    /**
     * The meta object literal for the '<em><b>Remove Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION = eINSTANCE.getVariationPointDerivationRule_RemoveExpression();

  }

} //ReuseextensionPackage
