/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Root Element Context</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension <em>Reuse Extension</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRootElementContext()
 * @model
 * @generated
 */
public interface RootElementContext extends RuleContext
{
  /**
   * Returns the value of the '<em><b>Reuse Extension</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRootElementContexts <em>Root Element Contexts</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reuse Extension</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reuse Extension</em>' container reference.
   * @see #setReuseExtension(ReuseExtension)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRootElementContext_ReuseExtension()
   * @see org.reuseware.coconut.reuseextension.ReuseExtension#getRootElementContexts
   * @model opposite="rootElementContexts" transient="false" ordered="false"
   * @generated
   */
  ReuseExtension getReuseExtension();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension <em>Reuse Extension</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Reuse Extension</em>' container reference.
   * @see #getReuseExtension()
   * @generated
   */
  void setReuseExtension(ReuseExtension value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // RootElementContext
