/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Setting Derivation Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPropertyExpression <em>Property Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getValueExpression <em>Value Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSettingDerivationRule()
 * @model
 * @generated
 */
public interface SettingDerivationRule extends EObject
{
  /**
   * Returns the value of the '<em><b>Port Type Binding</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getDerivationRules <em>Derivation Rules</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Binding</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Binding</em>' container reference.
   * @see #setPortTypeBinding(PortType2SettingBinding)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSettingDerivationRule_PortTypeBinding()
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding#getDerivationRules
   * @model opposite="derivationRules" transient="false" ordered="false"
   * @generated
   */
  PortType2SettingBinding getPortTypeBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPortTypeBinding <em>Port Type Binding</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Type Binding</em>' container reference.
   * @see #getPortTypeBinding()
   * @generated
   */
  void setPortTypeBinding(PortType2SettingBinding value);

  /**
   * Returns the value of the '<em><b>Property Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Property Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Property Expression</em>' attribute.
   * @see #setPropertyExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSettingDerivationRule_PropertyExpression()
   * @model required="true"
   * @generated
   */
  String getPropertyExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getPropertyExpression <em>Property Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Property Expression</em>' attribute.
   * @see #getPropertyExpression()
   * @generated
   */
  void setPropertyExpression(String value);

  /**
   * Returns the value of the '<em><b>Value Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value Expression</em>' attribute.
   * @see #setValueExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSettingDerivationRule_ValueExpression()
   * @model required="true"
   * @generated
   */
  String getValueExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule#getValueExpression <em>Value Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value Expression</em>' attribute.
   * @see #getValueExpression()
   * @generated
   */
  void setValueExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // SettingDerivationRule
