/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Value Hook Derivation Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getBeginIndexExpression <em>Begin Index Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getEndIndexExpression <em>End Index Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getListIndexExpression <em>List Index Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getValueHookDerivationRule()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='DefinedForAttribute'"
 * @generated
 */
public interface ValueHookDerivationRule extends VariationPointDerivationRule
{
  /**
   * Returns the value of the '<em><b>Begin Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Begin Index Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Begin Index Expression</em>' attribute.
   * @see #setBeginIndexExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getValueHookDerivationRule_BeginIndexExpression()
   * @model
   * @generated
   */
  String getBeginIndexExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getBeginIndexExpression <em>Begin Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Begin Index Expression</em>' attribute.
   * @see #getBeginIndexExpression()
   * @generated
   */
  void setBeginIndexExpression(String value);

  /**
   * Returns the value of the '<em><b>End Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End Index Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End Index Expression</em>' attribute.
   * @see #setEndIndexExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getValueHookDerivationRule_EndIndexExpression()
   * @model
   * @generated
   */
  String getEndIndexExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getEndIndexExpression <em>End Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End Index Expression</em>' attribute.
   * @see #getEndIndexExpression()
   * @generated
   */
  void setEndIndexExpression(String value);

  /**
   * Returns the value of the '<em><b>List Index Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>List Index Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>List Index Expression</em>' attribute.
   * @see #setListIndexExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getValueHookDerivationRule_ListIndexExpression()
   * @model
   * @generated
   */
  String getListIndexExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule#getListIndexExpression <em>List Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>List Index Expression</em>' attribute.
   * @see #getListIndexExpression()
   * @generated
   */
  void setListIndexExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // ValueHookDerivationRule
