/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variation Point Derivation Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getModeExpression <em>Mode Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getRemoveExpression <em>Remove Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getVariationPointDerivationRule()
 * @model abstract="true"
 * @generated
 */
public interface VariationPointDerivationRule extends AddressablePointDerivationRule
{
  /**
   * Returns the value of the '<em><b>Mode Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode Expression</em>' attribute.
   * @see #setModeExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getVariationPointDerivationRule_ModeExpression()
   * @model
   * @generated
   */
  String getModeExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getModeExpression <em>Mode Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode Expression</em>' attribute.
   * @see #getModeExpression()
   * @generated
   */
  void setModeExpression(String value);

  /**
   * Returns the value of the '<em><b>Remove Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Remove Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Remove Expression</em>' attribute.
   * @see #setRemoveExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getVariationPointDerivationRule_RemoveExpression()
   * @model
   * @generated
   */
  String getRemoveExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule#getRemoveExpression <em>Remove Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Remove Expression</em>' attribute.
   * @see #getRemoveExpression()
   * @generated
   */
  void setRemoveExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // VariationPointDerivationRule
