/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.reuseextension.CompositionAssociationBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public abstract class CompositionAssociationBindingImpl extends EObjectImpl implements CompositionAssociationBinding
{


   /**
   * The cached value of the '{@link #getEBoundClass() <em>EBound Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundClass()
   * @generated
   * @ordered
   */
  protected EClass eBoundClass;
  /**
   * The cached value of the '{@link #getEBoundFeature() <em>EBound Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundFeature()
   * @generated
   * @ordered
   */
  protected EStructuralFeature eBoundFeature;
  /**
   * The default value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected static final String IS_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected String isExpression = IS_EXPRESSION_EDEFAULT;
  /**
   * The cached value of the '{@link #getCompositionAssociation() <em>Composition Association</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionAssociation()
   * @generated
   * @ordered
   */
  protected CompositionAssociation compositionAssociation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionAssociationBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.COMPOSITION_ASSOCIATION_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getEBoundClass()
  {
    if (eBoundClass != null && eBoundClass.eIsProxy())
    {
      InternalEObject oldEBoundClass = (InternalEObject)eBoundClass;
      eBoundClass = (EClass)eResolveProxy(oldEBoundClass);
      if (eBoundClass != oldEBoundClass)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS, oldEBoundClass, eBoundClass));
      }
    }
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetEBoundClass()
  {
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundClass(EClass newEBoundClass)
  {
    EClass oldEBoundClass = eBoundClass;
    eBoundClass = newEBoundClass;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS, oldEBoundClass, eBoundClass));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature getEBoundFeature()
  {
    if (eBoundFeature != null && eBoundFeature.eIsProxy())
    {
      InternalEObject oldEBoundFeature = (InternalEObject)eBoundFeature;
      eBoundFeature = (EStructuralFeature)eResolveProxy(oldEBoundFeature);
      if (eBoundFeature != oldEBoundFeature)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
      }
    }
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature basicGetEBoundFeature()
  {
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundFeature(EStructuralFeature newEBoundFeature)
  {
    EStructuralFeature oldEBoundFeature = eBoundFeature;
    eBoundFeature = newEBoundFeature;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIsExpression()
  {
    return isExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsExpression(String newIsExpression)
  {
    String oldIsExpression = isExpression;
    isExpression = newIsExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION, oldIsExpression, isExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionAssociation getCompositionAssociation()
  {
    if (compositionAssociation != null && compositionAssociation.eIsProxy())
    {
      InternalEObject oldCompositionAssociation = (InternalEObject)compositionAssociation;
      compositionAssociation = (CompositionAssociation)eResolveProxy(oldCompositionAssociation);
      if (compositionAssociation != oldCompositionAssociation)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION, oldCompositionAssociation, compositionAssociation));
      }
    }
    return compositionAssociation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionAssociation basicGetCompositionAssociation()
  {
    return compositionAssociation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionAssociation(CompositionAssociation newCompositionAssociation)
  {
    CompositionAssociation oldCompositionAssociation = compositionAssociation;
    compositionAssociation = newCompositionAssociation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION, oldCompositionAssociation, compositionAssociation));
  }

  public void removeYou()
   {
      this.setCompositionAssociation (null);
      this.setEBoundClass (null);
      this.setEBoundFeature (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS:
        if (resolve) return getEBoundClass();
        return basicGetEBoundClass();
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE:
        if (resolve) return getEBoundFeature();
        return basicGetEBoundFeature();
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION:
        return getIsExpression();
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION:
        if (resolve) return getCompositionAssociation();
        return basicGetCompositionAssociation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS:
        setEBoundClass((EClass)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION:
        setIsExpression((String)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION:
        setCompositionAssociation((CompositionAssociation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS:
        setEBoundClass((EClass)null);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)null);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION:
        setIsExpression(IS_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION:
        setCompositionAssociation((CompositionAssociation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_CLASS:
        return eBoundClass != null;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__EBOUND_FEATURE:
        return eBoundFeature != null;
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__IS_EXPRESSION:
        return IS_EXPRESSION_EDEFAULT == null ? isExpression != null : !IS_EXPRESSION_EDEFAULT.equals(isExpression);
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION:
        return compositionAssociation != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (isExpression: ");
    result.append(isExpression);
    result.append(')');
    return result.toString();
  }
}


