/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding;
import org.reuseware.coconut.reuseextension.CompositionLanguageSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public class CompositionLanguageSpecificationImpl extends ReuseExtensionImpl implements CompositionLanguageSpecification
{


   /**
   * The cached value of the '{@link #getCompositionAssociationBindings() <em>Composition Association Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionAssociationBindings()
   * @generated
   * @ordered
   */
  protected EList<CompositionAssociation2CompositionLinkBinding> compositionAssociationBindings;
  /**
   * The default value of the '{@link #getCompositionProgramPhysicalLocationExpression() <em>Composition Program Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionProgramPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected static final String COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getCompositionProgramPhysicalLocationExpression() <em>Composition Program Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionProgramPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected String compositionProgramPhysicalLocationExpression = COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT;
  /**
   * The cached value of the '{@link #getFragmentRoleBindings() <em>Fragment Role Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFragmentRoleBindings()
   * @generated
   * @ordered
   */
  protected EList<FragmentRole2FragmentInstanceBinding> fragmentRoleBindings;
  /**
   * The default value of the '{@link #getUcpiExpression() <em>Ucpi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUcpiExpression()
   * @generated
   * @ordered
   */
  protected static final String UCPI_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getUcpiExpression() <em>Ucpi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUcpiExpression()
   * @generated
   * @ordered
   */
  protected String ucpiExpression = UCPI_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionLanguageSpecificationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.COMPOSITION_LANGUAGE_SPECIFICATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CompositionAssociation2CompositionLinkBinding> getCompositionAssociationBindings()
  {
    if (compositionAssociationBindings == null)
    {
      compositionAssociationBindings = new EObjectContainmentWithInverseEList<CompositionAssociation2CompositionLinkBinding>(CompositionAssociation2CompositionLinkBinding.class, this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS, ReuseextensionPackage.COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION);
    }
    return compositionAssociationBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCompositionProgramPhysicalLocationExpression()
  {
    return compositionProgramPhysicalLocationExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionProgramPhysicalLocationExpression(String newCompositionProgramPhysicalLocationExpression)
  {
    String oldCompositionProgramPhysicalLocationExpression = compositionProgramPhysicalLocationExpression;
    compositionProgramPhysicalLocationExpression = newCompositionProgramPhysicalLocationExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION, oldCompositionProgramPhysicalLocationExpression, compositionProgramPhysicalLocationExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FragmentRole2FragmentInstanceBinding> getFragmentRoleBindings()
  {
    if (fragmentRoleBindings == null)
    {
      fragmentRoleBindings = new EObjectContainmentWithInverseEList<FragmentRole2FragmentInstanceBinding>(FragmentRole2FragmentInstanceBinding.class, this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION);
    }
    return fragmentRoleBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUcpiExpression()
  {
    return ucpiExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUcpiExpression(String newUcpiExpression)
  {
    String oldUcpiExpression = ucpiExpression;
    ucpiExpression = newUcpiExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION, oldUcpiExpression, ucpiExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getCompositionAssociationBindings()).basicAdd(otherEnd, msgs);
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getFragmentRoleBindings()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        return ((InternalEList<?>)getCompositionAssociationBindings()).basicRemove(otherEnd, msgs);
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return ((InternalEList<?>)getFragmentRoleBindings()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        return getCompositionAssociationBindings();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION:
        return getCompositionProgramPhysicalLocationExpression();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return getFragmentRoleBindings();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION:
        return getUcpiExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        getCompositionAssociationBindings().clear();
        getCompositionAssociationBindings().addAll((Collection<? extends CompositionAssociation2CompositionLinkBinding>)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION:
        setCompositionProgramPhysicalLocationExpression((String)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        getFragmentRoleBindings().clear();
        getFragmentRoleBindings().addAll((Collection<? extends FragmentRole2FragmentInstanceBinding>)newValue);
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION:
        setUcpiExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        getCompositionAssociationBindings().clear();
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION:
        setCompositionProgramPhysicalLocationExpression(COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        getFragmentRoleBindings().clear();
        return;
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION:
        setUcpiExpression(UCPI_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS:
        return compositionAssociationBindings != null && !compositionAssociationBindings.isEmpty();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION:
        return COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT == null ? compositionProgramPhysicalLocationExpression != null : !COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT.equals(compositionProgramPhysicalLocationExpression);
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return fragmentRoleBindings != null && !fragmentRoleBindings.isEmpty();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION:
        return UCPI_EXPRESSION_EDEFAULT == null ? ucpiExpression != null : !UCPI_EXPRESSION_EDEFAULT.equals(ucpiExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (compositionProgramPhysicalLocationExpression: ");
    result.append(compositionProgramPhysicalLocationExpression);
    result.append(", ucpiExpression: ");
    result.append(ucpiExpression);
    result.append(')');
    return result.toString();
  }

  public void removeYou()
   {
      this.getCompositionAssociationBindings().clear();
      this.getFragmentRoleBindings().clear();
super.removeYou ();   }
}


