/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.ComponentModelSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public class FragmentRole2FragmentBindingImpl extends FragmentRoleBindingImpl implements FragmentRole2FragmentBinding
{


   /**
   * The default value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected static final String IS_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected String isExpression = IS_EXPRESSION_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortTypeBindings() <em>Port Type Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortTypeBindings()
   * @generated
   * @ordered
   */
  protected EList<PortType2PortBinding> portTypeBindings;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FragmentRole2FragmentBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.FRAGMENT_ROLE2_FRAGMENT_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComponentModelSpecification getComponentModelSpecification()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION) return null;
    return (ComponentModelSpecification)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetComponentModelSpecification(ComponentModelSpecification newComponentModelSpecification, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newComponentModelSpecification, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setComponentModelSpecification(ComponentModelSpecification newComponentModelSpecification)
  {
    if (newComponentModelSpecification != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION && newComponentModelSpecification != null))
    {
      if (EcoreUtil.isAncestor(this, newComponentModelSpecification))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newComponentModelSpecification != null)
        msgs = ((InternalEObject)newComponentModelSpecification).eInverseAdd(this, ReuseextensionPackage.COMPONENT_MODEL_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, ComponentModelSpecification.class, msgs);
      msgs = basicSetComponentModelSpecification(newComponentModelSpecification, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION, newComponentModelSpecification, newComponentModelSpecification));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIsExpression()
  {
    return isExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsExpression(String newIsExpression)
  {
    String oldIsExpression = isExpression;
    isExpression = newIsExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION, oldIsExpression, isExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PortType2PortBinding> getPortTypeBindings()
  {
    if (portTypeBindings == null)
    {
      portTypeBindings = new EObjectContainmentWithInverseEList<PortType2PortBinding>(PortType2PortBinding.class, this, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS, ReuseextensionPackage.PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING);
    }
    return portTypeBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetComponentModelSpecification((ComponentModelSpecification)otherEnd, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPortTypeBindings()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        return basicSetComponentModelSpecification(null, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<?>)getPortTypeBindings()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.COMPONENT_MODEL_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, ComponentModelSpecification.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        return getComponentModelSpecification();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION:
        return getIsExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        return getPortTypeBindings();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        setComponentModelSpecification((ComponentModelSpecification)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION:
        setIsExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        getPortTypeBindings().addAll((Collection<? extends PortType2PortBinding>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        setComponentModelSpecification((ComponentModelSpecification)null);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION:
        setIsExpression(IS_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION:
        return getComponentModelSpecification() != null;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION:
        return IS_EXPRESSION_EDEFAULT == null ? isExpression != null : !IS_EXPRESSION_EDEFAULT.equals(isExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS:
        return portTypeBindings != null && !portTypeBindings.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (isExpression: ");
    result.append(isExpression);
    result.append(')');
    return result.toString();
  }

  public void removeYou()
   {
      this.setComponentModelSpecification (null);
      this.getPortTypeBindings().clear();
super.removeYou ();   }
}


