/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding;
import org.reuseware.coconut.reuseextension.PortType2SyntaxBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.SyntaxDerivationRule;




/**
 * @generated
 **/
public class FragmentRole2SyntaxBindingImpl extends FragmentRoleBindingImpl implements FragmentRole2SyntaxBinding
{


   /**
   * The default value of the '{@link #getHeightExpression() <em>Height Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeightExpression()
   * @generated
   * @ordered
   */
  protected static final String HEIGHT_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getHeightExpression() <em>Height Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeightExpression()
   * @generated
   * @ordered
   */
  protected String heightExpression = HEIGHT_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getIconExpression() <em>Icon Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIconExpression()
   * @generated
   * @ordered
   */
  protected static final String ICON_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIconExpression() <em>Icon Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIconExpression()
   * @generated
   * @ordered
   */
  protected String iconExpression = ICON_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getVisibleExpression() <em>Visible Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVisibleExpression()
   * @generated
   * @ordered
   */
  protected static final String VISIBLE_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getVisibleExpression() <em>Visible Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVisibleExpression()
   * @generated
   * @ordered
   */
  protected String visibleExpression = VISIBLE_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getWidthExpression() <em>Width Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidthExpression()
   * @generated
   * @ordered
   */
  protected static final String WIDTH_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getWidthExpression() <em>Width Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidthExpression()
   * @generated
   * @ordered
   */
  protected String widthExpression = WIDTH_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getNameExpression() <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameExpression()
   * @generated
   * @ordered
   */
  protected static final String NAME_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getNameExpression() <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameExpression()
   * @generated
   * @ordered
   */
  protected String nameExpression = NAME_EXPRESSION_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortTypeBindings() <em>Port Type Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortTypeBindings()
   * @generated
   * @ordered
   */
  protected EList<PortType2SyntaxBinding> portTypeBindings;
  /**
   * The default value of the '{@link #getTargetPhysicalLocationExpression() <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected static final String TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getTargetPhysicalLocationExpression() <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected String targetPhysicalLocationExpression = TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getTargetUfiExpression() <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetUfiExpression()
   * @generated
   * @ordered
   */
  protected static final String TARGET_UFI_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getTargetUfiExpression() <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetUfiExpression()
   * @generated
   * @ordered
   */
  protected String targetUfiExpression = TARGET_UFI_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getUfiExpression() <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUfiExpression()
   * @generated
   * @ordered
   */
  protected static final String UFI_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getUfiExpression() <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUfiExpression()
   * @generated
   * @ordered
   */
  protected String ufiExpression = UFI_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FragmentRole2SyntaxBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.FRAGMENT_ROLE2_SYNTAX_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getHeightExpression()
  {
    return heightExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHeightExpression(String newHeightExpression)
  {
    String oldHeightExpression = heightExpression;
    heightExpression = newHeightExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION, oldHeightExpression, heightExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIconExpression()
  {
    return iconExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIconExpression(String newIconExpression)
  {
    String oldIconExpression = iconExpression;
    iconExpression = newIconExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION, oldIconExpression, iconExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getVisibleExpression()
  {
    return visibleExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVisibleExpression(String newVisibleExpression)
  {
    String oldVisibleExpression = visibleExpression;
    visibleExpression = newVisibleExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION, oldVisibleExpression, visibleExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getWidthExpression()
  {
    return widthExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setWidthExpression(String newWidthExpression)
  {
    String oldWidthExpression = widthExpression;
    widthExpression = newWidthExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION, oldWidthExpression, widthExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSyntaxSpecification getCompositionLanguageSyntax()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX) return null;
    return (CompositionLanguageSyntaxSpecification)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCompositionLanguageSyntax(CompositionLanguageSyntaxSpecification newCompositionLanguageSyntax, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newCompositionLanguageSyntax, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionLanguageSyntax(CompositionLanguageSyntaxSpecification newCompositionLanguageSyntax)
  {
    if (newCompositionLanguageSyntax != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX && newCompositionLanguageSyntax != null))
    {
      if (EcoreUtil.isAncestor(this, newCompositionLanguageSyntax))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newCompositionLanguageSyntax != null)
        msgs = ((InternalEObject)newCompositionLanguageSyntax).eInverseAdd(this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, CompositionLanguageSyntaxSpecification.class, msgs);
      msgs = basicSetCompositionLanguageSyntax(newCompositionLanguageSyntax, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX, newCompositionLanguageSyntax, newCompositionLanguageSyntax));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNameExpression()
  {
    return nameExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameExpression(String newNameExpression)
  {
    String oldNameExpression = nameExpression;
    nameExpression = newNameExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION, oldNameExpression, nameExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PortType2SyntaxBinding> getPortTypeBindings()
  {
    if (portTypeBindings == null)
    {
      portTypeBindings = new EObjectContainmentWithInverseEList<PortType2SyntaxBinding>(PortType2SyntaxBinding.class, this, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING);
    }
    return portTypeBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetPhysicalLocationExpression()
  {
    return targetPhysicalLocationExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetPhysicalLocationExpression(String newTargetPhysicalLocationExpression)
  {
    String oldTargetPhysicalLocationExpression = targetPhysicalLocationExpression;
    targetPhysicalLocationExpression = newTargetPhysicalLocationExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION, oldTargetPhysicalLocationExpression, targetPhysicalLocationExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetUfiExpression()
  {
    return targetUfiExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetUfiExpression(String newTargetUfiExpression)
  {
    String oldTargetUfiExpression = targetUfiExpression;
    targetUfiExpression = newTargetUfiExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION, oldTargetUfiExpression, targetUfiExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUfiExpression()
  {
    return ufiExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUfiExpression(String newUfiExpression)
  {
    String oldUfiExpression = ufiExpression;
    ufiExpression = newUfiExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION, oldUfiExpression, ufiExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetCompositionLanguageSyntax((CompositionLanguageSyntaxSpecification)otherEnd, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPortTypeBindings()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        return basicSetCompositionLanguageSyntax(null, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<?>)getPortTypeBindings()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, CompositionLanguageSyntaxSpecification.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION:
        return getHeightExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION:
        return getIconExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION:
        return getVisibleExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION:
        return getWidthExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        return getCompositionLanguageSyntax();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION:
        return getNameExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        return getPortTypeBindings();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        return getTargetPhysicalLocationExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION:
        return getTargetUfiExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION:
        return getUfiExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION:
        setHeightExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION:
        setIconExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION:
        setVisibleExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION:
        setWidthExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        setCompositionLanguageSyntax((CompositionLanguageSyntaxSpecification)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION:
        setNameExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        getPortTypeBindings().addAll((Collection<? extends PortType2SyntaxBinding>)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        setTargetPhysicalLocationExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION:
        setTargetUfiExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION:
        setUfiExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION:
        setHeightExpression(HEIGHT_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION:
        setIconExpression(ICON_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION:
        setVisibleExpression(VISIBLE_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION:
        setWidthExpression(WIDTH_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        setCompositionLanguageSyntax((CompositionLanguageSyntaxSpecification)null);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION:
        setNameExpression(NAME_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        setTargetPhysicalLocationExpression(TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION:
        setTargetUfiExpression(TARGET_UFI_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION:
        setUfiExpression(UFI_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION:
        return HEIGHT_EXPRESSION_EDEFAULT == null ? heightExpression != null : !HEIGHT_EXPRESSION_EDEFAULT.equals(heightExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION:
        return ICON_EXPRESSION_EDEFAULT == null ? iconExpression != null : !ICON_EXPRESSION_EDEFAULT.equals(iconExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION:
        return VISIBLE_EXPRESSION_EDEFAULT == null ? visibleExpression != null : !VISIBLE_EXPRESSION_EDEFAULT.equals(visibleExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION:
        return WIDTH_EXPRESSION_EDEFAULT == null ? widthExpression != null : !WIDTH_EXPRESSION_EDEFAULT.equals(widthExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX:
        return getCompositionLanguageSyntax() != null;
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION:
        return NAME_EXPRESSION_EDEFAULT == null ? nameExpression != null : !NAME_EXPRESSION_EDEFAULT.equals(nameExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS:
        return portTypeBindings != null && !portTypeBindings.isEmpty();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        return TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT == null ? targetPhysicalLocationExpression != null : !TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT.equals(targetPhysicalLocationExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION:
        return TARGET_UFI_EXPRESSION_EDEFAULT == null ? targetUfiExpression != null : !TARGET_UFI_EXPRESSION_EDEFAULT.equals(targetUfiExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION:
        return UFI_EXPRESSION_EDEFAULT == null ? ufiExpression != null : !UFI_EXPRESSION_EDEFAULT.equals(ufiExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == SyntaxDerivationRule.class)
    {
      switch (derivedFeatureID)
      {
        case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION: return ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION;
        case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION: return ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION;
        case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION: return ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION;
        case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION: return ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == SyntaxDerivationRule.class)
    {
      switch (baseFeatureID)
      {
        case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION: return ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__HEIGHT_EXPRESSION;
        case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION: return ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__ICON_EXPRESSION;
        case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION: return ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__VISIBLE_EXPRESSION;
        case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION: return ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__WIDTH_EXPRESSION;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (heightExpression: ");
    result.append(heightExpression);
    result.append(", iconExpression: ");
    result.append(iconExpression);
    result.append(", visibleExpression: ");
    result.append(visibleExpression);
    result.append(", widthExpression: ");
    result.append(widthExpression);
    result.append(", nameExpression: ");
    result.append(nameExpression);
    result.append(", targetPhysicalLocationExpression: ");
    result.append(targetPhysicalLocationExpression);
    result.append(", targetUfiExpression: ");
    result.append(targetUfiExpression);
    result.append(", ufiExpression: ");
    result.append(ufiExpression);
    result.append(')');
    return result.toString();
  }

  public void removeYou()
   {
      this.setCompositionLanguageSyntax (null);
      this.getPortTypeBindings().clear();
super.removeYou ();   }
}


