/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.fracol.PortType;
import org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding;
import org.reuseware.coconut.reuseextension.PortType2SyntaxBinding;
import org.reuseware.coconut.reuseextension.PortTypeBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public class PortType2SyntaxBindingImpl extends SyntaxDerivationRuleImpl implements PortType2SyntaxBinding
{


   /**
   * The cached value of the '{@link #getPortType() <em>Port Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortType()
   * @generated
   * @ordered
   */
  protected PortType portType;
  /**
   * The default value of the '{@link #getLabelExpression() <em>Label Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLabelExpression()
   * @generated
   * @ordered
   */
  protected static final String LABEL_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getLabelExpression() <em>Label Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLabelExpression()
   * @generated
   * @ordered
   */
  protected String labelExpression = LABEL_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PortType2SyntaxBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.PORT_TYPE2_SYNTAX_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType getPortType()
  {
    if (portType != null && portType.eIsProxy())
    {
      InternalEObject oldPortType = (InternalEObject)portType;
      portType = (PortType)eResolveProxy(oldPortType);
      if (portType != oldPortType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE, oldPortType, portType));
      }
    }
    return portType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType basicGetPortType()
  {
    return portType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortType(PortType newPortType)
  {
    PortType oldPortType = portType;
    portType = newPortType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE, oldPortType, portType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2SyntaxBinding getFragmentRole2SyntaxBinding()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING) return null;
    return (FragmentRole2SyntaxBinding)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragmentRole2SyntaxBinding(FragmentRole2SyntaxBinding newFragmentRole2SyntaxBinding, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragmentRole2SyntaxBinding, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragmentRole2SyntaxBinding(FragmentRole2SyntaxBinding newFragmentRole2SyntaxBinding)
  {
    if (newFragmentRole2SyntaxBinding != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING && newFragmentRole2SyntaxBinding != null))
    {
      if (EcoreUtil.isAncestor(this, newFragmentRole2SyntaxBinding))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragmentRole2SyntaxBinding != null)
        msgs = ((InternalEObject)newFragmentRole2SyntaxBinding).eInverseAdd(this, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS, FragmentRole2SyntaxBinding.class, msgs);
      msgs = basicSetFragmentRole2SyntaxBinding(newFragmentRole2SyntaxBinding, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING, newFragmentRole2SyntaxBinding, newFragmentRole2SyntaxBinding));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLabelExpression()
  {
    return labelExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLabelExpression(String newLabelExpression)
  {
    String oldLabelExpression = labelExpression;
    labelExpression = newLabelExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION, oldLabelExpression, labelExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragmentRole2SyntaxBinding((FragmentRole2SyntaxBinding)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        return basicSetFragmentRole2SyntaxBinding(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS, FragmentRole2SyntaxBinding.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE:
        if (resolve) return getPortType();
        return basicGetPortType();
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        return getFragmentRole2SyntaxBinding();
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION:
        return getLabelExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE:
        setPortType((PortType)newValue);
        return;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        setFragmentRole2SyntaxBinding((FragmentRole2SyntaxBinding)newValue);
        return;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION:
        setLabelExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE:
        setPortType((PortType)null);
        return;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        setFragmentRole2SyntaxBinding((FragmentRole2SyntaxBinding)null);
        return;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION:
        setLabelExpression(LABEL_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE:
        return portType != null;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING:
        return getFragmentRole2SyntaxBinding() != null;
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION:
        return LABEL_EXPRESSION_EDEFAULT == null ? labelExpression != null : !LABEL_EXPRESSION_EDEFAULT.equals(labelExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == PortTypeBinding.class)
    {
      switch (derivedFeatureID)
      {
        case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE: return ReuseextensionPackage.PORT_TYPE_BINDING__PORT_TYPE;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == PortTypeBinding.class)
    {
      switch (baseFeatureID)
      {
        case ReuseextensionPackage.PORT_TYPE_BINDING__PORT_TYPE: return ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING__PORT_TYPE;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (labelExpression: ");
    result.append(labelExpression);
    result.append(')');
    return result.toString();
  }

  public void removeYou()
   {
      this.setFragmentRole2SyntaxBinding (null);
super.removeYou ();   }
}


