/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.reuseextension.ReuseExtension;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.RootElementContext;




/**
 * @generated
 **/
public abstract class ReuseExtensionImpl extends EObjectImpl implements ReuseExtension
{


   /**
   * The cached value of the '{@link #getEPackages() <em>EPackages</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEPackages()
   * @generated
   * @ordered
   */
  protected EList<EPackage> ePackages;
  /**
   * The cached value of the '{@link #getFracolNamespace() <em>Fracol Namespace</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFracolNamespace()
   * @generated
   * @ordered
   */
  protected EList<String> fracolNamespace;
  /**
   * The cached value of the '{@link #getFracol() <em>Fracol</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFracol()
   * @generated
   * @ordered
   */
  protected FragmentCollaboration fracol;
  /**
   * The cached value of the '{@link #getParameters() <em>Parameters</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParameters()
   * @generated
   * @ordered
   */
  protected EList<String> parameters;
  /**
   * The default value of the '{@link #getRexName() <em>Rex Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRexName()
   * @generated
   * @ordered
   */
  protected static final String REX_NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getRexName() <em>Rex Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRexName()
   * @generated
   * @ordered
   */
  protected String rexName = REX_NAME_EDEFAULT;
  /**
   * The cached value of the '{@link #getRexNamespace() <em>Rex Namespace</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRexNamespace()
   * @generated
   * @ordered
   */
  protected EList<String> rexNamespace;
  /**
   * The cached value of the '{@link #getRootElementContexts() <em>Root Element Contexts</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRootElementContexts()
   * @generated
   * @ordered
   */
  protected EList<RootElementContext> rootElementContexts;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ReuseExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.REUSE_EXTENSION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<EPackage> getEPackages()
  {
    if (ePackages == null)
    {
      ePackages = new EObjectResolvingEList<EPackage>(EPackage.class, this, ReuseextensionPackage.REUSE_EXTENSION__EPACKAGES);
    }
    return ePackages;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getFracolNamespace()
  {
    if (fracolNamespace == null)
    {
      fracolNamespace = new EDataTypeEList<String>(String.class, this, ReuseextensionPackage.REUSE_EXTENSION__FRACOL_NAMESPACE);
    }
    return fracolNamespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentCollaboration getFracol()
  {
    if (fracol != null && fracol.eIsProxy())
    {
      InternalEObject oldFracol = (InternalEObject)fracol;
      fracol = (FragmentCollaboration)eResolveProxy(oldFracol);
      if (fracol != oldFracol)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.REUSE_EXTENSION__FRACOL, oldFracol, fracol));
      }
    }
    return fracol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentCollaboration basicGetFracol()
  {
    return fracol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFracol(FragmentCollaboration newFracol)
  {
    FragmentCollaboration oldFracol = fracol;
    fracol = newFracol;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.REUSE_EXTENSION__FRACOL, oldFracol, fracol));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getParameters()
  {
    if (parameters == null)
    {
      parameters = new EDataTypeEList<String>(String.class, this, ReuseextensionPackage.REUSE_EXTENSION__PARAMETERS);
    }
    return parameters;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRexName()
  {
    return rexName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRexName(String newRexName)
  {
    String oldRexName = rexName;
    rexName = newRexName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.REUSE_EXTENSION__REX_NAME, oldRexName, rexName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getRexNamespace()
  {
    if (rexNamespace == null)
    {
      rexNamespace = new EDataTypeEList<String>(String.class, this, ReuseextensionPackage.REUSE_EXTENSION__REX_NAMESPACE);
    }
    return rexNamespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RootElementContext> getRootElementContexts()
  {
    if (rootElementContexts == null)
    {
      rootElementContexts = new EObjectContainmentWithInverseEList<RootElementContext>(RootElementContext.class, this, ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS, ReuseextensionPackage.ROOT_ELEMENT_CONTEXT__REUSE_EXTENSION);
    }
    return rootElementContexts;
  }

  public void removeYou()
   {
      this.getEPackages().clear();
      this.setFracol (null);
      this.getRootElementContexts().clear();
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getRootElementContexts()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        return ((InternalEList<?>)getRootElementContexts()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__EPACKAGES:
        return getEPackages();
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL_NAMESPACE:
        return getFracolNamespace();
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL:
        if (resolve) return getFracol();
        return basicGetFracol();
      case ReuseextensionPackage.REUSE_EXTENSION__PARAMETERS:
        return getParameters();
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAME:
        return getRexName();
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAMESPACE:
        return getRexNamespace();
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        return getRootElementContexts();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__EPACKAGES:
        getEPackages().clear();
        getEPackages().addAll((Collection<? extends EPackage>)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL_NAMESPACE:
        getFracolNamespace().clear();
        getFracolNamespace().addAll((Collection<? extends String>)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL:
        setFracol((FragmentCollaboration)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__PARAMETERS:
        getParameters().clear();
        getParameters().addAll((Collection<? extends String>)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAME:
        setRexName((String)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAMESPACE:
        getRexNamespace().clear();
        getRexNamespace().addAll((Collection<? extends String>)newValue);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        getRootElementContexts().clear();
        getRootElementContexts().addAll((Collection<? extends RootElementContext>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__EPACKAGES:
        getEPackages().clear();
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL_NAMESPACE:
        getFracolNamespace().clear();
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL:
        setFracol((FragmentCollaboration)null);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__PARAMETERS:
        getParameters().clear();
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAME:
        setRexName(REX_NAME_EDEFAULT);
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAMESPACE:
        getRexNamespace().clear();
        return;
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        getRootElementContexts().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.REUSE_EXTENSION__EPACKAGES:
        return ePackages != null && !ePackages.isEmpty();
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL_NAMESPACE:
        return fracolNamespace != null && !fracolNamespace.isEmpty();
      case ReuseextensionPackage.REUSE_EXTENSION__FRACOL:
        return fracol != null;
      case ReuseextensionPackage.REUSE_EXTENSION__PARAMETERS:
        return parameters != null && !parameters.isEmpty();
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAME:
        return REX_NAME_EDEFAULT == null ? rexName != null : !REX_NAME_EDEFAULT.equals(rexName);
      case ReuseextensionPackage.REUSE_EXTENSION__REX_NAMESPACE:
        return rexNamespace != null && !rexNamespace.isEmpty();
      case ReuseextensionPackage.REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS:
        return rootElementContexts != null && !rootElementContexts.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (fracolNamespace: ");
    result.append(fracolNamespace);
    result.append(", parameters: ");
    result.append(parameters);
    result.append(", rexName: ");
    result.append(rexName);
    result.append(", rexNamespace: ");
    result.append(rexNamespace);
    result.append(')');
    return result.toString();
  }
}


