/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.reuseware.coconut.reuseextension.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ReuseextensionFactoryImpl extends EFactoryImpl implements ReuseextensionFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ReuseextensionFactory init()
  {
    try
    {
      ReuseextensionFactory theReuseextensionFactory = (ReuseextensionFactory)EPackage.Registry.INSTANCE.getEFactory("http://reuseware.org/coconut/reuseextension"); 
      if (theReuseextensionFactory != null)
      {
        return theReuseextensionFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new ReuseextensionFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case ReuseextensionPackage.ANCHOR_DERIVATION_RULE: return createAnchorDerivationRule();
      case ReuseextensionPackage.COMPONENT_MODEL_SPECIFICATION: return createComponentModelSpecification();
      case ReuseextensionPackage.COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING: return createCompositionAssociation2CompositionLinkBinding();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION: return createCompositionLanguageSpecification();
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION: return createCompositionLanguageSyntaxSpecification();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_BINDING: return createFragmentRole2FragmentBinding();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING: return createFragmentRole2FragmentInstanceBinding();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING: return createFragmentRole2FragmentReferenceBinding();
      case ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING: return createFragmentRole2SyntaxBinding();
      case ReuseextensionPackage.HOOK_DERIVATION_RULE: return createHookDerivationRule();
      case ReuseextensionPackage.PORT_TYPE2_HETEROGENEOUS_PORT_BINDING: return createPortType2HeterogeneousPortBinding();
      case ReuseextensionPackage.PORT_TYPE2_HOMOGENOUS_PORT_BINDING: return createPortType2HomogenousPortBinding();
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING: return createPortType2SettingBinding();
      case ReuseextensionPackage.PORT_TYPE2_SYNTAX_BINDING: return createPortType2SyntaxBinding();
      case ReuseextensionPackage.PROTOTYPE_DERIVATION_RULE: return createPrototypeDerivationRule();
      case ReuseextensionPackage.ROOT_ELEMENT_CONTEXT: return createRootElementContext();
      case ReuseextensionPackage.SETTING_DERIVATION_RULE: return createSettingDerivationRule();
      case ReuseextensionPackage.SLOT_DERIVATION_RULE: return createSlotDerivationRule();
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE: return createValueHookDerivationRule();
      case ReuseextensionPackage.VALUE_PROTOTYPE_DERIVATION_RULE: return createValuePrototypeDerivationRule();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AnchorDerivationRule createAnchorDerivationRule()
  {
    AnchorDerivationRuleImpl anchorDerivationRule = new AnchorDerivationRuleImpl();
    return anchorDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComponentModelSpecification createComponentModelSpecification()
  {
    ComponentModelSpecificationImpl componentModelSpecification = new ComponentModelSpecificationImpl();
    return componentModelSpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionAssociation2CompositionLinkBinding createCompositionAssociation2CompositionLinkBinding()
  {
    CompositionAssociation2CompositionLinkBindingImpl compositionAssociation2CompositionLinkBinding = new CompositionAssociation2CompositionLinkBindingImpl();
    return compositionAssociation2CompositionLinkBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSpecification createCompositionLanguageSpecification()
  {
    CompositionLanguageSpecificationImpl compositionLanguageSpecification = new CompositionLanguageSpecificationImpl();
    return compositionLanguageSpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSyntaxSpecification createCompositionLanguageSyntaxSpecification()
  {
    CompositionLanguageSyntaxSpecificationImpl compositionLanguageSyntaxSpecification = new CompositionLanguageSyntaxSpecificationImpl();
    return compositionLanguageSyntaxSpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentBinding createFragmentRole2FragmentBinding()
  {
    FragmentRole2FragmentBindingImpl fragmentRole2FragmentBinding = new FragmentRole2FragmentBindingImpl();
    return fragmentRole2FragmentBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentInstanceBinding createFragmentRole2FragmentInstanceBinding()
  {
    FragmentRole2FragmentInstanceBindingImpl fragmentRole2FragmentInstanceBinding = new FragmentRole2FragmentInstanceBindingImpl();
    return fragmentRole2FragmentInstanceBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentReferenceBinding createFragmentRole2FragmentReferenceBinding()
  {
    FragmentRole2FragmentReferenceBindingImpl fragmentRole2FragmentReferenceBinding = new FragmentRole2FragmentReferenceBindingImpl();
    return fragmentRole2FragmentReferenceBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2SyntaxBinding createFragmentRole2SyntaxBinding()
  {
    FragmentRole2SyntaxBindingImpl fragmentRole2SyntaxBinding = new FragmentRole2SyntaxBindingImpl();
    return fragmentRole2SyntaxBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HookDerivationRule createHookDerivationRule()
  {
    HookDerivationRuleImpl hookDerivationRule = new HookDerivationRuleImpl();
    return hookDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2HeterogeneousPortBinding createPortType2HeterogeneousPortBinding()
  {
    PortType2HeterogeneousPortBindingImpl portType2HeterogeneousPortBinding = new PortType2HeterogeneousPortBindingImpl();
    return portType2HeterogeneousPortBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2HomogenousPortBinding createPortType2HomogenousPortBinding()
  {
    PortType2HomogenousPortBindingImpl portType2HomogenousPortBinding = new PortType2HomogenousPortBindingImpl();
    return portType2HomogenousPortBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2SettingBinding createPortType2SettingBinding()
  {
    PortType2SettingBindingImpl portType2SettingBinding = new PortType2SettingBindingImpl();
    return portType2SettingBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2SyntaxBinding createPortType2SyntaxBinding()
  {
    PortType2SyntaxBindingImpl portType2SyntaxBinding = new PortType2SyntaxBindingImpl();
    return portType2SyntaxBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PrototypeDerivationRule createPrototypeDerivationRule()
  {
    PrototypeDerivationRuleImpl prototypeDerivationRule = new PrototypeDerivationRuleImpl();
    return prototypeDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RootElementContext createRootElementContext()
  {
    RootElementContextImpl rootElementContext = new RootElementContextImpl();
    return rootElementContext;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SettingDerivationRule createSettingDerivationRule()
  {
    SettingDerivationRuleImpl settingDerivationRule = new SettingDerivationRuleImpl();
    return settingDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SlotDerivationRule createSlotDerivationRule()
  {
    SlotDerivationRuleImpl slotDerivationRule = new SlotDerivationRuleImpl();
    return slotDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValueHookDerivationRule createValueHookDerivationRule()
  {
    ValueHookDerivationRuleImpl valueHookDerivationRule = new ValueHookDerivationRuleImpl();
    return valueHookDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValuePrototypeDerivationRule createValuePrototypeDerivationRule()
  {
    ValuePrototypeDerivationRuleImpl valuePrototypeDerivationRule = new ValuePrototypeDerivationRuleImpl();
    return valuePrototypeDerivationRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionPackage getReuseextensionPackage()
  {
    return (ReuseextensionPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static ReuseextensionPackage getPackage()
  {
    return ReuseextensionPackage.eINSTANCE;
  }

} //ReuseextensionFactoryImpl
