/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.reuseware.coconut.fracol.FracolPackage;

import org.reuseware.coconut.reuseextension.AddressablePointDerivationRule;
import org.reuseware.coconut.reuseextension.AnchorDerivationRule;
import org.reuseware.coconut.reuseextension.ComponentModelSpecification;
import org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding;
import org.reuseware.coconut.reuseextension.CompositionAssociationBinding;
import org.reuseware.coconut.reuseextension.CompositionLanguageSpecification;
import org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding;
import org.reuseware.coconut.reuseextension.FragmentRoleBinding;
import org.reuseware.coconut.reuseextension.HookDerivationRule;
import org.reuseware.coconut.reuseextension.PortType2HeterogeneousPortBinding;
import org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;
import org.reuseware.coconut.reuseextension.PortType2SettingBinding;
import org.reuseware.coconut.reuseextension.PortType2SyntaxBinding;
import org.reuseware.coconut.reuseextension.PortTypeBinding;
import org.reuseware.coconut.reuseextension.PrototypeDerivationRule;
import org.reuseware.coconut.reuseextension.ReferencePointDerivationRule;
import org.reuseware.coconut.reuseextension.ReuseExtension;
import org.reuseware.coconut.reuseextension.ReuseextensionFactory;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.RootElementContext;
import org.reuseware.coconut.reuseextension.RuleContext;
import org.reuseware.coconut.reuseextension.SettingDerivationRule;
import org.reuseware.coconut.reuseextension.SlotDerivationRule;
import org.reuseware.coconut.reuseextension.SyntaxDerivationRule;
import org.reuseware.coconut.reuseextension.ValueHookDerivationRule;
import org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule;
import org.reuseware.coconut.reuseextension.VariationPointDerivationRule;

import org.reuseware.coconut.reuseextension.util.ReuseextensionValidator;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ReuseextensionPackageImpl extends EPackageImpl implements ReuseextensionPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass addressablePointDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass anchorDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass componentModelSpecificationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionAssociation2CompositionLinkBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionAssociationBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionLanguageSpecificationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionLanguageSyntaxSpecificationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRole2FragmentBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRole2FragmentInstanceBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRole2FragmentReferenceBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRole2SyntaxBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRoleBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass hookDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portType2HeterogeneousPortBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portType2HomogenousPortBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portType2PortBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portType2SettingBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portType2SyntaxBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portTypeBindingEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass prototypeDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass referencePointDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass reuseExtensionEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass rootElementContextEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass ruleContextEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass settingDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass slotDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass syntaxDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass valueHookDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass valuePrototypeDerivationRuleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass variationPointDerivationRuleEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private ReuseextensionPackageImpl()
  {
    super(eNS_URI, ReuseextensionFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link ReuseextensionPackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static ReuseextensionPackage init()
  {
    if (isInited) return (ReuseextensionPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionPackage.eNS_URI);

    // Obtain or create and register package
    ReuseextensionPackageImpl theReuseextensionPackage = (ReuseextensionPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ReuseextensionPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ReuseextensionPackageImpl());

    isInited = true;

    // Initialize simple dependencies
    EcorePackage.eINSTANCE.eClass();
    FracolPackage.eINSTANCE.eClass();

    // Create package meta-data objects
    theReuseextensionPackage.createPackageContents();

    // Initialize created meta-data
    theReuseextensionPackage.initializePackageContents();

    // Register package validator
    EValidator.Registry.INSTANCE.put
      (theReuseextensionPackage, 
       new EValidator.Descriptor()
       {
         public EValidator getEValidator()
         {
           return ReuseextensionValidator.INSTANCE;
         }
       });

    // Mark meta-data to indicate it can't be changed
    theReuseextensionPackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(ReuseextensionPackage.eNS_URI, theReuseextensionPackage);
    return theReuseextensionPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAddressablePointDerivationRule()
  {
    return addressablePointDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAddressablePointDerivationRule_ForEachExpression()
  {
    return (EAttribute)addressablePointDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAddressablePointDerivationRule_HomoPortNameExpression()
  {
    return (EAttribute)addressablePointDerivationRuleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAddressablePointDerivationRule_PointNameExpression()
  {
    return (EAttribute)addressablePointDerivationRuleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAddressablePointDerivationRule_PortNameExpression()
  {
    return (EAttribute)addressablePointDerivationRuleEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getAddressablePointDerivationRule_PortTypeBinding()
  {
    return (EReference)addressablePointDerivationRuleEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAnchorDerivationRule()
  {
    return anchorDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getComponentModelSpecification()
  {
    return componentModelSpecificationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getComponentModelSpecification_FragmentRoleBindings()
  {
    return (EReference)componentModelSpecificationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionAssociation2CompositionLinkBinding()
  {
    return compositionAssociation2CompositionLinkBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification()
  {
    return (EReference)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_ForEach1Expression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_ForEach2Expression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_FragmentInstance1NameExpression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_FragmentInstance2NameExpression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_PortInstance1NameExpression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation2CompositionLinkBinding_PortInstance2NameExpression()
  {
    return (EAttribute)compositionAssociation2CompositionLinkBindingEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionAssociationBinding()
  {
    return compositionAssociationBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociationBinding_CompositionAssociation()
  {
    return (EReference)compositionAssociationBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionLanguageSpecification()
  {
    return compositionLanguageSpecificationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLanguageSpecification_CompositionAssociationBindings()
  {
    return (EReference)compositionLanguageSpecificationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionLanguageSpecification_CompositionProgramPhysicalLocationExpression()
  {
    return (EAttribute)compositionLanguageSpecificationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLanguageSpecification_FragmentRoleBindings()
  {
    return (EReference)compositionLanguageSpecificationEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionLanguageSpecification_UcpiExpression()
  {
    return (EAttribute)compositionLanguageSpecificationEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionLanguageSyntaxSpecification()
  {
    return compositionLanguageSyntaxSpecificationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLanguageSyntaxSpecification_FragmentRoleBindings()
  {
    return (EReference)compositionLanguageSyntaxSpecificationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRole2FragmentBinding()
  {
    return fragmentRole2FragmentBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2FragmentBinding_ComponentModelSpecification()
  {
    return (EReference)fragmentRole2FragmentBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2FragmentBinding_IsExpression()
  {
    return (EAttribute)fragmentRole2FragmentBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2FragmentBinding_PortTypeBindings()
  {
    return (EReference)fragmentRole2FragmentBindingEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRole2FragmentInstanceBinding()
  {
    return fragmentRole2FragmentInstanceBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification()
  {
    return (EReference)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2FragmentInstanceBinding_NameExpression()
  {
    return (EAttribute)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2FragmentInstanceBinding_PortTypeBindings()
  {
    return (EReference)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2FragmentInstanceBinding_TargetPhysicalLocationExpression()
  {
    return (EAttribute)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2FragmentInstanceBinding_TargetUfiExpression()
  {
    return (EAttribute)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2FragmentInstanceBinding_UfiExpression()
  {
    return (EAttribute)fragmentRole2FragmentInstanceBindingEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRole2FragmentReferenceBinding()
  {
    return fragmentRole2FragmentReferenceBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRole2SyntaxBinding()
  {
    return fragmentRole2SyntaxBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2SyntaxBinding_CompositionLanguageSyntax()
  {
    return (EReference)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2SyntaxBinding_NameExpression()
  {
    return (EAttribute)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole2SyntaxBinding_PortTypeBindings()
  {
    return (EReference)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2SyntaxBinding_TargetPhysicalLocationExpression()
  {
    return (EAttribute)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2SyntaxBinding_TargetUfiExpression()
  {
    return (EAttribute)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole2SyntaxBinding_UfiExpression()
  {
    return (EAttribute)fragmentRole2SyntaxBindingEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRoleBinding()
  {
    return fragmentRoleBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRoleBinding_FragmentRole()
  {
    return (EReference)fragmentRoleBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getHookDerivationRule()
  {
    return hookDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType2HeterogeneousPortBinding()
  {
    return portType2HeterogeneousPortBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType2HomogenousPortBinding()
  {
    return portType2HomogenousPortBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType2PortBinding()
  {
    return portType2PortBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType2PortBinding_DerivationRules()
  {
    return (EReference)portType2PortBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType2PortBinding_FragmentRoleBinding()
  {
    return (EReference)portType2PortBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType2SettingBinding()
  {
    return portType2SettingBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType2SettingBinding_DerivationRules()
  {
    return (EReference)portType2SettingBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType2SettingBinding_FragmentRoleBinding()
  {
    return (EReference)portType2SettingBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType2SyntaxBinding()
  {
    return portType2SyntaxBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType2SyntaxBinding_FragmentRole2SyntaxBinding()
  {
    return (EReference)portType2SyntaxBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortType2SyntaxBinding_LabelExpression()
  {
    return (EAttribute)portType2SyntaxBindingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortTypeBinding()
  {
    return portTypeBindingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortTypeBinding_PortType()
  {
    return (EReference)portTypeBindingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPrototypeDerivationRule()
  {
    return prototypeDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getReferencePointDerivationRule()
  {
    return referencePointDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getReuseExtension()
  {
    return reuseExtensionEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtension_EPackages()
  {
    return (EReference)reuseExtensionEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getReuseExtension_FracolNamespace()
  {
    return (EAttribute)reuseExtensionEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtension_Fracol()
  {
    return (EReference)reuseExtensionEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getReuseExtension_Parameters()
  {
    return (EAttribute)reuseExtensionEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getReuseExtension_RexName()
  {
    return (EAttribute)reuseExtensionEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getReuseExtension_RexNamespace()
  {
    return (EAttribute)reuseExtensionEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtension_RootElementContexts()
  {
    return (EReference)reuseExtensionEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getRootElementContext()
  {
    return rootElementContextEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRootElementContext_ReuseExtension()
  {
    return (EReference)rootElementContextEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getRuleContext()
  {
    return ruleContextEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRuleContext_EBoundClass()
  {
    return (EReference)ruleContextEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRuleContext_EBoundFeature()
  {
    return (EReference)ruleContextEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getRuleContext_IsExpression()
  {
    return (EAttribute)ruleContextEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSettingDerivationRule()
  {
    return settingDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getSettingDerivationRule_PortTypeBinding()
  {
    return (EReference)settingDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSettingDerivationRule_PropertyExpression()
  {
    return (EAttribute)settingDerivationRuleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSettingDerivationRule_ValueExpression()
  {
    return (EAttribute)settingDerivationRuleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSlotDerivationRule()
  {
    return slotDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSyntaxDerivationRule()
  {
    return syntaxDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSyntaxDerivationRule_HeightExpression()
  {
    return (EAttribute)syntaxDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSyntaxDerivationRule_IconExpression()
  {
    return (EAttribute)syntaxDerivationRuleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSyntaxDerivationRule_VisibleExpression()
  {
    return (EAttribute)syntaxDerivationRuleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSyntaxDerivationRule_WidthExpression()
  {
    return (EAttribute)syntaxDerivationRuleEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getValueHookDerivationRule()
  {
    return valueHookDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHookDerivationRule_BeginIndexExpression()
  {
    return (EAttribute)valueHookDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHookDerivationRule_EndIndexExpression()
  {
    return (EAttribute)valueHookDerivationRuleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValueHookDerivationRule_ListIndexExpression()
  {
    return (EAttribute)valueHookDerivationRuleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getValuePrototypeDerivationRule()
  {
    return valuePrototypeDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getValuePrototypeDerivationRule_ValueExpression()
  {
    return (EAttribute)valuePrototypeDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getVariationPointDerivationRule()
  {
    return variationPointDerivationRuleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVariationPointDerivationRule_ModeExpression()
  {
    return (EAttribute)variationPointDerivationRuleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVariationPointDerivationRule_RemoveExpression()
  {
    return (EAttribute)variationPointDerivationRuleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionFactory getReuseextensionFactory()
  {
    return (ReuseextensionFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    addressablePointDerivationRuleEClass = createEClass(ADDRESSABLE_POINT_DERIVATION_RULE);
    createEAttribute(addressablePointDerivationRuleEClass, ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION);
    createEAttribute(addressablePointDerivationRuleEClass, ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION);
    createEAttribute(addressablePointDerivationRuleEClass, ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION);
    createEAttribute(addressablePointDerivationRuleEClass, ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION);
    createEReference(addressablePointDerivationRuleEClass, ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING);

    anchorDerivationRuleEClass = createEClass(ANCHOR_DERIVATION_RULE);

    componentModelSpecificationEClass = createEClass(COMPONENT_MODEL_SPECIFICATION);
    createEReference(componentModelSpecificationEClass, COMPONENT_MODEL_SPECIFICATION__FRAGMENT_ROLE_BINDINGS);

    compositionAssociation2CompositionLinkBindingEClass = createEClass(COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING);
    createEReference(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH1_EXPRESSION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FOR_EACH2_EXPRESSION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE1_NAME_EXPRESSION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__FRAGMENT_INSTANCE2_NAME_EXPRESSION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE1_NAME_EXPRESSION);
    createEAttribute(compositionAssociation2CompositionLinkBindingEClass, COMPOSITION_ASSOCIATION2_COMPOSITION_LINK_BINDING__PORT_INSTANCE2_NAME_EXPRESSION);

    compositionAssociationBindingEClass = createEClass(COMPOSITION_ASSOCIATION_BINDING);
    createEReference(compositionAssociationBindingEClass, COMPOSITION_ASSOCIATION_BINDING__COMPOSITION_ASSOCIATION);

    compositionLanguageSpecificationEClass = createEClass(COMPOSITION_LANGUAGE_SPECIFICATION);
    createEReference(compositionLanguageSpecificationEClass, COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_ASSOCIATION_BINDINGS);
    createEAttribute(compositionLanguageSpecificationEClass, COMPOSITION_LANGUAGE_SPECIFICATION__COMPOSITION_PROGRAM_PHYSICAL_LOCATION_EXPRESSION);
    createEReference(compositionLanguageSpecificationEClass, COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS);
    createEAttribute(compositionLanguageSpecificationEClass, COMPOSITION_LANGUAGE_SPECIFICATION__UCPI_EXPRESSION);

    compositionLanguageSyntaxSpecificationEClass = createEClass(COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION);
    createEReference(compositionLanguageSyntaxSpecificationEClass, COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS);

    fragmentRole2FragmentBindingEClass = createEClass(FRAGMENT_ROLE2_FRAGMENT_BINDING);
    createEReference(fragmentRole2FragmentBindingEClass, FRAGMENT_ROLE2_FRAGMENT_BINDING__COMPONENT_MODEL_SPECIFICATION);
    createEAttribute(fragmentRole2FragmentBindingEClass, FRAGMENT_ROLE2_FRAGMENT_BINDING__IS_EXPRESSION);
    createEReference(fragmentRole2FragmentBindingEClass, FRAGMENT_ROLE2_FRAGMENT_BINDING__PORT_TYPE_BINDINGS);

    fragmentRole2FragmentInstanceBindingEClass = createEClass(FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING);
    createEReference(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION);
    createEAttribute(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION);
    createEReference(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS);
    createEAttribute(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION);
    createEAttribute(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION);
    createEAttribute(fragmentRole2FragmentInstanceBindingEClass, FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION);

    fragmentRole2FragmentReferenceBindingEClass = createEClass(FRAGMENT_ROLE2_FRAGMENT_REFERENCE_BINDING);

    fragmentRole2SyntaxBindingEClass = createEClass(FRAGMENT_ROLE2_SYNTAX_BINDING);
    createEReference(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX);
    createEAttribute(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__NAME_EXPRESSION);
    createEReference(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__PORT_TYPE_BINDINGS);
    createEAttribute(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION);
    createEAttribute(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__TARGET_UFI_EXPRESSION);
    createEAttribute(fragmentRole2SyntaxBindingEClass, FRAGMENT_ROLE2_SYNTAX_BINDING__UFI_EXPRESSION);

    fragmentRoleBindingEClass = createEClass(FRAGMENT_ROLE_BINDING);
    createEReference(fragmentRoleBindingEClass, FRAGMENT_ROLE_BINDING__FRAGMENT_ROLE);

    hookDerivationRuleEClass = createEClass(HOOK_DERIVATION_RULE);

    portType2HeterogeneousPortBindingEClass = createEClass(PORT_TYPE2_HETEROGENEOUS_PORT_BINDING);

    portType2HomogenousPortBindingEClass = createEClass(PORT_TYPE2_HOMOGENOUS_PORT_BINDING);

    portType2PortBindingEClass = createEClass(PORT_TYPE2_PORT_BINDING);
    createEReference(portType2PortBindingEClass, PORT_TYPE2_PORT_BINDING__DERIVATION_RULES);
    createEReference(portType2PortBindingEClass, PORT_TYPE2_PORT_BINDING__FRAGMENT_ROLE_BINDING);

    portType2SettingBindingEClass = createEClass(PORT_TYPE2_SETTING_BINDING);
    createEReference(portType2SettingBindingEClass, PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES);
    createEReference(portType2SettingBindingEClass, PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING);

    portType2SyntaxBindingEClass = createEClass(PORT_TYPE2_SYNTAX_BINDING);
    createEReference(portType2SyntaxBindingEClass, PORT_TYPE2_SYNTAX_BINDING__FRAGMENT_ROLE2_SYNTAX_BINDING);
    createEAttribute(portType2SyntaxBindingEClass, PORT_TYPE2_SYNTAX_BINDING__LABEL_EXPRESSION);

    portTypeBindingEClass = createEClass(PORT_TYPE_BINDING);
    createEReference(portTypeBindingEClass, PORT_TYPE_BINDING__PORT_TYPE);

    prototypeDerivationRuleEClass = createEClass(PROTOTYPE_DERIVATION_RULE);

    referencePointDerivationRuleEClass = createEClass(REFERENCE_POINT_DERIVATION_RULE);

    reuseExtensionEClass = createEClass(REUSE_EXTENSION);
    createEReference(reuseExtensionEClass, REUSE_EXTENSION__EPACKAGES);
    createEAttribute(reuseExtensionEClass, REUSE_EXTENSION__FRACOL_NAMESPACE);
    createEReference(reuseExtensionEClass, REUSE_EXTENSION__FRACOL);
    createEAttribute(reuseExtensionEClass, REUSE_EXTENSION__PARAMETERS);
    createEAttribute(reuseExtensionEClass, REUSE_EXTENSION__REX_NAME);
    createEAttribute(reuseExtensionEClass, REUSE_EXTENSION__REX_NAMESPACE);
    createEReference(reuseExtensionEClass, REUSE_EXTENSION__ROOT_ELEMENT_CONTEXTS);

    rootElementContextEClass = createEClass(ROOT_ELEMENT_CONTEXT);
    createEReference(rootElementContextEClass, ROOT_ELEMENT_CONTEXT__REUSE_EXTENSION);

    ruleContextEClass = createEClass(RULE_CONTEXT);
    createEReference(ruleContextEClass, RULE_CONTEXT__EBOUND_CLASS);
    createEReference(ruleContextEClass, RULE_CONTEXT__EBOUND_FEATURE);
    createEAttribute(ruleContextEClass, RULE_CONTEXT__IS_EXPRESSION);

    settingDerivationRuleEClass = createEClass(SETTING_DERIVATION_RULE);
    createEReference(settingDerivationRuleEClass, SETTING_DERIVATION_RULE__PORT_TYPE_BINDING);
    createEAttribute(settingDerivationRuleEClass, SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION);
    createEAttribute(settingDerivationRuleEClass, SETTING_DERIVATION_RULE__VALUE_EXPRESSION);

    slotDerivationRuleEClass = createEClass(SLOT_DERIVATION_RULE);

    syntaxDerivationRuleEClass = createEClass(SYNTAX_DERIVATION_RULE);
    createEAttribute(syntaxDerivationRuleEClass, SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION);
    createEAttribute(syntaxDerivationRuleEClass, SYNTAX_DERIVATION_RULE__ICON_EXPRESSION);
    createEAttribute(syntaxDerivationRuleEClass, SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION);
    createEAttribute(syntaxDerivationRuleEClass, SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION);

    valueHookDerivationRuleEClass = createEClass(VALUE_HOOK_DERIVATION_RULE);
    createEAttribute(valueHookDerivationRuleEClass, VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION);
    createEAttribute(valueHookDerivationRuleEClass, VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION);
    createEAttribute(valueHookDerivationRuleEClass, VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION);

    valuePrototypeDerivationRuleEClass = createEClass(VALUE_PROTOTYPE_DERIVATION_RULE);
    createEAttribute(valuePrototypeDerivationRuleEClass, VALUE_PROTOTYPE_DERIVATION_RULE__VALUE_EXPRESSION);

    variationPointDerivationRuleEClass = createEClass(VARIATION_POINT_DERIVATION_RULE);
    createEAttribute(variationPointDerivationRuleEClass, VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION);
    createEAttribute(variationPointDerivationRuleEClass, VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    FracolPackage theFracolPackage = (FracolPackage)EPackage.Registry.INSTANCE.getEPackage(FracolPackage.eNS_URI);
    EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    addressablePointDerivationRuleEClass.getESuperTypes().add(this.getRuleContext());
    anchorDerivationRuleEClass.getESuperTypes().add(this.getReferencePointDerivationRule());
    componentModelSpecificationEClass.getESuperTypes().add(this.getReuseExtension());
    compositionAssociation2CompositionLinkBindingEClass.getESuperTypes().add(this.getCompositionAssociationBinding());
    compositionAssociationBindingEClass.getESuperTypes().add(this.getRuleContext());
    compositionLanguageSpecificationEClass.getESuperTypes().add(this.getReuseExtension());
    compositionLanguageSyntaxSpecificationEClass.getESuperTypes().add(this.getReuseExtension());
    fragmentRole2FragmentBindingEClass.getESuperTypes().add(this.getFragmentRoleBinding());
    fragmentRole2FragmentInstanceBindingEClass.getESuperTypes().add(this.getFragmentRoleBinding());
    fragmentRole2FragmentInstanceBindingEClass.getESuperTypes().add(this.getRuleContext());
    fragmentRole2FragmentReferenceBindingEClass.getESuperTypes().add(this.getFragmentRole2FragmentInstanceBinding());
    fragmentRole2SyntaxBindingEClass.getESuperTypes().add(this.getFragmentRoleBinding());
    fragmentRole2SyntaxBindingEClass.getESuperTypes().add(this.getSyntaxDerivationRule());
    hookDerivationRuleEClass.getESuperTypes().add(this.getVariationPointDerivationRule());
    portType2HeterogeneousPortBindingEClass.getESuperTypes().add(this.getPortType2PortBinding());
    portType2HomogenousPortBindingEClass.getESuperTypes().add(this.getPortType2PortBinding());
    portType2PortBindingEClass.getESuperTypes().add(this.getPortTypeBinding());
    portType2SettingBindingEClass.getESuperTypes().add(this.getPortTypeBinding());
    portType2SyntaxBindingEClass.getESuperTypes().add(this.getSyntaxDerivationRule());
    portType2SyntaxBindingEClass.getESuperTypes().add(this.getPortTypeBinding());
    prototypeDerivationRuleEClass.getESuperTypes().add(this.getReferencePointDerivationRule());
    referencePointDerivationRuleEClass.getESuperTypes().add(this.getAddressablePointDerivationRule());
    rootElementContextEClass.getESuperTypes().add(this.getRuleContext());
    slotDerivationRuleEClass.getESuperTypes().add(this.getVariationPointDerivationRule());
    valueHookDerivationRuleEClass.getESuperTypes().add(this.getVariationPointDerivationRule());
    valuePrototypeDerivationRuleEClass.getESuperTypes().add(this.getReferencePointDerivationRule());
    variationPointDerivationRuleEClass.getESuperTypes().add(this.getAddressablePointDerivationRule());

    // Initialize classes and features; add operations and parameters
    initEClass(addressablePointDerivationRuleEClass, AddressablePointDerivationRule.class, "AddressablePointDerivationRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getAddressablePointDerivationRule_ForEachExpression(), ecorePackage.getEString(), "forEachExpression", null, 0, 1, AddressablePointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAddressablePointDerivationRule_HomoPortNameExpression(), ecorePackage.getEString(), "homoPortNameExpression", null, 0, 1, AddressablePointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAddressablePointDerivationRule_PointNameExpression(), ecorePackage.getEString(), "pointNameExpression", null, 0, 1, AddressablePointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAddressablePointDerivationRule_PortNameExpression(), ecorePackage.getEString(), "portNameExpression", null, 0, 1, AddressablePointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getAddressablePointDerivationRule_PortTypeBinding(), this.getPortType2PortBinding(), this.getPortType2PortBinding_DerivationRules(), "portTypeBinding", null, 0, 1, AddressablePointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(addressablePointDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(anchorDerivationRuleEClass, AnchorDerivationRule.class, "AnchorDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(anchorDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(componentModelSpecificationEClass, ComponentModelSpecification.class, "ComponentModelSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getComponentModelSpecification_FragmentRoleBindings(), this.getFragmentRole2FragmentBinding(), this.getFragmentRole2FragmentBinding_ComponentModelSpecification(), "fragmentRoleBindings", null, 0, -1, ComponentModelSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(componentModelSpecificationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionAssociation2CompositionLinkBindingEClass, CompositionAssociation2CompositionLinkBinding.class, "CompositionAssociation2CompositionLinkBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification(), this.getCompositionLanguageSpecification(), this.getCompositionLanguageSpecification_CompositionAssociationBindings(), "compositionLanguageSpecification", null, 0, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_ForEach1Expression(), ecorePackage.getEString(), "forEach1Expression", null, 0, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_ForEach2Expression(), ecorePackage.getEString(), "forEach2Expression", null, 0, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_FragmentInstance1NameExpression(), ecorePackage.getEString(), "fragmentInstance1NameExpression", null, 1, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_FragmentInstance2NameExpression(), ecorePackage.getEString(), "fragmentInstance2NameExpression", null, 1, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_PortInstance1NameExpression(), ecorePackage.getEString(), "portInstance1NameExpression", null, 0, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getCompositionAssociation2CompositionLinkBinding_PortInstance2NameExpression(), ecorePackage.getEString(), "portInstance2NameExpression", null, 0, 1, CompositionAssociation2CompositionLinkBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(compositionAssociation2CompositionLinkBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionAssociationBindingEClass, CompositionAssociationBinding.class, "CompositionAssociationBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionAssociationBinding_CompositionAssociation(), theFracolPackage.getCompositionAssociation(), null, "compositionAssociation", null, 1, 1, CompositionAssociationBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(compositionAssociationBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionLanguageSpecificationEClass, CompositionLanguageSpecification.class, "CompositionLanguageSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionLanguageSpecification_CompositionAssociationBindings(), this.getCompositionAssociation2CompositionLinkBinding(), this.getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification(), "compositionAssociationBindings", null, 0, -1, CompositionLanguageSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionLanguageSpecification_CompositionProgramPhysicalLocationExpression(), ecorePackage.getEString(), "compositionProgramPhysicalLocationExpression", null, 0, 1, CompositionLanguageSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCompositionLanguageSpecification_FragmentRoleBindings(), this.getFragmentRole2FragmentInstanceBinding(), this.getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification(), "fragmentRoleBindings", null, 0, -1, CompositionLanguageSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionLanguageSpecification_UcpiExpression(), ecorePackage.getEString(), "ucpiExpression", null, 1, 1, CompositionLanguageSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(compositionLanguageSpecificationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionLanguageSyntaxSpecificationEClass, CompositionLanguageSyntaxSpecification.class, "CompositionLanguageSyntaxSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionLanguageSyntaxSpecification_FragmentRoleBindings(), this.getFragmentRole2SyntaxBinding(), this.getFragmentRole2SyntaxBinding_CompositionLanguageSyntax(), "fragmentRoleBindings", null, 0, -1, CompositionLanguageSyntaxSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(compositionLanguageSyntaxSpecificationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRole2FragmentBindingEClass, FragmentRole2FragmentBinding.class, "FragmentRole2FragmentBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentRole2FragmentBinding_ComponentModelSpecification(), this.getComponentModelSpecification(), this.getComponentModelSpecification_FragmentRoleBindings(), "componentModelSpecification", null, 0, 1, FragmentRole2FragmentBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole2FragmentBinding_IsExpression(), ecorePackage.getEString(), "isExpression", null, 0, 1, FragmentRole2FragmentBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentRole2FragmentBinding_PortTypeBindings(), this.getPortType2PortBinding(), this.getPortType2PortBinding_FragmentRoleBinding(), "portTypeBindings", null, 0, -1, FragmentRole2FragmentBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(fragmentRole2FragmentBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRole2FragmentInstanceBindingEClass, FragmentRole2FragmentInstanceBinding.class, "FragmentRole2FragmentInstanceBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification(), this.getCompositionLanguageSpecification(), this.getCompositionLanguageSpecification_FragmentRoleBindings(), "compositionLanguageSpecification", null, 0, 1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole2FragmentInstanceBinding_NameExpression(), ecorePackage.getEString(), "nameExpression", null, 1, 1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentRole2FragmentInstanceBinding_PortTypeBindings(), this.getPortType2SettingBinding(), this.getPortType2SettingBinding_FragmentRoleBinding(), "portTypeBindings", null, 0, -1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole2FragmentInstanceBinding_TargetPhysicalLocationExpression(), ecorePackage.getEString(), "targetPhysicalLocationExpression", null, 0, 1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentRole2FragmentInstanceBinding_TargetUfiExpression(), ecorePackage.getEString(), "targetUfiExpression", null, 0, 1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentRole2FragmentInstanceBinding_UfiExpression(), ecorePackage.getEString(), "ufiExpression", null, 1, 1, FragmentRole2FragmentInstanceBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(fragmentRole2FragmentInstanceBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRole2FragmentReferenceBindingEClass, FragmentRole2FragmentReferenceBinding.class, "FragmentRole2FragmentReferenceBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(fragmentRole2FragmentReferenceBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRole2SyntaxBindingEClass, FragmentRole2SyntaxBinding.class, "FragmentRole2SyntaxBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentRole2SyntaxBinding_CompositionLanguageSyntax(), this.getCompositionLanguageSyntaxSpecification(), this.getCompositionLanguageSyntaxSpecification_FragmentRoleBindings(), "compositionLanguageSyntax", null, 0, 1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole2SyntaxBinding_NameExpression(), ecorePackage.getEString(), "nameExpression", null, 0, 1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentRole2SyntaxBinding_PortTypeBindings(), this.getPortType2SyntaxBinding(), this.getPortType2SyntaxBinding_FragmentRole2SyntaxBinding(), "portTypeBindings", null, 0, -1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole2SyntaxBinding_TargetPhysicalLocationExpression(), ecorePackage.getEString(), "targetPhysicalLocationExpression", null, 0, 1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentRole2SyntaxBinding_TargetUfiExpression(), ecorePackage.getEString(), "targetUfiExpression", null, 0, 1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentRole2SyntaxBinding_UfiExpression(), ecorePackage.getEString(), "ufiExpression", null, 0, 1, FragmentRole2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(fragmentRole2SyntaxBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRoleBindingEClass, FragmentRoleBinding.class, "FragmentRoleBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentRoleBinding_FragmentRole(), theFracolPackage.getFragmentRole(), null, "fragmentRole", null, 1, 1, FragmentRoleBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(fragmentRoleBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(hookDerivationRuleEClass, HookDerivationRule.class, "HookDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(hookDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portType2HeterogeneousPortBindingEClass, PortType2HeterogeneousPortBinding.class, "PortType2HeterogeneousPortBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(portType2HeterogeneousPortBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portType2HomogenousPortBindingEClass, PortType2HomogenousPortBinding.class, "PortType2HomogenousPortBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(portType2HomogenousPortBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portType2PortBindingEClass, PortType2PortBinding.class, "PortType2PortBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPortType2PortBinding_DerivationRules(), this.getAddressablePointDerivationRule(), this.getAddressablePointDerivationRule_PortTypeBinding(), "derivationRules", null, 0, -1, PortType2PortBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortType2PortBinding_FragmentRoleBinding(), this.getFragmentRole2FragmentBinding(), this.getFragmentRole2FragmentBinding_PortTypeBindings(), "fragmentRoleBinding", null, 0, 1, PortType2PortBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(portType2PortBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portType2SettingBindingEClass, PortType2SettingBinding.class, "PortType2SettingBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPortType2SettingBinding_DerivationRules(), this.getSettingDerivationRule(), this.getSettingDerivationRule_PortTypeBinding(), "derivationRules", null, 0, -1, PortType2SettingBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortType2SettingBinding_FragmentRoleBinding(), this.getFragmentRole2FragmentInstanceBinding(), this.getFragmentRole2FragmentInstanceBinding_PortTypeBindings(), "fragmentRoleBinding", null, 0, 1, PortType2SettingBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(portType2SettingBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portType2SyntaxBindingEClass, PortType2SyntaxBinding.class, "PortType2SyntaxBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPortType2SyntaxBinding_FragmentRole2SyntaxBinding(), this.getFragmentRole2SyntaxBinding(), this.getFragmentRole2SyntaxBinding_PortTypeBindings(), "fragmentRole2SyntaxBinding", null, 0, 1, PortType2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getPortType2SyntaxBinding_LabelExpression(), ecorePackage.getEString(), "labelExpression", null, 0, 1, PortType2SyntaxBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(portType2SyntaxBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portTypeBindingEClass, PortTypeBinding.class, "PortTypeBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPortTypeBinding_PortType(), theFracolPackage.getPortType(), null, "portType", null, 1, 1, PortTypeBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(portTypeBindingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(prototypeDerivationRuleEClass, PrototypeDerivationRule.class, "PrototypeDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(prototypeDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(referencePointDerivationRuleEClass, ReferencePointDerivationRule.class, "ReferencePointDerivationRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(referencePointDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(reuseExtensionEClass, ReuseExtension.class, "ReuseExtension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getReuseExtension_EPackages(), theEcorePackage.getEPackage(), null, "ePackages", null, 0, -1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getReuseExtension_FracolNamespace(), ecorePackage.getEString(), "fracolNamespace", null, 0, -1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getReuseExtension_Fracol(), theFracolPackage.getFragmentCollaboration(), null, "fracol", null, 1, 1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getReuseExtension_Parameters(), ecorePackage.getEString(), "parameters", null, 0, -1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getReuseExtension_RexName(), ecorePackage.getEString(), "rexName", null, 1, 1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getReuseExtension_RexNamespace(), ecorePackage.getEString(), "rexNamespace", null, 0, -1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getReuseExtension_RootElementContexts(), this.getRootElementContext(), this.getRootElementContext_ReuseExtension(), "rootElementContexts", null, 0, -1, ReuseExtension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(reuseExtensionEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(rootElementContextEClass, RootElementContext.class, "RootElementContext", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getRootElementContext_ReuseExtension(), this.getReuseExtension(), this.getReuseExtension_RootElementContexts(), "reuseExtension", null, 0, 1, RootElementContext.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(rootElementContextEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(ruleContextEClass, RuleContext.class, "RuleContext", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getRuleContext_EBoundClass(), theEcorePackage.getEClass(), null, "eBoundClass", null, 1, 1, RuleContext.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getRuleContext_EBoundFeature(), theEcorePackage.getEStructuralFeature(), null, "eBoundFeature", null, 0, 1, RuleContext.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getRuleContext_IsExpression(), ecorePackage.getEString(), "isExpression", null, 0, 1, RuleContext.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(ruleContextEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(settingDerivationRuleEClass, SettingDerivationRule.class, "SettingDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getSettingDerivationRule_PortTypeBinding(), this.getPortType2SettingBinding(), this.getPortType2SettingBinding_DerivationRules(), "portTypeBinding", null, 0, 1, SettingDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getSettingDerivationRule_PropertyExpression(), ecorePackage.getEString(), "propertyExpression", null, 1, 1, SettingDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSettingDerivationRule_ValueExpression(), ecorePackage.getEString(), "valueExpression", null, 1, 1, SettingDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(settingDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(slotDerivationRuleEClass, SlotDerivationRule.class, "SlotDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(slotDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(syntaxDerivationRuleEClass, SyntaxDerivationRule.class, "SyntaxDerivationRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getSyntaxDerivationRule_HeightExpression(), ecorePackage.getEString(), "heightExpression", null, 0, 1, SyntaxDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSyntaxDerivationRule_IconExpression(), ecorePackage.getEString(), "iconExpression", null, 0, 1, SyntaxDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSyntaxDerivationRule_VisibleExpression(), ecorePackage.getEString(), "visibleExpression", null, 0, 1, SyntaxDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSyntaxDerivationRule_WidthExpression(), ecorePackage.getEString(), "widthExpression", null, 0, 1, SyntaxDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(syntaxDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(valueHookDerivationRuleEClass, ValueHookDerivationRule.class, "ValueHookDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getValueHookDerivationRule_BeginIndexExpression(), ecorePackage.getEString(), "beginIndexExpression", null, 0, 1, ValueHookDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getValueHookDerivationRule_EndIndexExpression(), ecorePackage.getEString(), "endIndexExpression", null, 0, 1, ValueHookDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getValueHookDerivationRule_ListIndexExpression(), ecorePackage.getEString(), "listIndexExpression", null, 0, 1, ValueHookDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(valueHookDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(valuePrototypeDerivationRuleEClass, ValuePrototypeDerivationRule.class, "ValuePrototypeDerivationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getValuePrototypeDerivationRule_ValueExpression(), ecorePackage.getEString(), "valueExpression", null, 1, 1, ValuePrototypeDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(valuePrototypeDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(variationPointDerivationRuleEClass, VariationPointDerivationRule.class, "VariationPointDerivationRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getVariationPointDerivationRule_ModeExpression(), ecorePackage.getEString(), "modeExpression", null, 0, 1, VariationPointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVariationPointDerivationRule_RemoveExpression(), ecorePackage.getEString(), "removeExpression", null, 0, 1, VariationPointDerivationRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(variationPointDerivationRuleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // http://www.eclipse.org/emf/2002/Ecore
    createEcoreAnnotations();
  }

  /**
   * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createEcoreAnnotations()
  {
    String source = "http://www.eclipse.org/emf/2002/Ecore";		
    addAnnotation
      (anchorDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "NotDefinedForContainmentReference"
       });		
    addAnnotation
      (compositionAssociation2CompositionLinkBindingEClass, 
       source, 
       new String[] 
       {
       "constraints", "NameExpressionsSet"
       });		
    addAnnotation
      (hookDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "NotDefinedForCrossReference"
       });		
    addAnnotation
      (prototypeDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "NotDefinedForCrossReference"
       });		
    addAnnotation
      (ruleContextEClass, 
       source, 
       new String[] 
       {
       "constraints", "AllExpressions"
       });		
    addAnnotation
      (slotDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "NotDefinedForContainmentReference"
       });		
    addAnnotation
      (syntaxDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "AllExpressions"
       });		
    addAnnotation
      (valueHookDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "DefinedForAttribute"
       });		
    addAnnotation
      (valuePrototypeDerivationRuleEClass, 
       source, 
       new String[] 
       {
       "constraints", "NotDefinedForReference"
       });
  }

} //ReuseextensionPackageImpl
