/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.reuseextension.PortType2SettingBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.SettingDerivationRule;




/**
 * @generated
 **/
public class SettingDerivationRuleImpl extends EObjectImpl implements SettingDerivationRule
{


   /**
   * The default value of the '{@link #getPropertyExpression() <em>Property Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPropertyExpression()
   * @generated
   * @ordered
   */
  protected static final String PROPERTY_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getPropertyExpression() <em>Property Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPropertyExpression()
   * @generated
   * @ordered
   */
  protected String propertyExpression = PROPERTY_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getValueExpression() <em>Value Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueExpression()
   * @generated
   * @ordered
   */
  protected static final String VALUE_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getValueExpression() <em>Value Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueExpression()
   * @generated
   * @ordered
   */
  protected String valueExpression = VALUE_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SettingDerivationRuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.SETTING_DERIVATION_RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2SettingBinding getPortTypeBinding()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING) return null;
    return (PortType2SettingBinding)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetPortTypeBinding(PortType2SettingBinding newPortTypeBinding, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newPortTypeBinding, ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortTypeBinding(PortType2SettingBinding newPortTypeBinding)
  {
    if (newPortTypeBinding != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING && newPortTypeBinding != null))
    {
      if (EcoreUtil.isAncestor(this, newPortTypeBinding))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newPortTypeBinding != null)
        msgs = ((InternalEObject)newPortTypeBinding).eInverseAdd(this, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES, PortType2SettingBinding.class, msgs);
      msgs = basicSetPortTypeBinding(newPortTypeBinding, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING, newPortTypeBinding, newPortTypeBinding));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPropertyExpression()
  {
    return propertyExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPropertyExpression(String newPropertyExpression)
  {
    String oldPropertyExpression = propertyExpression;
    propertyExpression = newPropertyExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION, oldPropertyExpression, propertyExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getValueExpression()
  {
    return valueExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValueExpression(String newValueExpression)
  {
    String oldValueExpression = valueExpression;
    valueExpression = newValueExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SETTING_DERIVATION_RULE__VALUE_EXPRESSION, oldValueExpression, valueExpression));
  }

  public void removeYou()
   {
      this.setPortTypeBinding (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetPortTypeBinding((PortType2SettingBinding)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        return basicSetPortTypeBinding(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES, PortType2SettingBinding.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        return getPortTypeBinding();
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION:
        return getPropertyExpression();
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__VALUE_EXPRESSION:
        return getValueExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2SettingBinding)newValue);
        return;
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION:
        setPropertyExpression((String)newValue);
        return;
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__VALUE_EXPRESSION:
        setValueExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2SettingBinding)null);
        return;
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION:
        setPropertyExpression(PROPERTY_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__VALUE_EXPRESSION:
        setValueExpression(VALUE_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING:
        return getPortTypeBinding() != null;
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__PROPERTY_EXPRESSION:
        return PROPERTY_EXPRESSION_EDEFAULT == null ? propertyExpression != null : !PROPERTY_EXPRESSION_EDEFAULT.equals(propertyExpression);
      case ReuseextensionPackage.SETTING_DERIVATION_RULE__VALUE_EXPRESSION:
        return VALUE_EXPRESSION_EDEFAULT == null ? valueExpression != null : !VALUE_EXPRESSION_EDEFAULT.equals(valueExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (propertyExpression: ");
    result.append(propertyExpression);
    result.append(", valueExpression: ");
    result.append(valueExpression);
    result.append(')');
    return result.toString();
  }
}


