/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.SyntaxDerivationRule;




/**
 * @generated
 **/
public abstract class SyntaxDerivationRuleImpl extends EObjectImpl implements SyntaxDerivationRule
{


   /**
   * The default value of the '{@link #getHeightExpression() <em>Height Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeightExpression()
   * @generated
   * @ordered
   */
  protected static final String HEIGHT_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getHeightExpression() <em>Height Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeightExpression()
   * @generated
   * @ordered
   */
  protected String heightExpression = HEIGHT_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getIconExpression() <em>Icon Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIconExpression()
   * @generated
   * @ordered
   */
  protected static final String ICON_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIconExpression() <em>Icon Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIconExpression()
   * @generated
   * @ordered
   */
  protected String iconExpression = ICON_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getVisibleExpression() <em>Visible Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVisibleExpression()
   * @generated
   * @ordered
   */
  protected static final String VISIBLE_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getVisibleExpression() <em>Visible Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVisibleExpression()
   * @generated
   * @ordered
   */
  protected String visibleExpression = VISIBLE_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getWidthExpression() <em>Width Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidthExpression()
   * @generated
   * @ordered
   */
  protected static final String WIDTH_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getWidthExpression() <em>Width Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidthExpression()
   * @generated
   * @ordered
   */
  protected String widthExpression = WIDTH_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SyntaxDerivationRuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.SYNTAX_DERIVATION_RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getHeightExpression()
  {
    return heightExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHeightExpression(String newHeightExpression)
  {
    String oldHeightExpression = heightExpression;
    heightExpression = newHeightExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION, oldHeightExpression, heightExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIconExpression()
  {
    return iconExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIconExpression(String newIconExpression)
  {
    String oldIconExpression = iconExpression;
    iconExpression = newIconExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION, oldIconExpression, iconExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getVisibleExpression()
  {
    return visibleExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVisibleExpression(String newVisibleExpression)
  {
    String oldVisibleExpression = visibleExpression;
    visibleExpression = newVisibleExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION, oldVisibleExpression, visibleExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getWidthExpression()
  {
    return widthExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setWidthExpression(String newWidthExpression)
  {
    String oldWidthExpression = widthExpression;
    widthExpression = newWidthExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION, oldWidthExpression, widthExpression));
  }

  public void removeYou()
   {
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION:
        return getHeightExpression();
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION:
        return getIconExpression();
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION:
        return getVisibleExpression();
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION:
        return getWidthExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION:
        setHeightExpression((String)newValue);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION:
        setIconExpression((String)newValue);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION:
        setVisibleExpression((String)newValue);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION:
        setWidthExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION:
        setHeightExpression(HEIGHT_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION:
        setIconExpression(ICON_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION:
        setVisibleExpression(VISIBLE_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION:
        setWidthExpression(WIDTH_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__HEIGHT_EXPRESSION:
        return HEIGHT_EXPRESSION_EDEFAULT == null ? heightExpression != null : !HEIGHT_EXPRESSION_EDEFAULT.equals(heightExpression);
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__ICON_EXPRESSION:
        return ICON_EXPRESSION_EDEFAULT == null ? iconExpression != null : !ICON_EXPRESSION_EDEFAULT.equals(iconExpression);
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__VISIBLE_EXPRESSION:
        return VISIBLE_EXPRESSION_EDEFAULT == null ? visibleExpression != null : !VISIBLE_EXPRESSION_EDEFAULT.equals(visibleExpression);
      case ReuseextensionPackage.SYNTAX_DERIVATION_RULE__WIDTH_EXPRESSION:
        return WIDTH_EXPRESSION_EDEFAULT == null ? widthExpression != null : !WIDTH_EXPRESSION_EDEFAULT.equals(widthExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (heightExpression: ");
    result.append(heightExpression);
    result.append(", iconExpression: ");
    result.append(iconExpression);
    result.append(", visibleExpression: ");
    result.append(visibleExpression);
    result.append(", widthExpression: ");
    result.append(widthExpression);
    result.append(')');
    return result.toString();
  }
}


