/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.ValueHookDerivationRule;




/**
 * @generated
 **/
public class ValueHookDerivationRuleImpl extends VariationPointDerivationRuleImpl implements ValueHookDerivationRule
{

  /**
   * The default value of the '{@link #getBeginIndexExpression() <em>Begin Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBeginIndexExpression()
   * @generated
   * @ordered
   */
  protected static final String BEGIN_INDEX_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getBeginIndexExpression() <em>Begin Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBeginIndexExpression()
   * @generated
   * @ordered
   */
  protected String beginIndexExpression = BEGIN_INDEX_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getEndIndexExpression() <em>End Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEndIndexExpression()
   * @generated
   * @ordered
   */
  protected static final String END_INDEX_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getEndIndexExpression() <em>End Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEndIndexExpression()
   * @generated
   * @ordered
   */
  protected String endIndexExpression = END_INDEX_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getListIndexExpression() <em>List Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getListIndexExpression()
   * @generated
   * @ordered
   */
  protected static final String LIST_INDEX_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getListIndexExpression() <em>List Index Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getListIndexExpression()
   * @generated
   * @ordered
   */
  protected String listIndexExpression = LIST_INDEX_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ValueHookDerivationRuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.VALUE_HOOK_DERIVATION_RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getBeginIndexExpression()
  {
    return beginIndexExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBeginIndexExpression(String newBeginIndexExpression)
  {
    String oldBeginIndexExpression = beginIndexExpression;
    beginIndexExpression = newBeginIndexExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION, oldBeginIndexExpression, beginIndexExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getEndIndexExpression()
  {
    return endIndexExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEndIndexExpression(String newEndIndexExpression)
  {
    String oldEndIndexExpression = endIndexExpression;
    endIndexExpression = newEndIndexExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION, oldEndIndexExpression, endIndexExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getListIndexExpression()
  {
    return listIndexExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setListIndexExpression(String newListIndexExpression)
  {
    String oldListIndexExpression = listIndexExpression;
    listIndexExpression = newListIndexExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION, oldListIndexExpression, listIndexExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION:
        return getBeginIndexExpression();
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION:
        return getEndIndexExpression();
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION:
        return getListIndexExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION:
        setBeginIndexExpression((String)newValue);
        return;
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION:
        setEndIndexExpression((String)newValue);
        return;
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION:
        setListIndexExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION:
        setBeginIndexExpression(BEGIN_INDEX_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION:
        setEndIndexExpression(END_INDEX_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION:
        setListIndexExpression(LIST_INDEX_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__BEGIN_INDEX_EXPRESSION:
        return BEGIN_INDEX_EXPRESSION_EDEFAULT == null ? beginIndexExpression != null : !BEGIN_INDEX_EXPRESSION_EDEFAULT.equals(beginIndexExpression);
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__END_INDEX_EXPRESSION:
        return END_INDEX_EXPRESSION_EDEFAULT == null ? endIndexExpression != null : !END_INDEX_EXPRESSION_EDEFAULT.equals(endIndexExpression);
      case ReuseextensionPackage.VALUE_HOOK_DERIVATION_RULE__LIST_INDEX_EXPRESSION:
        return LIST_INDEX_EXPRESSION_EDEFAULT == null ? listIndexExpression != null : !LIST_INDEX_EXPRESSION_EDEFAULT.equals(listIndexExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (beginIndexExpression: ");
    result.append(beginIndexExpression);
    result.append(", endIndexExpression: ");
    result.append(endIndexExpression);
    result.append(", listIndexExpression: ");
    result.append(listIndexExpression);
    result.append(')');
    return result.toString();
  }


}


