/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.VariationPointDerivationRule;




/**
 * @generated
 **/
public abstract class VariationPointDerivationRuleImpl extends AddressablePointDerivationRuleImpl implements VariationPointDerivationRule
{

  /**
   * The default value of the '{@link #getModeExpression() <em>Mode Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getModeExpression()
   * @generated
   * @ordered
   */
  protected static final String MODE_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getModeExpression() <em>Mode Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getModeExpression()
   * @generated
   * @ordered
   */
  protected String modeExpression = MODE_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getRemoveExpression() <em>Remove Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRemoveExpression()
   * @generated
   * @ordered
   */
  protected static final String REMOVE_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getRemoveExpression() <em>Remove Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRemoveExpression()
   * @generated
   * @ordered
   */
  protected String removeExpression = REMOVE_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected VariationPointDerivationRuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.VARIATION_POINT_DERIVATION_RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getModeExpression()
  {
    return modeExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setModeExpression(String newModeExpression)
  {
    String oldModeExpression = modeExpression;
    modeExpression = newModeExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION, oldModeExpression, modeExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRemoveExpression()
  {
    return removeExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRemoveExpression(String newRemoveExpression)
  {
    String oldRemoveExpression = removeExpression;
    removeExpression = newRemoveExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION, oldRemoveExpression, removeExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION:
        return getModeExpression();
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION:
        return getRemoveExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION:
        setModeExpression((String)newValue);
        return;
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION:
        setRemoveExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION:
        setModeExpression(MODE_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION:
        setRemoveExpression(REMOVE_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__MODE_EXPRESSION:
        return MODE_EXPRESSION_EDEFAULT == null ? modeExpression != null : !MODE_EXPRESSION_EDEFAULT.equals(modeExpression);
      case ReuseextensionPackage.VARIATION_POINT_DERIVATION_RULE__REMOVE_EXPRESSION:
        return REMOVE_EXPRESSION_EDEFAULT == null ? removeExpression != null : !REMOVE_EXPRESSION_EDEFAULT.equals(removeExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (modeExpression: ");
    result.append(modeExpression);
    result.append(", removeExpression: ");
    result.append(removeExpression);
    result.append(')');
    return result.toString();
  }


}


