/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

public class RexNewFileContentProvider {
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexMetaInformation getMetaInformation() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexMetaInformation();
	}
	
	public String getNewFileContent(String newFileName) {
		return getExampleContent(new org.eclipse.emf.ecore.EClass[] {
			org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getComponentModelSpecification(),
			org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getCompositionLanguageSyntaxSpecification(),
			org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getCompositionLanguageSpecification(),
		}, getMetaInformation().getClassesWithSyntax(), newFileName);
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass[] startClasses, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		String content = "componentmodel org.reuseware.lib.examples.umlweaving\nimplements org.reuseware.lib.systems.default\nepackages <http://www.eclipse.org/uml2/3.0.0/UML> \nrootclass Model {\n\n\t// Core\n\tfragment role Default if $not name.startsWith('advice')$ {\n\t\tport type Rec {\n\t\t\tuml::Class.ownedOperation is hook {\n\t\t\t\tport = $self.name$\n\t\t\t}\n  \t\t\tuml::Class.ownedAttribute is hook {\n\t\t\t\tport = $self.name$\n\t\t\t}\n\t\t\tuml::Package.packagedElement is hook if $self.oclIsTypeOf(uml::Package)$ {\n \t\t\t\tforeach $packagedElement->select(c | c.oclIsTypeOf(uml::Class))$\n \t\t\t\t\tport = $self.name$ \n \t\t\t}\n  \t\t\tuml::Class is anchor {\n\t\t\t\tport = $self.name$\n  \t\t\t}\n\t\t}\n\t}\n\t\n\t// Aspect\n\tfragment role Default if $name.startsWith('advice')$ { \n\t\tport type Contrib {\n  \t\t\tuml::Operation is prototype if $owner.oclIsTypeOf(uml::Class)$ {\n\t\t\t\tport = $self.owner.oclAsType(uml::Class).name$ \n\t\t\t}\n  \t\t\tuml::Property is prototype if $owner.oclIsTypeOf(uml::Class)$ {\n\t\t\t\tport = $self.owner.oclAsType(uml::Class).name$ \n\t\t\t}\n\t\t\tuml::Association is prototype {\n\t\t\t\tport = $self.ownedEnd->at(1).type.name$\n\t\t\t}\n  \t\t\tuml::Class is slot {\n\t\t\t\tport = $self.name$\n  \t\t\t}\n\t\t}\n\t}\n}".replace("\n", System.getProperty("line.separator"));
		return content;
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass eClass, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		// create a minimal model
		org.eclipse.emf.ecore.EObject root = new org.reuseware.coconut.reuseextension.resource.rex.util.RexMinimalModelHelper().getMinimalModel(eClass, allClassesWithSyntax, newFileName);
		if (root == null) {
			// could not create a minimal model. returning an empty document is the best we
			// can do.
			return "";
		}
		// use printer to get text for model
		java.io.ByteArrayOutputStream buffer = new java.io.ByteArrayOutputStream();
		org.reuseware.coconut.reuseextension.resource.rex.IRexTextPrinter printer = getPrinter(buffer);
		try {
			printer.print(root);
		} catch (java.io.IOException e) {
			new org.reuseware.coconut.reuseextension.resource.rex.util.RexRuntimeUtil().logError("Exception while generating example content.", e);
		}
		return buffer.toString();
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTextPrinter getPrinter(java.io.OutputStream outputStream) {
		return getMetaInformation().createPrinter(outputStream, new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexResource());
	}
	
}
