/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

public class RexProblem implements org.reuseware.coconut.reuseextension.resource.rex.IRexProblem {
	
	private String message;
	private org.reuseware.coconut.reuseextension.resource.rex.RexEProblemType type;
	private org.reuseware.coconut.reuseextension.resource.rex.RexEProblemSeverity severity;
	private java.util.Collection<org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix> quickFixes;
	
	public RexProblem(String message, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemType type, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix>emptySet());
	}
	
	public RexProblem(String message, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemType type, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemSeverity severity, org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public RexProblem(String message, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemType type, org.reuseware.coconut.reuseextension.resource.rex.RexEProblemSeverity severity, java.util.Collection<org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.RexEProblemType getType() {
		return type;
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.RexEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.reuseware.coconut.reuseextension.resource.rex.IRexQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
