/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

public class RexReferenceResolverSwitch implements org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolverSwitch {
	
	/**
	 * This map stores a copy of the options the were set for loading the resource.
	 */
	private java.util.Map<Object, Object> options;
	
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.ReuseExtensionFracolReferenceResolver reuseExtensionFracolReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.ReuseExtensionFracolReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.ReuseExtensionEPackagesReferenceResolver reuseExtensionEPackagesReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.ReuseExtensionEPackagesReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.RuleContextEBoundClassReferenceResolver ruleContextEBoundClassReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.RuleContextEBoundClassReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.FragmentRoleBindingFragmentRoleReferenceResolver fragmentRoleBindingFragmentRoleReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.FragmentRoleBindingFragmentRoleReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.PortTypeBindingPortTypeReferenceResolver portTypeBindingPortTypeReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.PortTypeBindingPortTypeReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.CompositionAssociationBindingCompositionAssociationReferenceResolver compositionAssociationBindingCompositionAssociationReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.CompositionAssociationBindingCompositionAssociationReferenceResolver();
	protected org.reuseware.coconut.reuseextension.resource.rex.analysis.RuleContextEBoundFeatureReferenceResolver ruleContextEBoundFeatureReferenceResolver = new org.reuseware.coconut.reuseextension.resource.rex.analysis.RuleContextEBoundFeatureReferenceResolver();
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.ReuseExtension, org.reuseware.coconut.fracol.FragmentCollaboration> getReuseExtensionFracolReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension_Fracol(), reuseExtensionFracolReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.ReuseExtension, org.eclipse.emf.ecore.EPackage> getReuseExtensionEPackagesReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension_EPackages(), reuseExtensionEPackagesReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.RuleContext, org.eclipse.emf.ecore.EClass> getRuleContextEBoundClassReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext_EBoundClass(), ruleContextEBoundClassReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.FragmentRoleBinding, org.reuseware.coconut.fracol.FragmentRole> getFragmentRoleBindingFragmentRoleReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getFragmentRoleBinding_FragmentRole(), fragmentRoleBindingFragmentRoleReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.PortTypeBinding, org.reuseware.coconut.fracol.PortType> getPortTypeBindingPortTypeReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getPortTypeBinding_PortType(), portTypeBindingPortTypeReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.CompositionAssociationBinding, org.reuseware.coconut.fracol.CompositionAssociation> getCompositionAssociationBindingCompositionAssociationReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getCompositionAssociationBinding_CompositionAssociation(), compositionAssociationBindingCompositionAssociationReferenceResolver);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<org.reuseware.coconut.reuseextension.RuleContext, org.eclipse.emf.ecore.EStructuralFeature> getRuleContextEBoundFeatureReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext_EBoundFeature(), ruleContextEBoundFeatureReferenceResolver);
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		if (options != null) {
			this.options = new java.util.LinkedHashMap<Object, Object>();
			this.options.putAll(options);
		}
		reuseExtensionFracolReferenceResolver.setOptions(options);
		reuseExtensionEPackagesReferenceResolver.setOptions(options);
		ruleContextEBoundClassReferenceResolver.setOptions(options);
		fragmentRoleBindingFragmentRoleReferenceResolver.setOptions(options);
		portTypeBindingPortTypeReferenceResolver.setOptions(options);
		compositionAssociationBindingCompositionAssociationReferenceResolver.setOptions(options);
		ruleContextEBoundFeatureReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension().isInstance(container)) {
			RexFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentCollaboration> frr = new RexFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentCollaboration>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("fracol")) {
				reuseExtensionFracolReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.ReuseExtension) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension().isInstance(container)) {
			RexFuzzyResolveResult<org.eclipse.emf.ecore.EPackage> frr = new RexFuzzyResolveResult<org.eclipse.emf.ecore.EPackage>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("ePackages")) {
				reuseExtensionEPackagesReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.ReuseExtension) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext().isInstance(container)) {
			RexFuzzyResolveResult<org.eclipse.emf.ecore.EClass> frr = new RexFuzzyResolveResult<org.eclipse.emf.ecore.EClass>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("eBoundClass")) {
				ruleContextEBoundClassReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.RuleContext) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getFragmentRoleBinding().isInstance(container)) {
			RexFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole> frr = new RexFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("fragmentRole")) {
				fragmentRoleBindingFragmentRoleReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.FragmentRoleBinding) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getPortTypeBinding().isInstance(container)) {
			RexFuzzyResolveResult<org.reuseware.coconut.fracol.PortType> frr = new RexFuzzyResolveResult<org.reuseware.coconut.fracol.PortType>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("portType")) {
				portTypeBindingPortTypeReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.PortTypeBinding) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getCompositionAssociationBinding().isInstance(container)) {
			RexFuzzyResolveResult<org.reuseware.coconut.fracol.CompositionAssociation> frr = new RexFuzzyResolveResult<org.reuseware.coconut.fracol.CompositionAssociation>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("compositionAssociation")) {
				compositionAssociationBindingCompositionAssociationReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.CompositionAssociationBinding) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext().isInstance(container)) {
			RexFuzzyResolveResult<org.eclipse.emf.ecore.EStructuralFeature> frr = new RexFuzzyResolveResult<org.eclipse.emf.ecore.EStructuralFeature>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("eBoundFeature")) {
				ruleContextEBoundFeatureReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextension.RuleContext) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension_Fracol()) {
			return getResolverChain(reference, reuseExtensionFracolReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getReuseExtension_EPackages()) {
			return getResolverChain(reference, reuseExtensionEPackagesReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext_EBoundClass()) {
			return getResolverChain(reference, ruleContextEBoundClassReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getFragmentRoleBinding_FragmentRole()) {
			return getResolverChain(reference, fragmentRoleBindingFragmentRoleReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getPortTypeBinding_PortType()) {
			return getResolverChain(reference, portTypeBindingPortTypeReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getCompositionAssociationBinding_CompositionAssociation()) {
			return getResolverChain(reference, compositionAssociationBindingCompositionAssociationReferenceResolver);
		}
		if (reference == org.reuseware.coconut.reuseextension.ReuseextensionPackage.eINSTANCE.getRuleContext_EBoundFeature()) {
			return getResolverChain(reference, ruleContextEBoundFeatureReferenceResolver);
		}
		return null;
	}
	
	@SuppressWarnings({"rawtypes", "unchecked"})	
	public <ContainerType extends org.eclipse.emf.ecore.EObject, ReferenceType extends org.eclipse.emf.ecore.EObject> org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<ContainerType, ReferenceType> getResolverChain(org.eclipse.emf.ecore.EStructuralFeature reference, org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver<ContainerType, ReferenceType> originalResolver) {
		if (options == null) {
			return originalResolver;
		}
		Object value = options.get(org.reuseware.coconut.reuseextension.resource.rex.IRexOptions.ADDITIONAL_REFERENCE_RESOLVERS);
		if (value == null) {
			return originalResolver;
		}
		if (!(value instanceof java.util.Map)) {
			// send this to the error log
			new org.reuseware.coconut.reuseextension.resource.rex.util.RexRuntimeUtil().logWarning("Found value with invalid type for option " + org.reuseware.coconut.reuseextension.resource.rex.IRexOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + java.util.Map.class.getName() + ", but was " + value.getClass().getName() + ")", null);
			return originalResolver;
		}
		java.util.Map<?,?> resolverMap = (java.util.Map<?,?>) value;
		Object resolverValue = resolverMap.get(reference);
		if (resolverValue == null) {
			return originalResolver;
		}
		if (resolverValue instanceof org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver) {
			org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver replacingResolver = (org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver) resolverValue;
			if (replacingResolver instanceof org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver) {
				// pass original resolver to the replacing one
				((org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver) replacingResolver).setDelegate(originalResolver);
			}
			return replacingResolver;
		} else if (resolverValue instanceof java.util.Collection) {
			java.util.Collection replacingResolvers = (java.util.Collection) resolverValue;
			org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver replacingResolver = originalResolver;
			for (Object next : replacingResolvers) {
				if (next instanceof org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceCache) {
					org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver nextResolver = (org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolver) next;
					if (nextResolver instanceof org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver) {
						// pass original resolver to the replacing one
						((org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver) nextResolver).setDelegate(replacingResolver);
					}
					replacingResolver = nextResolver;
				} else {
					// The collection contains a non-resolver. Send a warning to the error log.
					new org.reuseware.coconut.reuseextension.resource.rex.util.RexRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.reuseextension.resource.rex.IRexOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver.class.getName() + ", but was " + next.getClass().getName() + ")", null);
				}
			}
			return replacingResolver;
		} else {
			// The value for the option ADDITIONAL_REFERENCE_RESOLVERS has an unknown type.
			new org.reuseware.coconut.reuseextension.resource.rex.util.RexRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.reuseextension.resource.rex.IRexOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.reuseextension.resource.rex.IRexDelegatingReferenceResolver.class.getName() + ", but was " + resolverValue.getClass().getName() + ")", null);
			return originalResolver;
		}
	}
	
}
