/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

public class RexTokenStyleInformationProvider {
	
	public static String TASK_ITEM_TOKEN_NAME = "TASK_ITEM";
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTokenStyle getDefaultTokenStyle(String tokenName) {
		if ("SL_COMMENT".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("ML_COMMENT".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("TEXT".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x00, 0x00, 0x00}, null, false, false, false, false);
		}
		if ("QUOTED_36_36".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x2A, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("componentmodel".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("implements".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("epackages".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("rootclass".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("compositionlanguagesyntax".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("compositionlanguage".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("ucpi".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("location".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("if".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("fragment".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("role".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("port".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("type".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("homo".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("association".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("foreach".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("ufi".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("target".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("reference".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("visible".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("icon".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("width".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("height".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("label".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("is".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("slot".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("mode".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("point".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("remove".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("hook".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("anchor".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("prototype".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("value".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("begin".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("idx".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("end".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("list".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("QUOTED_60_62".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x2A, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("TASK_ITEM".equals(tokenName)) {
			return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyle(new int[] {0x7F, 0x9F, 0xBF}, null, true, false, false, false);
		}
		return null;
	}
	
}
