/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorFactory
 * @model kind="package"
 * @generated
 */
public interface ReuseextensionactivatorPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "reuseextensionactivator";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://reuseware.org/coconut/reuseextensionactivator";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "org.reuseware.coconut.reuseextensionactivator";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ReuseextensionactivatorPackage eINSTANCE = org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl.init();

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ArgumentImpl <em>Argument</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ArgumentImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getArgument()
   * @generated
   */
  int ARGUMENT = 0;

  /**
   * The feature id for the '<em><b>Parameter</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARGUMENT__PARAMETER = 0;

  /**
   * The feature id for the '<em><b>Reuse Extension Activator</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARGUMENT__REUSE_EXTENSION_ACTIVATOR = 1;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARGUMENT__VALUE = 2;

  /**
   * The number of structural features of the '<em>Argument</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARGUMENT_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorImpl <em>Reuse Extension Activator</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getReuseExtensionActivator()
   * @generated
   */
  int REUSE_EXTENSION_ACTIVATOR = 5;

  /**
   * The feature id for the '<em><b>Activator List</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST = 0;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR__ARGUMENTS = 1;

  /**
   * The feature id for the '<em><b>Reuse Extension</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION = 2;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE = 3;

  /**
   * The number of structural features of the '<em>Reuse Extension Activator</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ComponentModelSpecificationActivatorImpl <em>Component Model Specification Activator</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ComponentModelSpecificationActivatorImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getComponentModelSpecificationActivator()
   * @generated
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR = 1;

  /**
   * The feature id for the '<em><b>Activator List</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST = REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ARGUMENTS = REUSE_EXTENSION_ACTIVATOR__ARGUMENTS;

  /**
   * The feature id for the '<em><b>Reuse Extension</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION = REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REX_NAMESPACE = REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE;

  /**
   * The number of structural features of the '<em>Component Model Specification Activator</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_MODEL_SPECIFICATION_ACTIVATOR_FEATURE_COUNT = REUSE_EXTENSION_ACTIVATOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSpecificationActivatorImpl <em>Composition Language Specification Activator</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSpecificationActivatorImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getCompositionLanguageSpecificationActivator()
   * @generated
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR = 2;

  /**
   * The feature id for the '<em><b>Activator List</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST = REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ARGUMENTS = REUSE_EXTENSION_ACTIVATOR__ARGUMENTS;

  /**
   * The feature id for the '<em><b>Reuse Extension</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION = REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REX_NAMESPACE = REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE;

  /**
   * The number of structural features of the '<em>Composition Language Specification Activator</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR_FEATURE_COUNT = REUSE_EXTENSION_ACTIVATOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSyntaxSpecificationActivatorImpl <em>Composition Language Syntax Specification Activator</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSyntaxSpecificationActivatorImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getCompositionLanguageSyntaxSpecificationActivator()
   * @generated
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR = 3;

  /**
   * The feature id for the '<em><b>Activator List</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST = REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST;

  /**
   * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ARGUMENTS = REUSE_EXTENSION_ACTIVATOR__ARGUMENTS;

  /**
   * The feature id for the '<em><b>Reuse Extension</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION = REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION;

  /**
   * The feature id for the '<em><b>Rex Namespace</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REX_NAMESPACE = REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE;

  /**
   * The number of structural features of the '<em>Composition Language Syntax Specification Activator</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR_FEATURE_COUNT = REUSE_EXTENSION_ACTIVATOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorListImpl <em>Reuse Extension Activator List</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorListImpl
   * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getReuseExtensionActivatorList()
   * @generated
   */
  int REUSE_EXTENSION_ACTIVATOR_LIST = 4;

  /**
   * The feature id for the '<em><b>Activators</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS = 0;

  /**
   * The number of structural features of the '<em>Reuse Extension Activator List</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REUSE_EXTENSION_ACTIVATOR_LIST_FEATURE_COUNT = 1;


  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.Argument <em>Argument</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Argument</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.Argument
   * @generated
   */
  EClass getArgument();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getParameter <em>Parameter</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Parameter</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.Argument#getParameter()
   * @see #getArgument()
   * @generated
   */
  EAttribute getArgument_Parameter();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator <em>Reuse Extension Activator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Reuse Extension Activator</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator()
   * @see #getArgument()
   * @generated
   */
  EReference getArgument_ReuseExtensionActivator();

  /**
   * Returns the meta object for the attribute '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.Argument#getValue()
   * @see #getArgument()
   * @generated
   */
  EAttribute getArgument_Value();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator <em>Component Model Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Component Model Specification Activator</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator
   * @generated
   */
  EClass getComponentModelSpecificationActivator();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator <em>Composition Language Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Language Specification Activator</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator
   * @generated
   */
  EClass getCompositionLanguageSpecificationActivator();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator <em>Composition Language Syntax Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Composition Language Syntax Specification Activator</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator
   * @generated
   */
  EClass getCompositionLanguageSyntaxSpecificationActivator();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList <em>Reuse Extension Activator List</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reuse Extension Activator List</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList
   * @generated
   */
  EClass getReuseExtensionActivatorList();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList#getActivators <em>Activators</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Activators</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList#getActivators()
   * @see #getReuseExtensionActivatorList()
   * @generated
   */
  EReference getReuseExtensionActivatorList_Activators();

  /**
   * Returns the meta object for class '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator <em>Reuse Extension Activator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reuse Extension Activator</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator
   * @generated
   */
  EClass getReuseExtensionActivator();

  /**
   * Returns the meta object for the container reference '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getActivatorList <em>Activator List</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Activator List</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getActivatorList()
   * @see #getReuseExtensionActivator()
   * @generated
   */
  EReference getReuseExtensionActivator_ActivatorList();

  /**
   * Returns the meta object for the containment reference list '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getArguments <em>Arguments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Arguments</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getArguments()
   * @see #getReuseExtensionActivator()
   * @generated
   */
  EReference getReuseExtensionActivator_Arguments();

  /**
   * Returns the meta object for the reference '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getReuseExtension <em>Reuse Extension</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Reuse Extension</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getReuseExtension()
   * @see #getReuseExtensionActivator()
   * @generated
   */
  EReference getReuseExtensionActivator_ReuseExtension();

  /**
   * Returns the meta object for the attribute list '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getRexNamespace <em>Rex Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Rex Namespace</em>'.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getRexNamespace()
   * @see #getReuseExtensionActivator()
   * @generated
   */
  EAttribute getReuseExtensionActivator_RexNamespace();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ReuseextensionactivatorFactory getReuseextensionactivatorFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ArgumentImpl <em>Argument</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ArgumentImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getArgument()
     * @generated
     */
    EClass ARGUMENT = eINSTANCE.getArgument();

    /**
     * The meta object literal for the '<em><b>Parameter</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARGUMENT__PARAMETER = eINSTANCE.getArgument_Parameter();

    /**
     * The meta object literal for the '<em><b>Reuse Extension Activator</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARGUMENT__REUSE_EXTENSION_ACTIVATOR = eINSTANCE.getArgument_ReuseExtensionActivator();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARGUMENT__VALUE = eINSTANCE.getArgument_Value();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ComponentModelSpecificationActivatorImpl <em>Component Model Specification Activator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ComponentModelSpecificationActivatorImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getComponentModelSpecificationActivator()
     * @generated
     */
    EClass COMPONENT_MODEL_SPECIFICATION_ACTIVATOR = eINSTANCE.getComponentModelSpecificationActivator();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSpecificationActivatorImpl <em>Composition Language Specification Activator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSpecificationActivatorImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getCompositionLanguageSpecificationActivator()
     * @generated
     */
    EClass COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR = eINSTANCE.getCompositionLanguageSpecificationActivator();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSyntaxSpecificationActivatorImpl <em>Composition Language Syntax Specification Activator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.CompositionLanguageSyntaxSpecificationActivatorImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getCompositionLanguageSyntaxSpecificationActivator()
     * @generated
     */
    EClass COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR = eINSTANCE.getCompositionLanguageSyntaxSpecificationActivator();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorListImpl <em>Reuse Extension Activator List</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorListImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getReuseExtensionActivatorList()
     * @generated
     */
    EClass REUSE_EXTENSION_ACTIVATOR_LIST = eINSTANCE.getReuseExtensionActivatorList();

    /**
     * The meta object literal for the '<em><b>Activators</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS = eINSTANCE.getReuseExtensionActivatorList_Activators();

    /**
     * The meta object literal for the '{@link org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorImpl <em>Reuse Extension Activator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseExtensionActivatorImpl
     * @see org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorPackageImpl#getReuseExtensionActivator()
     * @generated
     */
    EClass REUSE_EXTENSION_ACTIVATOR = eINSTANCE.getReuseExtensionActivator();

    /**
     * The meta object literal for the '<em><b>Activator List</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST = eINSTANCE.getReuseExtensionActivator_ActivatorList();

    /**
     * The meta object literal for the '<em><b>Arguments</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION_ACTIVATOR__ARGUMENTS = eINSTANCE.getReuseExtensionActivator_Arguments();

    /**
     * The meta object literal for the '<em><b>Reuse Extension</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION = eINSTANCE.getReuseExtensionActivator_ReuseExtension();

    /**
     * The meta object literal for the '<em><b>Rex Namespace</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE = eINSTANCE.getReuseExtensionActivator_RexNamespace();

  }

} //ReuseextensionactivatorPackage
