/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextensionactivator.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.ReuseExtension;
import org.reuseware.coconut.reuseextensionactivator.Argument;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList;
import org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage;




/**
 * @generated
 **/
public abstract class ReuseExtensionActivatorImpl extends EObjectImpl implements ReuseExtensionActivator
{


   /**
   * The cached value of the '{@link #getArguments() <em>Arguments</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArguments()
   * @generated
   * @ordered
   */
  protected EList<Argument> arguments;
  /**
   * The cached value of the '{@link #getReuseExtension() <em>Reuse Extension</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getReuseExtension()
   * @generated
   * @ordered
   */
  protected ReuseExtension reuseExtension;
  /**
   * The cached value of the '{@link #getRexNamespace() <em>Rex Namespace</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRexNamespace()
   * @generated
   * @ordered
   */
  protected EList<String> rexNamespace;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ReuseExtensionActivatorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionactivatorPackage.Literals.REUSE_EXTENSION_ACTIVATOR;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseExtensionActivatorList getActivatorList()
  {
    if (eContainerFeatureID() != ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST) return null;
    return (ReuseExtensionActivatorList)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetActivatorList(ReuseExtensionActivatorList newActivatorList, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newActivatorList, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setActivatorList(ReuseExtensionActivatorList newActivatorList)
  {
    if (newActivatorList != eInternalContainer() || (eContainerFeatureID() != ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST && newActivatorList != null))
    {
      if (EcoreUtil.isAncestor(this, newActivatorList))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newActivatorList != null)
        msgs = ((InternalEObject)newActivatorList).eInverseAdd(this, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS, ReuseExtensionActivatorList.class, msgs);
      msgs = basicSetActivatorList(newActivatorList, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST, newActivatorList, newActivatorList));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Argument> getArguments()
  {
    if (arguments == null)
    {
      arguments = new EObjectContainmentWithInverseEList<Argument>(Argument.class, this, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS, ReuseextensionactivatorPackage.ARGUMENT__REUSE_EXTENSION_ACTIVATOR);
    }
    return arguments;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseExtension getReuseExtension()
  {
    if (reuseExtension != null && reuseExtension.eIsProxy())
    {
      InternalEObject oldReuseExtension = (InternalEObject)reuseExtension;
      reuseExtension = (ReuseExtension)eResolveProxy(oldReuseExtension);
      if (reuseExtension != oldReuseExtension)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION, oldReuseExtension, reuseExtension));
      }
    }
    return reuseExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseExtension basicGetReuseExtension()
  {
    return reuseExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setReuseExtension(ReuseExtension newReuseExtension)
  {
    ReuseExtension oldReuseExtension = reuseExtension;
    reuseExtension = newReuseExtension;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION, oldReuseExtension, reuseExtension));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getRexNamespace()
  {
    if (rexNamespace == null)
    {
      rexNamespace = new EDataTypeEList<String>(String.class, this, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE);
    }
    return rexNamespace;
  }

  public void removeYou()
   {
      this.setActivatorList (null);
      this.getArguments().clear();
      this.setReuseExtension (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetActivatorList((ReuseExtensionActivatorList)otherEnd, msgs);
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getArguments()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        return basicSetActivatorList(null, msgs);
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        return ((InternalEList<?>)getArguments()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        return eInternalContainer().eInverseRemove(this, ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS, ReuseExtensionActivatorList.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        return getActivatorList();
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        return getArguments();
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION:
        if (resolve) return getReuseExtension();
        return basicGetReuseExtension();
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE:
        return getRexNamespace();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        setActivatorList((ReuseExtensionActivatorList)newValue);
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        getArguments().clear();
        getArguments().addAll((Collection<? extends Argument>)newValue);
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION:
        setReuseExtension((ReuseExtension)newValue);
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE:
        getRexNamespace().clear();
        getRexNamespace().addAll((Collection<? extends String>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        setActivatorList((ReuseExtensionActivatorList)null);
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        getArguments().clear();
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION:
        setReuseExtension((ReuseExtension)null);
        return;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE:
        getRexNamespace().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST:
        return getActivatorList() != null;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__ARGUMENTS:
        return arguments != null && !arguments.isEmpty();
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION:
        return reuseExtension != null;
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE:
        return rexNamespace != null && !rexNamespace.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (rexNamespace: ");
    result.append(rexNamespace);
    result.append(')');
    return result.toString();
  }
}


