/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.reuseware.coconut.reuseextensionactivator.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ReuseextensionactivatorFactoryImpl extends EFactoryImpl implements ReuseextensionactivatorFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ReuseextensionactivatorFactory init()
  {
    try
    {
      ReuseextensionactivatorFactory theReuseextensionactivatorFactory = (ReuseextensionactivatorFactory)EPackage.Registry.INSTANCE.getEFactory("http://reuseware.org/coconut/reuseextensionactivator"); 
      if (theReuseextensionactivatorFactory != null)
      {
        return theReuseextensionactivatorFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new ReuseextensionactivatorFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionactivatorFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case ReuseextensionactivatorPackage.ARGUMENT: return createArgument();
      case ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR: return createComponentModelSpecificationActivator();
      case ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR: return createCompositionLanguageSpecificationActivator();
      case ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR: return createCompositionLanguageSyntaxSpecificationActivator();
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST: return createReuseExtensionActivatorList();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Argument createArgument()
  {
    ArgumentImpl argument = new ArgumentImpl();
    return argument;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComponentModelSpecificationActivator createComponentModelSpecificationActivator()
  {
    ComponentModelSpecificationActivatorImpl componentModelSpecificationActivator = new ComponentModelSpecificationActivatorImpl();
    return componentModelSpecificationActivator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSpecificationActivator createCompositionLanguageSpecificationActivator()
  {
    CompositionLanguageSpecificationActivatorImpl compositionLanguageSpecificationActivator = new CompositionLanguageSpecificationActivatorImpl();
    return compositionLanguageSpecificationActivator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSyntaxSpecificationActivator createCompositionLanguageSyntaxSpecificationActivator()
  {
    CompositionLanguageSyntaxSpecificationActivatorImpl compositionLanguageSyntaxSpecificationActivator = new CompositionLanguageSyntaxSpecificationActivatorImpl();
    return compositionLanguageSyntaxSpecificationActivator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseExtensionActivatorList createReuseExtensionActivatorList()
  {
    ReuseExtensionActivatorListImpl reuseExtensionActivatorList = new ReuseExtensionActivatorListImpl();
    return reuseExtensionActivatorList;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionactivatorPackage getReuseextensionactivatorPackage()
  {
    return (ReuseextensionactivatorPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static ReuseextensionactivatorPackage getPackage()
  {
    return ReuseextensionactivatorPackage.eINSTANCE;
  }

} //ReuseextensionactivatorFactoryImpl
