/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.reuseware.coconut.reuseextension.ReuseextensionPackage;

import org.reuseware.coconut.reuseextensionactivator.Argument;
import org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator;
import org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator;
import org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList;
import org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorFactory;
import org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage;

import org.reuseware.coconut.reuseextensionactivator.util.ReuseextensionactivatorValidator;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ReuseextensionactivatorPackageImpl extends EPackageImpl implements ReuseextensionactivatorPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass argumentEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass componentModelSpecificationActivatorEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionLanguageSpecificationActivatorEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionLanguageSyntaxSpecificationActivatorEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass reuseExtensionActivatorListEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass reuseExtensionActivatorEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private ReuseextensionactivatorPackageImpl()
  {
    super(eNS_URI, ReuseextensionactivatorFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link ReuseextensionactivatorPackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static ReuseextensionactivatorPackage init()
  {
    if (isInited) return (ReuseextensionactivatorPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionactivatorPackage.eNS_URI);

    // Obtain or create and register package
    ReuseextensionactivatorPackageImpl theReuseextensionactivatorPackage = (ReuseextensionactivatorPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ReuseextensionactivatorPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ReuseextensionactivatorPackageImpl());

    isInited = true;

    // Initialize simple dependencies
    ReuseextensionPackage.eINSTANCE.eClass();

    // Create package meta-data objects
    theReuseextensionactivatorPackage.createPackageContents();

    // Initialize created meta-data
    theReuseextensionactivatorPackage.initializePackageContents();

    // Register package validator
    EValidator.Registry.INSTANCE.put
      (theReuseextensionactivatorPackage, 
       new EValidator.Descriptor()
       {
         public EValidator getEValidator()
         {
           return ReuseextensionactivatorValidator.INSTANCE;
         }
       });

    // Mark meta-data to indicate it can't be changed
    theReuseextensionactivatorPackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(ReuseextensionactivatorPackage.eNS_URI, theReuseextensionactivatorPackage);
    return theReuseextensionactivatorPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getArgument()
  {
    return argumentEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArgument_Parameter()
  {
    return (EAttribute)argumentEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArgument_ReuseExtensionActivator()
  {
    return (EReference)argumentEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArgument_Value()
  {
    return (EAttribute)argumentEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getComponentModelSpecificationActivator()
  {
    return componentModelSpecificationActivatorEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionLanguageSpecificationActivator()
  {
    return compositionLanguageSpecificationActivatorEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionLanguageSyntaxSpecificationActivator()
  {
    return compositionLanguageSyntaxSpecificationActivatorEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getReuseExtensionActivatorList()
  {
    return reuseExtensionActivatorListEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtensionActivatorList_Activators()
  {
    return (EReference)reuseExtensionActivatorListEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getReuseExtensionActivator()
  {
    return reuseExtensionActivatorEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtensionActivator_ActivatorList()
  {
    return (EReference)reuseExtensionActivatorEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtensionActivator_Arguments()
  {
    return (EReference)reuseExtensionActivatorEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getReuseExtensionActivator_ReuseExtension()
  {
    return (EReference)reuseExtensionActivatorEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getReuseExtensionActivator_RexNamespace()
  {
    return (EAttribute)reuseExtensionActivatorEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionactivatorFactory getReuseextensionactivatorFactory()
  {
    return (ReuseextensionactivatorFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    argumentEClass = createEClass(ARGUMENT);
    createEAttribute(argumentEClass, ARGUMENT__PARAMETER);
    createEReference(argumentEClass, ARGUMENT__REUSE_EXTENSION_ACTIVATOR);
    createEAttribute(argumentEClass, ARGUMENT__VALUE);

    componentModelSpecificationActivatorEClass = createEClass(COMPONENT_MODEL_SPECIFICATION_ACTIVATOR);

    compositionLanguageSpecificationActivatorEClass = createEClass(COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR);

    compositionLanguageSyntaxSpecificationActivatorEClass = createEClass(COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR);

    reuseExtensionActivatorListEClass = createEClass(REUSE_EXTENSION_ACTIVATOR_LIST);
    createEReference(reuseExtensionActivatorListEClass, REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS);

    reuseExtensionActivatorEClass = createEClass(REUSE_EXTENSION_ACTIVATOR);
    createEReference(reuseExtensionActivatorEClass, REUSE_EXTENSION_ACTIVATOR__ACTIVATOR_LIST);
    createEReference(reuseExtensionActivatorEClass, REUSE_EXTENSION_ACTIVATOR__ARGUMENTS);
    createEReference(reuseExtensionActivatorEClass, REUSE_EXTENSION_ACTIVATOR__REUSE_EXTENSION);
    createEAttribute(reuseExtensionActivatorEClass, REUSE_EXTENSION_ACTIVATOR__REX_NAMESPACE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    ReuseextensionPackage theReuseextensionPackage = (ReuseextensionPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    componentModelSpecificationActivatorEClass.getESuperTypes().add(this.getReuseExtensionActivator());
    compositionLanguageSpecificationActivatorEClass.getESuperTypes().add(this.getReuseExtensionActivator());
    compositionLanguageSyntaxSpecificationActivatorEClass.getESuperTypes().add(this.getReuseExtensionActivator());

    // Initialize classes and features; add operations and parameters
    initEClass(argumentEClass, Argument.class, "Argument", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getArgument_Parameter(), ecorePackage.getEString(), "parameter", null, 1, 1, Argument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getArgument_ReuseExtensionActivator(), this.getReuseExtensionActivator(), this.getReuseExtensionActivator_Arguments(), "reuseExtensionActivator", null, 0, 1, Argument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getArgument_Value(), ecorePackage.getEString(), "value", null, 1, 1, Argument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(argumentEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(componentModelSpecificationActivatorEClass, ComponentModelSpecificationActivator.class, "ComponentModelSpecificationActivator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(componentModelSpecificationActivatorEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionLanguageSpecificationActivatorEClass, CompositionLanguageSpecificationActivator.class, "CompositionLanguageSpecificationActivator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(compositionLanguageSpecificationActivatorEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionLanguageSyntaxSpecificationActivatorEClass, CompositionLanguageSyntaxSpecificationActivator.class, "CompositionLanguageSyntaxSpecificationActivator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(compositionLanguageSyntaxSpecificationActivatorEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(reuseExtensionActivatorListEClass, ReuseExtensionActivatorList.class, "ReuseExtensionActivatorList", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getReuseExtensionActivatorList_Activators(), this.getReuseExtensionActivator(), this.getReuseExtensionActivator_ActivatorList(), "activators", null, 0, -1, ReuseExtensionActivatorList.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(reuseExtensionActivatorListEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(reuseExtensionActivatorEClass, ReuseExtensionActivator.class, "ReuseExtensionActivator", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getReuseExtensionActivator_ActivatorList(), this.getReuseExtensionActivatorList(), this.getReuseExtensionActivatorList_Activators(), "activatorList", null, 0, 1, ReuseExtensionActivator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getReuseExtensionActivator_Arguments(), this.getArgument(), this.getArgument_ReuseExtensionActivator(), "arguments", null, 0, -1, ReuseExtensionActivator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getReuseExtensionActivator_ReuseExtension(), theReuseextensionPackage.getReuseExtension(), null, "reuseExtension", null, 1, 1, ReuseExtensionActivator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getReuseExtensionActivator_RexNamespace(), ecorePackage.getEString(), "rexNamespace", null, 0, -1, ReuseExtensionActivator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(reuseExtensionActivatorEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // http://www.eclipse.org/emf/2002/Ecore
    createEcoreAnnotations();
  }

  /**
   * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createEcoreAnnotations()
  {
    String source = "http://www.eclipse.org/emf/2002/Ecore";		
    addAnnotation
      (reuseExtensionActivatorEClass, 
       source, 
       new String[] 
       {
       "constraints", "AllArgumentsDefined"
       });
  }

} //ReuseextensionactivatorPackageImpl
